/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern7 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern7 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V8HImode:
      if (pattern8 (x1, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 7;

    case E_V2SImode:
      if (pattern8 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 8;

    case E_V4SImode:
      if (pattern8 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 10;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 307
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XVECEXP (x6, 0, 0);
      operands[3] = x8;
      x9 = XVECEXP (x6, 0, 2);
      operands[2] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return pattern19 (); /* [-1, 3] */

    case VEC_DUPLICATE:
      res = pattern20 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_vsb_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern30 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern30 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V8QImode:
          if (pattern31 (x1, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern31 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V4HImode:
          if (pattern31 (x1, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V8HImode:
          if (pattern31 (x1, 
E_V8HImode) != 0)
            return -1;
          return 5;

        case E_V2SImode:
          if (pattern31 (x1, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern31 (x1, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_VNx32QImode:
          if (pattern32 (x1, 
E_VNx32QImode) != 0)
            return -1;
          return 8;

        case E_VNx16HImode:
          if (pattern32 (x1, 
E_VNx16HImode) != 0)
            return -1;
          return 9;

        case E_VNx8SImode:
          if (pattern32 (x1, 
E_VNx8SImode) != 0)
            return -1;
          return 10;

        case E_VNx4DImode:
          if (pattern32 (x1, 
E_VNx4DImode) != 0)
            return -1;
          return 11;

        case E_VNx64QImode:
          if (pattern32 (x1, 
E_VNx64QImode) != 0)
            return -1;
          return 12;

        case E_VNx32HImode:
          if (pattern32 (x1, 
E_VNx32HImode) != 0)
            return -1;
          return 13;

        case E_VNx16SImode:
          if (pattern32 (x1, 
E_VNx16SImode) != 0)
            return -1;
          return 14;

        case E_VNx8DImode:
          if (pattern32 (x1, 
E_VNx8DImode) != 0)
            return -1;
          return 15;

        default:
          return -1;
        }

    case CONST_VECTOR:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern33 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 16;

        case E_VNx8QImode:
          if (pattern33 (x1, 
E_VNx8QImode) != 0)
            return -1;
          return 17;

        case E_VNx4QImode:
          if (pattern33 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 18;

        case E_VNx2QImode:
          if (pattern33 (x1, 
E_VNx2QImode) != 0)
            return -1;
          return 19;

        case E_VNx8HImode:
          if (pattern33 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 20;

        case E_VNx4HImode:
          if (pattern33 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 21;

        case E_VNx2HImode:
          if (pattern33 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 22;

        case E_VNx4SImode:
          if (pattern33 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 23;

        case E_VNx2SImode:
          if (pattern33 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 24;

        case E_VNx2DImode:
          if (pattern33 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 25;

        case E_V2DImode:
          if (pattern33 (x1, 
E_V2DImode) != 0)
            return -1;
          return 26;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern35 (x1);
      if (res >= 0)
        return res + 27; /* [27, 34] */
      return -1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          return 0;

        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode))
            return -1;
          return 2;

        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 4;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 5;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 6;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 7;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 8;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      return 0;

    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      return 1;

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          res = pattern94 (x3, 
E_V4HImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_V8HImode:
          res = pattern94 (x3, 
E_V8HImode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_V2SImode:
          res = pattern95 (x3, 
E_V2SImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_V4SImode:
          res = pattern95 (x3, 
E_V4SImode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_HImode:
          res = pattern94 (x3, 
E_HImode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        case E_SImode:
          res = pattern95 (x3, 
E_SImode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 168)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern96 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4SImode:
          if (pattern96 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 15;

        case E_VNx2DImode:
          if (pattern96 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 16;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern113 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern113 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern113 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern121 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern121 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern152 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern155 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern155 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern156 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern156 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern157 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern157 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern158 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern158 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern174 (x3, 
E_VNx8BImode, 
E_VNx8HImode); /* [-1, 2] */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4BImode:
          res = pattern173 (
E_VNx4BImode);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_VNx2DImode:
      res = pattern174 (x3, 
E_VNx2BImode, 
E_VNx2DImode);
      if (res >= 0)
        return res + 7; /* [7, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern188 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern188 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern188 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern194 (x3, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern194 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern194 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern194 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 168)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x6, 0, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern195 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 4;

        case E_VNx4SImode:
          if (pattern195 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  if (!aarch64_sve_ptrue_flag (x5, E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      operands[2] = x5;
      return pattern213 (x3); /* [-1, 2] */

    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 351)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 351)
        return -1;
      operands[4] = x5;
      x9 = XVECEXP (x6, 0, 2);
      operands[2] = x9;
      x10 = XVECEXP (x8, 0, 2);
      operands[3] = x10;
      return 3;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 4);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern226 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern226 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern226 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aligned_register_operand (operands[2], i1)
      || !aligned_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode)
          || !aligned_register_operand (operands[2], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode)
          || !aligned_register_operand (operands[2], E_VNx64QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode)
          || !aligned_register_operand (operands[2], E_VNx16HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode)
          || !aligned_register_operand (operands[2], E_VNx32HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!register_operand (operands[2], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!register_operand (operands[2], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!register_operand (operands[2], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!register_operand (operands[2], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!register_operand (operands[1], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!register_operand (operands[1], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!register_operand (operands[1], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!register_operand (operands[1], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 86
      || GET_MODE (x4) != E_VNx16BImode)
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || pattern259 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ldff1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          return pattern268 (x2, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern268 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern268 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern268 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx1TImode:
          if (pattern268 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[3] = x8;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (x5))
        {
        case E_VNx16QImode:
          if (pattern269 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 5;

        case E_VNx8HImode:
          if (pattern269 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern269 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2DImode:
          if (pattern269 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx1TImode:
          if (pattern269 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern287 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern287 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern287 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_comparison_operator (operands[1], i1)
      || !general_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern298 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern301 (x1, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern301 (x1, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern301 (x1, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern301 (x1, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern314 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern314 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern314 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern320 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern320 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern320 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  return pattern327 (x1); /* [-1, 4] */
}

int
pattern334 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !aarch64_simd_shift_imm_offset_si (operands[2], i1))
    return -1;
  return 0;
}

int
pattern336 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern341 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_imm24 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern346 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  return pattern351 (x5); /* [-1, 0] */
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern355 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern355 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern355 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern355 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern364 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern367 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!aarch64_any_register_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x1) != E_VNx8QImode)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x1) != E_VNx4QImode)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x1) != E_VNx4HImode)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x1) != E_VNx2HImode)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x1) != E_VNx2SImode)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x1) != E_VNx4HFmode)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x1) != E_VNx2HFmode)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x1) != E_VNx4BFmode)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x1) != E_VNx2BFmode)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x1) != E_VNx2SFmode)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 18;

    case E_VNx32QImode:
      if (!register_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 19;

    case E_VNx16HImode:
      if (!register_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 20;

    case E_VNx8SImode:
      if (!register_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x1) != E_VNx8SImode)
        return -1;
      return 21;

    case E_VNx4DImode:
      if (!register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      return 22;

    case E_VNx16BFmode:
      if (!register_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode)
        return -1;
      return 23;

    case E_VNx16HFmode:
      if (!register_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode)
        return -1;
      return 24;

    case E_VNx8SFmode:
      if (!register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x1) != E_VNx8SFmode)
        return -1;
      return 25;

    case E_VNx4DFmode:
      if (!register_operand (operands[0], E_VNx4DFmode)
          || GET_MODE (x1) != E_VNx4DFmode)
        return -1;
      return 26;

    case E_VNx48QImode:
      if (!register_operand (operands[0], E_VNx48QImode)
          || GET_MODE (x1) != E_VNx48QImode)
        return -1;
      return 27;

    case E_VNx24HImode:
      if (!register_operand (operands[0], E_VNx24HImode)
          || GET_MODE (x1) != E_VNx24HImode)
        return -1;
      return 28;

    case E_VNx12SImode:
      if (!register_operand (operands[0], E_VNx12SImode)
          || GET_MODE (x1) != E_VNx12SImode)
        return -1;
      return 29;

    case E_VNx6DImode:
      if (!register_operand (operands[0], E_VNx6DImode)
          || GET_MODE (x1) != E_VNx6DImode)
        return -1;
      return 30;

    case E_VNx24BFmode:
      if (!register_operand (operands[0], E_VNx24BFmode)
          || GET_MODE (x1) != E_VNx24BFmode)
        return -1;
      return 31;

    case E_VNx24HFmode:
      if (!register_operand (operands[0], E_VNx24HFmode)
          || GET_MODE (x1) != E_VNx24HFmode)
        return -1;
      return 32;

    case E_VNx12SFmode:
      if (!register_operand (operands[0], E_VNx12SFmode)
          || GET_MODE (x1) != E_VNx12SFmode)
        return -1;
      return 33;

    case E_VNx6DFmode:
      if (!register_operand (operands[0], E_VNx6DFmode)
          || GET_MODE (x1) != E_VNx6DFmode)
        return -1;
      return 34;

    case E_VNx64QImode:
      if (!register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 35;

    case E_VNx32HImode:
      if (!register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 36;

    case E_VNx16SImode:
      if (!register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x1) != E_VNx16SImode)
        return -1;
      return 37;

    case E_VNx8DImode:
      if (!register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      return 38;

    case E_VNx32BFmode:
      if (!register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode)
        return -1;
      return 39;

    case E_VNx32HFmode:
      if (!register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode)
        return -1;
      return 40;

    case E_VNx16SFmode:
      if (!register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x1) != E_VNx16SFmode)
        return -1;
      return 41;

    case E_VNx8DFmode:
      if (!register_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x1) != E_VNx8DFmode)
        return -1;
      return 42;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern320 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern320 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern320 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern320 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern320 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern431 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || GET_MODE (x3) != E_V8QImode
          || GET_MODE (x4) != E_V8HImode
          || !register_operand (operands[2], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x3) != E_V4HImode
          || GET_MODE (x4) != E_V4SImode
          || !register_operand (operands[2], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 169:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 0;

        case 307:
          x6 = XVECEXP (x4, 0, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[3] = x5;
          x7 = XVECEXP (x4, 0, 2);
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx2BImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (XINT (x3, 1))
        {
        case 169:
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 2;

        case 307:
          x9 = XVECEXP (x3, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          x10 = XVECEXP (x3, 0, 2);
          operands[2] = x10;
          if (!register_operand (operands[2], E_VNx4BImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SUBREG:
    case TRUNCATE:
      if (!subreg_lowpart_operator (x3, E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 169:
          operands[5] = x3;
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 4;

        case 307:
          x6 = XVECEXP (x4, 0, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          operands[3] = x3;
          x5 = XVECEXP (x4, 0, 0);
          operands[4] = x5;
          x7 = XVECEXP (x4, 0, 2);
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx8BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern485 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 4
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern492 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  return pattern49 (x1); /* [-1, 1] */
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[1], E_VNx16QImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern510 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern509 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern509 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern509 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern509 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern509 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern509 (x1, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern561 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  return pattern448 (x5, 
31, 
3, 
UNSPEC_VOLATILE); /* [-1, 0] */
}

int
pattern567 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern566 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern566 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern566 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern566 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_VNx2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_VNx2SImode)
    return -1;
  return 0;
}

int
pattern582 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !memory_operand (operands[1], E_VNx8QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4HImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2HImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2SImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_VNx2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_VNx2SImode)
    return -1;
  return 0;
}

int
pattern608 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern479 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern479 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return pattern303 (); /* [-1, 2] */
}

int
pattern619 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern626 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern631 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern638 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern646 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern645 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern645 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern645 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern645 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern645 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern645 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern659 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern667 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern664 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern664 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern664 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern664 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern674 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      return pattern673 (x1); /* [-1, 2] */

    case PLUS:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x5, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x1) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x5) != E_V8SImode
              || GET_MODE (x6) != E_V8SImode
              || !register_operand (operands[2], E_V8HImode)
              || !aarch64_int_rnd_operand (operands[4], E_V8SImode)
              || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode))
            return -1;
          return 3;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || GET_MODE (x3) != E_V4DImode
              || GET_MODE (x5) != E_V4DImode
              || GET_MODE (x6) != E_V4DImode
              || !register_operand (operands[2], E_V4SImode)
              || !aarch64_int_rnd_operand (operands[4], E_V4DImode)
              || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || GET_MODE (x3) != E_V2TImode
              || GET_MODE (x5) != E_V2TImode
              || GET_MODE (x6) != E_V2TImode
              || !register_operand (operands[2], E_V2DImode)
              || !aarch64_int_rnd_operand (operands[4], E_V2TImode)
              || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern691 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || pattern690 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern697 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_imm24 (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_imm24 (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 2;

        case E_DImode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern705 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern708 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern705 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern705 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern705 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern705 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern705 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern705 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern705 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern705 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern705 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern705 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern707 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern707 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern707 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern707 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern707 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern707 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern707 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern707 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern707 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern707 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern740 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_sve_arith_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern744 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[2], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern754 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern753 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern753 (x1, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern753 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern753 (x1, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern753 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern753 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern766 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern772 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern771 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern771 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern771 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern781 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern784 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern783 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern783 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern783 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern783 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern797 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i3)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern805 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_carry_operation (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern811 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_cnt_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern816 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern823 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  return pattern822 (x2, 
i1); /* [-1, 0] */
}

int
pattern829 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[3] = x3;
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern828 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern828 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x4 = XEXP (x1, 0);
      operands[5] = x4;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[4] = x7;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern865 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern872 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern878 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!aarch64_sync_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!aarch64_sync_memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!aarch64_sync_memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern883 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[4], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern887 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          return pattern886 (x1, 
E_V4SImode, 
E_HImode, 
E_SImode, 
E_V8HImode, 
E_V4HImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern886 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 0);
      operands[5] = x8;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V4SImode)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4HImode
              || !register_operand (operands[2], E_V8HImode)
              || !vect_par_cnst_hi_half (operands[3], E_V8HImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_V4HImode:
              if (!register_operand (operands[4], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[4], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x2) != E_V2DImode)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_MODE (x9) != E_V2DImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2SImode
              || !register_operand (operands[2], E_V4SImode)
              || !vect_par_cnst_hi_half (operands[3], E_V4SImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_V2SImode:
              if (!register_operand (operands[4], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[4], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern926 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern931 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[5] = x1;
  if (!memory_operand (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!register_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!memory_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern934 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern942 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern947 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern953 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern963 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern968 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern975 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern981 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 40
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern985 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!memory_operand (operands[2], E_V8QImode)
          || !register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!memory_operand (operands[2], E_V4HImode)
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!memory_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!memory_operand (operands[2], E_V2SImode)
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!memory_operand (operands[2], E_V2SFmode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 4;

    case E_DFmode:
      if (!memory_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern996 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1001 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1009 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1016 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1020 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1030 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1038 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1037 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1037 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1037 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1037 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1049 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1058 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_uxt_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1065 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1069 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SFmode
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1079 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1086 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i2)
      || !aarch64_simd_umax_half_mode (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1099 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1040 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1040 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1040 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1040 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return 4;

        case E_VNx4SFmode:
          return 5;

        case E_VNx2DFmode:
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1104 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1104 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1104 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1105 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1105 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1105 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern1138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SFmode
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1147 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1)
      || pattern986 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1178 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i4))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern1177 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1186 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1189 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1189 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1189 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1189 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1201 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[5] = x6;
  if (!aarch64_sve_ptrue_flag (operands[5], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[6] = x7;
  switch (GET_MODE (x4))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[6], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[6], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[6], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[6], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1213 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != AND)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[4]))
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 1);
      x11 = XVECEXP (x10, 0, 3);
      switch (GET_MODE (x11))
        {
        case E_VNx16BImode:
          return pattern1212 (x1, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1212 (x1, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1212 (x1, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (pattern1212 (x1, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 1);
      x11 = XVECEXP (x10, 0, 3);
      switch (GET_MODE (x11))
        {
        case E_VNx16BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16BImode)
              || !register_operand (operands[3], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8BImode)
              || !register_operand (operands[3], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4BImode)
              || !register_operand (operands[3], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx2BImode
              || !register_operand (operands[2], E_VNx2BImode)
              || !register_operand (operands[3], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1247 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1247 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1255 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_sve_float_arith_immediate (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1262 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1295 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1300 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1357 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x7, 0, 2);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern1365 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_simd_register (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[4], i2)
      || !aarch64_simd_register (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !aarch64_simd_register (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !aarch64_simd_register (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[6] = x3;
  if (!subreg_lowpart_operator (operands[6], E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[4] = x9;
  if (!aarch64_simd_shift_imm_si (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x4, 2);
  operands[5] = x10;
  if (!aarch64_simd_shift_imm_si (operands[5], E_SImode)
      || !
#line 6604 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && UINTVAL (operands[4]) + UINTVAL (operands[5]) <= 32))
    return -1;
  return 864; /* *aarch64_bfxilsi_extrdi */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !register_operand (operands[1], E_V3x16QImode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4497; /* aarch64_simd_st3v16qi */

    case E_V3x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !register_operand (operands[1], E_V3x8HImode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4498; /* aarch64_simd_st3v8hi */

    case E_V3x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !register_operand (operands[1], E_V3x4SImode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4499; /* aarch64_simd_st3v4si */

    case E_V3x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !register_operand (operands[1], E_V3x2DImode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4500; /* aarch64_simd_st3v2di */

    case E_V3x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !register_operand (operands[1], E_V3x8HFmode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4501; /* aarch64_simd_st3v8hf */

    case E_V3x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !register_operand (operands[1], E_V3x4SFmode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4502; /* aarch64_simd_st3v4sf */

    case E_V3x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !register_operand (operands[1], E_V3x2DFmode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4503; /* aarch64_simd_st3v2df */

    case E_V3x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !register_operand (operands[1], E_V3x8BFmode)
          || !
#line 7717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4504; /* aarch64_simd_st3v8bf */

    case E_V3x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !register_operand (operands[1], E_V3x8QImode)
          || !
#line 8707 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5108; /* aarch64_st3v8qi_dreg */

    case E_V3x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !register_operand (operands[1], E_V3x4HImode)
          || !
#line 8707 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5109; /* aarch64_st3v4hi_dreg */

    case E_V3x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !register_operand (operands[1], E_V3x2SImode)
          || !
#line 8707 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5110; /* aarch64_st3v2si_dreg */

    case E_V3x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !register_operand (operands[1], E_V3x4HFmode)
          || !
#line 8707 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5111; /* aarch64_st3v4hf_dreg */

    case E_V3x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !register_operand (operands[1], E_V3x2SFmode)
          || !
#line 8707 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5112; /* aarch64_st3v2sf_dreg */

    case E_V3x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !register_operand (operands[1], E_V3x4BFmode)
          || !
#line 8707 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5113; /* aarch64_st3v4bf_dreg */

    case E_V3x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !register_operand (operands[1], E_V3x1DImode)
          || !
#line 8717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5114; /* aarch64_st3di_dreg */

    case E_V3x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !register_operand (operands[1], E_V3x1DFmode)
          || !
#line 8717 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5115; /* aarch64_st3df_dreg */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4529; /* aarch64_simd_ld4rv8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4530; /* aarch64_simd_ld4rv4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4531; /* aarch64_simd_ld4rv2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4532; /* aarch64_simd_ld4rdi */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4533; /* aarch64_simd_ld4rv4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4534; /* aarch64_simd_ld4rv2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4535; /* aarch64_simd_ld4rdf */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4536; /* aarch64_simd_ld4rv4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode)
          || GET_MODE (x3) != E_V4x16QImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4537; /* aarch64_simd_ld4rv16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode)
          || GET_MODE (x3) != E_V4x8HImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4538; /* aarch64_simd_ld4rv8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode)
          || GET_MODE (x3) != E_V4x4SImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4539; /* aarch64_simd_ld4rv4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode)
          || GET_MODE (x3) != E_V4x2DImode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4540; /* aarch64_simd_ld4rv2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode)
          || GET_MODE (x3) != E_V4x8HFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4541; /* aarch64_simd_ld4rv8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode)
          || GET_MODE (x3) != E_V4x4SFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4542; /* aarch64_simd_ld4rv4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode)
          || GET_MODE (x3) != E_V4x2DFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4543; /* aarch64_simd_ld4rv2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode)
          || GET_MODE (x3) != E_V4x8BFmode
          || !
#line 7772 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4544; /* aarch64_simd_ld4rv8bf */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8QImode)
          || !
#line 8403 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4811; /* aarch64_ld3v8qi_dreg */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HImode)
          || !
#line 8403 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4812; /* aarch64_ld3v4hi_dreg */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SImode)
          || !
#line 8403 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4813; /* aarch64_ld3v2si_dreg */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HFmode)
          || !
#line 8403 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4814; /* aarch64_ld3v4hf_dreg */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SFmode)
          || !
#line 8403 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4815; /* aarch64_ld3v2sf_dreg */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4BFmode)
          || !
#line 8403 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4816; /* aarch64_ld3v4bf_dreg */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DImode)
          || !
#line 8413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4817; /* aarch64_ld3di_dreg */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DFmode)
          || !
#line 8413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4818; /* aarch64_ld3df_dreg */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1625; /* aarch64_absv8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1628; /* aarch64_absv16qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1629; /* aarch64_absv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1632; /* aarch64_absv8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1633; /* aarch64_absv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1636; /* aarch64_absv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1637; /* aarch64_absv2di */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1638; /* aarch64_absdi */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 8847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 60 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 5162; /* aarch64_frecpxhf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 8847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5163; /* aarch64_frecpxsf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 8847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5164; /* aarch64_frecpxdf */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern72 (x1))
    {
    case 0:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12857; /* aarch64_sve_uzpqvnx64qi */

    case 1:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12859; /* aarch64_sve_uzpqvnx32hi */

    case 2:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12861; /* aarch64_sve_uzpqvnx16si */

    case 3:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12863; /* aarch64_sve_uzpqvnx8di */

    case 4:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12865; /* aarch64_sve_uzpqvnx32bf */

    case 5:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12867; /* aarch64_sve_uzpqvnx32hf */

    case 6:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12869; /* aarch64_sve_uzpqvnx16sf */

    case 7:
      if (!
#line 3903 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12871; /* aarch64_sve_uzpqvnx8df */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 3199 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2656; /* aarch64_float_trunc_rodd_df */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 3208 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2657; /* aarch64_float_trunc_rodd_lo_v2sf */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern68 (x1))
    {
    case 0:
      if (!
#line 9370 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10771; /* aarch64_sve_uunpklo_vnx16qi */

    case 1:
      if (!
#line 9370 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10775; /* aarch64_sve_uunpklo_vnx8hi */

    case 2:
      if (!
#line 9370 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10779; /* aarch64_sve_uunpklo_vnx4si */

    case 3:
      if (!
#line 10036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10918; /* aarch64_sve_punpklo_vnx16bi */

    case 4:
      if (!
#line 10036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10920; /* aarch64_sve_punpklo_vnx8bi */

    case 5:
      if (!
#line 10036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10922; /* aarch64_sve_punpklo_vnx4bi */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern469 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6549; /* aarch64_pred_one_cmplvnx16qi */

        case E_VNx8QImode:
          if (pattern469 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6558; /* aarch64_pred_one_cmplvnx8qi */

        case E_VNx4QImode:
          if (pattern469 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6567; /* aarch64_pred_one_cmplvnx4qi */

        case E_VNx2QImode:
          if (pattern469 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6576; /* aarch64_pred_one_cmplvnx2qi */

        case E_VNx8HImode:
          if (pattern469 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6585; /* aarch64_pred_one_cmplvnx8hi */

        case E_VNx4HImode:
          if (pattern469 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6594; /* aarch64_pred_one_cmplvnx4hi */

        case E_VNx2HImode:
          if (pattern469 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6603; /* aarch64_pred_one_cmplvnx2hi */

        case E_VNx4SImode:
          if (pattern469 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6612; /* aarch64_pred_one_cmplvnx4si */

        case E_VNx2SImode:
          if (pattern469 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6621; /* aarch64_pred_one_cmplvnx2si */

        case E_VNx2DImode:
          if (pattern469 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6630; /* aarch64_pred_one_cmplvnx2di */

        case E_V8QImode:
          if (pattern469 (x2, 
E_V8QImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6639; /* aarch64_pred_one_cmplv8qi */

        case E_V16QImode:
          if (pattern469 (x2, 
E_V16QImode, 
E_VNx16BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6648; /* aarch64_pred_one_cmplv16qi */

        case E_V4HImode:
          if (pattern469 (x2, 
E_V4HImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6657; /* aarch64_pred_one_cmplv4hi */

        case E_V8HImode:
          if (pattern469 (x2, 
E_V8HImode, 
E_VNx8BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6666; /* aarch64_pred_one_cmplv8hi */

        case E_V2SImode:
          if (pattern469 (x2, 
E_V2SImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6675; /* aarch64_pred_one_cmplv2si */

        case E_V4SImode:
          if (pattern469 (x2, 
E_V4SImode, 
E_VNx4BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6684; /* aarch64_pred_one_cmplv4si */

        case E_V2DImode:
          if (pattern469 (x2, 
E_V2DImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6693; /* aarch64_pred_one_cmplv2di */

        case E_V1DImode:
          if (pattern469 (x2, 
E_V1DImode, 
E_VNx2BImode) != 0
              || !
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6702; /* aarch64_pred_one_cmplv1di */

        default:
          return -1;
        }

    case XOR:
      switch (pattern601 (x2))
        {
        case 0:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11888; /* *aarch64_sve2_nbslvnx16qi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11889; /* *aarch64_sve2_nbslvnx16qi */

        case 1:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11890; /* *aarch64_sve2_nbslvnx8hi */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11891; /* *aarch64_sve2_nbslvnx8hi */

        case 2:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11892; /* *aarch64_sve2_nbslvnx4si */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11893; /* *aarch64_sve2_nbslvnx4si */

        case 3:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return 11894; /* *aarch64_sve2_nbslvnx2di */
          if (!rtx_equal_p (x6, operands[2])
              || !
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11895; /* *aarch64_sve2_nbslvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern470 (x2))
    {
    case 0:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6552; /* aarch64_pred_popcountvnx16qi */

    case 1:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6561; /* aarch64_pred_popcountvnx8qi */

    case 2:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6570; /* aarch64_pred_popcountvnx4qi */

    case 3:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6579; /* aarch64_pred_popcountvnx2qi */

    case 4:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6588; /* aarch64_pred_popcountvnx8hi */

    case 5:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6597; /* aarch64_pred_popcountvnx4hi */

    case 6:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6606; /* aarch64_pred_popcountvnx2hi */

    case 7:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6615; /* aarch64_pred_popcountvnx4si */

    case 8:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6624; /* aarch64_pred_popcountvnx2si */

    case 9:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6633; /* aarch64_pred_popcountvnx2di */

    case 10:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6642; /* aarch64_pred_popcountv8qi */

    case 11:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6651; /* aarch64_pred_popcountv16qi */

    case 12:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6660; /* aarch64_pred_popcountv4hi */

    case 13:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6669; /* aarch64_pred_popcountv8hi */

    case 14:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6678; /* aarch64_pred_popcountv2si */

    case 15:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6687; /* aarch64_pred_popcountv4si */

    case 16:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6696; /* aarch64_pred_popcountv2di */

    case 17:
      if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6705; /* aarch64_pred_popcountv1di */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern77 (x3, 
E_HFmode) != 0
                  || !(
#line 7432 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                return -1;
              return 1101; /* fminhf3 */

            case E_SFmode:
              if (pattern77 (x3, 
E_SFmode) != 0
                  || !
#line 7432 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1105; /* fminsf3 */

            case E_DFmode:
              if (pattern77 (x3, 
E_DFmode) != 0
                  || !
#line 7432 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 1109; /* fmindf3 */

            case E_V4HFmode:
              if (pattern77 (x3, 
E_V4HFmode) != 0
                  || !(
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2689; /* fminv4hf3 */

            case E_V8HFmode:
              if (pattern121 (x3, 
E_V8HFmode, 
E_V8HFmode) != 0
                  || !(
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2695; /* fminv8hf3 */

            case E_V2SFmode:
              if (pattern77 (x3, 
E_V2SFmode) != 0
                  || !
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2705; /* fminv2sf3 */

            case E_V4SFmode:
              if (pattern77 (x3, 
E_V4SFmode) != 0
                  || !
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2711; /* fminv4sf3 */

            case E_V2DFmode:
              if (pattern77 (x3, 
E_V2DFmode) != 0
                  || !
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2715; /* fminv2df3 */

            case E_VNx16BFmode:
              if (pattern78 (x3, 
E_VNx16BFmode) != 0
                  || !(
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12230; /* *aarch64_sve_fminnmvnx16bf */

            case E_VNx32BFmode:
              if (pattern78 (x3, 
E_VNx32BFmode) != 0
                  || !(
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12234; /* *aarch64_sve_fminnmvnx32bf */

            case E_VNx16HFmode:
              if (pattern78 (x3, 
E_VNx16HFmode) != 0
                  || !
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12238; /* *aarch64_sve_fminnmvnx16hf */

            case E_VNx8SFmode:
              if (pattern78 (x3, 
E_VNx8SFmode) != 0
                  || !
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12242; /* *aarch64_sve_fminnmvnx8sf */

            case E_VNx4DFmode:
              if (pattern78 (x3, 
E_VNx4DFmode) != 0
                  || !
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12246; /* *aarch64_sve_fminnmvnx4df */

            case E_VNx32HFmode:
              if (pattern78 (x3, 
E_VNx32HFmode) != 0
                  || !
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12250; /* *aarch64_sve_fminnmvnx32hf */

            case E_VNx16SFmode:
              if (pattern78 (x3, 
E_VNx16SFmode) != 0
                  || !
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12254; /* *aarch64_sve_fminnmvnx16sf */

            case E_VNx8DFmode:
              if (pattern78 (x3, 
E_VNx8DFmode) != 0
                  || !
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12258; /* *aarch64_sve_fminnmvnx8df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern80 (x3))
            {
            case 0:
              if (!(
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12262; /* aarch64_sve_single_fminnmvnx16bf */

            case 1:
              if (!(
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 12266; /* aarch64_sve_single_fminnmvnx32bf */

            case 2:
              if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12270; /* aarch64_sve_single_fminnmvnx16hf */

            case 3:
              if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12274; /* aarch64_sve_single_fminnmvnx8sf */

            case 4:
              if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12278; /* aarch64_sve_single_fminnmvnx4df */

            case 5:
              if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12282; /* aarch64_sve_single_fminnmvnx32hf */

            case 6:
              if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12286; /* aarch64_sve_single_fminnmvnx16sf */

            case 7:
              if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 12290; /* aarch64_sve_single_fminnmvnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 277)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          x5 = XVECEXP (x3, 0, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1053 (x3, 
E_VNx8BFmode) != 0
                  || !
#line 491 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))
                return -1;
              return 11793; /* aarch64_sve_fclampvnx8bf */

            case E_VNx8HFmode:
              if (pattern1053 (x3, 
E_VNx8HFmode) != 0
                  || !
#line 492 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 11794; /* aarch64_sve_fclampvnx8hf */

            case E_VNx4SFmode:
              if (pattern1053 (x3, 
E_VNx4SFmode) != 0
                  || !
#line 493 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 11795; /* aarch64_sve_fclampvnx4sf */

            case E_VNx2DFmode:
              if (pattern1053 (x3, 
E_VNx2DFmode) != 0
                  || !
#line 494 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
                return -1;
              return 11796; /* aarch64_sve_fclampvnx2df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != VEC_DUPLICATE)
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BFmode:
              if (pattern1113 (x3, 
E_VNx8BFmode, 
E_VNx16BFmode) != 0
                  || !(
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 11801; /* aarch64_sve_fclamp_singlevnx16bf */

            case E_VNx32BFmode:
              if (pattern1113 (x3, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0
                  || !(
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return -1;
              return 11802; /* aarch64_sve_fclamp_singlevnx32bf */

            case E_VNx16HFmode:
              if (pattern1113 (x3, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0
                  || !
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11803; /* aarch64_sve_fclamp_singlevnx16hf */

            case E_VNx8SFmode:
              if (pattern1113 (x3, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0
                  || !
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11804; /* aarch64_sve_fclamp_singlevnx8sf */

            case E_VNx4DFmode:
              if (pattern1113 (x3, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0
                  || !
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11805; /* aarch64_sve_fclamp_singlevnx4df */

            case E_VNx32HFmode:
              if (pattern1113 (x3, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0
                  || !
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11806; /* aarch64_sve_fclamp_singlevnx32hf */

            case E_VNx16SFmode:
              if (pattern1113 (x3, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0
                  || !
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11807; /* aarch64_sve_fclamp_singlevnx16sf */

            case E_VNx8DFmode:
              if (pattern1113 (x3, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0
                  || !
#line 1422 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11808; /* aarch64_sve_fclamp_singlevnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4856; /* aarch64_uzp1v8qi */

    case 1:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4866; /* aarch64_uzp1v16qi */

    case 2:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4880; /* aarch64_uzp1v4hi */

    case 3:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4890; /* aarch64_uzp1v8hi */

    case 4:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4904; /* aarch64_uzp1v2si */

    case 5:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4914; /* aarch64_uzp1v4si */

    case 6:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4920; /* aarch64_uzp1v2di */

    case 7:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4934; /* aarch64_uzp1v4hf */

    case 8:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4944; /* aarch64_uzp1v8hf */

    case 9:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4958; /* aarch64_uzp1v4bf */

    case 10:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4968; /* aarch64_uzp1v8bf */

    case 11:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4982; /* aarch64_uzp1v2sf */

    case 12:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4992; /* aarch64_uzp1v4sf */

    case 13:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4998; /* aarch64_uzp1v2df */

    case 14:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10469; /* aarch64_sve_uzp1vnx16qi */

    case 15:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10479; /* aarch64_sve_uzp1vnx8qi */

    case 16:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10489; /* aarch64_sve_uzp1vnx4qi */

    case 17:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10499; /* aarch64_sve_uzp1vnx2qi */

    case 18:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10509; /* aarch64_sve_uzp1vnx8hi */

    case 19:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10519; /* aarch64_sve_uzp1vnx4hi */

    case 20:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10529; /* aarch64_sve_uzp1vnx2hi */

    case 21:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10539; /* aarch64_sve_uzp1vnx4si */

    case 22:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10549; /* aarch64_sve_uzp1vnx2si */

    case 23:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10559; /* aarch64_sve_uzp1vnx2di */

    case 24:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10569; /* aarch64_sve_uzp1vnx8hf */

    case 25:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10579; /* aarch64_sve_uzp1vnx4hf */

    case 26:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10589; /* aarch64_sve_uzp1vnx2hf */

    case 27:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10599; /* aarch64_sve_uzp1vnx8bf */

    case 28:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10609; /* aarch64_sve_uzp1vnx4bf */

    case 29:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10619; /* aarch64_sve_uzp1vnx2bf */

    case 30:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10629; /* aarch64_sve_uzp1vnx4sf */

    case 31:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10639; /* aarch64_sve_uzp1vnx2sf */

    case 32:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10649; /* aarch64_sve_uzp1vnx2df */

    case 33:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10730; /* aarch64_sve_uzp1vnx16bi */

    case 34:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10736; /* aarch64_sve_uzp1vnx8bi */

    case 35:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10742; /* aarch64_sve_uzp1vnx4bi */

    case 36:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10748; /* aarch64_sve_uzp1vnx2bi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16QImode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (8 / 8), 0, 15)))
        return -1;
      return 12768; /* aarch64_sve_dupqvnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12769; /* aarch64_sve_dupqvnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (32 / 8), 0, 15)))
        return -1;
      return 12770; /* aarch64_sve_dupqvnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (64 / 8), 0, 15)))
        return -1;
      return 12771; /* aarch64_sve_dupqvnx2di */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x3) != E_VNx8BFmode
          || !register_operand (operands[1], E_VNx8BFmode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12772; /* aarch64_sve_dupqvnx8bf */

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (16 / 8), 0, 15)))
        return -1;
      return 12773; /* aarch64_sve_dupqvnx8hf */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (32 / 8), 0, 15)))
        return -1;
      return 12774; /* aarch64_sve_dupqvnx4sf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2DFmode)
          || !
#line 3804 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[2]) * (64 / 8), 0, 15)))
        return -1;
      return 12775; /* aarch64_sve_dupqvnx2df */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!(
#line 7432 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1100; /* fmaxhf3 */

    case 1:
      if (!
#line 7432 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1104; /* fmaxsf3 */

    case 2:
      if (!
#line 7432 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1108; /* fmaxdf3 */

    case 3:
      if (!(
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2686; /* fmaxv4hf3 */

    case 4:
      if (!(
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2694; /* fmaxv8hf3 */

    case 5:
      if (!
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2702; /* fmaxv2sf3 */

    case 6:
      if (!
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2710; /* fmaxv4sf3 */

    case 7:
      if (!
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2714; /* fmaxv2df3 */

    case 8:
      if (!(
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12228; /* *aarch64_sve_fmaxnmvnx16bf */

    case 9:
      if (!(
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12232; /* *aarch64_sve_fmaxnmvnx32bf */

    case 10:
      if (!
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12236; /* *aarch64_sve_fmaxnmvnx16hf */

    case 11:
      if (!
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12240; /* *aarch64_sve_fmaxnmvnx8sf */

    case 12:
      if (!
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12244; /* *aarch64_sve_fmaxnmvnx4df */

    case 13:
      if (!
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12248; /* *aarch64_sve_fmaxnmvnx32hf */

    case 14:
      if (!
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12252; /* *aarch64_sve_fmaxnmvnx16sf */

    case 15:
      if (!
#line 2515 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12256; /* *aarch64_sve_fmaxnmvnx8df */

    case 16:
      if (!(
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 693 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12260; /* aarch64_sve_single_fmaxnmvnx16bf */

    case 17:
      if (!(
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 694 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12264; /* aarch64_sve_single_fmaxnmvnx32bf */

    case 18:
      if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12268; /* aarch64_sve_single_fmaxnmvnx16hf */

    case 19:
      if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12272; /* aarch64_sve_single_fmaxnmvnx8sf */

    case 20:
      if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12276; /* aarch64_sve_single_fmaxnmvnx4df */

    case 21:
      if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12280; /* aarch64_sve_single_fmaxnmvnx32hf */

    case 22:
      if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12284; /* aarch64_sve_single_fmaxnmvnx16sf */

    case 23:
      if (!
#line 2526 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12288; /* aarch64_sve_single_fmaxnmvnx8df */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern118 (x1))
    {
    case 0:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10472; /* aarch64_sve_uzpq2vnx16qi */

    case 1:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10482; /* aarch64_sve_uzpq2vnx8qi */

    case 2:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10492; /* aarch64_sve_uzpq2vnx4qi */

    case 3:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10502; /* aarch64_sve_uzpq2vnx2qi */

    case 4:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10512; /* aarch64_sve_uzpq2vnx8hi */

    case 5:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10522; /* aarch64_sve_uzpq2vnx4hi */

    case 6:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10532; /* aarch64_sve_uzpq2vnx2hi */

    case 7:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10542; /* aarch64_sve_uzpq2vnx4si */

    case 8:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10552; /* aarch64_sve_uzpq2vnx2si */

    case 9:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10562; /* aarch64_sve_uzpq2vnx2di */

    case 10:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10572; /* aarch64_sve_uzpq2vnx8hf */

    case 11:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10582; /* aarch64_sve_uzpq2vnx4hf */

    case 12:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10592; /* aarch64_sve_uzpq2vnx2hf */

    case 13:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10602; /* aarch64_sve_uzpq2vnx8bf */

    case 14:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10612; /* aarch64_sve_uzpq2vnx4bf */

    case 15:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10622; /* aarch64_sve_uzpq2vnx2bf */

    case 16:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10632; /* aarch64_sve_uzpq2vnx4sf */

    case 17:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10642; /* aarch64_sve_uzpq2vnx2sf */

    case 18:
      if (!(
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3180 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10652; /* aarch64_sve_uzpq2vnx2df */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode)
          || !
#line 7864 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4585; /* aarch64_vec_stl1_lanesv1di_lanesi */

    case E_V1DFmode:
      if (!register_operand (operands[1], E_V1DFmode)
          || !
#line 7864 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4586; /* aarch64_vec_stl1_lanesv1df_lanedf */

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 7864 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4587; /* aarch64_vec_stl1_lanesv2di_lanedi */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 7864 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4588; /* aarch64_vec_stl1_lanesv2df_lanedf */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern91 (x1))
    {
    case 0:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2129; /* aarch64_sminpv8qi */

    case 1:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2135; /* aarch64_sminpv16qi */

    case 2:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2145; /* aarch64_sminpv4hi */

    case 3:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2151; /* aarch64_sminpv8hi */

    case 4:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2161; /* aarch64_sminpv2si */

    case 5:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2167; /* aarch64_sminpv4si */

    case 6:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10348; /* aarch64_pred_reduc_smin_vnx16qi */

    case 7:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10355; /* aarch64_pred_reduc_smin_vnx8hi */

    case 8:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10362; /* aarch64_pred_reduc_smin_vnx4si */

    case 9:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10369; /* aarch64_pred_reduc_smin_vnx2di */

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
        return -1;
      return 1139; /* tlsie_tiny_si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
        return -1;
      return 1140; /* tlsie_tiny_di */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern119 (x1))
    {
    case 0:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10660; /* aarch64_sve_uzp2qvnx16qi */

    case 1:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10666; /* aarch64_sve_uzp2qvnx8hi */

    case 2:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10672; /* aarch64_sve_uzp2qvnx4si */

    case 3:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10678; /* aarch64_sve_uzp2qvnx2di */

    case 4:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10684; /* aarch64_sve_uzp2qvnx8bf */

    case 5:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10690; /* aarch64_sve_uzp2qvnx8hf */

    case 6:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10696; /* aarch64_sve_uzp2qvnx4sf */

    case 7:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10702; /* aarch64_sve_uzp2qvnx2df */

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern92 (x1))
    {
    case 0:
      if (!(
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2716; /* aarch64_faddpv4hf */

    case 1:
      if (!(
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2719; /* aarch64_faddpv8hf */

    case 2:
      if (!
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2720; /* aarch64_faddpv2sf */

    case 3:
      if (!
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2723; /* aarch64_faddpv4sf */

    case 4:
      if (!
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2724; /* aarch64_faddpv2df */

    case 5:
      if (!
#line 9027 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10373; /* aarch64_pred_reduc_plus_vnx8hf */

    case 6:
      if (!
#line 9027 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10378; /* aarch64_pred_reduc_plus_vnx4sf */

    case 7:
      if (!
#line 9027 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10383; /* aarch64_pred_reduc_plus_vnx2df */

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern110 (x2, 
E_VNx16BImode, 
86) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 85
      || GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 85
      || GET_MODE (x4) != E_VNx16BImode
      || !
#line 1127 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 5729; /* aarch64_update_ffr_for_load */
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern134 (x2, 
84, 
E_VNx16QImode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[1], E_VNx16BFmode)
          || !
#line 3387 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12589; /* aarch64_sve2_fp8_cvtnvnx16bf */

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[1], E_VNx16HFmode)
          || !
#line 3387 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12590; /* aarch64_sve2_fp8_cvtnvnx16hf */

    default:
      return -1;
    }
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1))
    {
    case 0:
      if (!(
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5282; /* aarch64_faminv4hf */

    case 1:
      if (!(
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5284; /* aarch64_faminv8hf */

    case 2:
      if (!
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5286; /* aarch64_faminv2sf */

    case 3:
      if (!
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5288; /* aarch64_faminv4sf */

    case 4:
      if (!
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5290; /* aarch64_faminv2df */

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12709; /* aarch64_pred_reduc_smaxqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12717; /* aarch64_pred_reduc_smaxqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12725; /* aarch64_pred_reduc_smaxqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12733; /* aarch64_pred_reduc_smaxqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10346; /* aarch64_pred_reduc_ior_vnx16qi */

    case 1:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10353; /* aarch64_pred_reduc_ior_vnx8hi */

    case 2:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10360; /* aarch64_pred_reduc_ior_vnx4si */

    case 3:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10367; /* aarch64_pred_reduc_ior_vnx2di */

    default:
      return -1;
    }
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      res = recog_193 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 1L:
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      switch (pattern866 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7239; /* *cond_absvnx8hf_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              && 
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7305; /* *cond_absvnx8hf_any_strict */
          break;

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7250; /* *cond_absvnx4sf_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              && 
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7316; /* *cond_absvnx4sf_any_strict */
          break;

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7261; /* *cond_absvnx2df_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              && 
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7327; /* *cond_absvnx2df_any_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[4] = x4;
  if (aarch64_sve_gp_strictness (operands[4], E_SImode))
    {
      res = recog_194 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 4
      || XINT (x5, 1) != 393)
    return -1;
  x7 = XVECEXP (x5, 0, 2);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[3] = x8;
  x6 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x6, operands[3]))
    {
      res = recog_195 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[4] = x6;
  if (XWINT (x4, 0) == 0L)
    {
      x9 = XVECEXP (x5, 0, 1);
      if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x10 = XVECEXP (x3, 0, 0);
          operands[5] = x10;
          x11 = XVECEXP (x5, 0, 0);
          operands[6] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1300 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) == 0
                  && 
#line 6408 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 8981; /* *aarch64_cond_abdvnx8hf_any_relaxed */
              break;

            case E_VNx4SFmode:
              if (pattern1300 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) == 0
                  && 
#line 6408 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 8982; /* *aarch64_cond_abdvnx4sf_any_relaxed */
              break;

            case E_VNx2DFmode:
              if (pattern1300 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) == 0
                  && 
#line 6408 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 8983; /* *aarch64_cond_abdvnx2df_any_relaxed */
              break;

            default:
              break;
            }
        }
    }
  operands[5] = x4;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[6] = x9;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  switch (pattern1301 (x2))
    {
    case 0:
      if (!
#line 6456 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8984; /* *aarch64_cond_abdvnx8hf_any_strict */

    case 1:
      if (!
#line 6456 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8985; /* *aarch64_cond_abdvnx4sf_any_strict */

    case 2:
      if (!
#line 6456 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8986; /* *aarch64_cond_abdvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11763; /* *cond_sqshlvnx4si_2 */
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11771; /* *cond_sqshlvnx4si_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1294 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11779; /* *cond_sqshlvnx4si_any */
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11634; /* *cond_urhaddvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11677; /* *cond_urhaddvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11717; /* *cond_urhaddvnx4si_any */
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11620; /* *cond_uhsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11665; /* *cond_uhsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11705; /* *cond_uhsubvnx8hi_any */
}

 int
recog_240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11640; /* *cond_srhaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11682; /* *cond_srhaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11722; /* *cond_srhaddvnx2di_any */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11614; /* *cond_shsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11660; /* *cond_shsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11700; /* *cond_shsubvnx8hi_any */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1056 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8513; /* *cond_fmin_nanvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8659; /* *cond_fmin_nanvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8763; /* *cond_fmin_nanvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8526; /* *cond_fmin_nanvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8672; /* *cond_fmin_nanvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8776; /* *cond_fmin_nanvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8539; /* *cond_fmin_nanvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8685; /* *cond_fmin_nanvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8789; /* *cond_fmin_nanvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8552; /* *cond_fmin_nanvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8698; /* *cond_fmin_nanvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8802; /* *cond_fmin_nanvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8613; /* *cond_fmin_nanvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8863; /* *cond_fmin_nanvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8620; /* *cond_fmin_nanvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8870; /* *cond_fmin_nanvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8627; /* *cond_fmin_nanvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8877; /* *cond_fmin_nanvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8565; /* *cond_fmin_nanvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8711; /* *cond_fmin_nanvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8815; /* *cond_fmin_nanvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8578; /* *cond_fmin_nanvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8724; /* *cond_fmin_nanvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8828; /* *cond_fmin_nanvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8591; /* *cond_fmin_nanvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8737; /* *cond_fmin_nanvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8841; /* *cond_fmin_nanvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8604; /* *cond_fmin_nanvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8750; /* *cond_fmin_nanvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8854; /* *cond_fmin_nanvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8634; /* *cond_fmin_nanvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8884; /* *cond_fmin_nanvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8641; /* *cond_fmin_nanvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8891; /* *cond_fmin_nanvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8648; /* *cond_fmin_nanvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8898; /* *cond_fmin_nanvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1121 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9243; /* *cond_fnmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9271; /* *cond_fnmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9303; /* *cond_fnmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9247; /* *cond_fnmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9275; /* *cond_fnmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9307; /* *cond_fnmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9251; /* *cond_fnmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9279; /* *cond_fnmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9311; /* *cond_fnmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9267; /* *cond_fnmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9299; /* *cond_fnmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9255; /* *cond_fnmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9287; /* *cond_fnmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9319; /* *cond_fnmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9259; /* *cond_fnmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9291; /* *cond_fnmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9323; /* *cond_fnmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9263; /* *cond_fnmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9295; /* *cond_fnmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9327; /* *cond_fnmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9283; /* *cond_fnmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9315; /* *cond_fnmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern479 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7459; /* *cond_ashlvnx16qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7629; /* *cond_ashlvnx16qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7799; /* *cond_ashlvnx16qi_any */

        case E_VNx8QImode:
          if (pattern479 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7476; /* *cond_ashlvnx8qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7646; /* *cond_ashlvnx8qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7816; /* *cond_ashlvnx8qi_any */

        case E_VNx4QImode:
          if (pattern479 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7493; /* *cond_ashlvnx4qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7663; /* *cond_ashlvnx4qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7833; /* *cond_ashlvnx4qi_any */

        case E_VNx2QImode:
          if (pattern479 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7510; /* *cond_ashlvnx2qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7680; /* *cond_ashlvnx2qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7850; /* *cond_ashlvnx2qi_any */

        case E_VNx8HImode:
          if (pattern479 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7527; /* *cond_ashlvnx8hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7697; /* *cond_ashlvnx8hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7867; /* *cond_ashlvnx8hi_any */

        case E_VNx4HImode:
          if (pattern479 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7544; /* *cond_ashlvnx4hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7714; /* *cond_ashlvnx4hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7884; /* *cond_ashlvnx4hi_any */

        case E_VNx2HImode:
          if (pattern479 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7561; /* *cond_ashlvnx2hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7731; /* *cond_ashlvnx2hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7901; /* *cond_ashlvnx2hi_any */

        case E_VNx4SImode:
          if (pattern479 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7578; /* *cond_ashlvnx4si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7748; /* *cond_ashlvnx4si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7918; /* *cond_ashlvnx4si_any */

        case E_VNx2SImode:
          if (pattern479 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7595; /* *cond_ashlvnx2si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7765; /* *cond_ashlvnx2si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7935; /* *cond_ashlvnx2si_any */

        case E_VNx2DImode:
          if (pattern479 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7612; /* *cond_ashlvnx2di_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7782; /* *cond_ashlvnx2di_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7952; /* *cond_ashlvnx2di_any */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern996 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8268; /* *cond_ashlvnx16qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8298; /* *cond_ashlvnx16qi_any_const */

        case E_VNx8QImode:
          if (pattern996 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8271; /* *cond_ashlvnx8qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8301; /* *cond_ashlvnx8qi_any_const */

        case E_VNx4QImode:
          if (pattern996 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8274; /* *cond_ashlvnx4qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8304; /* *cond_ashlvnx4qi_any_const */

        case E_VNx2QImode:
          if (pattern996 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8277; /* *cond_ashlvnx2qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8307; /* *cond_ashlvnx2qi_any_const */

        case E_VNx8HImode:
          if (pattern996 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8280; /* *cond_ashlvnx8hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8310; /* *cond_ashlvnx8hi_any_const */

        case E_VNx4HImode:
          if (pattern996 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8283; /* *cond_ashlvnx4hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8313; /* *cond_ashlvnx4hi_any_const */

        case E_VNx2HImode:
          if (pattern996 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8286; /* *cond_ashlvnx2hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8316; /* *cond_ashlvnx2hi_any_const */

        case E_VNx4SImode:
          if (pattern996 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8289; /* *cond_ashlvnx4si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8319; /* *cond_ashlvnx4si_any_const */

        case E_VNx2SImode:
          if (pattern996 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8292; /* *cond_ashlvnx2si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8322; /* *cond_ashlvnx2si_any_const */

        case E_VNx2DImode:
          if (pattern996 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8295; /* *cond_ashlvnx2di_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8325; /* *cond_ashlvnx2di_any_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x4, 1))
        {
        case 316:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1054 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6958; /* cond_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern1054 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6961; /* cond_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern1054 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6964; /* cond_revbvnx4si */

            case E_VNx2DImode:
              if (pattern1054 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6967; /* cond_revbvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1054 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6959; /* cond_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern1054 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6962; /* cond_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern1054 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6965; /* cond_revhvnx4si */

            case E_VNx2DImode:
              if (pattern1054 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6968; /* cond_revhvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1054 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6960; /* cond_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern1054 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6963; /* cond_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern1054 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6966; /* cond_revwvnx4si */

            case E_VNx2DImode:
              if (pattern1054 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6969; /* cond_revwvnx2di */

            default:
              return -1;
            }

        case 317:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1115 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12760; /* cond_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1115 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12761; /* cond_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1115 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12762; /* cond_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1115 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12763; /* cond_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1115 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12764; /* cond_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1115 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12765; /* cond_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1115 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12766; /* cond_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1115 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3783 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12767; /* cond_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_269 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 321:
          switch (pattern870 (x2))
            {
            case 0:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8112; /* *cond_smulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8114; /* *cond_smulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8116; /* *cond_smulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8118; /* *cond_smulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8120; /* *cond_smulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8122; /* *cond_smulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8124; /* *cond_smulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8126; /* *cond_smulhvnx2di_z */

            default:
              return -1;
            }

        case 322:
          switch (pattern870 (x2))
            {
            case 0:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8113; /* *cond_umulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8115; /* *cond_umulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8117; /* *cond_umulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8119; /* *cond_umulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8121; /* *cond_umulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8123; /* *cond_umulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8125; /* *cond_umulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8127; /* *cond_umulhvnx2di_z */

            default:
              return -1;
            }

        case 400:
          switch (pattern873 (x2))
            {
            case 0:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8337; /* *cond_lslvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8340; /* *cond_lslvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8343; /* *cond_lslvnx4si_m */

            case 3:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8346; /* *cond_lslvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8349; /* *cond_lslvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8352; /* *cond_lslvnx4si_z */

            default:
              return -1;
            }

        case 401:
          switch (pattern873 (x2))
            {
            case 0:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8338; /* *cond_asrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8341; /* *cond_asrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8344; /* *cond_asrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8347; /* *cond_asrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8350; /* *cond_asrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8353; /* *cond_asrvnx4si_z */

            default:
              return -1;
            }

        case 402:
          switch (pattern873 (x2))
            {
            case 0:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8339; /* *cond_lsrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8342; /* *cond_lsrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8345; /* *cond_lsrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8348; /* *cond_lsrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8351; /* *cond_lsrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8354; /* *cond_lsrvnx4si_z */

            default:
              return -1;
            }

        case 125:
          return recog_253 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 4:
      return recog_268 (x1, insn, pnum_clobbers);

    case 5:
      return recog_267 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern605 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6716; /* *cond_qabsvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6806; /* *cond_qabsvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6725; /* *cond_qabsvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6815; /* *cond_qabsvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6734; /* *cond_qabsvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6824; /* *cond_qabsvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6743; /* *cond_qabsvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6833; /* *cond_qabsvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6752; /* *cond_qabsvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6842; /* *cond_qabsvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6761; /* *cond_qabsvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6851; /* *cond_qabsvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6770; /* *cond_qabsvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6860; /* *cond_qabsvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6779; /* *cond_qabsvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6869; /* *cond_qabsvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6788; /* *cond_qabsvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6878; /* *cond_qabsvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6797; /* *cond_qabsvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6887; /* *cond_qabsvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern796 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6287; /* maskstorevnx16qivnx16bi */

        case E_VNx8QImode:
          if (pattern796 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6288; /* maskstorevnx8qivnx8bi */

        case E_VNx4QImode:
          if (pattern796 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6289; /* maskstorevnx4qivnx4bi */

        case E_VNx2QImode:
          if (pattern796 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6290; /* maskstorevnx2qivnx2bi */

        case E_VNx8HImode:
          if (pattern796 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6291; /* maskstorevnx8hivnx8bi */

        case E_VNx4HImode:
          if (pattern796 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6292; /* maskstorevnx4hivnx4bi */

        case E_VNx2HImode:
          if (pattern796 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6293; /* maskstorevnx2hivnx2bi */

        case E_VNx4SImode:
          if (pattern796 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6294; /* maskstorevnx4sivnx4bi */

        case E_VNx2SImode:
          if (pattern796 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6295; /* maskstorevnx2sivnx2bi */

        case E_VNx2DImode:
          if (pattern796 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6296; /* maskstorevnx2divnx2bi */

        case E_VNx8HFmode:
          if (pattern796 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6297; /* maskstorevnx8hfvnx8bi */

        case E_VNx4HFmode:
          if (pattern796 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6298; /* maskstorevnx4hfvnx4bi */

        case E_VNx2HFmode:
          if (pattern796 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6299; /* maskstorevnx2hfvnx2bi */

        case E_VNx8BFmode:
          if (pattern796 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6300; /* maskstorevnx8bfvnx8bi */

        case E_VNx4BFmode:
          if (pattern796 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6301; /* maskstorevnx4bfvnx4bi */

        case E_VNx2BFmode:
          if (pattern796 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6302; /* maskstorevnx2bfvnx2bi */

        case E_VNx4SFmode:
          if (pattern796 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6303; /* maskstorevnx4sfvnx4bi */

        case E_VNx2SFmode:
          if (pattern796 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6304; /* maskstorevnx2sfvnx2bi */

        case E_VNx2DFmode:
          if (pattern796 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6305; /* maskstorevnx2dfvnx2bi */

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8QImode:
          if (pattern864 (x3, 
E_VNx8QImode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2349 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6330; /* aarch64_store_truncvnx8qivnx8hi */

        case E_VNx4QImode:
          if (pattern864 (x3, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6331; /* aarch64_store_truncvnx4qivnx4si */

        case E_VNx4HImode:
          if (pattern864 (x3, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6332; /* aarch64_store_truncvnx4hivnx4si */

        case E_VNx2QImode:
          if (pattern864 (x3, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6333; /* aarch64_store_truncvnx2qivnx2di */

        case E_VNx2HImode:
          if (pattern864 (x3, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6334; /* aarch64_store_truncvnx2hivnx2di */

        case E_VNx2SImode:
          if (pattern864 (x3, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6335; /* aarch64_store_truncvnx2sivnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern148 (x1))
    {
    case 0:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3519; /* aarch64_sqrdmlshv4hi */

    case 1:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3523; /* aarch64_sqrdmlshv8hi */

    case 2:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3527; /* aarch64_sqrdmlshv2si */

    case 3:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3531; /* aarch64_sqrdmlshv4si */

    case 4:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3533; /* aarch64_sqrdmlshhi */

    case 5:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3535; /* aarch64_sqrdmlshsi */

    case 6:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11816; /* aarch64_sve_sqrdmlshvnx16qi */

    case 7:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11824; /* aarch64_sve_sqrdmlshvnx8hi */

    case 8:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11832; /* aarch64_sve_sqrdmlshvnx4si */

    case 9:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11840; /* aarch64_sve_sqrdmlshvnx2di */

    case 10:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3539; /* aarch64_sqrdmlsh_lanev4hi */

    case 11:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3559; /* aarch64_sqrdmlsh_laneqv4hi */

    case 12:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3543; /* aarch64_sqrdmlsh_lanev8hi */

    case 13:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3563; /* aarch64_sqrdmlsh_laneqv8hi */

    case 14:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3547; /* aarch64_sqrdmlsh_lanev2si */

    case 15:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3567; /* aarch64_sqrdmlsh_laneqv2si */

    case 16:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3551; /* aarch64_sqrdmlsh_lanev4si */

    case 17:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3571; /* aarch64_sqrdmlsh_laneqv4si */

    case 18:
      if (!
#line 5677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3553; /* aarch64_sqrdmlsh_lanehi */

    case 19:
      if (!
#line 5715 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3573; /* aarch64_sqrdmlsh_laneqhi */

    case 20:
      if (!
#line 5677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3555; /* aarch64_sqrdmlsh_lanesi */

    case 21:
      if (!
#line 5715 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3575; /* aarch64_sqrdmlsh_laneqsi */

    case 22:
      if (!
#line 1468 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11842; /* aarch64_sve_sqrdmlsh_lane_vnx8hi */

    case 23:
      if (!
#line 1468 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11844; /* aarch64_sve_sqrdmlsh_lane_vnx4si */

    case 24:
      if (!
#line 1468 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11846; /* aarch64_sve_sqrdmlsh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9952; /* while_ltsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9962; /* while_ltdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9972; /* while_ltsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9982; /* while_ltdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9992; /* while_ltsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10002; /* while_ltdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10012; /* while_ltsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10022; /* while_ltdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern194 (x3, 
E_VNx16QImode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12793; /* aarch64_sve_tbxqvnx16qi */

    case E_VNx8HImode:
      if (pattern194 (x3, 
E_VNx8HImode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12795; /* aarch64_sve_tbxqvnx8hi */

    case E_VNx4SImode:
      if (pattern194 (x3, 
E_VNx4SImode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12797; /* aarch64_sve_tbxqvnx4si */

    case E_VNx2DImode:
      if (pattern194 (x3, 
E_VNx2DImode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12799; /* aarch64_sve_tbxqvnx2di */

    case E_VNx8BFmode:
      if (pattern791 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12801; /* aarch64_sve_tbxqvnx8bf */

    case E_VNx8HFmode:
      if (pattern791 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12803; /* aarch64_sve_tbxqvnx8hf */

    case E_VNx4SFmode:
      if (pattern791 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12805; /* aarch64_sve_tbxqvnx4sf */

    case E_VNx2DFmode:
      if (pattern791 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !(
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3190 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12807; /* aarch64_sve_tbxqvnx2df */

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1))
    {
    case 0:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10305; /* fold_extract_after_last_vnx16qi */

    case 1:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10307; /* fold_extract_after_last_vnx8hi */

    case 2:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10309; /* fold_extract_after_last_vnx4si */

    case 3:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10311; /* fold_extract_after_last_vnx2di */

    case 4:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10313; /* fold_extract_after_last_vnx8bf */

    case 5:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10315; /* fold_extract_after_last_vnx8hf */

    case 6:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10317; /* fold_extract_after_last_vnx4sf */

    case 7:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10319; /* fold_extract_after_last_vnx2df */

    case 8:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10321; /* aarch64_fold_extract_vector_after_last_vnx16qi */

    case 9:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10323; /* aarch64_fold_extract_vector_after_last_vnx8hi */

    case 10:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10325; /* aarch64_fold_extract_vector_after_last_vnx4si */

    case 11:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10327; /* aarch64_fold_extract_vector_after_last_vnx2di */

    case 12:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10329; /* aarch64_fold_extract_vector_after_last_vnx8bf */

    case 13:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10331; /* aarch64_fold_extract_vector_after_last_vnx8hf */

    case 14:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10333; /* aarch64_fold_extract_vector_after_last_vnx4sf */

    case 15:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10335; /* aarch64_fold_extract_vector_after_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3831; /* aarch64_usri_nv8qi */

    case 1:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3835; /* aarch64_usri_nv16qi */

    case 2:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3839; /* aarch64_usri_nv4hi */

    case 3:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3843; /* aarch64_usri_nv8hi */

    case 4:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3847; /* aarch64_usri_nv2si */

    case 5:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3851; /* aarch64_usri_nv4si */

    case 6:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3855; /* aarch64_usri_nv2di */

    case 7:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3859; /* aarch64_usri_ndi */

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12505; /* aarch64_sve_sqrdcmlah180vnx16qi */

    case 1:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12513; /* aarch64_sve_sqrdcmlah180vnx8hi */

    case 2:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12521; /* aarch64_sve_sqrdcmlah180vnx4si */

    case 3:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12529; /* aarch64_sve_sqrdcmlah180vnx2di */

    case 4:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12537; /* aarch64_sqrdcmlah180_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12545; /* aarch64_sqrdcmlah180_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern58 (x2, 
E_DImode, 
31, 
E_BLKmode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode)
      || !
#line 7880 "../../../gcc/config/aarch64/aarch64.md"
(REGNO (operands[0]) == INTVAL (operands[1])))
    return -1;
  return 1154; /* stack_tie */
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 3096 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12549; /* aarch64_sve_cdot180vnx4si */

    case 1:
      if (!
#line 3096 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12553; /* aarch64_sve_cdot180vnx2di */

    case 2:
      if (!
#line 3113 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12557; /* aarch64_cdot180_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12561; /* aarch64_cdot180_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern192 (x1))
    {
    case 0:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12431; /* aarch64_pred_smaxpvnx16qi */

    case 1:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12436; /* aarch64_pred_smaxpvnx8hi */

    case 2:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12441; /* aarch64_pred_smaxpvnx4si */

    case 3:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12446; /* aarch64_pred_smaxpvnx2di */

    default:
      return -1;
    }
}

 int
recog_384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern184 (x1, 
E_DImode))
    {
    case 0:
      if (!
#line 677 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11378; /* aarch64_sve_cntp_c8 */

    case 1:
      if (!
#line 677 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11379; /* aarch64_sve_cntp_c16 */

    case 2:
      if (!
#line 677 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11380; /* aarch64_sve_cntp_c32 */

    case 3:
      if (!
#line 677 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11381; /* aarch64_sve_cntp_c64 */

    default:
      return -1;
    }
}

 int
recog_392 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10117; /* while_rwsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10127; /* while_rwdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10137; /* while_rwsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10147; /* while_rwdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10157; /* while_rwsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10167; /* while_rwdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10177; /* while_rwsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10187; /* while_rwdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern218 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[1] = x4;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[0], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode)
                  || !
#line 557 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11342; /* aarch64_scatter_stntvnx4si */

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode)
                  || !
#line 557 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11344; /* aarch64_scatter_stntvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[0], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode)
                  || !
#line 557 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11343; /* aarch64_scatter_stntvnx2di */

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode)
                  || !
#line 557 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11345; /* aarch64_scatter_stntvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          switch (pattern1170 (x6, 
E_VNx4SImode, 
E_VNx4BImode))
            {
            case 0:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
                return -1;
              return 11346; /* aarch64_scatter_stnt_vnx4sivnx8qi */

            case 1:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
                return -1;
              return 11347; /* aarch64_scatter_stnt_vnx4sivnx4qi */

            case 2:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
                return -1;
              return 11348; /* aarch64_scatter_stnt_vnx4sivnx2qi */

            case 3:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
                return -1;
              return 11349; /* aarch64_scatter_stnt_vnx4sivnx4hi */

            case 4:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
                return -1;
              return 11350; /* aarch64_scatter_stnt_vnx4sivnx2hi */

            case 5:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
                return -1;
              return 11351; /* aarch64_scatter_stnt_vnx4sivnx2si */

            default:
              return -1;
            }

        case E_VNx2BImode:
          switch (pattern1170 (x6, 
E_VNx2DImode, 
E_VNx2BImode))
            {
            case 0:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
                return -1;
              return 11352; /* aarch64_scatter_stnt_vnx2divnx8qi */

            case 1:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
                return -1;
              return 11353; /* aarch64_scatter_stnt_vnx2divnx4qi */

            case 2:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
                return -1;
              return 11354; /* aarch64_scatter_stnt_vnx2divnx2qi */

            case 3:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
                return -1;
              return 11355; /* aarch64_scatter_stnt_vnx2divnx4hi */

            case 4:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
                return -1;
              return 11356; /* aarch64_scatter_stnt_vnx2divnx2hi */

            case 5:
              if (!
#line 574 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
                return -1;
              return 11357; /* aarch64_scatter_stnt_vnx2divnx2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern217 (x1))
    {
    case 0:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11277; /* aarch64_st1vnx32qi_strided2 */

    case 1:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11279; /* aarch64_st1vnx16hi_strided2 */

    case 2:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11281; /* aarch64_st1vnx8si_strided2 */

    case 3:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11283; /* aarch64_st1vnx4di_strided2 */

    case 4:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11285; /* aarch64_st1vnx16bf_strided2 */

    case 5:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11287; /* aarch64_st1vnx16hf_strided2 */

    case 6:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11289; /* aarch64_st1vnx8sf_strided2 */

    case 7:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11291; /* aarch64_st1vnx4df_strided2 */

    case 8:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11293; /* aarch64_st1vnx64qi_strided2 */

    case 9:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11295; /* aarch64_st1vnx32hi_strided2 */

    case 10:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11297; /* aarch64_st1vnx16si_strided2 */

    case 11:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11299; /* aarch64_st1vnx8di_strided2 */

    case 12:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11301; /* aarch64_st1vnx32bf_strided2 */

    case 13:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11303; /* aarch64_st1vnx32hf_strided2 */

    case 14:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11305; /* aarch64_st1vnx16sf_strided2 */

    case 15:
      if (!
#line 493 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11307; /* aarch64_st1vnx8df_strided2 */

    default:
      return -1;
    }
}

 int
recog_423 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern945 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6071 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8948; /* aarch64_pred_subvnx8hf */

    case E_VNx4SFmode:
      if (pattern945 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6071 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8949; /* aarch64_pred_subvnx4sf */

    case E_VNx2DFmode:
      if (pattern945 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6071 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8950; /* aarch64_pred_subvnx2df */

    case E_VNx8BFmode:
      if (pattern203 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 11790; /* aarch64_pred_subvnx8bf */

    default:
      return -1;
    }
}

 int
recog_431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern249 (x1))
    {
    case 0:
      if (!
#line 1429 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13674; /* aarch64_sme_smlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1429 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13678; /* aarch64_sme_smlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13690; /* aarch64_sme_smlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13694; /* aarch64_sme_smlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13698; /* aarch64_sme_smlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13702; /* aarch64_sme_smlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1557 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13802; /* aarch64_sme_smlsvnx2divnx8hi */

    case 7:
      if (!
#line 1587 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13810; /* aarch64_sme_smlsvnx2divnx16hi */

    case 8:
      if (!
#line 1587 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13814; /* aarch64_sme_smlsvnx2divnx32hi */

    case 9:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13722; /* aarch64_sme_single_smlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13726; /* aarch64_sme_single_smlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13730; /* aarch64_sme_single_smlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13734; /* aarch64_sme_single_smlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1618 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13826; /* aarch64_sme_single_smlsvnx2divnx16hi */

    case 14:
      if (!
#line 1618 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13830; /* aarch64_sme_single_smlsvnx2divnx32hi */

    case 15:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13754; /* aarch64_sme_lane_smlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13758; /* aarch64_sme_lane_smlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13762; /* aarch64_sme_lane_smlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13766; /* aarch64_sme_lane_smlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13770; /* aarch64_sme_lane_smlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13774; /* aarch64_sme_lane_smlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13842; /* aarch64_sme_lane_smlsvnx2divnx8hi */

    case 22:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13846; /* aarch64_sme_lane_smlsvnx2divnx16hi */

    case 23:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13850; /* aarch64_sme_lane_smlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1443 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13682; /* *aarch64_sme_smlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1443 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13686; /* *aarch64_sme_smlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1320 ())
            {
            case 0:
              if (
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13706; /* *aarch64_sme_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13710; /* *aarch64_sme_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1321 ())
        {
        case 0:
          if (!
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13714; /* *aarch64_sme_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13718; /* *aarch64_sme_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1571 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13806; /* *aarch64_sme_smlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1321 ())
        {
        case 0:
          if (!
#line 1601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13818; /* *aarch64_sme_smlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13822; /* *aarch64_sme_smlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1322 (x3))
            {
            case 0:
              if (
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13738; /* *aarch64_sme_single_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13742; /* *aarch64_sme_single_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern248 (x3))
        {
        case 0:
          if (!
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13746; /* *aarch64_sme_single_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13750; /* *aarch64_sme_single_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1633 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13834; /* *aarch64_sme_single_smlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1633 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13838; /* *aarch64_sme_single_smlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13778; /* *aarch64_sme_lane_smlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1360 (x3))
                {
                case 0:
                  if (
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13782; /* *aarch64_sme_lane_smlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13786; /* *aarch64_sme_lane_smlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13790; /* *aarch64_sme_lane_smlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1361 (x3))
        {
        case 0:
          if (!
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13794; /* *aarch64_sme_lane_smlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13798; /* *aarch64_sme_lane_smlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13854; /* *aarch64_sme_lane_smlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1361 (x3))
        {
        case 0:
          if (!
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13858; /* *aarch64_sme_lane_smlsvnx2divnx16hi */

        case 1:
          if (!
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13862; /* *aarch64_sme_lane_smlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern232 (x1))
    {
    case 0:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13271; /* aarch64_sme_write_horvnx32qivnx32qi */

    case 1:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13273; /* aarch64_sme_write_horvnx16hivnx16hi */

    case 2:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13275; /* aarch64_sme_write_horvnx8sivnx8si */

    case 3:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13277; /* aarch64_sme_write_horvnx4divnx4di */

    case 4:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13279; /* aarch64_sme_write_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13281; /* aarch64_sme_write_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13283; /* aarch64_sme_write_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13285; /* aarch64_sme_write_horvnx4dfvnx4df */

    case 8:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13287; /* aarch64_sme_write_horvnx64qivnx64qi */

    case 9:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13289; /* aarch64_sme_write_horvnx32hivnx32hi */

    case 10:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13291; /* aarch64_sme_write_horvnx16sivnx16si */

    case 11:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13293; /* aarch64_sme_write_horvnx8divnx8di */

    case 12:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13295; /* aarch64_sme_write_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13297; /* aarch64_sme_write_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13299; /* aarch64_sme_write_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13301; /* aarch64_sme_write_horvnx8dfvnx8df */

    case 16:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13303; /* *aarch64_sme_write_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13305; /* *aarch64_sme_write_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13307; /* *aarch64_sme_write_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13309; /* *aarch64_sme_write_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13311; /* *aarch64_sme_write_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13313; /* *aarch64_sme_write_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13315; /* *aarch64_sme_write_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13317; /* *aarch64_sme_write_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13319; /* *aarch64_sme_write_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13321; /* *aarch64_sme_write_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13323; /* *aarch64_sme_write_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13325; /* *aarch64_sme_write_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13327; /* *aarch64_sme_write_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13329; /* *aarch64_sme_write_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13331; /* *aarch64_sme_write_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13333; /* *aarch64_sme_write_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_446 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 282:
      if (pattern199 (x1) != 0
          || !
#line 9206 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5208; /* aarch64_sm3tt1aqv4si */

    case 283:
      if (pattern199 (x1) != 0
          || !
#line 9206 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5209; /* aarch64_sm3tt1bqv4si */

    case 284:
      if (pattern199 (x1) != 0
          || !
#line 9206 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5210; /* aarch64_sm3tt2aqv4si */

    case 285:
      if (pattern199 (x1) != 0
          || !
#line 9206 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5211; /* aarch64_sm3tt2bqv4si */

    case 591:
      return recog_399 (x1, insn, pnum_clobbers);

    case 194:
      return recog_420 (x1, insn, pnum_clobbers);

    case 459:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 10181 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5347; /* aarch64_fmlalbv8hf */

        case 1:
          if (!
#line 2091 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12008; /* aarch64_sve_add_fmlalbvnx8hf */

        case 2:
          if (!
#line 10196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5349; /* aarch64_fmlalb_lanev8hfv8qi */

        case 3:
          if (!
#line 10196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5351; /* aarch64_fmlalb_lanev8hfv16qi */

        default:
          return -1;
        }

    case 465:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 10181 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5348; /* aarch64_fmlaltv8hf */

        case 1:
          if (!
#line 2091 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12009; /* aarch64_sve_add_fmlaltvnx8hf */

        case 2:
          if (!
#line 10196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5350; /* aarch64_fmlalt_lanev8hfv8qi */

        case 3:
          if (!
#line 10196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5352; /* aarch64_fmlalt_lanev8hfv16qi */

        default:
          return -1;
        }

    case 460:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 10212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5353; /* aarch64_fmlallbbv4sf */

        case 1:
          if (!
#line 2106 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12010; /* aarch64_sve_add_fmlallbbvnx4sf */

        case 2:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5357; /* aarch64_fmlallbb_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5361; /* aarch64_fmlallbb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 461:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 10212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5354; /* aarch64_fmlallbtv4sf */

        case 1:
          if (!
#line 2106 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12011; /* aarch64_sve_add_fmlallbtvnx4sf */

        case 2:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5358; /* aarch64_fmlallbt_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5362; /* aarch64_fmlallbt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 462:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 10212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5355; /* aarch64_fmlalltbv4sf */

        case 1:
          if (!
#line 2106 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12012; /* aarch64_sve_add_fmlalltbvnx4sf */

        case 2:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5359; /* aarch64_fmlalltb_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5363; /* aarch64_fmlalltb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 463:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 10212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5356; /* aarch64_fmlallttv4sf */

        case 1:
          if (!
#line 2106 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12013; /* aarch64_sve_add_fmlallttvnx4sf */

        case 2:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5360; /* aarch64_fmlalltt_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5364; /* aarch64_fmlalltt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 127:
      return recog_397 (x1, insn, pnum_clobbers);

    case 391:
      return recog_413 (x1, insn, pnum_clobbers);

    case 353:
      switch (pattern204 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3388 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8495; /* aarch64_pred_famaxvnx8hf */

        case 1:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3388 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8499; /* aarch64_pred_famaxvnx4sf */

        case 2:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3388 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8503; /* aarch64_pred_famaxvnx2df */

        default:
          return -1;
        }

    case 354:
      switch (pattern204 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3389 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8496; /* aarch64_pred_faminvnx8hf */

        case 1:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3389 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8500; /* aarch64_pred_faminvnx4sf */

        case 2:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3389 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)))
            return -1;
          return 8504; /* aarch64_pred_faminvnx2df */

        default:
          return -1;
        }

    case 371:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8497; /* aarch64_pred_divvnx8hf */

        case 1:
          if (!
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8501; /* aarch64_pred_divvnx4sf */

        case 2:
          if (!
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8505; /* aarch64_pred_divvnx2df */

        default:
          return -1;
        }

    case 379:
      return recog_424 (x1, insn, pnum_clobbers);

    case 352:
      return recog_422 (x1, insn, pnum_clobbers);

    case 355:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8918; /* aarch64_pred_cadd90vnx8hf */

        case 1:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8920; /* aarch64_pred_cadd90vnx4sf */

        case 2:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8922; /* aarch64_pred_cadd90vnx2df */

        default:
          return -1;
        }

    case 356:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8919; /* aarch64_pred_cadd270vnx8hf */

        case 1:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8921; /* aarch64_pred_cadd270vnx4sf */

        case 2:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8923; /* aarch64_pred_cadd270vnx2df */

        default:
          return -1;
        }

    case 393:
      return recog_423 (x1, insn, pnum_clobbers);

    case 378:
      return recog_421 (x1, insn, pnum_clobbers);

    case 372:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9021; /* aarch64_pred_fmax_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9027; /* aarch64_pred_fmax_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9033; /* aarch64_pred_fmax_nanvnx2df */

        case 3:
          if (!
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11784; /* aarch64_pred_fmax_nanvnx8bf */

        default:
          return -1;
        }

    case 373:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9022; /* aarch64_pred_fmaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9028; /* aarch64_pred_fmaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9034; /* aarch64_pred_fmaxvnx2df */

        case 3:
          if (!
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11785; /* aarch64_pred_fmaxvnx8bf */

        default:
          return -1;
        }

    case 374:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9023; /* aarch64_pred_fmin_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9029; /* aarch64_pred_fmin_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9035; /* aarch64_pred_fmin_nanvnx2df */

        case 3:
          if (!
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11786; /* aarch64_pred_fmin_nanvnx8bf */

        default:
          return -1;
        }

    case 375:
      return recog_412 (x1, insn, pnum_clobbers);

    case 395:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9025; /* aarch64_pred_smaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9031; /* aarch64_pred_smaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9037; /* aarch64_pred_smaxvnx2df */

        case 3:
          if (!
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11791; /* aarch64_pred_smaxvnx8bf */

        case 4:
          if (!
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12477; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12479; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12481; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 396:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9026; /* aarch64_pred_sminvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9032; /* aarch64_pred_sminvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9038; /* aarch64_pred_sminvnx2df */

        case 3:
          if (!
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11792; /* aarch64_pred_sminvnx8bf */

        case 4:
          if (!
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12478; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12480; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))
            return -1;
          return 12482; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 579:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern229 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3281 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9414; /* aarch64_sve_bfdot_lanevnx4sf */

    case 580:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern229 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3282 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9415; /* aarch64_sve_bfmlalb_lanevnx4sf */

    case 581:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern229 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3283 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9416; /* aarch64_sve_bfmlalt_lanevnx4sf */

    case 582:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern229 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3284 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9417; /* aarch64_sve_bfmlslb_lanevnx4sf */

    case 583:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern229 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3285 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9418; /* aarch64_sve_bfmlslt_lanevnx4sf */

    case 357:
      switch (pattern214 (x1))
        {
        case 0:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10189; /* aarch64_pred_fcmeqvnx8hf */

        case 1:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10195; /* aarch64_pred_fcmeqvnx4sf */

        case 2:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10201; /* aarch64_pred_fcmeqvnx2df */

        default:
          return -1;
        }

    case 358:
      return recog_418 (x1, insn, pnum_clobbers);

    case 359:
      return recog_417 (x1, insn, pnum_clobbers);

    case 364:
      return recog_416 (x1, insn, pnum_clobbers);

    case 365:
      return recog_415 (x1, insn, pnum_clobbers);

    case 366:
      switch (pattern214 (x1))
        {
        case 0:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10194; /* aarch64_pred_fcmnevnx8hf */

        case 1:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10200; /* aarch64_pred_fcmnevnx4sf */

        case 2:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10206; /* aarch64_pred_fcmnevnx2df */

        default:
          return -1;
        }

    case 367:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern947 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 8528 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10207; /* aarch64_pred_fcmuovnx8hf */

        case E_VNx4BImode:
          if (pattern947 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 8528 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10208; /* aarch64_pred_fcmuovnx4sf */

        case E_VNx2BImode:
          if (pattern947 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 8528 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10209; /* aarch64_pred_fcmuovnx2df */

        default:
          return -1;
        }

    case 439:
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern877 (x2, 
E_VNx4SFmode, 
E_VNx8BFmode, 
E_VNx4BImode) != 0
              || !
#line 9901 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
            return -1;
          return 10906; /* aarch64_sve_cvtntvnx8bf */

        case E_VNx8HFmode:
          if (pattern877 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
              || !
#line 3233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12577; /* aarch64_sve_cvtntvnx8hf */

        case E_VNx4SFmode:
          if (pattern877 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
              || !
#line 3233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12578; /* aarch64_sve_cvtntvnx4sf */

        default:
          return -1;
        }

    case 120:
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 348 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11188; /* aarch64_gather_ld1q */

    case 122:
      return recog_414 (x1, insn, pnum_clobbers);

    case 541:
      return recog_411 (x1, insn, pnum_clobbers);

    case 542:
      return recog_410 (x1, insn, pnum_clobbers);

    case 622:
      if (pattern218 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!aarch64_reg_or_zero (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 530 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11341; /* aarch64_scatter_st1q */

    case 124:
      return recog_402 (x1, insn, pnum_clobbers);

    case 481:
      return recog_406 (x1, insn, pnum_clobbers);

    case 443:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 84
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx16QImode))
        return -1;
      switch (pattern1063 (x2))
        {
        case 0:
          if (!
#line 2162 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx8HFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12020; /* aarch64_sve_dotvnx8hf */

        case 1:
          if (!
#line 2162 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx4SFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12021; /* aarch64_sve_dotvnx4sf */

        default:
          return -1;
        }

    case 441:
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VNx4SFmode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DFmode)
          || !
#line 3323 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12582; /* aarch64_sve2_cvtxntvnx2df */

    case 136:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12641; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12649; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12657; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12665; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12642; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12650; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12658; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12666; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12643; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12651; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12659; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12667; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12644; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12652; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12660; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12668; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12645; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12653; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12661; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12669; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12646; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12654; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12662; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12670; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12647; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12655; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12663; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12671; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern219 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12648; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12656; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12664; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3681 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12672; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 632:
      return recog_405 (x1, insn, pnum_clobbers);

    case 695:
      return recog_419 (x1, insn, pnum_clobbers);

    case 699:
      return recog_404 (x1, insn, pnum_clobbers);

    case 701:
      return recog_403 (x1, insn, pnum_clobbers);

    case 650:
      return recog_401 (x1, insn, pnum_clobbers);

    case 651:
      return recog_400 (x1, insn, pnum_clobbers);

    case 679:
      return recog_407 (x1, insn, pnum_clobbers);

    case 703:
      return recog_398 (x1, insn, pnum_clobbers);

    case 633:
      return recog_426 (x1, insn, pnum_clobbers);

    case 663:
      return recog_425 (x1, insn, pnum_clobbers);

    case 639:
      return recog_409 (x1, insn, pnum_clobbers);

    case 646:
      return recog_408 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern614 (x2, 
E_SImode))
                {
                case 0:
                  return 216; /* *add_zero_extendqi_si */

                case 1:
                  return 220; /* *add_zero_extendhi_si */

                case 2:
                  return 224; /* *add_zero_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern614 (x2, 
E_DImode))
                {
                case 0:
                  return 218; /* *add_zero_extendqi_di */

                case 1:
                  return 222; /* *add_zero_extendhi_di */

                case 2:
                  return 226; /* *add_zero_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern615 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3065; /* aarch64_uaddwv8qi */

            case E_V4SImode:
              if (pattern615 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3067; /* aarch64_uaddwv4hi */

            case E_V2DImode:
              if (pattern615 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3069; /* aarch64_uaddwv2si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern291 (x2))
            {
            case 0:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3036; /* aarch64_uaddlv8qi */

            case 1:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3040; /* aarch64_uaddlv4hi */

            case 2:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3044; /* aarch64_uaddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SMAX:
          switch (pattern621 (x2, 
SMIN))
            {
            case 0:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1689; /* aarch64_sabalv8qi */

            case 1:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1691; /* aarch64_sabalv4hi */

            case 2:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1693; /* aarch64_sabalv2si */

            case 3:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1695; /* aarch64_sabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1697; /* aarch64_sabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1699; /* aarch64_sabal2v4si_insn */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern621 (x2, 
UMIN))
            {
            case 0:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1690; /* aarch64_uabalv8qi */

            case 1:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1692; /* aarch64_uabalv4hi */

            case 2:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1694; /* aarch64_uabalv2si */

            case 3:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1696; /* aarch64_uabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1698; /* aarch64_uabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1700; /* aarch64_uabal2v4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern616 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3012; /* aarch64_uaddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3024; /* aarch64_uaddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3016; /* aarch64_uaddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3028; /* aarch64_uaddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3020; /* aarch64_uaddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3032; /* aarch64_uaddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern618 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3071; /* aarch64_uaddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3077; /* aarch64_uaddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3073; /* aarch64_uaddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3079; /* aarch64_uaddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3075; /* aarch64_uaddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3081; /* aarch64_uaddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern385 (x2, 
E_DImode) != 0)
        return -1;
      switch (pattern327 (x2))
        {
        case 0:
          if (!
#line 10381 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10964; /* aarch64_sve_incdi_pat */

        case 1:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10998; /* *aarch64_sve_incdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11001; /* *aarch64_sve_incdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11004; /* *aarch64_sve_incdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11007; /* *aarch64_sve_incdivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_473 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      switch (pattern406 (x3))
        {
        case 0:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8178; /* *bicvnx16qi3 */

        case 1:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8179; /* *bicvnx8qi3 */

        case 2:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8180; /* *bicvnx4qi3 */

        case 3:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8181; /* *bicvnx2qi3 */

        case 4:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8182; /* *bicvnx8hi3 */

        case 5:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8183; /* *bicvnx4hi3 */

        case 6:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8184; /* *bicvnx2hi3 */

        case 7:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8185; /* *bicvnx4si3 */

        case 8:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8186; /* *bicvnx2si3 */

        case 9:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8187; /* *bicvnx2di3 */

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL
          || XINT (x4, 1) != 126)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x8))
        {
        case LT:
          switch (pattern957 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9759; /* *cmpltvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9769; /* *cmpltvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9799; /* *cmpltvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9779; /* *cmpltvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9809; /* *cmpltvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9829; /* *cmpltvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9789; /* *cmpltvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9819; /* *cmpltvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9839; /* *cmpltvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9849; /* *cmpltvnx2di_and */

            default:
              return -1;
            }

        case LE:
          switch (pattern957 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9760; /* *cmplevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9770; /* *cmplevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9800; /* *cmplevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9780; /* *cmplevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9810; /* *cmplevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9830; /* *cmplevnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9790; /* *cmplevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9820; /* *cmplevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9840; /* *cmplevnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9850; /* *cmplevnx2di_and */

            default:
              return -1;
            }

        case EQ:
          switch (pattern957 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9761; /* *cmpeqvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9771; /* *cmpeqvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9801; /* *cmpeqvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9781; /* *cmpeqvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9811; /* *cmpeqvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9831; /* *cmpeqvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9791; /* *cmpeqvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9821; /* *cmpeqvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9841; /* *cmpeqvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9851; /* *cmpeqvnx2di_and */

            default:
              return -1;
            }

        case NE:
          switch (pattern957 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9762; /* *cmpnevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9772; /* *cmpnevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9802; /* *cmpnevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9782; /* *cmpnevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9812; /* *cmpnevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9832; /* *cmpnevnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9792; /* *cmpnevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9822; /* *cmpnevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9842; /* *cmpnevnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9852; /* *cmpnevnx2di_and */

            default:
              return -1;
            }

        case GE:
          switch (pattern957 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9763; /* *cmpgevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9773; /* *cmpgevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9803; /* *cmpgevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9783; /* *cmpgevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9813; /* *cmpgevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9833; /* *cmpgevnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9793; /* *cmpgevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9823; /* *cmpgevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9843; /* *cmpgevnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9853; /* *cmpgevnx2di_and */

            default:
              return -1;
            }

        case GT:
          switch (pattern957 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9764; /* *cmpgtvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9774; /* *cmpgtvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9804; /* *cmpgtvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9784; /* *cmpgtvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9814; /* *cmpgtvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9834; /* *cmpgtvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9794; /* *cmpgtvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9824; /* *cmpgtvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9844; /* *cmpgtvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9854; /* *cmpgtvnx2di_and */

            default:
              return -1;
            }

        case LTU:
          switch (pattern958 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9765; /* *cmplovnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9775; /* *cmplovnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9805; /* *cmplovnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9785; /* *cmplovnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9815; /* *cmplovnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9835; /* *cmplovnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9795; /* *cmplovnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9825; /* *cmplovnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9845; /* *cmplovnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9855; /* *cmplovnx2di_and */

            default:
              return -1;
            }

        case LEU:
          switch (pattern958 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9766; /* *cmplsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9776; /* *cmplsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9806; /* *cmplsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9786; /* *cmplsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9816; /* *cmplsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9836; /* *cmplsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9796; /* *cmplsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9826; /* *cmplsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9846; /* *cmplsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9856; /* *cmplsvnx2di_and */

            default:
              return -1;
            }

        case GEU:
          switch (pattern958 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9767; /* *cmphsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9777; /* *cmphsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9807; /* *cmphsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9787; /* *cmphsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9817; /* *cmphsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9837; /* *cmphsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9797; /* *cmphsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9827; /* *cmphsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9847; /* *cmphsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9857; /* *cmphsvnx2di_and */

            default:
              return -1;
            }

        case GTU:
          switch (pattern958 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9768; /* *cmphivnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9778; /* *cmphivnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9808; /* *cmphivnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9788; /* *cmphivnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9818; /* *cmphivnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9838; /* *cmphivnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9798; /* *cmphivnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9828; /* *cmphivnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9848; /* *cmphivnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9858; /* *cmphivnx2di_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      switch (pattern409 (x3))
        {
        case 0:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10210; /* *fcmeqvnx8hf_and_combine */

        case 1:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10216; /* *fcmeqvnx4sf_and_combine */

        case 2:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10222; /* *fcmeqvnx2df_and_combine */

        case 3:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10211; /* *fcmgevnx8hf_and_combine */

        case 4:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10217; /* *fcmgevnx4sf_and_combine */

        case 5:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10223; /* *fcmgevnx2df_and_combine */

        case 6:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10212; /* *fcmgtvnx8hf_and_combine */

        case 7:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10218; /* *fcmgtvnx4sf_and_combine */

        case 8:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10224; /* *fcmgtvnx2df_and_combine */

        case 9:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10213; /* *fcmlevnx8hf_and_combine */

        case 10:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10219; /* *fcmlevnx4sf_and_combine */

        case 11:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10225; /* *fcmlevnx2df_and_combine */

        case 12:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10214; /* *fcmltvnx8hf_and_combine */

        case 13:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10220; /* *fcmltvnx4sf_and_combine */

        case 14:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10226; /* *fcmltvnx2df_and_combine */

        case 15:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10215; /* *fcmnevnx8hf_and_combine */

        case 16:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10221; /* *fcmnevnx4sf_and_combine */

        case 17:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10227; /* *fcmnevnx2df_and_combine */

        case 18:
          if (!
#line 8573 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10228; /* *fcmuovnx8hf_and_combine */

        case 19:
          if (!
#line 8573 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10229; /* *fcmuovnx4sf_and_combine */

        case 20:
          if (!
#line 8573 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10230; /* *fcmuovnx2df_and_combine */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern527 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1601; /* negv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1605; /* negv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1609; /* negv2si2_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2398; /* negv4hf2_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2402; /* negv2sf2_vec_concatz_be */

        default:
          return -1;
        }

    case LT:
      switch (pattern530 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4078; /* aarch64_cmltv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4098; /* aarch64_cmltv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4243; /* aarch64_cmltv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4118; /* aarch64_cmltv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4263; /* aarch64_cmltv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4298; /* aarch64_cmltdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4313; /* aarch64_facltv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4329; /* aarch64_facltv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4357; /* aarch64_facltdf_vec_concatz_be */

        default:
          return -1;
        }

    case LE:
      switch (pattern530 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4081; /* aarch64_cmlev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4101; /* aarch64_cmlev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4246; /* aarch64_cmlev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4121; /* aarch64_cmlev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4266; /* aarch64_cmlev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4301; /* aarch64_cmledf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4316; /* aarch64_faclev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4332; /* aarch64_faclev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4360; /* aarch64_facledf_vec_concatz_be */

        default:
          return -1;
        }

    case EQ:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      switch (pattern528 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4084; /* aarch64_cmeqv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4104; /* aarch64_cmeqv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4249; /* aarch64_cmeqv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4124; /* aarch64_cmeqv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4269; /* aarch64_cmeqv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4304; /* aarch64_cmeqdf_vec_concatz_be */

        default:
          return -1;
        }

    case GE:
      switch (pattern530 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4087; /* aarch64_cmgev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4107; /* aarch64_cmgev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4252; /* aarch64_cmgev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4127; /* aarch64_cmgev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4272; /* aarch64_cmgev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4307; /* aarch64_cmgedf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4319; /* aarch64_facgev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4335; /* aarch64_facgev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4363; /* aarch64_facgedf_vec_concatz_be */

        default:
          return -1;
        }

    case GT:
      switch (pattern530 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4090; /* aarch64_cmgtv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4110; /* aarch64_cmgtv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4255; /* aarch64_cmgtv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4130; /* aarch64_cmgtv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4275; /* aarch64_cmgtv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4310; /* aarch64_cmgtdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4322; /* aarch64_facgtv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4338; /* aarch64_facgtv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4366; /* aarch64_facgtdf_vec_concatz_be */

        default:
          return -1;
        }

    case LTU:
      switch (pattern532 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4153; /* aarch64_cmltuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4169; /* aarch64_cmltuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4185; /* aarch64_cmltuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case LEU:
      switch (pattern532 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4156; /* aarch64_cmleuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4172; /* aarch64_cmleuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4188; /* aarch64_cmleuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GEU:
      switch (pattern532 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4159; /* aarch64_cmgeuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4175; /* aarch64_cmgeuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4191; /* aarch64_cmgeuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GTU:
      switch (pattern532 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4162; /* aarch64_cmgtuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4178; /* aarch64_cmgtuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4194; /* aarch64_cmgtuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case NE:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7399 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 4240; /* *aarch64_cmtstdi_vec_concatz_be */

    default:
      return -1;
    }
}

 int
recog_499 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern672 (x2))
            {
            case 0:
              if (!
#line 1829 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2204; /* aarch64_xtn2v8hi_insn_le */

            case 1:
              if (!
#line 1829 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2205; /* aarch64_xtn2v4si_insn_le */

            case 2:
              if (!
#line 1829 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2206; /* aarch64_xtn2v2di_insn_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x6, 0);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  switch (pattern772 (x2))
                    {
                    case 0:
                      if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3190; /* aarch64_addhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3192; /* aarch64_addhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3194; /* aarch64_addhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern834 (x2))
                    {
                    case 0:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3196; /* aarch64_raddhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3198; /* aarch64_raddhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3200; /* aarch64_raddhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                case MINUS:
                  switch (pattern834 (x2))
                    {
                    case 0:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3197; /* aarch64_rsubhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3199; /* aarch64_rsubhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3201; /* aarch64_rsubhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern772 (x2))
                {
                case 0:
                  if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3191; /* aarch64_subhn2v8hi_insn_le */

                case 1:
                  if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3193; /* aarch64_subhn2v4si_insn_le */

                case 2:
                  if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3195; /* aarch64_subhn2v2di_insn_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern675 (x2))
                {
                case 0:
                  if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4014; /* aarch64_sshrn2_nv8hi_insn_le */

                case 1:
                  if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4020; /* aarch64_sshrn2_nv4si_insn_le */

                case 2:
                  if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4026; /* aarch64_sshrn2_nv2di_insn_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SMIN:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != SMAX)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x8 = XEXP (x6, 1);
              operands[3] = x8;
              x9 = XEXP (x5, 1);
              operands[4] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1085 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !
#line 5497 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3396; /* aarch64_sqxtun2v8hi_le */

                case E_V8HImode:
                  if (pattern1085 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !
#line 5497 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3397; /* aarch64_sqxtun2v4si_le */

                case E_V4SImode:
                  if (pattern1085 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 5497 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3398; /* aarch64_sqxtun2v2di_le */

                default:
                  return -1;
                }

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              operands[3] = x10;
              x11 = XEXP (x7, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[2] = x11;
                  x8 = XEXP (x6, 1);
                  operands[4] = x8;
                  x9 = XEXP (x5, 1);
                  operands[5] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1174 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V8HImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V8HImode)
                          || !
#line 7068 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4064; /* aarch64_sqshrun2_nv8hi_insn_le */

                    case E_V8HImode:
                      if (pattern1174 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V4SImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V4SImode)
                          || !
#line 7068 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4065; /* aarch64_sqshrun2_nv4si_insn_le */

                    case E_V4SImode:
                      if (pattern1174 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V2DImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V2DImode)
                          || !
#line 7068 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4066; /* aarch64_sqshrun2_nv2di_insn_le */

                    default:
                      return -1;
                    }

                case PLUS:
                  x12 = XEXP (x11, 0);
                  if (GET_CODE (x12) != SIGN_EXTEND)
                    return -1;
                  x13 = XEXP (x12, 0);
                  operands[2] = x13;
                  x14 = XEXP (x11, 1);
                  operands[4] = x14;
                  x8 = XEXP (x6, 1);
                  operands[5] = x8;
                  x9 = XEXP (x5, 1);
                  operands[6] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1237 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V8SImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V8SImode)
                          || !
#line 7130 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4070; /* aarch64_sqrshrun2_nv8hi_insn_le */

                    case E_V8HImode:
                      if (pattern1237 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V4DImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V4DImode)
                          || !
#line 7130 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4071; /* aarch64_sqrshrun2_nv4si_insn_le */

                    case E_V4SImode:
                      if (pattern1237 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V2TImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V2TImode)
                          || !
#line 7130 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4072; /* aarch64_sqrshrun2_nv2di_insn_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern674 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4015; /* aarch64_ushrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4021; /* aarch64_ushrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4027; /* aarch64_ushrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4048; /* aarch64_rshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4051; /* aarch64_rshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4054; /* aarch64_rshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 588
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V2SFmode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V2DFmode)
              || !
#line 3219 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2658; /* aarch64_float_trunc_rodd_hi_v4sf_le */

        case 3:
          if (XINT (x3, 1) != 188
              || GET_MODE (x3) != E_V8QImode)
            return -1;
          x16 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 84
              || GET_MODE (x16) != E_DImode
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x17 = XVECEXP (x3, 0, 1);
          operands[3] = x17;
          if (!register_operand (operands[3], E_V4SFmode)
              || !
#line 10118 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8 && !BYTES_BIG_ENDIAN))
            return -1;
          return 5328; /* aarch64_fcvtnv4sf_high_le */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern671 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 3264 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2666; /* aarch64_float_truncate_hi_v4sf_le */

        case E_V8HFmode:
          if (pattern671 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 3264 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2667; /* aarch64_float_truncate_hi_v8hf_le */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_494 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern773 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2990; /* *aarch64_combinezv8qi */

        case E_V8HImode:
          if (pattern773 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2991; /* *aarch64_combinezv4hi */

        case E_V8BFmode:
          if (pattern773 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2992; /* *aarch64_combinezv4bf */

        case E_V8HFmode:
          if (pattern773 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2993; /* *aarch64_combinezv4hf */

        case E_V4SImode:
          if (pattern773 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2994; /* *aarch64_combinezv2si */

        case E_V4SFmode:
          if (pattern773 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2995; /* *aarch64_combinezv2sf */

        case E_V2SImode:
          if (pattern773 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2996; /* *aarch64_combinezsi */

        case E_V2SFmode:
          if (pattern773 (x2, 
E_SFmode, 
E_V2SFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2997; /* *aarch64_combinezsf */

        case E_V2DImode:
          if (pattern773 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2998; /* *aarch64_combinezdi */

        case E_V2DFmode:
          if (pattern773 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2999; /* *aarch64_combinezdf */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern672 (x2))
            {
            case 0:
              if (!
#line 5411 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3372; /* aarch64_sqxtn2v8hi_le */

            case 1:
              if (!
#line 5411 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3374; /* aarch64_sqxtn2v4si_le */

            case 2:
              if (!
#line 5411 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3376; /* aarch64_sqxtn2v2di_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern674 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4010; /* aarch64_sqsshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4016; /* aarch64_sqsshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4022; /* aarch64_sqsshrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4046; /* aarch64_sqrshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4049; /* aarch64_sqrshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4052; /* aarch64_sqrshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern675 (x2))
            {
            case 0:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4011; /* aarch64_squshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4017; /* aarch64_squshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4023; /* aarch64_squshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern672 (x2))
            {
            case 0:
              if (!
#line 5411 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3373; /* aarch64_uqxtn2v8hi_le */

            case 1:
              if (!
#line 5411 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3375; /* aarch64_uqxtn2v4si_le */

            case 2:
              if (!
#line 5411 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3377; /* aarch64_uqxtn2v2di_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern675 (x2))
            {
            case 0:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4012; /* aarch64_uqsshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4018; /* aarch64_uqsshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4024; /* aarch64_uqsshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern674 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4013; /* aarch64_uqushrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4019; /* aarch64_uqushrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6942 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4025; /* aarch64_uqushrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4047; /* aarch64_uqrshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4050; /* aarch64_uqrshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6994 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4053; /* aarch64_uqrshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_508 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_472 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (!register_operand (x5, E_VNx16BImode))
        return -1;
      operands[1] = x5;
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 86
          && GET_MODE (x3) == E_VNx16BImode
          && 
#line 1162 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return 5732; /* aarch64_rdffr_z */
      operands[2] = x5;
      operands[1] = x3;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !
#line 6759 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9039; /* andvnx16bi3 */

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (pattern49 (x2))
            {
            case 0:
              return 531; /* and_ashlsi3 */

            case 1:
              return 546; /* and_ashldi3 */

            default:
              return -1;
            }

        case CONST_INT:
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern937 (x2, 
E_SImode) != 0
                  || !
#line 6647 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (SImode, operands[3], operands[2])))
                return -1;
              return 879; /* *andim_ashiftsi_bfiz */

            case E_DImode:
              if (pattern937 (x2, 
E_DImode) != 0
                  || !
#line 6647 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (DImode, operands[3], operands[2])))
                return -1;
              return 880; /* *andim_ashiftdi_bfiz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern50 (x2))
        {
        case 0:
          return 534; /* and_ashrsi3 */

        case 1:
          return 549; /* and_ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[2] = x7;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern492 (x2))
        {
        case 0:
          return 537; /* and_lshrsi3 */

        case 1:
          return 552; /* and_lshrdi3 */

        default:
          break;
        }
      if (XWINT (x7, 0) != 56L)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 176
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[2] = x11;
      if (!aarch64_granule16_simm9 (operands[2], E_DImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 8457 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1231; /* stg */

    case ROTATERT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern50 (x2))
        {
        case 0:
          return 540; /* and_rotrsi3 */

        case 1:
          return 555; /* and_rotrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern50 (x2))
        {
        case 0:
          return 543; /* and_rotlsi3 */

        case 1:
          return 558; /* and_rotldi3 */

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern716 (x2, 
E_SImode) != 0)
                return -1;
              return 589; /* andnsi3 */

            case E_DImode:
              if (pattern716 (x2, 
E_DImode) != 0)
                return -1;
              return 591; /* andndi3 */

            case E_V8QImode:
              if (pattern716 (x2, 
E_V8QImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1340; /* andnv8qi3 */

            case E_V16QImode:
              if (pattern716 (x2, 
E_V16QImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1343; /* andnv16qi3 */

            case E_V4HImode:
              if (pattern716 (x2, 
E_V4HImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1344; /* andnv4hi3 */

            case E_V8HImode:
              if (pattern716 (x2, 
E_V8HImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1347; /* andnv8hi3 */

            case E_V2SImode:
              if (pattern716 (x2, 
E_V2SImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1348; /* andnv2si3 */

            case E_V4SImode:
              if (pattern716 (x2, 
E_V4SImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1351; /* andnv4si3 */

            case E_V2DImode:
              if (pattern716 (x2, 
E_V2DImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1352; /* andnv2di3 */

            case E_VNx16BImode:
              if (pattern716 (x2, 
E_VNx16BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7338; /* *one_cmplvnx16bi3 */

            case E_VNx8BImode:
              if (pattern716 (x2, 
E_VNx8BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7339; /* *one_cmplvnx8bi3 */

            case E_VNx4BImode:
              if (pattern716 (x2, 
E_VNx4BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7340; /* *one_cmplvnx4bi3 */

            case E_VNx2BImode:
              if (pattern716 (x2, 
E_VNx2BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7341; /* *one_cmplvnx2bi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern371 (x2))
            {
            case 0:
              return 603; /* and_one_cmpl_ashlsi3 */

            case 1:
              return 618; /* and_one_cmpl_ashldi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern371 (x2))
            {
            case 0:
              return 606; /* and_one_cmpl_ashrsi3 */

            case 1:
              return 621; /* and_one_cmpl_ashrdi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern371 (x2))
            {
            case 0:
              return 609; /* and_one_cmpl_lshrsi3 */

            case 1:
              return 624; /* and_one_cmpl_lshrdi3 */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern371 (x2))
            {
            case 0:
              return 612; /* and_one_cmpl_rotrsi3 */

            case 1:
              return 627; /* and_one_cmpl_rotrdi3 */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern371 (x2))
            {
            case 0:
              return 615; /* and_one_cmpl_rotlsi3 */

            case 1:
              return 630; /* and_one_cmpl_rotldi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_473 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9043; /* aarch64_pred_andvnx16bi_z */

            case 1:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9046; /* aarch64_pred_andvnx8bi_z */

            case 2:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9049; /* aarch64_pred_andvnx4bi_z */

            case 3:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9052; /* aarch64_pred_andvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (pattern518 (x2))
                {
                case 0:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9079; /* aarch64_pred_bicvnx16bi_z */

                case 1:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9081; /* aarch64_pred_bicvnx8bi_z */

                case 2:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9083; /* aarch64_pred_bicvnx4bi_z */

                case 3:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9085; /* aarch64_pred_bicvnx2bi_z */

                case 4:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9103; /* aarch64_pred_norvnx16bi_z */

                case 5:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9105; /* aarch64_pred_norvnx8bi_z */

                case 6:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9107; /* aarch64_pred_norvnx4bi_z */

                case 7:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9109; /* aarch64_pred_norvnx2bi_z */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pnum_clobbers == NULL
                  || XVECLEN (x12, 0) != 4)
                return -1;
              x13 = XVECEXP (x12, 0, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x14 = XVECEXP (x12, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x12, 0, 2);
              operands[2] = x15;
              x16 = XVECEXP (x12, 0, 3);
              operands[3] = x16;
              x5 = XEXP (x2, 1);
              if (!rtx_equal_p (x5, operands[1]))
                return -1;
              switch (XINT (x12, 1))
                {
                case 357:
                  switch (pattern1137 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10231; /* *fcmeqvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10237; /* *fcmeqvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10243; /* *fcmeqvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10249; /* *fcmeqvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10255; /* *fcmeqvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10261; /* *fcmeqvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 358:
                  switch (pattern1137 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10232; /* *fcmgevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10238; /* *fcmgevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10244; /* *fcmgevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10250; /* *fcmgevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10256; /* *fcmgevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10262; /* *fcmgevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 359:
                  switch (pattern1137 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10233; /* *fcmgtvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10239; /* *fcmgtvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10245; /* *fcmgtvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10251; /* *fcmgtvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10257; /* *fcmgtvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10263; /* *fcmgtvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 364:
                  switch (pattern1137 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10234; /* *fcmlevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10240; /* *fcmlevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10246; /* *fcmlevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10252; /* *fcmlevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10258; /* *fcmlevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10264; /* *fcmlevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 365:
                  switch (pattern1137 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10235; /* *fcmltvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10241; /* *fcmltvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10247; /* *fcmltvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10253; /* *fcmltvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10259; /* *fcmltvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10265; /* *fcmltvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 366:
                  switch (pattern1137 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10236; /* *fcmnevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10242; /* *fcmnevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10248; /* *fcmnevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10254; /* *fcmnevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10260; /* *fcmnevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10266; /* *fcmnevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 367:
                  x7 = XEXP (x3, 1);
                  switch (GET_CODE (x7))
                    {
                    case REG:
                    case SUBREG:
                      operands[4] = x7;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1230 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8678 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10267; /* *fcmuovnx8hf_bic_combine */

                        case E_VNx4BImode:
                          if (pattern1230 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8678 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10268; /* *fcmuovnx4sf_bic_combine */

                        case E_VNx2BImode:
                          if (pattern1230 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8678 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10269; /* *fcmuovnx2df_bic_combine */

                        default:
                          return -1;
                        }

                    case NOT:
                      x17 = XEXP (x7, 0);
                      operands[4] = x17;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1231 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10270; /* *fcmuovnx8hf_nor_combine */

                        case E_VNx4BImode:
                          if (pattern1231 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10271; /* *fcmuovnx4sf_nor_combine */

                        case E_VNx2BImode:
                          if (pattern1231 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10272; /* *fcmuovnx2df_nor_combine */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern301 (x2, 
E_VNx16BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9044; /* aarch64_pred_iorvnx16bi_z */

            case E_VNx8BImode:
              if (pattern301 (x2, 
E_VNx8BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9047; /* aarch64_pred_iorvnx8bi_z */

            case E_VNx4BImode:
              if (pattern301 (x2, 
E_VNx4BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9050; /* aarch64_pred_iorvnx4bi_z */

            case E_VNx2BImode:
              if (pattern301 (x2, 
E_VNx2BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9053; /* aarch64_pred_iorvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          switch (pattern518 (x2))
            {
            case 0:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9080; /* aarch64_pred_ornvnx16bi_z */

            case 1:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9082; /* aarch64_pred_ornvnx8bi_z */

            case 2:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9084; /* aarch64_pred_ornvnx4bi_z */

            case 3:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9086; /* aarch64_pred_ornvnx2bi_z */

            case 4:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9104; /* aarch64_pred_nandvnx16bi_z */

            case 5:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9106; /* aarch64_pred_nandvnx8bi_z */

            case 6:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9108; /* aarch64_pred_nandvnx4bi_z */

            case 7:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9110; /* aarch64_pred_nandvnx2bi_z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern302 (x2))
        {
        case 0:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9045; /* aarch64_pred_xorvnx16bi_z */

        case 1:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9048; /* aarch64_pred_xorvnx8bi_z */

        case 2:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9051; /* aarch64_pred_xorvnx4bi_z */

        case 3:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9054; /* aarch64_pred_xorvnx2bi_z */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern309 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern755 (x3, 
E_SImode) == 0
                  && 
#line 7385 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1083; /* *aarch64_sminsi3_cssc */
              break;

            case E_DImode:
              if (pattern755 (x3, 
E_DImode) == 0
                  && 
#line 7385 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1087; /* *aarch64_smindi3_cssc */
              break;

            case E_SFmode:
              if (pattern31 (x3, 
E_SFmode) == 0
                  && 
#line 7419 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1096; /* sminsf3 */
              break;

            case E_DFmode:
              if (pattern31 (x3, 
E_DFmode) == 0
                  && 
#line 7419 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1097; /* smindf3 */
              break;

            case E_V8QImode:
              if (pattern31 (x3, 
E_V8QImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2075; /* sminv8qi3 */
              break;

            case E_V16QImode:
              if (pattern31 (x3, 
E_V16QImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2085; /* sminv16qi3 */
              break;

            case E_V4HImode:
              if (pattern31 (x3, 
E_V4HImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2091; /* sminv4hi3 */
              break;

            case E_V8HImode:
              if (pattern31 (x3, 
E_V8HImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2101; /* sminv8hi3 */
              break;

            case E_V2SImode:
              if (pattern31 (x3, 
E_V2SImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2107; /* sminv2si3 */
              break;

            case E_V4SImode:
              if (pattern31 (x3, 
E_V4SImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2117; /* sminv4si3 */
              break;

            case E_V4HFmode:
              if (pattern31 (x3, 
E_V4HFmode) == 0
                  && (
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2671; /* sminv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern31 (x3, 
E_V8HFmode) == 0
                  && (
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2673; /* sminv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern31 (x3, 
E_V2SFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2675; /* sminv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern31 (x3, 
E_V4SFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2677; /* sminv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern31 (x3, 
E_V2DFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2679; /* sminv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern32 (x3, 
E_VNx32QImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11391; /* *sminvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern32 (x3, 
E_VNx16HImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11395; /* *sminvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern32 (x3, 
E_VNx8SImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11399; /* *sminvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern32 (x3, 
E_VNx4DImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11403; /* *sminvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern32 (x3, 
E_VNx64QImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11407; /* *sminvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern32 (x3, 
E_VNx32HImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11411; /* *sminvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern32 (x3, 
E_VNx16SImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11415; /* *sminvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern32 (x3, 
E_VNx8DImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11419; /* *sminvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1091; /* *aarch64_sminsi3_zero */

            case 1:
              return 1093; /* *aarch64_smindi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7399; /* *post_ra_sminvnx16qi3 */

        case 2:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7404; /* *post_ra_sminvnx8qi3 */

        case 3:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7409; /* *post_ra_sminvnx4qi3 */

        case 4:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7414; /* *post_ra_sminvnx2qi3 */

        case 5:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7419; /* *post_ra_sminvnx8hi3 */

        case 6:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7424; /* *post_ra_sminvnx4hi3 */

        case 7:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7429; /* *post_ra_sminvnx2hi3 */

        case 8:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7434; /* *post_ra_sminvnx4si3 */

        case 9:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7439; /* *post_ra_sminvnx2si3 */

        case 10:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7444; /* *post_ra_sminvnx2di3 */

        case 11:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7449; /* *post_ra_sminv2di3 */

        case 12:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11424; /* aarch64_sve_single_sminvnx32qi */

        case 13:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11429; /* aarch64_sve_single_sminvnx16hi */

        case 14:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11434; /* aarch64_sve_single_sminvnx8si */

        case 15:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11439; /* aarch64_sve_single_sminvnx4di */

        case 16:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11444; /* aarch64_sve_single_sminvnx64qi */

        case 17:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11449; /* aarch64_sve_single_sminvnx32hi */

        case 18:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11454; /* aarch64_sve_single_sminvnx16si */

        case 19:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11459; /* aarch64_sve_single_sminvnx8di */

        default:
          return -1;
        }

    case SMAX:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[1] = x9;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern962 (x3, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6814 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3995; /* aarch64_sqshrun_nhi_insn */

                case 65535L:
                  if (pattern962 (x3, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6814 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3996; /* aarch64_sqshrun_nsi_insn */

                case 4294967295L:
                  if (pattern962 (x3, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6814 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3997; /* aarch64_sqshrun_ndi_insn */

                default:
                  return -1;
                }

            case PLUS:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != SIGN_EXTEND)
                return -1;
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 1);
              operands[3] = x12;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern1073 (x3, 
E_SImode, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6885 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4007; /* aarch64_sqrshrun_nhi_insn */

                case 65535L:
                  if (pattern1073 (x3, 
E_DImode, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6885 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4008; /* aarch64_sqrshrun_nsi_insn */

                case 4294967295L:
                  if (!register_operand (operands[0], E_TImode)
                      || GET_MODE (x3) != E_TImode
                      || GET_MODE (x4) != E_TImode
                      || pattern1072 (x6, 
E_TImode, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6885 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4009; /* aarch64_sqrshrun_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern313 (x3))
            {
            case 0:
              if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11510; /* aarch64_sve_sclampvnx16qi */

            case 1:
              if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11512; /* aarch64_sve_sclampvnx8hi */

            case 2:
              if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11514; /* aarch64_sve_sclampvnx4si */

            case 3:
              if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11516; /* aarch64_sve_sclampvnx2di */

            case 4:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11526; /* aarch64_sve_sclamp_singlevnx32qi */

            case 5:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11528; /* aarch64_sve_sclamp_singlevnx16hi */

            case 6:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11530; /* aarch64_sve_sclamp_singlevnx8si */

            case 7:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11532; /* aarch64_sve_sclamp_singlevnx4di */

            case 8:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11534; /* aarch64_sve_sclamp_singlevnx64qi */

            case 9:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11536; /* aarch64_sve_sclamp_singlevnx32hi */

            case 10:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11538; /* aarch64_sve_sclamp_singlevnx16si */

            case 11:
              if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11540; /* aarch64_sve_sclamp_singlevnx8di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern310 (x3))
        {
        case 0:
          if (!(
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5292; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5294; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5296; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5298; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5300; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      res = recog_474 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
          || !
#line 6675 "../../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
        return -1;
      return 883; /* *ashiftsi_extvdi_bfiz */

    case SIGN_EXTEND:
      switch (pattern307 (x3))
        {
        case 0:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 867; /* *extendqi_shft_si */

        case 1:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 871; /* *extendhi_shft_si */

        case 2:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 875; /* *extendsi_shft_si */

        case 3:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 869; /* *extendqi_shft_di */

        case 4:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 873; /* *extendhi_shft_di */

        case 5:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 877; /* *extendsi_shft_di */

        case 6:
          if (!
#line 6534 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3782; /* aarch64_sshllv8qi */

        case 7:
          if (!
#line 6534 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3784; /* aarch64_sshllv4hi */

        case 8:
          if (!
#line 6534 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3786; /* aarch64_sshllv2si */

        case 9:
          if (!
#line 6566 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3788; /* aarch64_sshll2v16qi */

        case 10:
          if (!
#line 6566 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3790; /* aarch64_sshll2v8hi */

        case 11:
          if (!
#line 6566 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3792; /* aarch64_sshll2v4si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern307 (x3))
        {
        case 0:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 868; /* *zero_extendqi_shft_si */

        case 1:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 872; /* *zero_extendhi_shft_si */

        case 2:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 876; /* *zero_extendsi_shft_si */

        case 3:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 870; /* *zero_extendqi_shft_di */

        case 4:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 874; /* *zero_extendhi_shft_di */

        case 5:
          if (!
#line 6630 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 878; /* *zero_extendsi_shft_di */

        case 6:
          if (!
#line 6534 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3783; /* aarch64_ushllv8qi */

        case 7:
          if (!
#line 6534 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3785; /* aarch64_ushllv4hi */

        case 8:
          if (!
#line 6534 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3787; /* aarch64_ushllv2si */

        case 9:
          if (!
#line 6566 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3789; /* aarch64_ushll2v16qi */

        case 10:
          if (!
#line 6566 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3791; /* aarch64_ushll2v8hi */

        case 11:
          if (!
#line 6566 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3793; /* aarch64_ushll2v4si */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x10 = XEXP (x4, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern334 (x3, 
E_VOIDmode, 
E_SImode) != 0
              || !aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
              || !
#line 6660 "../../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 881; /* *ashiftsi_extv_bfiz */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_simd_shift_imm_offset_di (operands[2], E_VOIDmode)
              || !aarch64_simd_shift_imm_di (operands[3], E_VOIDmode)
              || !
#line 6660 "../../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 882; /* *ashiftdi_extv_bfiz */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 7347 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1076; /* *sqrthf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 7347 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1077; /* *sqrtsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 7347 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1078; /* *sqrtdf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 7550 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 4384; /* *sqrtv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 7550 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 4387; /* *sqrtv8hf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 7550 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4388; /* *sqrtv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 7550 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4391; /* *sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 7550 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4392; /* *sqrtv2df2 */

    default:
      return -1;
    }
}

 int
recog_547 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10178; /* while_wrsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10188; /* while_wrdivnx2bi_ptest */
}

 int
recog_549 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10138; /* while_wrsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10148; /* while_wrdivnx8bi_ptest */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10078; /* *while_wrsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10088; /* *while_wrdivnx4bi_cc */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10157; /* while_rwsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10167; /* while_rwdivnx4bi_ptest */
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10176; /* while_ugesivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10186; /* while_ugedivnx2bi_ptest */
}

 int
recog_571 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10175; /* while_ugtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10185; /* while_ugtdivnx2bi_ptest */
}

 int
recog_581 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10134; /* while_gtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10144; /* while_gtdivnx8bi_ptest */
}

 int
recog_591 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10093; /* *while_gesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10103; /* *while_gedivnx2bi_cc */
}

 int
recog_601 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern684 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9958; /* while_wrsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9968; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9978; /* while_wrsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9988; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9998; /* while_wrsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10008; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10018; /* while_wrsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10028; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_606 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XINT (x4, 1))
    {
    case 126:
      return recog_600 (x1, insn, pnum_clobbers);

    case 140:
      switch (pattern684 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9949; /* while_lesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9959; /* while_ledivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9969; /* while_lesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9979; /* while_ledivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9989; /* while_lesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9999; /* while_ledivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10009; /* while_lesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10019; /* while_ledivnx2bi */

        default:
          return -1;
        }

    case 141:
      switch (pattern684 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9950; /* while_ultsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9960; /* while_ultdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9970; /* while_ultsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9980; /* while_ultdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9990; /* while_ultsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10000; /* while_ultdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10010; /* while_ultsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10020; /* while_ultdivnx2bi */

        default:
          return -1;
        }

    case 142:
      switch (pattern684 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9951; /* while_ulesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9961; /* while_uledivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9971; /* while_ulesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9981; /* while_uledivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9991; /* while_ulesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10001; /* while_uledivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10011; /* while_ulesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10021; /* while_uledivnx2bi */

        default:
          return -1;
        }

    case 143:
      switch (pattern684 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9952; /* while_ltsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9962; /* while_ltdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9972; /* while_ltsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9982; /* while_ltdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9992; /* while_ltsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10002; /* while_ltdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10012; /* while_ltsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10022; /* while_ltdivnx2bi */

        default:
          return -1;
        }

    case 136:
      switch (pattern684 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9953; /* while_gesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9963; /* while_gedivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9973; /* while_gesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9983; /* while_gedivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9993; /* while_gesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10003; /* while_gedivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10013; /* while_gesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10023; /* while_gedivnx2bi */

        default:
          return -1;
        }

    case 137:
      switch (pattern684 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9954; /* while_gtsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9964; /* while_gtdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9974; /* while_gtsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9984; /* while_gtdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9994; /* while_gtsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10004; /* while_gtdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10014; /* while_gtsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10024; /* while_gtdivnx2bi */

        default:
          return -1;
        }

    case 138:
      return recog_604 (x1, insn, pnum_clobbers);

    case 139:
      return recog_603 (x1, insn, pnum_clobbers);

    case 144:
      return recog_602 (x1, insn, pnum_clobbers);

    case 145:
      return recog_601 (x1, insn, pnum_clobbers);

    case 305:
      switch (pattern686 (x1))
        {
        case 0:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 8))
            return -1;
          return 10939; /* aarch64_sve_pfirstvnx16bi */

        case 1:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
            return -1;
          return 10941; /* aarch64_sve_pfirstvnx8bi */

        case 2:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
            return -1;
          return 10943; /* aarch64_sve_pfirstvnx4bi */

        case 3:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
            return -1;
          return 10945; /* aarch64_sve_pfirstvnx2bi */

        default:
          return -1;
        }

    case 306:
      switch (pattern686 (x1))
        {
        case 0:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
            return -1;
          return 10940; /* aarch64_sve_pnextvnx16bi */

        case 1:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return -1;
          return 10942; /* aarch64_sve_pnextvnx8bi */

        case 2:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return -1;
          return 10944; /* aarch64_sve_pnextvnx4bi */

        case 3:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return -1;
          return 10946; /* aarch64_sve_pnextvnx2bi */

        default:
          return -1;
        }

    case 471:
      switch (pattern688 (x1, 
471))
        {
        case 0:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11156; /* aarch64_ld1vnx32qi_strided2 */

        case 1:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11158; /* aarch64_ld1vnx16hi_strided2 */

        case 2:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11160; /* aarch64_ld1vnx8si_strided2 */

        case 3:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11162; /* aarch64_ld1vnx4di_strided2 */

        case 4:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11164; /* aarch64_ld1vnx16bf_strided2 */

        case 5:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11166; /* aarch64_ld1vnx16hf_strided2 */

        case 6:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11168; /* aarch64_ld1vnx8sf_strided2 */

        case 7:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11170; /* aarch64_ld1vnx4df_strided2 */

        default:
          return -1;
        }

    case 472:
      switch (pattern688 (x1, 
472))
        {
        case 0:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11157; /* aarch64_ldnt1vnx32qi_strided2 */

        case 1:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11159; /* aarch64_ldnt1vnx16hi_strided2 */

        case 2:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11161; /* aarch64_ldnt1vnx8si_strided2 */

        case 3:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11163; /* aarch64_ldnt1vnx4di_strided2 */

        case 4:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11165; /* aarch64_ldnt1vnx16bf_strided2 */

        case 5:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11167; /* aarch64_ldnt1vnx16hf_strided2 */

        case 6:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11169; /* aarch64_ldnt1vnx8sf_strided2 */

        case 7:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11171; /* aarch64_ldnt1vnx4df_strided2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_622 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      if (pattern37 (x1) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      switch (pattern1155 (x3))
        {
        case 0:
          return 63; /* *call_insn */

        case 1:
          if (!
#line 1412 "../../../gcc/config/aarch64/aarch64.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 65; /* *sibcall_insn */

        default:
          return -1;
        }

    case SET:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CALL:
          if (pattern352 (x1) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          res = recog_617 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XEXP (x4, 0);
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != UNSPEC
              || pattern980 (x2) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (pattern368 (x3, 
30, 
CLOBBER, 
E_DImode) != 0)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[0] = x8;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XVECEXP (x9, 0, 0);
          operands[1] = x10;
          if (!const_int_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (GET_MODE (x7) != E_SImode
                  || !(
#line 7869 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1152; /* tlsdesc_small_sve_si */

            case E_DImode:
              if (GET_MODE (x7) != E_DImode
                  || !(
#line 7869 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1153; /* tlsdesc_small_sve_di */

            default:
              return -1;
            }

        case PLUS:
          if (!pmode_plus_operator (x4, E_VOIDmode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != SET)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!pmode_register_operand (operands[1], E_VOIDmode))
            return -1;
          x11 = XEXP (x4, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          x12 = XEXP (x9, 1);
          if (memory_operand (x12, E_VOIDmode))
            {
              res = recog_618 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          operands[6] = x13;
          if (aarch64_mem_pair_operator (operands[6], E_TImode))
            {
              res = recog_619 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != MEM)
            return -1;
          x15 = XEXP (x14, 0);
          if (!pmode_plus_operator (x15, E_VOIDmode))
            return -1;
          operands[2] = x12;
          x16 = XEXP (x3, 1);
          operands[3] = x16;
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[0]))
            return -1;
          x18 = XEXP (x13, 0);
          switch (GET_CODE (x18))
            {
            case PLUS:
              operands[8] = x18;
              if (!pmode_plus_operator (operands[8], E_VOIDmode))
                return -1;
              operands[6] = x4;
              operands[7] = x13;
              operands[9] = x14;
              if (aarch64_mem_pair_operator (operands[9], E_SImode)
                  && pattern1351 (x1, 
E_SImode) == 0
                  && 
#line 2236 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (SImode))
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return 100; /* *storewb_pre_pair_4 */
              if (aarch64_mem_pair_operator (operands[9], E_DImode)
                  && pattern1351 (x1, 
E_DImode) == 0
                  && 
#line 2236 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (DImode))
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return 101; /* *storewb_pre_pair_8 */
              if (!aarch64_mem_pair_operator (operands[9], E_TImode)
                  || !aarch64_mem_pair_operator (operands[7], E_TImode)
                  || !aarch64_ldp_reg_operand (operands[2], E_TImode))
                return -1;
              operands[10] = x15;
              x19 = XEXP (x15, 1);
              operands[5] = x19;
              if (!const_int_operand (operands[5], E_VOIDmode)
                  || !aarch64_ldp_reg_operand (operands[3], E_TImode))
                return -1;
              x20 = XEXP (x18, 0);
              if (!rtx_equal_p (x20, operands[0]))
                return -1;
              x21 = XEXP (x18, 1);
              if (!rtx_equal_p (x21, operands[4])
                  || !
#line 2266 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && aarch64_mem_pair_offset (operands[4], TImode)
   && known_eq (INTVAL (operands[5]), INTVAL (operands[4]) + 16)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return -1;
              return 102; /* *storewb_pre_pair_16 */

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x15, 1);
              if (GET_CODE (x19) != CONST_INT)
                return -1;
              operands[5] = x4;
              operands[6] = x13;
              if (!aarch64_stp_reg_operand (operands[2], E_VOIDmode))
                return -1;
              operands[7] = x14;
              operands[8] = x15;
              if (!aarch64_stp_reg_operand (operands[3], E_VOIDmode))
                return -1;
              switch (XWINT (x19, 0))
                {
                case 4L:
                  if (!aarch64_mem_pair_operator (operands[6], E_SImode)
                      || !aarch64_mem_pair_operator (operands[7], E_SImode)
                      || !
#line 2290 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                    return -1;
                  return 103; /* *storewb_post_pair_4 */

                case 8L:
                  if (!aarch64_mem_pair_operator (operands[6], E_DImode)
                      || !aarch64_mem_pair_operator (operands[7], E_DImode)
                      || !
#line 2290 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                    return -1;
                  return 104; /* *storewb_post_pair_8 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 109
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 66
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x22 = XVECEXP (x4, 0, 0);
          operands[0] = x22;
          x23 = XVECEXP (x4, 0, 1);
          operands[1] = x23;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          x14 = XEXP (x3, 0);
          operands[3] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1252 (
E_SImode) != 0
                  || !
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
                return -1;
              return 1173; /* stack_protect_test_si */

            case E_DImode:
              if (pattern1252 (
E_DImode) != 0
                  || !
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
                return -1;
              return 1174; /* stack_protect_test_di */

            default:
              return -1;
            }

        case SS_PLUS:
          switch (pattern354 (x1))
            {
            case 0:
              return 3302; /* aarch64_ssaddsi3 */

            case 1:
              return 3304; /* aarch64_ssadddi3 */

            default:
              return -1;
            }

        case SS_MINUS:
          switch (pattern354 (x1))
            {
            case 0:
              return 3303; /* aarch64_sssubsi3 */

            case 1:
              return 3305; /* aarch64_sssubdi3 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (pnum_clobbers == NULL
              || pattern359 (x4, 
E_CCmode, 
27) != 0
              || pattern710 (x1, 
SET, 
E_CCmode) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != SET)
            return -1;
          x16 = XEXP (x3, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 5
              || XINT (x16, 1) != 27)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x9, 0);
          operands[0] = x13;
          x24 = XVECEXP (x16, 0, 0);
          operands[2] = x24;
          x25 = XVECEXP (x16, 0, 1);
          operands[3] = x25;
          x26 = XVECEXP (x16, 0, 2);
          operands[4] = x26;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          x27 = XVECEXP (x16, 0, 3);
          operands[5] = x27;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x28 = XVECEXP (x16, 0, 4);
          operands[6] = x28;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          switch (pattern565 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 5365; /* aarch64_compare_and_swapqi */

            case 1:
              *pnum_clobbers = 1;
              return 5366; /* aarch64_compare_and_swaphi */

            case 2:
              *pnum_clobbers = 1;
              return 5367; /* aarch64_compare_and_swapsi */

            case 3:
              *pnum_clobbers = 1;
              return 5368; /* aarch64_compare_and_swapdi */

            case 4:
              *pnum_clobbers = 1;
              return 5369; /* aarch64_compare_and_swapti */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L
              || pattern451 (x1, 
91, 
USE, 
90, 
E_DImode, 
89) != 0)
            return -1;
          return 12929; /* aarch64_smstart_za */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8QImode:
      switch (pattern574 (x3, 
E_VNx8QImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1068 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1074 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1080 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1086 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1092 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1098 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx4QImode:
      switch (pattern574 (x3, 
E_VNx4QImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1069 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1075 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1081 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1087 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1093 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1099 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2QImode:
      switch (pattern574 (x3, 
E_VNx2QImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1070 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1076 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1082 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1088 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1094 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1100 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx4HImode:
      switch (pattern574 (x3, 
E_VNx4HImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1071 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1077 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1083 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1089 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1095 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1101 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2HImode:
      switch (pattern574 (x3, 
E_VNx2HImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1072 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1078 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1084 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1090 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1096 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1102 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2SImode:
      switch (pattern574 (x3, 
E_VNx2SImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1073 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1079 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1085 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1091 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1097 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1103 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern865 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1134 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1167 (insn, operands);

    case E_VNx4SFmode:
      if (pattern865 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1145 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1178 (insn, operands);

    case E_VNx2DFmode:
      if (pattern865 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1156 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1189 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern865 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1133 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1166 (insn, operands);

    case E_VNx4SFmode:
      if (pattern865 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1144 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1177 (insn, operands);

    case E_VNx2DFmode:
      if (pattern865 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1155 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1188 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2944 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2952 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1294 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2960 (insn, operands);
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2943 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2951 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1294 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2959 (insn, operands);
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2825 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2870 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2910 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2812 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2859 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2899 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2846 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2887 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2927 (insn, operands);
}

 rtx_insn *
split_37 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2833 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2876 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2916 (insn, operands);
}

 rtx_insn *
split_42 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2819 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2865 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2905 (insn, operands);
}

 rtx_insn *
split_47 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2806 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2854 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2894 (insn, operands);
}

 rtx_insn *
split_53 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2828 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2872 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2912 (insn, operands);
}

 rtx_insn *
split_59 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1098 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1670 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1743 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1795 (insn, operands);

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1683 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1756 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1808 (insn, operands);

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1696 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1769 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1821 (insn, operands);

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1709 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1782 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1834 (insn, operands);

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5788 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1941 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5829 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1944 (insn, operands);

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5788 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1942 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5829 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1945 (insn, operands);

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5788 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1943 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5829 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1946 (insn, operands);

        default:
          return NULL;
        }

    case 1L:
      switch (pattern1099 (x2))
        {
        case 0:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1847 (insn, operands);

        case 1:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1860 (insn, operands);

        case 2:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1873 (insn, operands);

        case 3:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1886 (insn, operands);

        case 4:
          if (pattern1253 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !(
#line 5868 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5877 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1947 (insn, operands);

        case 5:
          if (pattern1253 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !(
#line 5868 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5877 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1948 (insn, operands);

        case 6:
          if (pattern1253 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !(
#line 5868 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5877 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1949 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_66 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (XINT (x3, 1) != 125)
    return NULL;
  switch (pattern857 (x2))
    {
    case 0:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1569 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1573 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1577 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1617 (insn, operands);

    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1581 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1621 (insn, operands);

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1585 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1625 (insn, operands);

    case 5:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1589 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1629 (insn, operands);

    case 6:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1593 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1633 (insn, operands);

    case 7:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1597 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1637 (insn, operands);

    case 8:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1601 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1641 (insn, operands);

    case 9:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1605 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1645 (insn, operands);

    case 10:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1570 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 11:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1574 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 12:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1578 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1618 (insn, operands);

    case 13:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1582 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1622 (insn, operands);

    case 14:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1586 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1626 (insn, operands);

    case 15:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1590 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1630 (insn, operands);

    case 16:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1594 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1634 (insn, operands);

    case 17:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1598 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1638 (insn, operands);

    case 18:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1602 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1642 (insn, operands);

    case 19:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1606 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3258 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1646 (insn, operands);

    case 20:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1571 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 21:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1575 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 22:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1579 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1619 (insn, operands);

    case 23:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1583 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1623 (insn, operands);

    case 24:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1587 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1627 (insn, operands);

    case 25:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1591 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1631 (insn, operands);

    case 26:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1595 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1635 (insn, operands);

    case 27:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1599 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1639 (insn, operands);

    case 28:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1603 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1643 (insn, operands);

    case 29:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1607 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3259 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1647 (insn, operands);

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1572 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 31:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1576 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 32:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1580 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1620 (insn, operands);

    case 33:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1584 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1624 (insn, operands);

    case 34:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1588 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1628 (insn, operands);

    case 35:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1592 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1632 (insn, operands);

    case 36:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1596 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1636 (insn, operands);

    case 37:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1600 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1640 (insn, operands);

    case 38:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1604 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1644 (insn, operands);

    case 39:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5110 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5115 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_1608 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !((
#line 5135 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 3260 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 5141 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1648 (insn, operands);

    case 40:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2803 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2851 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
        return NULL;
      return gen_split_2891 (insn, operands);

    case 41:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2815 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2861 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
        return NULL;
      return gen_split_2901 (insn, operands);

    case 42:
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2827 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2871 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
        return NULL;
      return gen_split_2911 (insn, operands);

    case 43:
      return split_56 (x1, insn);

    case 44:
      return split_55 (x1, insn);

    case 45:
      return split_54 (x1, insn);

    case 46:
      return split_53 (x1, insn);

    case 47:
      return split_52 (x1, insn);

    case 48:
      return split_51 (x1, insn);

    case 49:
      return split_50 (x1, insn);

    case 50:
      return split_49 (x1, insn);

    case 51:
      return split_48 (x1, insn);

    case 52:
      return split_47 (x1, insn);

    case 53:
      return split_46 (x1, insn);

    case 54:
      return split_45 (x1, insn);

    case 55:
      return split_44 (x1, insn);

    case 56:
      return split_43 (x1, insn);

    case 57:
      return split_42 (x1, insn);

    case 58:
      return split_41 (x1, insn);

    case 59:
      return split_40 (x1, insn);

    case 60:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2808 (insn, operands);

    case 61:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2820 (insn, operands);

    case 62:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2832 (insn, operands);

    case 63:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2844 (insn, operands);

    case 64:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2931 (insn, operands);

    case 65:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2933 (insn, operands);

    case 66:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2935 (insn, operands);

    case 67:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2937 (insn, operands);

    case 68:
      return split_39 (x1, insn);

    case 69:
      return split_38 (x1, insn);

    case 70:
      return split_37 (x1, insn);

    case 71:
      return split_36 (x1, insn);

    case 72:
      return split_35 (x1, insn);

    case 73:
      return split_34 (x1, insn);

    case 74:
      return split_33 (x1, insn);

    case 75:
      return split_32 (x1, insn);

    case 76:
      return split_31 (x1, insn);

    case 77:
      return split_30 (x1, insn);

    case 78:
      return split_29 (x1, insn);

    case 79:
      return split_28 (x1, insn);

    case 80:
      return split_27 (x1, insn);

    case 81:
      return split_26 (x1, insn);

    case 82:
      return split_25 (x1, insn);

    case 83:
      return split_24 (x1, insn);

    case 84:
      return split_23 (x1, insn);

    case 85:
      return split_22 (x1, insn);

    case 86:
      return split_21 (x1, insn);

    case 87:
      return split_20 (x1, insn);

    case 88:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2814 (insn, operands);

    case 89:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2826 (insn, operands);

    case 90:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2838 (insn, operands);

    case 91:
      if (!(
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2850 (insn, operands);

    case 92:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2932 (insn, operands);

    case 93:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2934 (insn, operands);

    case 94:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2936 (insn, operands);

    case 95:
      if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1140 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_2938 (insn, operands);

    case 96:
      return split_19 (x1, insn);

    case 97:
      return split_18 (x1, insn);

    case 98:
      return split_17 (x1, insn);

    case 99:
      return split_16 (x1, insn);

    case 100:
      return split_15 (x1, insn);

    case 101:
      return split_14 (x1, insn);

    case 102:
      return split_13 (x1, insn);

    case 103:
      return split_12 (x1, insn);

    case 104:
      if (!(
#line 3503 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3509 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_3040 (insn, operands);

    case 105:
      if (!(
#line 3503 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3509 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_3041 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_87 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2497 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2507 (insn, operands);
}

 rtx_insn *
split_90 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2437 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2447 (insn, operands);
}

 rtx_insn *
split_93 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2536 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2546 (insn, operands);
}

 rtx_insn *
split_96 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2476 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2486 (insn, operands);
}

 rtx_insn *
split_100 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2555 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2565 (insn, operands);
}

 rtx_insn *
split_104 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2475 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2485 (insn, operands);
}

 rtx_insn *
split_109 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2534 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2544 (insn, operands);
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2414 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2424 (insn, operands);
}

 rtx_insn *
split_122 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2433 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2443 (insn, operands);
}

 rtx_insn *
split_130 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2432 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2442 (insn, operands);
}

 rtx_insn *
split_138 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != LABEL_REF)
        return NULL;
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return NULL;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case EQ:
          switch (pattern698 (x2))
            {
            case 0:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_1 (insn, operands);

            case 1:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_5 (insn, operands);

            case 2:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_3 (insn, operands);

            case 3:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_7 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          switch (pattern698 (x2))
            {
            case 0:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_2 (insn, operands);

            case 1:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_6 (insn, operands);

            case 2:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_4 (insn, operands);

            case 3:
              if (!((
#line 908 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)) && 
#line 912 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case TRUNCATE:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x2;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          operands[0] = x2;
          if (aarch64_reg_or_zero (operands[0], E_DImode)
              && GET_CODE (x5) == REG
              && REGNO (x5) == 84
              && GET_MODE (x5) == E_DImode
              && 
#line 1901 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP8 && !TARGET_CHEAP_FPMR_WRITE && can_create_pseudo_p ()))
            return gen_split_14 (insn, operands);
          break;

        case TRUNCATE:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x2, E_DImode))
        return NULL;
      switch (pattern29 (x1))
        {
        case 0:
          if (!(
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6466 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_120 (insn, operands);

        case 1:
          if (!(
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6466 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_121 (insn, operands);

        case 2:
          if (!(
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64) && 
#line 6466 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_123 (insn, operands);

        case 3:
          if (!(
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64) && 
#line 6466 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_122 (insn, operands);

        case 4:
          if (!(
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64) && 
#line 6466 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_124 (insn, operands);

        case 5:
          if (!(
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64) && 
#line 6466 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
            return NULL;
          return gen_split_125 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      return split_79 (x1, insn);

    case ZERO_EXTEND:
      return split_81 (x1, insn);

    case IOR:
      return split_82 (x1, insn);

    case XOR:
      return split_83 (x1, insn);

    case AND:
      return split_80 (x1, insn);

    case NOT:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != XOR)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern365 (x2))
        {
        case 0:
          if (!
#line 5337 "../../../gcc/config/aarch64/aarch64.md"
(reload_completed && FP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_69 (insn, operands);

        case 1:
          if (!
#line 5337 "../../../gcc/config/aarch64/aarch64.md"
(reload_completed && FP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_70 (insn, operands);

        default:
          return NULL;
        }

    case CTZ:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 5643 "../../../gcc/config/aarch64/aarch64.md"
(reload_completed && !TARGET_CSSC))
            return NULL;
          return gen_split_71 (insn, operands);

        case 1:
          if (!
#line 5643 "../../../gcc/config/aarch64/aarch64.md"
(reload_completed && !TARGET_CSSC))
            return NULL;
          return gen_split_72 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern17 (x2))
            {
            case 0:
              if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_85 (insn, operands);

            case 1:
              if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_90 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          x8 = XEXP (x3, 1);
          if (subreg_lowpart_operator (x8, E_VOIDmode))
            {
              switch (pattern841 (x2))
                {
                case 0:
                  if ((
#line 5896 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[4]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)
   && INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5899 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                    return gen_split_95 (insn, operands);
                  break;

                case 1:
                  if ((
#line 5896 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[4]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)
   && INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5899 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                    return gen_split_96 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[3] = x8;
          if (!register_operand (operands[3], E_QImode))
            return NULL;
          switch (pattern2 (x2))
            {
            case 0:
              if (!(
#line 5941 "../../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5943 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_97 (insn, operands);

            case 1:
              if (!(
#line 5941 "../../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5943 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_100 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern18 (x1))
        {
        case 0:
          if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_86 (insn, operands);

        case 1:
          if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_91 (insn, operands);

        case 2:
          if (!(
#line 5941 "../../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5943 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_98 (insn, operands);

        case 3:
          if (!(
#line 5941 "../../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5943 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_101 (insn, operands);

        case 4:
          if (!
#line 6046 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_105 (insn, operands);

        case 5:
          if (!
#line 6061 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern18 (x1))
        {
        case 0:
          if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_87 (insn, operands);

        case 1:
          if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_92 (insn, operands);

        case 2:
          if (!(
#line 5941 "../../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)) && 
#line 5943 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_99 (insn, operands);

        case 3:
          if (!(
#line 5941 "../../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)) && 
#line 5943 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_102 (insn, operands);

        case 4:
          if (!
#line 6000 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_103 (insn, operands);

        case 5:
          if (!
#line 6015 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD && reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    case ROTATERT:
      x3 = XEXP (x2, 1);
      if (!subreg_lowpart_operator (x3, E_VOIDmode))
        return NULL;
      operands[4] = x3;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != NEG
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != AND
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      switch (pattern15 (x2))
        {
        case 0:
          if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_88 (insn, operands);

        case 1:
          if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern17 (x2))
            {
            case 0:
              if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_89 (insn, operands);

            case 1:
              if (!(
#line 5871 "../../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)) && 
#line 5873 "../../../gcc/config/aarch64/aarch64.md"
( true)))
                return NULL;
              return gen_split_94 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case CONST:
          switch (pattern457 (x2))
            {
            case 0:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_147 (insn, operands);

            case 1:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_148 (insn, operands);

            case 2:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_149 (insn, operands);

            case 3:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_150 (insn, operands);

            case 4:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_151 (insn, operands);

            case 5:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_152 (insn, operands);

            case 6:
              if (!(
#line 1305 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && can_create_pseudo_p ()) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                return NULL;
              return gen_split_153 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!aarch64_simd_shift_imm_offset_di (operands[2], E_VOIDmode))
        return NULL;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      if (!aarch64_simd_shift_imm_di (operands[3], E_VOIDmode)
          || !
#line 6349 "../../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]), 1,
	     GET_MODE_BITSIZE (DImode) - 1)
   && (INTVAL (operands[2]) + INTVAL (operands[3]))
       == GET_MODE_BITSIZE (SImode)))
        return NULL;
      return gen_split_107 (insn, operands);

    case VEC_SELECT:
      return split_78 (x1, insn);

    case SIGN_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          switch (pattern361 (x2))
            {
            case 0:
              if (!(
#line 1968 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../../gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_154 (insn, operands);

            case 1:
              if (!(
#line 1968 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../../gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_156 (insn, operands);

            case 2:
              if (!(
#line 1968 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 1970 "../../../gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_158 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (pattern366 (x2))
            {
            case 0:
              if (!(
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../../gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_342 (insn, operands);

            case 1:
              if (!(
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../../gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_344 (insn, operands);

            case 2:
              if (!(
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 9846 "../../../gcc/config/aarch64/aarch64-simd.md"
( SIGN_EXTEND == ZERO_EXTEND
   && aarch64_split_simd_shift_p (insn))))
                return NULL;
              return gen_split_346 (insn, operands);

            default:
              return NULL;
            }

        case SS_PLUS:
          if (pattern38 (x7, 
E_SImode) != 0)
            return NULL;
          switch (pattern924 (x2))
            {
            case 0:
              if (!(
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2713 (insn, operands);

            case 1:
              if (!(
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2715 (insn, operands);

            case 2:
              if (!(
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2717 (insn, operands);

            case 3:
              if (!(
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10778 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2719 (insn, operands);

            default:
              return NULL;
            }

        case SS_MINUS:
          if (pattern39 (x7) != 0)
            return NULL;
          switch (pattern925 (x2))
            {
            case 0:
              if (!(
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2746 (insn, operands);

            case 1:
              if (!(
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2748 (insn, operands);

            case 2:
              if (!(
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2750 (insn, operands);

            case 3:
              if (!(
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11011 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2752 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC:
      return split_77 (x1, insn);

    case SS_PLUS:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2698 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2701 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2704 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2707 (insn, operands);

        case 4:
          if (!(
#line 10823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2722 (insn, operands);

        case 5:
          if (!(
#line 10862 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2725 (insn, operands);

        case 6:
          if (!(
#line 10903 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2728 (insn, operands);

        default:
          return NULL;
        }

    case US_PLUS:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2699 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2705 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2708 (insn, operands);

        case 4:
          if (!(
#line 10823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2723 (insn, operands);

        case 5:
          if (!(
#line 10862 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2726 (insn, operands);

        case 6:
          if (!(
#line 10903 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2729 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          switch (pattern23 (x2))
            {
            case 0:
              if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2730 (insn, operands);

            case 1:
              if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2733 (insn, operands);

            case 2:
              if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2736 (insn, operands);

            case 3:
              if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2739 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 3
              || XINT (x3, 1) != 307
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x10 = XVECEXP (x3, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          switch (pattern1049 (x3))
            {
            case 0:
              if (!(
#line 10968 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2742 (insn, operands);

            case 1:
              if (!(
#line 10968 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2743 (insn, operands);

            case 2:
              if (!(
#line 10968 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2744 (insn, operands);

            case 3:
              if (!(
#line 10968 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10970 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2745 (insn, operands);

            default:
              return NULL;
            }

        case VEC_DUPLICATE:
          switch (pattern24 (x2))
            {
            case 0:
              if (!(
#line 11056 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11061 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2754 (insn, operands);

            case 1:
              if (!(
#line 11095 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11100 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2757 (insn, operands);

            case 2:
              if (!(
#line 11136 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11141 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2760 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SS_MINUS:
      switch (pattern25 (x1))
        {
        case 0:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2731 (insn, operands);

        case 1:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2734 (insn, operands);

        case 2:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2737 (insn, operands);

        case 3:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2740 (insn, operands);

        case 4:
          if (!(
#line 11056 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11061 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2755 (insn, operands);

        case 5:
          if (!(
#line 11095 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11100 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2758 (insn, operands);

        case 6:
          if (!(
#line 11136 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11141 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2761 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      switch (pattern25 (x1))
        {
        case 0:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2732 (insn, operands);

        case 1:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2735 (insn, operands);

        case 2:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2738 (insn, operands);

        case 3:
          if (!(
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10951 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2741 (insn, operands);

        case 4:
          if (!(
#line 11056 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11061 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2756 (insn, operands);

        case 5:
          if (!(
#line 11095 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11100 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2759 (insn, operands);

        case 6:
          if (!(
#line 11136 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 11141 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2762 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
