/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 6;

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 7;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 8;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 9;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aligned_register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 307
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_tls_le_symref (operands[1], E_VOIDmode))
    return -1;
  return pattern42 (x3); /* [-1, 1] */
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!aligned_register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 1;

        case E_VNx8DImode:
          if (!aligned_register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern83 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i3
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern77 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern77 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern77 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern77 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern77 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V2SImode:
      if (!register_operand (operands[2], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern100 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_qi (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern90 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern90 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern90 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern90 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 3;

    case E_BFmode:
      if (pattern90 (x3, 
E_VNx8BFmode, 
E_VNx8BImode, 
E_BFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern90 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern90 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern90 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern113 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern113 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern113 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern121 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern121 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern121 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern77 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (!memory_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x3) != E_VNx32QImode
          || !aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx16HImode:
      if (!memory_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x3) != E_VNx16HImode
          || !aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      return 1;

    case E_VNx8SImode:
      if (!memory_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x3) != E_VNx8SImode
          || !aligned_register_operand (operands[1], E_VNx8SImode))
        return -1;
      return 2;

    case E_VNx4DImode:
      if (!memory_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x3) != E_VNx4DImode
          || !aligned_register_operand (operands[1], E_VNx4DImode))
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (!memory_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x3) != E_VNx16BFmode
          || !aligned_register_operand (operands[1], E_VNx16BFmode))
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (!memory_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x3) != E_VNx16HFmode
          || !aligned_register_operand (operands[1], E_VNx16HFmode))
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (!memory_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (!memory_operand (operands[0], E_VNx4DFmode)
          || GET_MODE (x3) != E_VNx4DFmode
          || !aligned_register_operand (operands[1], E_VNx4DFmode))
        return -1;
      return 7;

    case E_VNx64QImode:
      if (!memory_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x3) != E_VNx64QImode
          || !aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      return 8;

    case E_VNx32HImode:
      if (!memory_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x3) != E_VNx32HImode
          || !aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      return 9;

    case E_VNx16SImode:
      if (!memory_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x3) != E_VNx16SImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 10;

    case E_VNx8DImode:
      if (!memory_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x3) != E_VNx8DImode
          || !aligned_register_operand (operands[1], E_VNx8DImode))
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (!memory_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x3) != E_VNx32BFmode
          || !aligned_register_operand (operands[1], E_VNx32BFmode))
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (!memory_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x3) != E_VNx32HFmode
          || !aligned_register_operand (operands[1], E_VNx32HFmode))
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (!memory_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (!memory_operand (operands[0], E_VNx8DFmode)
          || GET_MODE (x3) != E_VNx8DFmode
          || !aligned_register_operand (operands[1], E_VNx8DFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 4);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern226 (x3, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern226 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern226 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern226 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 168)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 93)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (!const_int_operand (x7, E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[2] = x10;
      operands[3] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          return pattern240 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern240 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[1] = x12;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[3] = x10;
      operands[4] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          res = pattern244 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern244 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      return pattern260 (x2, 
E_VNx16QImode, 
E_VNx4BImode, 
E_VNx4SImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern260 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern271 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_ldff1_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern274 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx1TImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern277 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern285 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern305 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_simd_shll_imm_vec (operands[2], i1))
    return -1;
  return 0;
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ABS)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern298 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern298 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern298 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern298 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern298 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern316 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern316 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern316 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern316 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern316 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_rshift_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern327 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return pattern326 (x3); /* [-1, 4] */
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx8HImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (XINT (x2, 1))
    {
    case 169:
      operands[5] = x1;
      x3 = XVECEXP (x2, 0, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 1);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x4 = XVECEXP (x2, 0, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      operands[3] = x1;
      x3 = XVECEXP (x2, 0, 0);
      operands[4] = x3;
      x5 = XVECEXP (x2, 0, 2);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern341 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern341 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 5
      || GET_MODE (x1) != E_DImode)
    return -1;
  return 0;
}

int
pattern355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern360 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  return pattern362 (x1); /* [-1, 1] */
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !aarch64_sync_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !aarch64_sync_memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !aarch64_sync_memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !aarch64_sync_memory_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern377 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_hi_half (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern386 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern391 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern396 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern403 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (XINT (x2, 1))
    {
    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          return pattern407 (x1, 
E_VNx8BImode, 
E_VNx8HFmode); /* [-1, 0] */

        case E_VNx4BImode:
          if (pattern407 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        case E_VNx2BImode:
          if (pattern407 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 358:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern407 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 3;

        case E_VNx4BImode:
          if (pattern407 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 4;

        case E_VNx2BImode:
          if (pattern407 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern407 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 6;

        case E_VNx4BImode:
          if (pattern407 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 7;

        case E_VNx2BImode:
          if (pattern407 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case 364:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern407 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 9;

        case E_VNx4BImode:
          if (pattern407 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 10;

        case E_VNx2BImode:
          if (pattern407 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case 365:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern407 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 12;

        case E_VNx4BImode:
          if (pattern407 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 13;

        case E_VNx2BImode:
          if (pattern407 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 14;

        default:
          return -1;
        }

    case 366:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern407 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 15;

        case E_VNx4BImode:
          if (pattern407 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 16;

        case E_VNx2BImode:
          if (pattern407 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case 367:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern408 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 18;

        case E_VNx4BImode:
          if (pattern408 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 19;

        case E_VNx2BImode:
          if (pattern408 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern442 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern31 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern31 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern31 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern31 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern31 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern31 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern31 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern31 (x1, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_QImode:
      if (pattern31 (x1, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern440 (x1, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern440 (x1, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      return 10;

    case E_VNx16QImode:
      if (pattern441 (x1, 
E_VNx16QImode) != 0)
        return -1;
      return 11;

    case E_VNx8HImode:
      if (pattern441 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 12;

    case E_VNx4SImode:
      if (pattern441 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 13;

    case E_VNx2DImode:
      if (pattern441 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 351)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 351)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[4] = x7;
  if (!aarch64_sve_ptrue_flag (operands[4], E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 0);
  operands[5] = x8;
  x9 = XVECEXP (x2, 0, 2);
  operands[2] = x9;
  x10 = XVECEXP (x4, 0, 0);
  operands[6] = x10;
  x11 = XVECEXP (x4, 0, 2);
  operands[3] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern459 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern459 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern459 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern474 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[4] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[5] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern473 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern473 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern473 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern473 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern481 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_lshift_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern484 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern483 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern483 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern483 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern483 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern493 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern493 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern493 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern493 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern493 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern505 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  return pattern504 (x1); /* [-1, 4] */
}

int
pattern508 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[4] = x7;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  switch (GET_CODE (operands[3]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x1) != E_V8QImode
              || pattern435 (x2, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x1) != E_V16QImode
              || GET_MODE (x2) != E_V16QImode
              || GET_MODE (x3) != E_V16HImode
              || GET_MODE (x4) != E_V16HImode
              || GET_MODE (x5) != E_V16HImode
              || !register_operand (operands[2], E_V16QImode)
              || !aarch64_int_rnd_operand (operands[4], E_V16HImode)
              || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x1) != E_V4HImode
              || pattern436 (x2, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V8HImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode
              || GET_MODE (x5) != E_V8SImode
              || !register_operand (operands[2], E_V8HImode)
              || !aarch64_int_rnd_operand (operands[4], E_V8SImode)
              || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V8HImode)
              || !register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x1) != E_V2SImode
              || pattern437 (x2, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_V4DImode
              || GET_MODE (x4) != E_V4DImode
              || GET_MODE (x5) != E_V4DImode
              || !register_operand (operands[2], E_V4SImode)
              || !aarch64_int_rnd_operand (operands[4], E_V4DImode)
              || !aarch64_simd_shift_imm_vec_si (operands[3], E_V4SImode)
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          return 5;

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_V2TImode
              || GET_MODE (x4) != E_V2TImode
              || GET_MODE (x5) != E_V2TImode
              || !register_operand (operands[2], E_V2DImode)
              || !aarch64_int_rnd_operand (operands[4], E_V2TImode)
              || !aarch64_simd_shift_imm_vec_di (operands[3], E_V2DImode)
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case CONST_INT:
      if (!aarch64_simd_shift_imm_offset_di (operands[3], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_TImode
          || GET_MODE (x4) != E_TImode
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[2], E_DImode)
          || !aarch64_int_rnd_operand (operands[4], E_TImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CC_NZCmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  return 0;
}

int
pattern564 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (XINT (x3, 1) != 27
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 66
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != UNSPEC_VOLATILE
          || XVECLEN (x8, 0) != 5
          || XINT (x8, 1) != 27)
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      x11 = XVECEXP (x8, 0, 1);
      operands[3] = x11;
      x12 = XVECEXP (x8, 0, 2);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x8, 0, 3);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x14 = XVECEXP (x8, 0, 4);
      operands[6] = x14;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x15 = XVECEXP (x1, 0, 3);
      x16 = XEXP (x15, 0);
      operands[7] = x16;
      return pattern565 (x1); /* [-1, 4] */

    case 2:
      if (XINT (x3, 1) != 31)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x17 = XVECEXP (x3, 0, 1);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x7, 0);
      operands[3] = x18;
      x15 = XVECEXP (x1, 0, 3);
      x16 = XEXP (x15, 0);
      operands[4] = x16;
      x4 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          res = pattern567 (x3);
          if (res >= 0)
            return res + 5; /* [5, 8] */
          return -1;

        case MINUS:
          res = pattern567 (x3);
          if (res >= 0)
            return res + 9; /* [9, 12] */
          return -1;

        case IOR:
          res = pattern569 (x3);
          if (res >= 0)
            return res + 13; /* [13, 16] */
          return -1;

        case XOR:
          res = pattern569 (x3);
          if (res >= 0)
            return res + 17; /* [17, 20] */
          return -1;

        case AND:
          res = pattern569 (x3);
          if (res >= 0)
            return res + 21; /* [21, 24] */
          return -1;

        case NOT:
          x19 = XEXP (x4, 0);
          if (GET_CODE (x19) != AND)
            return -1;
          x20 = XEXP (x19, 1);
          operands[1] = x20;
          x21 = XEXP (x19, 0);
          if (!rtx_equal_p (x21, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern570 (x3, 
E_QImode) != 0)
                return -1;
              return 25;

            case E_HImode:
              if (pattern570 (x3, 
E_HImode) != 0)
                return -1;
              return 26;

            case E_SImode:
              if (pattern570 (x3, 
E_SImode) != 0)
                return -1;
              return 27;

            case E_DImode:
              if (pattern570 (x3, 
E_DImode) != 0)
                return -1;
              return 28;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern612 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern627 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern626 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern626 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern626 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern626 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern632 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern639 (x1, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern639 (x1, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern639 (x1, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_vsm_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[4] = x10;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x6) != E_V4SImode
              || GET_MODE (x7) != E_V4HImode
              || !register_operand (operands[1], E_V8HImode)
              || !vect_par_cnst_hi_half (operands[2], E_V8HImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 0;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x6) != E_V2DImode
              || GET_MODE (x7) != E_V2SImode
              || !register_operand (operands[1], E_V4SImode)
              || !vect_par_cnst_hi_half (operands[2], E_V4SImode)
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 2;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x4;
      x6 = XEXP (x1, 0);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern651 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern651 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern683 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[5] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      x10 = XEXP (x4, 1);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern681 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern681 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern681 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      x10 = XEXP (x4, 1);
      operands[5] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern682 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern682 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern682 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern702 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern707 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern710 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern713 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !aarch64_simd_shift_imm_qi (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !aarch64_simd_shift_imm_hi (operands[1], E_VOIDmode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[1], E_VOIDmode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[1], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern720 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ld1rq_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern725 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern730 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern735 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern738 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern747 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern750 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern756 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern764 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern758 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern758 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern758 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern758 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern758 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern758 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern775 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  x11 = XEXP (x1, 1);
  operands[4] = x11;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern774 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern774 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern774 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern789 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_arith_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern793 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern801 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern810 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_reg_or_zero (operands[1], i1)
      || !aarch64_borrow_operation (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern817 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case VEC_SELECT:
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      x3 = XEXP (x1, 1);
      operands[5] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != VEC_SELECT
          || GET_MODE (x2) != E_HFmode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 2;

        case E_V4SFmode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern832 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern840 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[2] = x2;
      return 1;

    default:
      return -1;
    }
}

int
pattern847 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern846 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern846 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern846 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern858 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_general_reg (operands[0], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern864 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern871 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern877 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i3)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern882 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern881 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern881 (x1, 
E_V8HImode, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern881 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern881 (x1, 
E_V4SImode, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern881 (x1, 
E_V2DImode, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern881 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern891 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern890 (x4); /* [-1, 1] */
}

int
pattern897 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern902 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_orr_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern907 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2SFmode)
    return -1;
  return 0;
}

int
pattern915 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern920 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != NEG)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x7, 1);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  switch (GET_MODE (x9))
    {
    case E_SImode:
      if (GET_MODE (x10) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x7) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x10) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode
          || GET_MODE (x7) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern936 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[3], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern950 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern957 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern995 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1002 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1010 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern336 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1017 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1025 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !vect_par_cnst_even_or_odd_half (operands[4], i2)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1034 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1046 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1039 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1039 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1039 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1040 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1040 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1040 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1063 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode
          || !register_operand (operands[1], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1073 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1072 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1082 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1089 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  operands[1] = x4;
  if (!aarch64_sve_ptrue_svpattern_immediate (operands[1], E_VNx16BImode))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 128
      || GET_MODE (x5) != E_VNx16BImode)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[3] = x7;
  x8 = XVECEXP (x5, 0, 0);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[5] = x9;
  if (!aarch64_simd_imm_zero (operands[5], E_VNx16BImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x10))
    {
    case SET:
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1102 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_sve_float_arith_immediate (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1104 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1104 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1104 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        case E_VNx8BFmode:
          if (pattern1104 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern1105 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (pattern1105 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SFmode:
          if (pattern1105 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DFmode:
          if (pattern1105 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_VNx2DImode
      || !register_operand (operands[5], E_VNx2BImode)
      || !register_operand (operands[1], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[6] = x3;
  if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
    return -1;
  return 0;
}

int
pattern1135 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1143 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1151 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  switch (GET_CODE (x11))
    {
    case AND:
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != NOT)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XEXP (x13, 1);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || GET_MODE (x6) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !register_operand (operands[3], E_SImode)
              || pattern1150 (x11, 
E_SImode) != 0)
            return -1;
          return 0;

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !register_operand (operands[3], E_DImode)
              || pattern1150 (x11, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != AND
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != NOT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x14, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x12, 1);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1196 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1210 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[4], i4))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1219 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern1228 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1234 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1241 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern1247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1257 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      return 0;

    case E_TImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1294 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (pattern1302 (x1, 
E_VNx2HImode) != 0)
        return -1;
      return 1;

    case E_VNx2HFmode:
      if (pattern1302 (x1, 
E_VNx2HFmode) != 0)
        return -1;
      return 2;

    case E_VNx2BFmode:
      if (pattern1302 (x1, 
E_VNx2BFmode) != 0)
        return -1;
      return 3;

    case E_VNx2SImode:
      if (pattern1303 (x1, 
E_VNx2SImode) != 0)
        return -1;
      return 4;

    case E_VNx2SFmode:
      if (pattern1303 (x1, 
E_VNx2SFmode) != 0)
        return -1;
      return 5;

    case E_VNx2DImode:
      if (pattern1304 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern1304 (x1, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern1319 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1329 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1334 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || pattern1333 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[1], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[1], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[1], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[1], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1350 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1359 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 126)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x6, operands[6]))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x7, operands[7]))
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          return pattern1357 (x1, 
E_VNx16BImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1357 (x1, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (pattern1358 (x13, 
E_VNx16BImode, 
E_VNx16QImode) != 0)
            return -1;
          return 2;

        case E_VNx8BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (pattern1358 (x13, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          operands[3] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern935 (x2, 
E_SImode) == 0
                  && 
#line 1675 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_movk_shift (rtx_mode_t (operands[2], SImode),
		       rtx_mode_t (operands[3], SImode)) >= 0))
                return 73; /* aarch64_movksi */
              break;

            case E_DImode:
              if (pattern935 (x2, 
E_DImode) == 0
                  && 
#line 1675 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_movk_shift (rtx_mode_t (operands[2], DImode),
		       rtx_mode_t (operands[3], DImode)) >= 0))
                return 74; /* aarch64_movkdi */
              break;

            default:
              break;
            }
          break;

        case AND:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ASHIFT:
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTRACT:
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SUBREG:
        case TRUNCATE:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XWINT (x4, 0) != -1080863910568919041L
          || GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_DImode
          || pattern788 (x2) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_QImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 175)
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[2] = x8;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 8385 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
            return -1;
          return 1226; /* irg */

        case MEM:
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != UNSPEC
              || XVECLEN (x9, 0) != 1
              || XINT (x9, 1) != 176
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (GET_CODE (x10) != AND
              || GET_MODE (x10) != E_DImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
            return -1;
          x13 = XEXP (x11, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x14 = XEXP (x11, 1);
          operands[2] = x14;
          if (!aarch64_granule16_simm9 (operands[2], E_DImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[0])
              || !
#line 8443 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
            return -1;
          return 1230; /* ldg */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case AND:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != NOT)
            return -1;
          x15 = XEXP (x5, 1);
          switch (GET_CODE (x15))
            {
            case REG:
            case SUBREG:
              operands[2] = x15;
              x6 = XEXP (x3, 0);
              operands[3] = x6;
              operands[1] = x4;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx16BImode:
                  if (pattern1111 (x2, 
E_VNx16BImode) != 0
                      || !
#line 8831 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10297; /* vcond_mask_vnx16bivnx16bi */

                case E_VNx8BImode:
                  if (pattern1111 (x2, 
E_VNx8BImode) != 0
                      || !
#line 8831 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10298; /* vcond_mask_vnx8bivnx8bi */

                case E_VNx4BImode:
                  if (pattern1111 (x2, 
E_VNx4BImode) != 0
                      || !
#line 8831 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10299; /* vcond_mask_vnx4bivnx4bi */

                case E_VNx2BImode:
                  if (pattern1111 (x2, 
E_VNx2BImode) != 0
                      || !
#line 8831 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10300; /* vcond_mask_vnx2bivnx2bi */

                default:
                  return -1;
                }

            case NOT:
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern989 (x2, 
E_V8QImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V8QImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11948; /* *aarch64_sve2_bsl2n_unpredv8qi */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11949; /* *aarch64_sve2_bsl2n_unpredv8qi */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V8QImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11962; /* *aarch64_sve2_bsl2n_unpredv8qi */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11963; /* *aarch64_sve2_bsl2n_unpredv8qi */

                case E_V16QImode:
                  if (pattern989 (x2, 
E_V16QImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V16QImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11950; /* *aarch64_sve2_bsl2n_unpredv16qi */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11951; /* *aarch64_sve2_bsl2n_unpredv16qi */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V16QImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11964; /* *aarch64_sve2_bsl2n_unpredv16qi */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11965; /* *aarch64_sve2_bsl2n_unpredv16qi */

                case E_V4HImode:
                  if (pattern989 (x2, 
E_V4HImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V4HImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11952; /* *aarch64_sve2_bsl2n_unpredv4hi */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11953; /* *aarch64_sve2_bsl2n_unpredv4hi */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V4HImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11966; /* *aarch64_sve2_bsl2n_unpredv4hi */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11967; /* *aarch64_sve2_bsl2n_unpredv4hi */

                case E_V8HImode:
                  if (pattern989 (x2, 
E_V8HImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V8HImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11954; /* *aarch64_sve2_bsl2n_unpredv8hi */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11955; /* *aarch64_sve2_bsl2n_unpredv8hi */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V8HImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11968; /* *aarch64_sve2_bsl2n_unpredv8hi */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11969; /* *aarch64_sve2_bsl2n_unpredv8hi */

                case E_V2SImode:
                  if (pattern989 (x2, 
E_V2SImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V2SImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11956; /* *aarch64_sve2_bsl2n_unpredv2si */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11957; /* *aarch64_sve2_bsl2n_unpredv2si */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V2SImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11970; /* *aarch64_sve2_bsl2n_unpredv2si */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11971; /* *aarch64_sve2_bsl2n_unpredv2si */

                case E_V4SImode:
                  if (pattern989 (x2, 
E_V4SImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V4SImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11958; /* *aarch64_sve2_bsl2n_unpredv4si */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11959; /* *aarch64_sve2_bsl2n_unpredv4si */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V4SImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11972; /* *aarch64_sve2_bsl2n_unpredv4si */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11973; /* *aarch64_sve2_bsl2n_unpredv4si */

                case E_V2DImode:
                  if (pattern989 (x2, 
E_V2DImode) != 0)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (register_operand (operands[3], E_V2DImode))
                    {
                      x16 = XEXP (x15, 0);
                      if (rtx_equal_p (x16, operands[1])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11960; /* *aarch64_sve2_bsl2n_unpredv2di */
                      if (rtx_equal_p (x16, operands[2])
                          && 
#line 1898 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                        return 11961; /* *aarch64_sve2_bsl2n_unpredv2di */
                    }
                  x16 = XEXP (x15, 0);
                  operands[3] = x16;
                  if (!register_operand (operands[3], E_V2DImode))
                    return -1;
                  if (rtx_equal_p (x9, operands[1])
                      && 
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11974; /* *aarch64_sve2_bsl2n_unpredv2di */
                  if (!rtx_equal_p (x9, operands[2])
                      || !
#line 1914 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11975; /* *aarch64_sve2_bsl2n_unpredv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern581 (x5) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          switch (pattern1038 (x2))
            {
            case 0:
              x17 = XVECEXP (x5, 0, 1);
              x18 = XEXP (x17, 0);
              x19 = XEXP (x18, 0);
              operands[3] = x19;
              if (register_operand (operands[3], E_VNx16QImode))
                {
                  x20 = XEXP (x17, 1);
                  x21 = XEXP (x20, 0);
                  if (rtx_equal_p (x21, operands[1])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11932; /* *aarch64_sve2_bsl2nvnx16qi */
                  if (rtx_equal_p (x21, operands[2])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11933; /* *aarch64_sve2_bsl2nvnx16qi */
                }
              x20 = XEXP (x17, 1);
              x21 = XEXP (x20, 0);
              operands[3] = x21;
              if (!register_operand (operands[3], E_VNx16QImode))
                return -1;
              if (rtx_equal_p (x19, operands[1])
                  && 
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11940; /* *aarch64_sve2_bsl2nvnx16qi */
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11941; /* *aarch64_sve2_bsl2nvnx16qi */

            case 1:
              x17 = XVECEXP (x5, 0, 1);
              x18 = XEXP (x17, 0);
              x19 = XEXP (x18, 0);
              operands[3] = x19;
              if (register_operand (operands[3], E_VNx8HImode))
                {
                  x20 = XEXP (x17, 1);
                  x21 = XEXP (x20, 0);
                  if (rtx_equal_p (x21, operands[1])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11934; /* *aarch64_sve2_bsl2nvnx8hi */
                  if (rtx_equal_p (x21, operands[2])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11935; /* *aarch64_sve2_bsl2nvnx8hi */
                }
              x20 = XEXP (x17, 1);
              x21 = XEXP (x20, 0);
              operands[3] = x21;
              if (!register_operand (operands[3], E_VNx8HImode))
                return -1;
              if (rtx_equal_p (x19, operands[1])
                  && 
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11942; /* *aarch64_sve2_bsl2nvnx8hi */
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11943; /* *aarch64_sve2_bsl2nvnx8hi */

            case 2:
              x17 = XVECEXP (x5, 0, 1);
              x18 = XEXP (x17, 0);
              x19 = XEXP (x18, 0);
              operands[3] = x19;
              if (register_operand (operands[3], E_VNx4SImode))
                {
                  x20 = XEXP (x17, 1);
                  x21 = XEXP (x20, 0);
                  if (rtx_equal_p (x21, operands[1])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11936; /* *aarch64_sve2_bsl2nvnx4si */
                  if (rtx_equal_p (x21, operands[2])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11937; /* *aarch64_sve2_bsl2nvnx4si */
                }
              x20 = XEXP (x17, 1);
              x21 = XEXP (x20, 0);
              operands[3] = x21;
              if (!register_operand (operands[3], E_VNx4SImode))
                return -1;
              if (rtx_equal_p (x19, operands[1])
                  && 
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11944; /* *aarch64_sve2_bsl2nvnx4si */
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11945; /* *aarch64_sve2_bsl2nvnx4si */

            case 3:
              x17 = XVECEXP (x5, 0, 1);
              x18 = XEXP (x17, 0);
              x19 = XEXP (x18, 0);
              operands[3] = x19;
              if (register_operand (operands[3], E_VNx2DImode))
                {
                  x20 = XEXP (x17, 1);
                  x21 = XEXP (x20, 0);
                  if (rtx_equal_p (x21, operands[1])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11938; /* *aarch64_sve2_bsl2nvnx2di */
                  if (rtx_equal_p (x21, operands[2])
                      && 
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return 11939; /* *aarch64_sve2_bsl2nvnx2di */
                }
              x20 = XEXP (x17, 1);
              x21 = XEXP (x20, 0);
              operands[3] = x21;
              if (!register_operand (operands[3], E_VNx2DImode))
                return -1;
              if (rtx_equal_p (x19, operands[1])
                  && 
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11946; /* *aarch64_sve2_bsl2nvnx2di */
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11947; /* *aarch64_sve2_bsl2nvnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern59 (x1))
    {
    case 0:
      if (!
#line 3678 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2849; /* aarch64_reduc_smin_internalv8qi */

    case 1:
      if (!
#line 3678 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2853; /* aarch64_reduc_smin_internalv16qi */

    case 2:
      if (!
#line 3678 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2857; /* aarch64_reduc_smin_internalv4hi */

    case 3:
      if (!
#line 3678 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2861; /* aarch64_reduc_smin_internalv8hi */

    case 4:
      if (!
#line 3678 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2865; /* aarch64_reduc_smin_internalv4si */

    case 5:
      if (!
#line 3687 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2869; /* aarch64_reduc_smin_internalv2si */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      return recog_59 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      switch (pattern599 (x2))
        {
        case 0:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
            return -1;
          return 6971; /* *zero_extendvnx8qivnx8hi2 */

        case 1:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
            return -1;
          return 6973; /* *zero_extendvnx4qivnx8hi2 */

        case 2:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
            return -1;
          return 6975; /* *zero_extendvnx2qivnx8hi2 */

        case 3:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
            return -1;
          return 6977; /* *zero_extendvnx4hivnx8hi2 */

        case 4:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
            return -1;
          return 6979; /* *zero_extendvnx2hivnx8hi2 */

        case 5:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
            return -1;
          return 6981; /* *zero_extendvnx2sivnx8hi2 */

        case 6:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
            return -1;
          return 6983; /* *zero_extendvnx8qivnx4hi2 */

        case 7:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
            return -1;
          return 6985; /* *zero_extendvnx4qivnx4hi2 */

        case 8:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
            return -1;
          return 6987; /* *zero_extendvnx2qivnx4hi2 */

        case 9:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
            return -1;
          return 6989; /* *zero_extendvnx4hivnx4hi2 */

        case 10:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
            return -1;
          return 6991; /* *zero_extendvnx2hivnx4hi2 */

        case 11:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
            return -1;
          return 6993; /* *zero_extendvnx2sivnx4hi2 */

        case 12:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
            return -1;
          return 6995; /* *zero_extendvnx8qivnx2hi2 */

        case 13:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
            return -1;
          return 6997; /* *zero_extendvnx4qivnx2hi2 */

        case 14:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
            return -1;
          return 6999; /* *zero_extendvnx2qivnx2hi2 */

        case 15:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
            return -1;
          return 7001; /* *zero_extendvnx4hivnx2hi2 */

        case 16:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
            return -1;
          return 7003; /* *zero_extendvnx2hivnx2hi2 */

        case 17:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
            return -1;
          return 7005; /* *zero_extendvnx2sivnx2hi2 */

        case 18:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
            return -1;
          return 7007; /* *zero_extendvnx8qivnx4si2 */

        case 19:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
            return -1;
          return 7009; /* *zero_extendvnx4qivnx4si2 */

        case 20:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
            return -1;
          return 7011; /* *zero_extendvnx2qivnx4si2 */

        case 21:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
            return -1;
          return 7013; /* *zero_extendvnx4hivnx4si2 */

        case 22:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
            return -1;
          return 7015; /* *zero_extendvnx2hivnx4si2 */

        case 23:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
            return -1;
          return 7017; /* *zero_extendvnx2sivnx4si2 */

        case 24:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
            return -1;
          return 7019; /* *zero_extendvnx8qivnx2si2 */

        case 25:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
            return -1;
          return 7021; /* *zero_extendvnx4qivnx2si2 */

        case 26:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
            return -1;
          return 7023; /* *zero_extendvnx2qivnx2si2 */

        case 27:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
            return -1;
          return 7025; /* *zero_extendvnx4hivnx2si2 */

        case 28:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
            return -1;
          return 7027; /* *zero_extendvnx2hivnx2si2 */

        case 29:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
            return -1;
          return 7029; /* *zero_extendvnx2sivnx2si2 */

        case 30:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
            return -1;
          return 7031; /* *zero_extendvnx8qivnx2di2 */

        case 31:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
            return -1;
          return 7033; /* *zero_extendvnx4qivnx2di2 */

        case 32:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
            return -1;
          return 7035; /* *zero_extendvnx2qivnx2di2 */

        case 33:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
            return -1;
          return 7037; /* *zero_extendvnx4hivnx2di2 */

        case 34:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
            return -1;
          return 7039; /* *zero_extendvnx2hivnx2di2 */

        case 35:
          if (!
#line 3355 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
            return -1;
          return 7041; /* *zero_extendvnx2sivnx2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_64 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_62 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_65 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern470 (x3))
        {
        case 0:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6547; /* aarch64_pred_absvnx16qi */

        case 1:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6556; /* aarch64_pred_absvnx8qi */

        case 2:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6565; /* aarch64_pred_absvnx4qi */

        case 3:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6574; /* aarch64_pred_absvnx2qi */

        case 4:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6583; /* aarch64_pred_absvnx8hi */

        case 5:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6592; /* aarch64_pred_absvnx4hi */

        case 6:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6601; /* aarch64_pred_absvnx2hi */

        case 7:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6610; /* aarch64_pred_absvnx4si */

        case 8:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6619; /* aarch64_pred_absvnx2si */

        case 9:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6628; /* aarch64_pred_absvnx2di */

        case 10:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6637; /* aarch64_pred_absv8qi */

        case 11:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6646; /* aarch64_pred_absv16qi */

        case 12:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6655; /* aarch64_pred_absv4hi */

        case 13:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6664; /* aarch64_pred_absv8hi */

        case 14:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6673; /* aarch64_pred_absv2si */

        case 15:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6682; /* aarch64_pred_absv4si */

        case 16:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6691; /* aarch64_pred_absv2di */

        case 17:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6700; /* aarch64_pred_absv1di */

        default:
          return -1;
        }

    case NEG:
      switch (pattern470 (x3))
        {
        case 0:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6548; /* aarch64_pred_negvnx16qi */

        case 1:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6557; /* aarch64_pred_negvnx8qi */

        case 2:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6566; /* aarch64_pred_negvnx4qi */

        case 3:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6575; /* aarch64_pred_negvnx2qi */

        case 4:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6584; /* aarch64_pred_negvnx8hi */

        case 5:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6593; /* aarch64_pred_negvnx4hi */

        case 6:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6602; /* aarch64_pred_negvnx2hi */

        case 7:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6611; /* aarch64_pred_negvnx4si */

        case 8:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6620; /* aarch64_pred_negvnx2si */

        case 9:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6629; /* aarch64_pred_negvnx2di */

        case 10:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6638; /* aarch64_pred_negv8qi */

        case 11:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6647; /* aarch64_pred_negv16qi */

        case 12:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6656; /* aarch64_pred_negv4hi */

        case 13:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6665; /* aarch64_pred_negv8hi */

        case 14:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6674; /* aarch64_pred_negv2si */

        case 15:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6683; /* aarch64_pred_negv4si */

        case 16:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6692; /* aarch64_pred_negv2di */

        case 17:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6701; /* aarch64_pred_negv1di */

        default:
          return -1;
        }

    case NOT:
      return recog_63 (x1, insn, pnum_clobbers);

    case CLRSB:
      switch (pattern470 (x3))
        {
        case 0:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6550; /* aarch64_pred_clrsbvnx16qi */

        case 1:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6559; /* aarch64_pred_clrsbvnx8qi */

        case 2:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6568; /* aarch64_pred_clrsbvnx4qi */

        case 3:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6577; /* aarch64_pred_clrsbvnx2qi */

        case 4:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6586; /* aarch64_pred_clrsbvnx8hi */

        case 5:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6595; /* aarch64_pred_clrsbvnx4hi */

        case 6:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6604; /* aarch64_pred_clrsbvnx2hi */

        case 7:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6613; /* aarch64_pred_clrsbvnx4si */

        case 8:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6622; /* aarch64_pred_clrsbvnx2si */

        case 9:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6631; /* aarch64_pred_clrsbvnx2di */

        case 10:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6640; /* aarch64_pred_clrsbv8qi */

        case 11:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6649; /* aarch64_pred_clrsbv16qi */

        case 12:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6658; /* aarch64_pred_clrsbv4hi */

        case 13:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6667; /* aarch64_pred_clrsbv8hi */

        case 14:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6676; /* aarch64_pred_clrsbv2si */

        case 15:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6685; /* aarch64_pred_clrsbv4si */

        case 16:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6694; /* aarch64_pred_clrsbv2di */

        case 17:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6703; /* aarch64_pred_clrsbv1di */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern470 (x3))
        {
        case 0:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6551; /* aarch64_pred_clzvnx16qi */

        case 1:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6560; /* aarch64_pred_clzvnx8qi */

        case 2:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6569; /* aarch64_pred_clzvnx4qi */

        case 3:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6578; /* aarch64_pred_clzvnx2qi */

        case 4:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6587; /* aarch64_pred_clzvnx8hi */

        case 5:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6596; /* aarch64_pred_clzvnx4hi */

        case 6:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6605; /* aarch64_pred_clzvnx2hi */

        case 7:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6614; /* aarch64_pred_clzvnx4si */

        case 8:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6623; /* aarch64_pred_clzvnx2si */

        case 9:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6632; /* aarch64_pred_clzvnx2di */

        case 10:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6641; /* aarch64_pred_clzv8qi */

        case 11:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6650; /* aarch64_pred_clzv16qi */

        case 12:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6659; /* aarch64_pred_clzv4hi */

        case 13:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6668; /* aarch64_pred_clzv8hi */

        case 14:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6677; /* aarch64_pred_clzv2si */

        case 15:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6686; /* aarch64_pred_clzv4si */

        case 16:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6695; /* aarch64_pred_clzv2di */

        case 17:
          if (!
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6704; /* aarch64_pred_clzv1di */

        default:
          return -1;
        }

    case POPCOUNT:
      return recog_70 (x1, insn, pnum_clobbers);

    case BITREVERSE:
      return recog_69 (x1, insn, pnum_clobbers);

    case SS_ABS:
      return recog_68 (x1, insn, pnum_clobbers);

    case SS_NEG:
      return recog_67 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_61 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern472 (x3))
        {
        case 0:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7342; /* aarch64_pred_mulvnx16qi */

        case 1:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7347; /* aarch64_pred_mulvnx8qi */

        case 2:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7352; /* aarch64_pred_mulvnx4qi */

        case 3:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7357; /* aarch64_pred_mulvnx2qi */

        case 4:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7362; /* aarch64_pred_mulvnx8hi */

        case 5:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7367; /* aarch64_pred_mulvnx4hi */

        case 6:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7372; /* aarch64_pred_mulvnx2hi */

        case 7:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7377; /* aarch64_pred_mulvnx4si */

        case 8:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7382; /* aarch64_pred_mulvnx2si */

        case 9:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7387; /* aarch64_pred_mulvnx2di */

        case 10:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7392; /* aarch64_pred_mulv2di */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern472 (x3))
        {
        case 0:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7343; /* aarch64_pred_smaxvnx16qi */

        case 1:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7348; /* aarch64_pred_smaxvnx8qi */

        case 2:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7353; /* aarch64_pred_smaxvnx4qi */

        case 3:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7358; /* aarch64_pred_smaxvnx2qi */

        case 4:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7363; /* aarch64_pred_smaxvnx8hi */

        case 5:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7368; /* aarch64_pred_smaxvnx4hi */

        case 6:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7373; /* aarch64_pred_smaxvnx2hi */

        case 7:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7378; /* aarch64_pred_smaxvnx4si */

        case 8:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7383; /* aarch64_pred_smaxvnx2si */

        case 9:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7388; /* aarch64_pred_smaxvnx2di */

        case 10:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7393; /* aarch64_pred_smaxv2di */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern475 (x3))
        {
        case 0:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7344; /* aarch64_pred_sminvnx16qi */

        case 1:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7349; /* aarch64_pred_sminvnx8qi */

        case 2:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7354; /* aarch64_pred_sminvnx4qi */

        case 3:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7359; /* aarch64_pred_sminvnx2qi */

        case 4:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7364; /* aarch64_pred_sminvnx8hi */

        case 5:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7369; /* aarch64_pred_sminvnx4hi */

        case 6:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7374; /* aarch64_pred_sminvnx2hi */

        case 7:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7379; /* aarch64_pred_sminvnx4si */

        case 8:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7384; /* aarch64_pred_sminvnx2si */

        case 9:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7389; /* aarch64_pred_sminvnx2di */

        case 10:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7394; /* aarch64_pred_sminv2di */

        case 11:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11518; /* *aarch64_sve_sclampvnx16qi_x */

        case 12:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11520; /* *aarch64_sve_sclampvnx8hi_x */

        case 13:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11522; /* *aarch64_sve_sclampvnx4si_x */

        case 14:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11524; /* *aarch64_sve_sclampvnx2di_x */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern477 (x3))
        {
        case 0:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7345; /* aarch64_pred_umaxvnx16qi */

        case 1:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7350; /* aarch64_pred_umaxvnx8qi */

        case 2:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7355; /* aarch64_pred_umaxvnx4qi */

        case 3:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7360; /* aarch64_pred_umaxvnx2qi */

        case 4:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7365; /* aarch64_pred_umaxvnx8hi */

        case 5:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7370; /* aarch64_pred_umaxvnx4hi */

        case 6:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7375; /* aarch64_pred_umaxvnx2hi */

        case 7:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7380; /* aarch64_pred_umaxvnx4si */

        case 8:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7385; /* aarch64_pred_umaxvnx2si */

        case 9:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7390; /* aarch64_pred_umaxvnx2di */

        case 10:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7395; /* aarch64_pred_umaxv2di */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern478 (x3))
        {
        case 0:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7346; /* aarch64_pred_uminvnx16qi */

        case 1:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7351; /* aarch64_pred_uminvnx8qi */

        case 2:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7356; /* aarch64_pred_uminvnx4qi */

        case 3:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7361; /* aarch64_pred_uminvnx2qi */

        case 4:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7366; /* aarch64_pred_uminvnx8hi */

        case 5:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7371; /* aarch64_pred_uminvnx4hi */

        case 6:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7376; /* aarch64_pred_uminvnx2hi */

        case 7:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7381; /* aarch64_pred_uminvnx4si */

        case 8:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7386; /* aarch64_pred_uminvnx2si */

        case 9:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7391; /* aarch64_pred_uminvnx2di */

        case 10:
          if (!
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7396; /* aarch64_pred_uminv2di */

        case 11:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11519; /* *aarch64_sve_uclampvnx16qi_x */

        case 12:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11521; /* *aarch64_sve_uclampvnx8hi_x */

        case 13:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11523; /* *aarch64_sve_uclampvnx4si_x */

        case 14:
          if (!
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11525; /* *aarch64_sve_uclampvnx2di_x */

        default:
          return -1;
        }

    case DIV:
      switch (pattern480 (x3))
        {
        case 0:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8128; /* aarch64_pred_divvnx4si */

        case 1:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8130; /* aarch64_pred_divvnx2di */

        case 2:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8132; /* aarch64_pred_divv4si */

        case 3:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8134; /* aarch64_pred_divv2di */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern480 (x3))
        {
        case 0:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8129; /* aarch64_pred_udivvnx4si */

        case 1:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8131; /* aarch64_pred_udivvnx2di */

        case 2:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8133; /* aarch64_pred_udivv4si */

        case 3:
          if (!
#line 4614 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8135; /* aarch64_pred_udivv2di */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern482 (x3))
        {
        case 0:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8208; /* aarch64_pred_ashlvnx16qi */

        case 1:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8211; /* aarch64_pred_ashlvnx8qi */

        case 2:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8214; /* aarch64_pred_ashlvnx4qi */

        case 3:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8217; /* aarch64_pred_ashlvnx2qi */

        case 4:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8220; /* aarch64_pred_ashlvnx8hi */

        case 5:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8223; /* aarch64_pred_ashlvnx4hi */

        case 6:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8226; /* aarch64_pred_ashlvnx2hi */

        case 7:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8229; /* aarch64_pred_ashlvnx4si */

        case 8:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8232; /* aarch64_pred_ashlvnx2si */

        case 9:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8235; /* aarch64_pred_ashlvnx2di */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (pattern603 (x3))
        {
        case 0:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8209; /* aarch64_pred_ashrvnx16qi */

        case 1:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8212; /* aarch64_pred_ashrvnx8qi */

        case 2:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8215; /* aarch64_pred_ashrvnx4qi */

        case 3:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8218; /* aarch64_pred_ashrvnx2qi */

        case 4:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8221; /* aarch64_pred_ashrvnx8hi */

        case 5:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8224; /* aarch64_pred_ashrvnx4hi */

        case 6:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8227; /* aarch64_pred_ashrvnx2hi */

        case 7:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8230; /* aarch64_pred_ashrvnx4si */

        case 8:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8233; /* aarch64_pred_ashrvnx2si */

        case 9:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8236; /* aarch64_pred_ashrvnx2di */

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_66 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern484 (x3))
        {
        case 0:
          if (!
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11872; /* *aarch64_sve2_norvnx16qi */

        case 1:
          if (!
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11873; /* *aarch64_sve2_norvnx8hi */

        case 2:
          if (!
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11874; /* *aarch64_sve2_norvnx4si */

        case 3:
          if (!
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11875; /* *aarch64_sve2_norvnx2di */

        default:
          return -1;
        }

    case IOR:
      switch (pattern484 (x3))
        {
        case 0:
          if (!
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11876; /* *aarch64_sve2_nandvnx16qi */

        case 1:
          if (!
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11877; /* *aarch64_sve2_nandvnx8hi */

        case 2:
          if (!
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11878; /* *aarch64_sve2_nandvnx4si */

        case 3:
          if (!
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11879; /* *aarch64_sve2_nandvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern121 (x3, 
E_V8HImode, 
E_V8QImode) != 0
              || !
#line 5046 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3219; /* aarch64_pmullv8qi */

        case E_TImode:
          if (pattern121 (x3, 
E_TImode, 
E_DImode) != 0
              || !
#line 9825 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5240; /* aarch64_crypto_pmulldi */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V8QImode)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_V8QImode
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!vect_par_cnst_hi_half (operands[3], E_V16QImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      x9 = XEXP (x5, 1);
      if (!rtx_equal_p (x9, operands[3])
          || !
#line 5061 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3220; /* aarch64_pmull_hiv16qi_insn */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3712; /* aarch64_sqrshlv8qi */

    case 1:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3720; /* aarch64_sqrshlv16qi */

    case 2:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3728; /* aarch64_sqrshlv4hi */

    case 3:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3736; /* aarch64_sqrshlv8hi */

    case 4:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3744; /* aarch64_sqrshlv2si */

    case 5:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3752; /* aarch64_sqrshlv4si */

    case 6:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3756; /* aarch64_sqrshlv2di */

    case 7:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3760; /* aarch64_sqrshlqi */

    case 8:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3764; /* aarch64_sqrshlhi */

    case 9:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3768; /* aarch64_sqrshlsi */

    case 10:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3776; /* aarch64_sqrshldi */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern115 (x1))
    {
    case 0:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8995; /* *iorvnx8hf3 */

    case 1:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8998; /* *iorvnx4hf3 */

    case 2:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9001; /* *iorvnx2hf3 */

    case 3:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9004; /* *iorvnx8bf3 */

    case 4:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9007; /* *iorvnx4bf3 */

    case 5:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9010; /* *iorvnx2bf3 */

    case 6:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9013; /* *iorvnx4sf3 */

    case 7:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9016; /* *iorvnx2sf3 */

    case 8:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9019; /* *iorvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern119 (x1))
    {
    case 0:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10659; /* aarch64_sve_uzp1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10665; /* aarch64_sve_uzp1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10671; /* aarch64_sve_uzp1qvnx4si */

    case 3:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10677; /* aarch64_sve_uzp1qvnx2di */

    case 4:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10683; /* aarch64_sve_uzp1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10689; /* aarch64_sve_uzp1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10695; /* aarch64_sve_uzp1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10701; /* aarch64_sve_uzp1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern98 (x1))
    {
    case 0:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3642; /* aarch64_sshlv8qi */

    case 1:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3654; /* aarch64_sshlv16qi */

    case 2:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3658; /* aarch64_sshlv4hi */

    case 3:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3670; /* aarch64_sshlv8hi */

    case 4:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3674; /* aarch64_sshlv2si */

    case 5:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3686; /* aarch64_sshlv4si */

    case 6:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3690; /* aarch64_sshlv2di */

    case 7:
      if (!
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3694; /* aarch64_sshldi */

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern75 (x1))
    {
    case 0:
      return 1037; /* fcvtzssf3 */

    case 1:
      if (!
#line 7217 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1045; /* fcvtzshfsi3 */

    case 2:
      return 1039; /* fcvtzsdf3 */

    case 3:
      if (!
#line 7217 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1047; /* fcvtzshfdi3 */

    case 4:
      if (!
#line 7237 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1053; /* fcvtzshf3 */

    case 5:
      if (!(
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2632; /* fcvtzsv4hf3 */

    case 6:
      if (!(
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2634; /* fcvtzsv8hf3 */

    case 7:
      if (!
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2636; /* fcvtzsv2sf3 */

    case 8:
      if (!
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2638; /* fcvtzsv4sf3 */

    case 9:
      if (!
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2640; /* fcvtzsv2df3 */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern125 (x1))
    {
    case 0:
      if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12067; /* aarch64_sve_sqdmullbvnx8hi */

    case 1:
      if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12088; /* aarch64_sve_sqdmullbvnx4si */

    case 2:
      if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12109; /* aarch64_sve_sqdmullbvnx2di */

    case 3:
      if (!
#line 2283 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12125; /* aarch64_sve_sqdmullb_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12131; /* aarch64_sve_sqdmullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12712; /* aarch64_pred_reduc_uminqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12720; /* aarch64_pred_reduc_uminqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12728; /* aarch64_pred_reduc_uminqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12736; /* aarch64_pred_reduc_uminqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern131 (x1))
    {
    case 0:
      if (!
#line 2984 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12485; /* aarch64_sve_sqcadd90vnx16qi */

    case 1:
      if (!
#line 2984 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12489; /* aarch64_sve_sqcadd90vnx8hi */

    case 2:
      if (!
#line 2984 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12493; /* aarch64_sve_sqcadd90vnx4si */

    case 3:
      if (!
#line 2984 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12497; /* aarch64_sve_sqcadd90vnx2di */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 4
      || XINT (x4, 1) != 393)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x4, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (pattern1292 (x2))
    {
    case 0:
      if (!
#line 6329 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8972; /* *aarch64_cond_abdvnx8hf_2_strict */

    case 1:
      if (!
#line 6329 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8973; /* *aarch64_cond_abdvnx4sf_2_strict */

    case 2:
      if (!
#line 6329 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8974; /* *aarch64_cond_abdvnx2df_2_strict */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern867 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7216; /* *cond_sqrtvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7282; /* *cond_sqrtvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7227; /* *cond_sqrtvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7293; /* *cond_sqrtvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7238; /* *cond_sqrtvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7304; /* *cond_sqrtvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7249; /* *cond_sqrtvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7315; /* *cond_sqrtvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7260; /* *cond_sqrtvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7326; /* *cond_sqrtvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7271; /* *cond_sqrtvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7337; /* *cond_sqrtvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern867 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7212; /* *cond_frintnvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7278; /* *cond_frintnvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7223; /* *cond_frintnvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7289; /* *cond_frintnvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7234; /* *cond_frintnvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7300; /* *cond_frintnvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7245; /* *cond_frintnvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7311; /* *cond_frintnvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7256; /* *cond_frintnvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7322; /* *cond_frintnvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7267; /* *cond_frintnvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7333; /* *cond_frintnvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11607; /* *cond_uhaddvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11654; /* *cond_uhaddvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11694; /* *cond_uhaddvnx16qi_any */
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11627; /* *cond_sqrshlvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11671; /* *cond_sqrshlvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11711; /* *cond_sqrshlvnx4si_any */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1101 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8515; /* *cond_mulvnx8bf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8661; /* *cond_mulvnx8bf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8765; /* *cond_mulvnx8bf_any_relaxed */

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8528; /* *cond_mulvnx8hf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8674; /* *cond_mulvnx8hf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8778; /* *cond_mulvnx8hf_any_relaxed */

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8541; /* *cond_mulvnx4sf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8687; /* *cond_mulvnx4sf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8791; /* *cond_mulvnx4sf_any_relaxed */

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8554; /* *cond_mulvnx2df_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8700; /* *cond_mulvnx2df_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8804; /* *cond_mulvnx2df_any_relaxed */

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8615; /* *cond_mulvnx8hf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8865; /* *cond_mulvnx8hf_any_const_relaxed */

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8622; /* *cond_mulvnx4sf_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8872; /* *cond_mulvnx4sf_any_const_relaxed */

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8629; /* *cond_mulvnx2df_2_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8879; /* *cond_mulvnx2df_any_const_relaxed */

        default:
          return -1;
        }

    case 1L:
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern1101 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8567; /* *cond_mulvnx8bf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8713; /* *cond_mulvnx8bf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8817; /* *cond_mulvnx8bf_any_strict */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8580; /* *cond_mulvnx8hf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8726; /* *cond_mulvnx8hf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8830; /* *cond_mulvnx8hf_any_strict */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8593; /* *cond_mulvnx4sf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8739; /* *cond_mulvnx4sf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8843; /* *cond_mulvnx4sf_any_strict */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8606; /* *cond_mulvnx2df_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8752; /* *cond_mulvnx2df_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8856; /* *cond_mulvnx2df_any_strict */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8636; /* *cond_mulvnx8hf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8886; /* *cond_mulvnx8hf_any_const_strict */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8643; /* *cond_mulvnx4sf_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8893; /* *cond_mulvnx4sf_any_const_strict */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8650; /* *cond_mulvnx2df_2_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8900; /* *cond_mulvnx2df_any_const_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XINT (x3, 1))
    {
    case 299:
      return recog_196 (x1, insn, pnum_clobbers);

    case 351:
      return recog_197 (x1, insn, pnum_clobbers);

    case 380:
      switch (pattern867 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7207; /* *cond_negvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7273; /* *cond_negvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7218; /* *cond_negvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7284; /* *cond_negvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7229; /* *cond_negvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7295; /* *cond_negvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7240; /* *cond_negvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7306; /* *cond_negvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7251; /* *cond_negvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7317; /* *cond_negvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7262; /* *cond_negvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7328; /* *cond_negvnx2df_any_strict */

        default:
          return -1;
        }

    case 383:
      switch (pattern867 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7208; /* *cond_frecpxvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7274; /* *cond_frecpxvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7219; /* *cond_frecpxvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7285; /* *cond_frecpxvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7230; /* *cond_frecpxvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7296; /* *cond_frecpxvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7241; /* *cond_frecpxvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7307; /* *cond_frecpxvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7252; /* *cond_frecpxvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7318; /* *cond_frecpxvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7263; /* *cond_frecpxvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7329; /* *cond_frecpxvnx2df_any_strict */

        default:
          return -1;
        }

    case 384:
      switch (pattern867 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7209; /* *cond_roundvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7275; /* *cond_roundvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7220; /* *cond_roundvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7286; /* *cond_roundvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7231; /* *cond_roundvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7297; /* *cond_roundvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7242; /* *cond_roundvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7308; /* *cond_roundvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7253; /* *cond_roundvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7319; /* *cond_roundvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7264; /* *cond_roundvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7330; /* *cond_roundvnx2df_any_strict */

        default:
          return -1;
        }

    case 385:
      switch (pattern867 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7210; /* *cond_nearbyintvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7276; /* *cond_nearbyintvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7221; /* *cond_nearbyintvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7287; /* *cond_nearbyintvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7232; /* *cond_nearbyintvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7298; /* *cond_nearbyintvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7243; /* *cond_nearbyintvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7309; /* *cond_nearbyintvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7254; /* *cond_nearbyintvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7320; /* *cond_nearbyintvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7265; /* *cond_nearbyintvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7331; /* *cond_nearbyintvnx2df_any_strict */

        default:
          return -1;
        }

    case 386:
      switch (pattern867 (x2))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7211; /* *cond_floorvnx8hf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7277; /* *cond_floorvnx8hf_any_relaxed */

        case 1:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7222; /* *cond_floorvnx4sf_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7288; /* *cond_floorvnx4sf_any_relaxed */

        case 2:
          x4 = XVECEXP (x3, 0, 0);
          operands[3] = x4;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7233; /* *cond_floorvnx2df_2_relaxed */
          operands[4] = x4;
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7299; /* *cond_floorvnx2df_any_relaxed */

        case 3:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7244; /* *cond_floorvnx8hf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7310; /* *cond_floorvnx8hf_any_strict */

        case 4:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7255; /* *cond_floorvnx4sf_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7321; /* *cond_floorvnx4sf_any_strict */

        case 5:
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7266; /* *cond_floorvnx2df_2_strict */
          operands[3] = x5;
          if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 7332; /* *cond_floorvnx2df_any_strict */

        default:
          return -1;
        }

    case 387:
      return recog_207 (x1, insn, pnum_clobbers);

    case 388:
      return recog_206 (x1, insn, pnum_clobbers);

    case 389:
      return recog_205 (x1, insn, pnum_clobbers);

    case 390:
      return recog_204 (x1, insn, pnum_clobbers);

    case 392:
      return recog_203 (x1, insn, pnum_clobbers);

    case 369:
      return recog_202 (x1, insn, pnum_clobbers);

    case 370:
      return recog_201 (x1, insn, pnum_clobbers);

    case 394:
      return recog_200 (x1, insn, pnum_clobbers);

    case 397:
      return recog_199 (x1, insn, pnum_clobbers);

    case 368:
      return recog_198 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern850 (x2))
        {
        case 0:
          if (!
#line 2894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12465; /* *cond_sadalpvnx8hi_2 */

        case 1:
          if (!
#line 2894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12467; /* *cond_sadalpvnx4si_2 */

        case 2:
          if (!
#line 2894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12469; /* *cond_sadalpvnx2di_2 */

        case 3:
          if (!
#line 2917 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12471; /* *cond_sadalpvnx8hi_z */

        case 4:
          if (!
#line 2917 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12473; /* *cond_sadalpvnx4si_z */

        case 5:
          if (!
#line 2917 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12475; /* *cond_sadalpvnx2di_z */

        default:
          return -1;
        }

    case 103:
      switch (pattern850 (x2))
        {
        case 0:
          if (!
#line 2894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12466; /* *cond_uadalpvnx8hi_2 */

        case 1:
          if (!
#line 2894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12468; /* *cond_uadalpvnx4si_2 */

        case 2:
          if (!
#line 2894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12470; /* *cond_uadalpvnx2di_2 */

        case 3:
          if (!
#line 2917 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12472; /* *cond_uadalpvnx8hi_z */

        case 4:
          if (!
#line 2917 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12474; /* *cond_uadalpvnx4si_z */

        case 5:
          if (!
#line 2917 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12476; /* *cond_uadalpvnx2di_z */

        default:
          return -1;
        }

    case 438:
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4SFmode:
              if (pattern1156 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
                  || !
#line 3178 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12565; /* *cond_fcvtltvnx4sf_relaxed */

            case E_VNx2DFmode:
              if (pattern1156 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
                  || !
#line 3178 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12566; /* *cond_fcvtltvnx2df_relaxed */

            default:
              return -1;
            }

        case 1L:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4SFmode:
              if (pattern1156 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
                  || !
#line 3197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12567; /* *cond_fcvtltvnx4sf_strict */

            case E_VNx2DFmode:
              if (pattern1156 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
                  || !
#line 3197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12568; /* *cond_fcvtltvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 440:
      if (GET_MODE (x3) != E_VNx4SFmode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 0L:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          if (!
#line 3279 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 12580; /* *cond_fcvtxvnx4sf_any_relaxed */

        case 1L:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1])
              || !
#line 3302 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
            return -1;
          return 12581; /* *cond_fcvtxvnx4sf_any_strict */

        default:
          return -1;
        }

    case 442:
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[2] = x7;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern1157 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 3563 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12608; /* *cond_flogbvnx8hf */

            case E_VNx4SImode:
              if (pattern1157 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 3563 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12609; /* *cond_flogbvnx4sf */

            case E_VNx2DImode:
              if (pattern1157 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 3563 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12610; /* *cond_flogbvnx2df */

            default:
              return -1;
            }

        case 1L:
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern1157 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 3586 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12611; /* *cond_flogbvnx8hf_strict */

            case E_VNx4SImode:
              if (pattern1157 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 3586 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12612; /* *cond_flogbvnx4sf_strict */

            case E_VNx2DImode:
              if (pattern1157 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 3586 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 12613; /* *cond_flogbvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern729 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7466; /* *cond_usaddvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7636; /* *cond_usaddvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7806; /* *cond_usaddvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7483; /* *cond_usaddvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7653; /* *cond_usaddvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7823; /* *cond_usaddvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7500; /* *cond_usaddvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7670; /* *cond_usaddvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7840; /* *cond_usaddvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7517; /* *cond_usaddvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7687; /* *cond_usaddvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7857; /* *cond_usaddvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7534; /* *cond_usaddvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7704; /* *cond_usaddvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7874; /* *cond_usaddvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7551; /* *cond_usaddvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7721; /* *cond_usaddvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7891; /* *cond_usaddvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7568; /* *cond_usaddvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7738; /* *cond_usaddvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7908; /* *cond_usaddvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7585; /* *cond_usaddvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7755; /* *cond_usaddvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7925; /* *cond_usaddvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7602; /* *cond_usaddvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7772; /* *cond_usaddvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7942; /* *cond_usaddvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7619; /* *cond_usaddvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7789; /* *cond_usaddvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2766 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7959; /* *cond_usaddvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern605 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6717; /* *cond_qnegvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6807; /* *cond_qnegvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6726; /* *cond_qnegvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6816; /* *cond_qnegvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6735; /* *cond_qnegvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6825; /* *cond_qnegvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6744; /* *cond_qnegvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6834; /* *cond_qnegvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6753; /* *cond_qnegvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6843; /* *cond_qnegvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6762; /* *cond_qnegvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6852; /* *cond_qnegvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6771; /* *cond_qnegvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6861; /* *cond_qnegvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6780; /* *cond_qnegvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6870; /* *cond_qnegvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6789; /* *cond_qnegvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6879; /* *cond_qnegvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6798; /* *cond_qnegvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2759 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6888; /* *cond_qnegvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      if (pattern796 (x3, 
E_VNx32QImode, 
E_VNx16BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6306; /* vec_mask_store_lanesvnx32qivnx16qi */

    case E_VNx16HImode:
      if (pattern796 (x3, 
E_VNx16HImode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6307; /* vec_mask_store_lanesvnx16hivnx8hi */

    case E_VNx8SImode:
      if (pattern796 (x3, 
E_VNx8SImode, 
E_VNx4BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6308; /* vec_mask_store_lanesvnx8sivnx4si */

    case E_VNx4DImode:
      if (pattern796 (x3, 
E_VNx4DImode, 
E_VNx2BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6309; /* vec_mask_store_lanesvnx4divnx2di */

    case E_VNx16BFmode:
      if (pattern796 (x3, 
E_VNx16BFmode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6310; /* vec_mask_store_lanesvnx16bfvnx8bf */

    case E_VNx16HFmode:
      if (pattern796 (x3, 
E_VNx16HFmode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6311; /* vec_mask_store_lanesvnx16hfvnx8hf */

    case E_VNx8SFmode:
      if (pattern796 (x3, 
E_VNx8SFmode, 
E_VNx4BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6312; /* vec_mask_store_lanesvnx8sfvnx4sf */

    case E_VNx4DFmode:
      if (pattern796 (x3, 
E_VNx4DFmode, 
E_VNx2BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6313; /* vec_mask_store_lanesvnx4dfvnx2df */

    case E_VNx48QImode:
      if (pattern796 (x3, 
E_VNx48QImode, 
E_VNx16BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6314; /* vec_mask_store_lanesvnx48qivnx16qi */

    case E_VNx24HImode:
      if (pattern796 (x3, 
E_VNx24HImode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6315; /* vec_mask_store_lanesvnx24hivnx8hi */

    case E_VNx12SImode:
      if (pattern796 (x3, 
E_VNx12SImode, 
E_VNx4BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6316; /* vec_mask_store_lanesvnx12sivnx4si */

    case E_VNx6DImode:
      if (pattern796 (x3, 
E_VNx6DImode, 
E_VNx2BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6317; /* vec_mask_store_lanesvnx6divnx2di */

    case E_VNx24BFmode:
      if (pattern796 (x3, 
E_VNx24BFmode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6318; /* vec_mask_store_lanesvnx24bfvnx8bf */

    case E_VNx24HFmode:
      if (pattern796 (x3, 
E_VNx24HFmode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6319; /* vec_mask_store_lanesvnx24hfvnx8hf */

    case E_VNx12SFmode:
      if (pattern796 (x3, 
E_VNx12SFmode, 
E_VNx4BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6320; /* vec_mask_store_lanesvnx12sfvnx4sf */

    case E_VNx6DFmode:
      if (pattern796 (x3, 
E_VNx6DFmode, 
E_VNx2BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6321; /* vec_mask_store_lanesvnx6dfvnx2df */

    case E_VNx64QImode:
      if (pattern796 (x3, 
E_VNx64QImode, 
E_VNx16BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6322; /* vec_mask_store_lanesvnx64qivnx16qi */

    case E_VNx32HImode:
      if (pattern796 (x3, 
E_VNx32HImode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6323; /* vec_mask_store_lanesvnx32hivnx8hi */

    case E_VNx16SImode:
      if (pattern796 (x3, 
E_VNx16SImode, 
E_VNx4BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6324; /* vec_mask_store_lanesvnx16sivnx4si */

    case E_VNx8DImode:
      if (pattern796 (x3, 
E_VNx8DImode, 
E_VNx2BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6325; /* vec_mask_store_lanesvnx8divnx2di */

    case E_VNx32BFmode:
      if (pattern796 (x3, 
E_VNx32BFmode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6326; /* vec_mask_store_lanesvnx32bfvnx8bf */

    case E_VNx32HFmode:
      if (pattern796 (x3, 
E_VNx32HFmode, 
E_VNx8BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6327; /* vec_mask_store_lanesvnx32hfvnx8hf */

    case E_VNx16SFmode:
      if (pattern796 (x3, 
E_VNx16SFmode, 
E_VNx4BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6328; /* vec_mask_store_lanesvnx16sfvnx4sf */

    case E_VNx8DFmode:
      if (pattern796 (x3, 
E_VNx8DFmode, 
E_VNx2BImode) != 0
          || !
#line 2327 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6329; /* vec_mask_store_lanesvnx8dfvnx2df */

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      switch (pattern792 (x3, 
E_V8QImode))
        {
        case 0:
          if (!
#line 8536 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4829; /* aarch64_qtbx1v8qi */

        case 1:
          if (!
#line 8559 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4833; /* aarch64_qtbx2v8qi */

        case 2:
          if (!
#line 8582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4837; /* aarch64_qtbx3v8qi */

        case 3:
          if (!
#line 8605 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4841; /* aarch64_qtbx4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern792 (x3, 
E_V16QImode))
        {
        case 0:
          if (!
#line 8536 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4830; /* aarch64_qtbx1v16qi */

        case 1:
          if (!
#line 8559 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4834; /* aarch64_qtbx2v16qi */

        case 2:
          if (!
#line 8582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4838; /* aarch64_qtbx3v16qi */

        case 3:
          if (!
#line 8605 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4842; /* aarch64_qtbx4v16qi */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern194 (x3, 
E_VNx16QImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12792; /* aarch64_sve_tbxvnx16qi */

    case E_VNx8HImode:
      if (pattern194 (x3, 
E_VNx8HImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12794; /* aarch64_sve_tbxvnx8hi */

    case E_VNx4SImode:
      if (pattern194 (x3, 
E_VNx4SImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12796; /* aarch64_sve_tbxvnx4si */

    case E_VNx2DImode:
      if (pattern194 (x3, 
E_VNx2DImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12798; /* aarch64_sve_tbxvnx2di */

    case E_VNx8BFmode:
      if (pattern791 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12800; /* aarch64_sve_tbxvnx8bf */

    case E_VNx8HFmode:
      if (pattern791 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12802; /* aarch64_sve_tbxvnx8hf */

    case E_VNx4SFmode:
      if (pattern791 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12804; /* aarch64_sve_tbxvnx4sf */

    case E_VNx2DFmode:
      if (pattern791 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12806; /* aarch64_sve_tbxvnx2df */

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9953; /* while_gesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9963; /* while_gedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9973; /* while_gesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9983; /* while_gedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9993; /* while_gesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10003; /* while_gedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10013; /* while_gesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10023; /* while_gedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern796 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6336; /* aarch64_stnt1vnx16qi */

    case E_VNx8HImode:
      if (pattern796 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6337; /* aarch64_stnt1vnx8hi */

    case E_VNx4SImode:
      if (pattern796 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6338; /* aarch64_stnt1vnx4si */

    case E_VNx2DImode:
      if (pattern796 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6339; /* aarch64_stnt1vnx2di */

    case E_VNx8BFmode:
      if (pattern796 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6340; /* aarch64_stnt1vnx8bf */

    case E_VNx8HFmode:
      if (pattern796 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6341; /* aarch64_stnt1vnx8hf */

    case E_VNx4SFmode:
      if (pattern796 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6342; /* aarch64_stnt1vnx4sf */

    case E_VNx2DFmode:
      if (pattern796 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 2396 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6343; /* aarch64_stnt1vnx2df */

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1))
    {
    case 0:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10306; /* fold_extract_last_vnx16qi */

    case 1:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10308; /* fold_extract_last_vnx8hi */

    case 2:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10310; /* fold_extract_last_vnx4si */

    case 3:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10312; /* fold_extract_last_vnx2di */

    case 4:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10314; /* fold_extract_last_vnx8bf */

    case 5:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10316; /* fold_extract_last_vnx8hf */

    case 6:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10318; /* fold_extract_last_vnx4sf */

    case 7:
      if (!
#line 8904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10320; /* fold_extract_last_vnx2df */

    case 8:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10322; /* aarch64_fold_extract_vector_last_vnx16qi */

    case 9:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10324; /* aarch64_fold_extract_vector_last_vnx8hi */

    case 10:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10326; /* aarch64_fold_extract_vector_last_vnx4si */

    case 11:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10328; /* aarch64_fold_extract_vector_last_vnx2di */

    case 12:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10330; /* aarch64_fold_extract_vector_last_vnx8bf */

    case 13:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10332; /* aarch64_fold_extract_vector_last_vnx8hf */

    case 14:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10334; /* aarch64_fold_extract_vector_last_vnx4sf */

    case 15:
      if (!
#line 8918 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10336; /* aarch64_fold_extract_vector_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern177 (x1))
    {
    case 0:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
        return -1;
      return 10839; /* aarch64_sve_floatuns_nonextendvnx8hivnx8hf */

    case 1:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10845; /* aarch64_sve_floatuns_nonextendvnx4sivnx8hf */

    case 2:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 10851; /* aarch64_sve_floatuns_nonextendvnx2divnx8hf */

    case 3:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
        return -1;
      return 10841; /* aarch64_sve_floatuns_nonextendvnx8hivnx4sf */

    case 4:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10847; /* aarch64_sve_floatuns_nonextendvnx4sivnx4sf */

    case 5:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 10853; /* aarch64_sve_floatuns_nonextendvnx2divnx4sf */

    case 6:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
        return -1;
      return 10843; /* aarch64_sve_floatuns_nonextendvnx8hivnx2df */

    case 7:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10849; /* aarch64_sve_floatuns_nonextendvnx4sivnx2df */

    case 8:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 10855; /* aarch64_sve_floatuns_nonextendvnx2divnx2df */

    case 9:
      if (!
#line 9607 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10857; /* aarch64_sve_floatuns_extendvnx4sivnx2df */

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3830; /* aarch64_ssri_nv8qi */

    case 1:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3834; /* aarch64_ssri_nv16qi */

    case 2:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3838; /* aarch64_ssri_nv4hi */

    case 3:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3842; /* aarch64_ssri_nv8hi */

    case 4:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3846; /* aarch64_ssri_nv2si */

    case 5:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3850; /* aarch64_ssri_nv4si */

    case 6:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3854; /* aarch64_ssri_nv2di */

    case 7:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3858; /* aarch64_ssri_ndi */

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12502; /* aarch64_sve_cmla270vnx16qi */

    case 1:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12510; /* aarch64_sve_cmla270vnx8hi */

    case 2:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12518; /* aarch64_sve_cmla270vnx4si */

    case 3:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12526; /* aarch64_sve_cmla270vnx2di */

    case 4:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12534; /* aarch64_cmla270_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12542; /* aarch64_cmla270_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SFmode:
      if (pattern876 (x3, 
E_VNx8HFmode, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
          || !
#line 3147 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12563; /* aarch64_pred_fcvtltvnx4sf */

    case E_VNx2DFmode:
      if (pattern876 (x3, 
E_VNx4SFmode, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
          || !
#line 3147 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12564; /* aarch64_pred_fcvtltvnx2df */

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern186 (x1))
    {
    case 0:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11813; /* aarch64_sve_sbclbvnx16qi */

    case 1:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11821; /* aarch64_sve_sbclbvnx8hi */

    case 2:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11829; /* aarch64_sve_sbclbvnx4si */

    case 3:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11837; /* aarch64_sve_sbclbvnx2di */

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern180 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
        return -1;
      *pnum_clobbers = 1;
      return 10940; /* aarch64_sve_pnextvnx16bi */

    case 1:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      *pnum_clobbers = 1;
      return 10942; /* aarch64_sve_pnextvnx8bi */

    case 2:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      *pnum_clobbers = 1;
      return 10944; /* aarch64_sve_pnextvnx4bi */

    case 3:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      *pnum_clobbers = 1;
      return 10946; /* aarch64_sve_pnextvnx2bi */

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (XWINT (x3, 0) != 1L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  x5 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x5))
    {
    case CONST:
      operands[1] = x5;
      if (!aarch64_sve_ptrue_svpattern_immediate (operands[1], E_VNx16BImode))
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 128
          || GET_MODE (x6) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[3] = x8;
      x9 = XVECEXP (x6, 0, 0);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x10 = XVECEXP (x6, 0, 1);
      operands[5] = x10;
      if (!aarch64_simd_imm_zero (operands[5], E_VNx16BImode)
          || !
#line 1035 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 5722; /* *aarch64_sve_ptruevnx16bi_ptest */

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      x6 = XEXP (x5, 0);
      if (!aarch64_sve_ptrue_svpattern_immediate (x6, E_VNx16BImode))
        return -1;
      operands[1] = x6;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 2
          || XINT (x11, 1) != 128
          || GET_MODE (x11) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[3] = x8;
      x12 = XVECEXP (x11, 0, 0);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x11, 0, 1);
      operands[5] = x13;
      switch (GET_MODE (x5))
        {
        case E_VNx8BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx8BImode)
              || !
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5723; /* *aarch64_sve_ptruevnx8bi_ptest */

        case E_VNx4BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx4BImode)
              || !
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5724; /* *aarch64_sve_ptruevnx4bi_ptest */

        case E_VNx2BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx2BImode)
              || !
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5725; /* *aarch64_sve_ptruevnx2bi_ptest */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x5) != 86
          || GET_MODE (x5) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (!rtx_equal_p (x8, operands[1])
          || !
#line 1200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      *pnum_clobbers = 1;
      return 5734; /* *aarch64_rdffr_ptest */

    case UNSPEC:
      return recog_394 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16QImode
      || pattern257 (x2, 
89, 
E_VNx16QImode, 
93) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_VNx16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 93
      || GET_MODE (x4) != E_VNx16QImode)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!pmode_register_operand (operands[1], E_VOIDmode)
          || !
#line 512 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME))
        return -1;
      return 12962; /* aarch64_sme_ldr0 */

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !aarch64_mov_operand (operands[3], E_SImode)
              || !(
#line 527 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
            return -1;
          return 12963; /* aarch64_sme_ldrnsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !aarch64_mov_operand (operands[3], E_DImode)
              || !(
#line 527 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
            return -1;
          return 12964; /* aarch64_sme_ldrndi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 2L:
      switch (pattern997 (x2))
        {
        case 0:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12899; /* aarch64_sve_luti2vnx16qi */

        case 1:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12901; /* aarch64_sve_luti2vnx8hi */

        case 2:
          if (!
#line 4121 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12907; /* aarch64_sve_luti2vnx16hi */

        case 3:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12903; /* aarch64_sve_luti2vnx8hf */

        case 4:
          if (!
#line 4121 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12909; /* aarch64_sve_luti2vnx16hf */

        case 5:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12905; /* aarch64_sve_luti2vnx8bf */

        case 6:
          if (!
#line 4121 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12911; /* aarch64_sve_luti2vnx16bf */

        default:
          return -1;
        }

    case 4L:
      switch (pattern997 (x2))
        {
        case 0:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12900; /* aarch64_sve_luti4vnx16qi */

        case 1:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12902; /* aarch64_sve_luti4vnx8hi */

        case 2:
          if (!
#line 4121 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12908; /* aarch64_sve_luti4vnx16hi */

        case 3:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12904; /* aarch64_sve_luti4vnx8hf */

        case 4:
          if (!
#line 4121 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12910; /* aarch64_sve_luti4vnx16hf */

        case 5:
          if (!
#line 4109 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12906; /* aarch64_sve_luti4vnx8bf */

        case 6:
          if (!
#line 4121 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_LUT && TARGET_SVE2_OR_SME2))
            return -1;
          return 12912; /* aarch64_sve_luti4vnx16bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[4] = x3;
  if (aarch64_sve_gp_strictness (operands[4], E_SImode))
    {
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern206 (x2))
        {
        case 0:
          if (
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9024; /* aarch64_pred_fminvnx8hf */
          break;

        case 1:
          if (
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9030; /* aarch64_pred_fminvnx4sf */
          break;

        case 2:
          if (
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9036; /* aarch64_pred_fminvnx2df */
          break;

        case 3:
          if (
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return 11787; /* aarch64_pred_fminvnx8bf */
          break;

        default:
          break;
        }
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  if (pattern485 (x6, 
373) != 0)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (pattern927 (x2))
    {
    case 0:
      if (!
#line 491 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))
        return -1;
      return 11797; /* *aarch64_sve_fclampvnx8bf_x */

    case 1:
      if (!
#line 492 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11798; /* *aarch64_sve_fclampvnx8hf_x */

    case 2:
      if (!
#line 493 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11799; /* *aarch64_sve_fclampvnx4sf_x */

    case 3:
      if (!
#line 494 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11800; /* *aarch64_sve_fclampvnx2df_x */

    default:
      return -1;
    }
}

 int
recog_416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern215 (x1))
    {
    case 0:
      if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10192; /* aarch64_pred_fcmlevnx8hf */

    case 1:
      if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10198; /* aarch64_pred_fcmlevnx4sf */

    case 2:
      if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10204; /* aarch64_pred_fcmlevnx2df */

    case 3:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 2);
      x4 = XVECEXP (x3, 0, 1);
      if (XWINT (x4, 0) == 0L)
        {
          switch (pattern1258 (x2))
            {
            case 0:
              if (
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10275; /* *aarch64_pred_faclevnx8hf_relaxed */
              break;

            case 1:
              if (
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10279; /* *aarch64_pred_faclevnx4sf_relaxed */
              break;

            case 2:
              if (
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10283; /* *aarch64_pred_faclevnx2df_relaxed */
              break;

            default:
              break;
            }
        }
      operands[5] = x4;
      switch (pattern1259 (x2))
        {
        case 0:
          if (!
#line 8811 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10287; /* *aarch64_pred_faclevnx8hf_strict */

        case 1:
          if (!
#line 8811 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10291; /* *aarch64_pred_faclevnx4sf_strict */

        case 2:
          if (!
#line 8811 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10295; /* *aarch64_pred_faclevnx2df_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern224 (x1))
    {
    case 0:
      if (!
#line 1159 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13366; /* aarch64_sme_subvnx8si */

    case 1:
      if (!(
#line 1159 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13368; /* aarch64_sme_subvnx4di */

    case 2:
      if (!
#line 1159 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13370; /* aarch64_sme_subvnx16si */

    case 3:
      if (!(
#line 1159 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13372; /* aarch64_sme_subvnx8di */

    case 4:
      if (!
#line 1172 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13374; /* *aarch64_sme_subvnx8si_plus */

    case 5:
      if (!(
#line 1172 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 720 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13376; /* *aarch64_sme_subvnx4di_plus */

    case 6:
      if (!
#line 1172 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13378; /* *aarch64_sme_subvnx16si_plus */

    case 7:
      if (!(
#line 1172 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 721 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13380; /* *aarch64_sme_subvnx8di_plus */

    default:
      return -1;
    }
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern223 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 3);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern241 (x1))
            {
            case 0:
              if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13447; /* aarch64_sme_usdotvnx4sivnx32qi */

            case 1:
              if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13450; /* aarch64_sme_usdotvnx4sivnx64qi */

            case 2:
              if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13453; /* aarch64_sme_usdotvnx4sivnx16hi */

            case 3:
              if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13456; /* aarch64_sme_usdotvnx4sivnx32hi */

            case 4:
              if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13459; /* aarch64_sme_usdotvnx2divnx32qi */

            case 5:
              if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13462; /* aarch64_sme_usdotvnx2divnx64qi */

            case 6:
              if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13465; /* aarch64_sme_usdotvnx2divnx16hi */

            case 7:
              if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13468; /* aarch64_sme_usdotvnx2divnx32hi */

            case 8:
              if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13495; /* aarch64_sme_single_usdotvnx4sivnx32qi */

            case 9:
              if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13498; /* aarch64_sme_single_usdotvnx4sivnx64qi */

            case 10:
              if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13501; /* aarch64_sme_single_usdotvnx4sivnx16hi */

            case 11:
              if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13504; /* aarch64_sme_single_usdotvnx4sivnx32hi */

            case 12:
              if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13507; /* aarch64_sme_single_usdotvnx2divnx32qi */

            case 13:
              if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13510; /* aarch64_sme_single_usdotvnx2divnx64qi */

            case 14:
              if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13513; /* aarch64_sme_single_usdotvnx2divnx16hi */

            case 15:
              if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13516; /* aarch64_sme_single_usdotvnx2divnx32hi */

            case 16:
              if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13551; /* aarch64_sme_lane_usdotvnx4sivnx32qi */

            case 17:
              if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13559; /* aarch64_sme_lane_usdotvnx4sivnx64qi */

            case 18:
              if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13567; /* aarch64_sme_lane_usdotvnx4sivnx16hi */

            case 19:
              if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13575; /* aarch64_sme_lane_usdotvnx4sivnx32hi */

            case 20:
              if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13583; /* aarch64_sme_lane_usdotvnx2divnx32qi */

            case 21:
              if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13591; /* aarch64_sme_lane_usdotvnx2divnx64qi */

            case 22:
              if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13599; /* aarch64_sme_lane_usdotvnx2divnx16hi */

            case 23:
              if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13607; /* aarch64_sme_lane_usdotvnx2divnx32hi */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x4 = XEXP (x1, 0);
          if (GET_MODE (x4) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_VNx4SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_VNx16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 4);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_VNx32QImode:
              if (!register_operand (operands[1], E_VNx32QImode)
                  || !
#line 1354 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13541; /* aarch64_sme_single_sudotvnx4sivnx32qi */

            case E_VNx64QImode:
              if (!register_operand (operands[1], E_VNx64QImode)
                  || !
#line 1354 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13542; /* aarch64_sme_single_sudotvnx4sivnx64qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 3);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern245 (x1))
            {
            case 0:
              if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13471; /* *aarch64_sme_usdotvnx4sivnx32qi_plus */

            case 1:
              if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13474; /* *aarch64_sme_usdotvnx4sivnx64qi_plus */

            case 2:
              if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13477; /* *aarch64_sme_usdotvnx4sivnx16hi_plus */

            case 3:
              if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13480; /* *aarch64_sme_usdotvnx4sivnx32hi_plus */

            case 4:
              if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13483; /* *aarch64_sme_usdotvnx2divnx32qi_plus */

            case 5:
              if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13486; /* *aarch64_sme_usdotvnx2divnx64qi_plus */

            case 6:
              if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13489; /* *aarch64_sme_usdotvnx2divnx16hi_plus */

            case 7:
              if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13492; /* *aarch64_sme_usdotvnx2divnx32hi_plus */

            case 8:
              if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13519; /* *aarch64_sme_single_usdotvnx4sivnx32qi_plus */

            case 9:
              if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13522; /* *aarch64_sme_single_usdotvnx4sivnx64qi_plus */

            case 10:
              if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13525; /* *aarch64_sme_single_usdotvnx4sivnx16hi_plus */

            case 11:
              if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13528; /* *aarch64_sme_single_usdotvnx4sivnx32hi_plus */

            case 12:
              if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13531; /* *aarch64_sme_single_usdotvnx2divnx32qi_plus */

            case 13:
              if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13534; /* *aarch64_sme_single_usdotvnx2divnx64qi_plus */

            case 14:
              if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13537; /* *aarch64_sme_single_usdotvnx2divnx16hi_plus */

            case 15:
              if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13540; /* *aarch64_sme_single_usdotvnx2divnx32hi_plus */

            case 16:
              if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13615; /* *aarch64_sme_lane_usdotvnx4sivnx32qi_plus */

            case 17:
              if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || false)))
                return -1;
              return 13623; /* *aarch64_sme_lane_usdotvnx4sivnx64qi_plus */

            case 18:
              if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13631; /* *aarch64_sme_lane_usdotvnx4sivnx16hi_plus */

            case 19:
              if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || false)))
                return -1;
              return 13639; /* *aarch64_sme_lane_usdotvnx4sivnx32hi_plus */

            case 20:
              if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13647; /* *aarch64_sme_lane_usdotvnx2divnx32qi_plus */

            case 21:
              if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13655; /* *aarch64_sme_lane_usdotvnx2divnx64qi_plus */

            case 22:
              if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13663; /* *aarch64_sme_lane_usdotvnx2divnx16hi_plus */

            case 23:
              if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || false)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
                return -1;
              return 13671; /* *aarch64_sme_lane_usdotvnx2divnx32hi_plus */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x4 = XEXP (x1, 0);
          if (GET_MODE (x4) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_VNx4SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[3] = x6;
          if (!register_operand (operands[3], E_VNx16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 4);
          operands[2] = x7;
          switch (GET_MODE (x3))
            {
            case E_VNx32QImode:
              if (!register_operand (operands[2], E_VNx32QImode)
                  || !
#line 1369 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13543; /* *aarch64_sme_single_sudotvnx4sivnx32qi_plus */

            case E_VNx64QImode:
              if (!register_operand (operands[2], E_VNx64QImode)
                  || !
#line 1369 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13544; /* *aarch64_sme_single_sudotvnx4sivnx64qi_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 43:
      return recog_157 (x1, insn, pnum_clobbers);

    case 9:
      if (pattern73 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 465; /* aarch64_crc32b */

    case 14:
      if (pattern73 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 466; /* aarch64_crc32h */

    case 15:
      if (pattern74 (x1, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 467; /* aarch64_crc32w */

    case 16:
      if (pattern73 (x1, 
E_DImode, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 468; /* aarch64_crc32x */

    case 10:
      if (pattern73 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 469; /* aarch64_crc32cb */

    case 11:
      if (pattern73 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 470; /* aarch64_crc32ch */

    case 12:
      if (pattern74 (x1, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 471; /* aarch64_crc32cw */

    case 13:
      if (pattern73 (x1, 
E_DImode, 
E_SImode) != 0
          || !
#line 4716 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CRC32))
        return -1;
      return 472; /* aarch64_crc32cx */

    case 84:
      if (pattern73 (x1, 
E_QImode, 
E_DImode) != 0
          || !
#line 6076 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 757; /* *aarch64_sisd_ushl */

    case 105:
      if (pattern73 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 6086 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 758; /* *aarch64_ushl_2s */

    case 83:
      if (pattern73 (x1, 
E_QImode, 
E_DImode) != 0
          || !
#line 6096 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 759; /* *aarch64_sisd_sshl */

    case 85:
      if (pattern73 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 6106 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 760; /* *aarch64_sshl_2s */

    case 19:
      return recog_152 (x1, insn, pnum_clobbers);

    case 20:
      return recog_151 (x1, insn, pnum_clobbers);

    case 79:
      return recog_150 (x1, insn, pnum_clobbers);

    case 104:
      return recog_149 (x1, insn, pnum_clobbers);

    case 196:
      return recog_95 (x1, insn, pnum_clobbers);

    case 199:
      return recog_94 (x1, insn, pnum_clobbers);

    case 277:
      return recog_93 (x1, insn, pnum_clobbers);

    case 278:
      return recog_74 (x1, insn, pnum_clobbers);

    case 42:
      return recog_126 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1142; /* tlsle12_si */

        case 1:
          if (!
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1143; /* tlsle12_di */

        default:
          return -1;
        }

    case 100:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 163 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1144; /* tlsle24_si */

        case 1:
          if (!
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1145; /* tlsle24_di */

        default:
          return -1;
        }

    case 74:
      if (pattern84 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1156; /* paciasp */

    case 2:
      if (pattern84 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1157; /* autiasp */

    case 75:
      if (pattern84 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1158; /* pacibsp */

    case 3:
      if (pattern84 (x1, 
E_DImode, 
30, 
31) != 0)
        return -1;
      return 1159; /* autibsp */

    case 72:
      if (pattern84 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1160; /* pacia1716 */

    case 0:
      if (pattern84 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1161; /* autia1716 */

    case 73:
      if (pattern84 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1162; /* pacib1716 */

    case 1:
      if (pattern84 (x1, 
E_DImode, 
17, 
16) != 0)
        return -1;
      return 1163; /* autib1716 */

    case 109:
      return recog_148 (x1, insn, pnum_clobbers);

    case 154:
      if (pattern86 (x1) != 0)
        return -1;
      return 1183; /* speculation_tracker */

    case 155:
      if (pattern86 (x1) != 0)
        return -1;
      return 1184; /* speculation_tracker_rev */

    case 405:
      return recog_170 (x1, insn, pnum_clobbers);

    case 406:
      return recog_169 (x1, insn, pnum_clobbers);

    case 112:
      return recog_117 (x1, insn, pnum_clobbers);

    case 186:
      return recog_156 (x1, insn, pnum_clobbers);

    case 185:
      return recog_155 (x1, insn, pnum_clobbers);

    case 274:
      return recog_90 (x1, insn, pnum_clobbers);

    case 208:
      return recog_122 (x1, insn, pnum_clobbers);

    case 209:
      return recog_120 (x1, insn, pnum_clobbers);

    case 206:
      return recog_121 (x1, insn, pnum_clobbers);

    case 207:
      return recog_119 (x1, insn, pnum_clobbers);

    case 198:
      return recog_147 (x1, insn, pnum_clobbers);

    case 201:
      return recog_146 (x1, insn, pnum_clobbers);

    case 197:
      return recog_145 (x1, insn, pnum_clobbers);

    case 200:
      return recog_144 (x1, insn, pnum_clobbers);

    case 202:
      return recog_143 (x1, insn, pnum_clobbers);

    case 218:
      return recog_159 (x1, insn, pnum_clobbers);

    case 271:
      return recog_110 (x1, insn, pnum_clobbers);

    case 219:
      return recog_75 (x1, insn, pnum_clobbers);

    case 221:
      return recog_88 (x1, insn, pnum_clobbers);

    case 220:
      return recog_116 (x1, insn, pnum_clobbers);

    case 216:
      return recog_73 (x1, insn, pnum_clobbers);

    case 217:
      return recog_78 (x1, insn, pnum_clobbers);

    case 229:
      return recog_142 (x1, insn, pnum_clobbers);

    case 230:
      return recog_141 (x1, insn, pnum_clobbers);

    case 231:
      return recog_92 (x1, insn, pnum_clobbers);

    case 232:
      return recog_91 (x1, insn, pnum_clobbers);

    case 227:
      return recog_98 (x1, insn, pnum_clobbers);

    case 228:
      return recog_97 (x1, insn, pnum_clobbers);

    case 233:
      return recog_115 (x1, insn, pnum_clobbers);

    case 234:
      return recog_114 (x1, insn, pnum_clobbers);

    case 226:
      return recog_96 (x1, insn, pnum_clobbers);

    case 94:
      return recog_86 (x1, insn, pnum_clobbers);

    case 95:
      return recog_85 (x1, insn, pnum_clobbers);

    case 96:
      return recog_84 (x1, insn, pnum_clobbers);

    case 183:
      return recog_113 (x1, insn, pnum_clobbers);

    case 273:
      return recog_77 (x1, insn, pnum_clobbers);

    case 242:
      return recog_89 (x1, insn, pnum_clobbers);

    case 246:
      if (pattern105 (x1, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 8615 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4843; /* aarch64_combinev16qi */

    case 247:
      return recog_72 (x1, insn, pnum_clobbers);

    case 248:
      return recog_83 (x1, insn, pnum_clobbers);

    case 251:
      return recog_82 (x1, insn, pnum_clobbers);

    case 252:
      return recog_81 (x1, insn, pnum_clobbers);

    case 249:
      return recog_80 (x1, insn, pnum_clobbers);

    case 250:
      return recog_79 (x1, insn, pnum_clobbers);

    case 28:
      return recog_112 (x1, insn, pnum_clobbers);

    case 266:
      if (pattern74 (x1, 
E_V4SImode) != 0
          || !
#line 9015 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5184; /* aarch64_crypto_sha1su1v4si */

    case 269:
      if (pattern74 (x1, 
E_V4SImode) != 0
          || !
#line 9060 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5191; /* aarch64_crypto_sha256su0v4si */

    case 292:
      if (pattern74 (x1, 
E_V2DImode) != 0
          || !
#line 9094 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
        return -1;
      return 5195; /* aarch64_crypto_sha512su0qv2di */

    case 288:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 9229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
            return -1;
          return 5214; /* aarch64_sm4eqv4si */

        case 1:
          if (!
#line 4232 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_SM4))
            return -1;
          return 12920; /* aarch64_sve2_sm4e */

        default:
          return -1;
        }

    case 289:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 9239 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
            return -1;
          return 5215; /* aarch64_sm4ekeyqv4si */

        case 1:
          if (!
#line 4243 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_SM4))
            return -1;
          return 12921; /* aarch64_sve2_sm4ekey */

        default:
          return -1;
        }

    case 272:
      if (pattern105 (x1, 
E_V2DImode, 
E_TImode) != 0
          || !
#line 9835 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
        return -1;
      return 5241; /* aarch64_crypto_pmullv2di */

    case 586:
      if (pattern73 (x1, 
E_V4SFmode, 
E_V8BFmode) != 0
          || !
#line 9986 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5275; /* aarch64_bfcvtn2v8bf */

    case 589:
      return recog_168 (x1, insn, pnum_clobbers);

    case 590:
      return recog_167 (x1, insn, pnum_clobbers);

    case 190:
      return recog_192 (x1, insn, pnum_clobbers);

    case 192:
      return recog_191 (x1, insn, pnum_clobbers);

    case 204:
      return recog_118 (x1, insn, pnum_clobbers);

    case 69:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 5533; /* *dmb */

    case 125:
      return recog_71 (x1, insn, pnum_clobbers);

    case 152:
      return recog_104 (x1, insn, pnum_clobbers);

    case 158:
      return recog_154 (x1, insn, pnum_clobbers);

    case 119:
      return recog_109 (x1, insn, pnum_clobbers);

    case 177:
      return recog_103 (x1, insn, pnum_clobbers);

    case 148:
      return recog_108 (x1, insn, pnum_clobbers);

    case 398:
      return recog_140 (x1, insn, pnum_clobbers);

    case 399:
      return recog_139 (x1, insn, pnum_clobbers);

    case 298:
      return recog_105 (x1, insn, pnum_clobbers);

    case 400:
      switch (pattern112 (x1))
        {
        case 0:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8328; /* aarch64_sve_lslvnx16qi */

        case 1:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8331; /* aarch64_sve_lslvnx8hi */

        case 2:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8334; /* aarch64_sve_lslvnx4si */

        default:
          return -1;
        }

    case 401:
      switch (pattern112 (x1))
        {
        case 0:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8329; /* aarch64_sve_asrvnx16qi */

        case 1:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8332; /* aarch64_sve_asrvnx8hi */

        case 2:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8335; /* aarch64_sve_asrvnx4si */

        default:
          return -1;
        }

    case 402:
      switch (pattern112 (x1))
        {
        case 0:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8330; /* aarch64_sve_lsrvnx16qi */

        case 1:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8333; /* aarch64_sve_lsrvnx8hi */

        case 2:
          if (!
#line 4978 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8336; /* aarch64_sve_lsrvnx4si */

        default:
          return -1;
        }

    case 328:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 5184 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8453; /* aarch64_sve_ftsmulvnx8hf */

        case 1:
          if (!
#line 5184 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8455; /* aarch64_sve_ftsmulvnx4sf */

        case 2:
          if (!
#line 5184 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8457; /* aarch64_sve_ftsmulvnx2df */

        default:
          return -1;
        }

    case 329:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 5184 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8454; /* aarch64_sve_ftsselvnx8hf */

        case 1:
          if (!
#line 5184 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8456; /* aarch64_sve_ftsselvnx4sf */

        case 2:
          if (!
#line 5184 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8458; /* aarch64_sve_ftsselvnx2df */

        default:
          return -1;
        }

    case 313:
      return recog_125 (x1, insn, pnum_clobbers);

    case 314:
      return recog_123 (x1, insn, pnum_clobbers);

    case 315:
      return recog_124 (x1, insn, pnum_clobbers);

    case 308:
      return recog_190 (x1, insn, pnum_clobbers);

    case 309:
      return recog_189 (x1, insn, pnum_clobbers);

    case 310:
      return recog_188 (x1, insn, pnum_clobbers);

    case 311:
      return recog_187 (x1, insn, pnum_clobbers);

    case 312:
      return recog_186 (x1, insn, pnum_clobbers);

    case 243:
      return recog_107 (x1, insn, pnum_clobbers);

    case 172:
      return recog_138 (x1, insn, pnum_clobbers);

    case 628:
      return recog_102 (x1, insn, pnum_clobbers);

    case 629:
      return recog_101 (x1, insn, pnum_clobbers);

    case 630:
      return recog_100 (x1, insn, pnum_clobbers);

    case 631:
      return recog_99 (x1, insn, pnum_clobbers);

    case 338:
      return recog_137 (x1, insn, pnum_clobbers);

    case 339:
      return recog_136 (x1, insn, pnum_clobbers);

    case 334:
      return recog_135 (x1, insn, pnum_clobbers);

    case 335:
      return recog_134 (x1, insn, pnum_clobbers);

    case 336:
      return recog_132 (x1, insn, pnum_clobbers);

    case 337:
      return recog_133 (x1, insn, pnum_clobbers);

    case 133:
      return recog_111 (x1, insn, pnum_clobbers);

    case 612:
      return recog_153 (x1, insn, pnum_clobbers);

    case 607:
      return recog_131 (x1, insn, pnum_clobbers);

    case 609:
      return recog_76 (x1, insn, pnum_clobbers);

    case 494:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12036; /* aarch64_sve_saddwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12044; /* aarch64_sve_saddwbvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12052; /* aarch64_sve_saddwbvnx2di */

        default:
          return -1;
        }

    case 495:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12037; /* aarch64_sve_saddwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12045; /* aarch64_sve_saddwtvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12053; /* aarch64_sve_saddwtvnx2di */

        default:
          return -1;
        }

    case 539:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12038; /* aarch64_sve_ssubwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12046; /* aarch64_sve_ssubwbvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12054; /* aarch64_sve_ssubwbvnx2di */

        default:
          return -1;
        }

    case 540:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12039; /* aarch64_sve_ssubwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12047; /* aarch64_sve_ssubwtvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12055; /* aarch64_sve_ssubwtvnx2di */

        default:
          return -1;
        }

    case 551:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12040; /* aarch64_sve_uaddwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12048; /* aarch64_sve_uaddwbvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12056; /* aarch64_sve_uaddwbvnx2di */

        default:
          return -1;
        }

    case 552:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12041; /* aarch64_sve_uaddwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12049; /* aarch64_sve_uaddwtvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12057; /* aarch64_sve_uaddwtvnx2di */

        default:
          return -1;
        }

    case 571:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12042; /* aarch64_sve_usubwbvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12050; /* aarch64_sve_usubwbvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12058; /* aarch64_sve_usubwbvnx2di */

        default:
          return -1;
        }

    case 572:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12043; /* aarch64_sve_usubwtvnx8hi */

        case 1:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12051; /* aarch64_sve_usubwtvnx4si */

        case 2:
          if (!
#line 2233 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12059; /* aarch64_sve_usubwtvnx2di */

        default:
          return -1;
        }

    case 489:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12060; /* aarch64_sve_sabdlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12081; /* aarch64_sve_sabdlbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12102; /* aarch64_sve_sabdlbvnx2di */

        default:
          return -1;
        }

    case 490:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12061; /* aarch64_sve_sabdltvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12082; /* aarch64_sve_sabdltvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12103; /* aarch64_sve_sabdltvnx2di */

        default:
          return -1;
        }

    case 491:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12062; /* aarch64_sve_saddlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12083; /* aarch64_sve_saddlbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12104; /* aarch64_sve_saddlbvnx2di */

        default:
          return -1;
        }

    case 492:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12063; /* aarch64_sve_saddlbtvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12084; /* aarch64_sve_saddlbtvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12105; /* aarch64_sve_saddlbtvnx2di */

        default:
          return -1;
        }

    case 493:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12064; /* aarch64_sve_saddltvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12085; /* aarch64_sve_saddltvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12106; /* aarch64_sve_saddltvnx2di */

        default:
          return -1;
        }

    case 505:
      return recog_166 (x1, insn, pnum_clobbers);

    case 506:
      return recog_165 (x1, insn, pnum_clobbers);

    case 509:
      return recog_164 (x1, insn, pnum_clobbers);

    case 511:
      return recog_163 (x1, insn, pnum_clobbers);

    case 535:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12069; /* aarch64_sve_ssublbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12090; /* aarch64_sve_ssublbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12111; /* aarch64_sve_ssublbvnx2di */

        default:
          return -1;
        }

    case 536:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12070; /* aarch64_sve_ssublbtvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12091; /* aarch64_sve_ssublbtvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12112; /* aarch64_sve_ssublbtvnx2di */

        default:
          return -1;
        }

    case 537:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12071; /* aarch64_sve_ssubltvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12092; /* aarch64_sve_ssubltvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12113; /* aarch64_sve_ssubltvnx2di */

        default:
          return -1;
        }

    case 538:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12072; /* aarch64_sve_ssubltbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12093; /* aarch64_sve_ssubltbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12114; /* aarch64_sve_ssubltbvnx2di */

        default:
          return -1;
        }

    case 547:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12073; /* aarch64_sve_uabdlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12094; /* aarch64_sve_uabdlbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12115; /* aarch64_sve_uabdlbvnx2di */

        default:
          return -1;
        }

    case 548:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12074; /* aarch64_sve_uabdltvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12095; /* aarch64_sve_uabdltvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12116; /* aarch64_sve_uabdltvnx2di */

        default:
          return -1;
        }

    case 549:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12075; /* aarch64_sve_uaddlbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12096; /* aarch64_sve_uaddlbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12117; /* aarch64_sve_uaddlbvnx2di */

        default:
          return -1;
        }

    case 550:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12076; /* aarch64_sve_uaddltvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12097; /* aarch64_sve_uaddltvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12118; /* aarch64_sve_uaddltvnx2di */

        default:
          return -1;
        }

    case 557:
      return recog_162 (x1, insn, pnum_clobbers);

    case 558:
      return recog_161 (x1, insn, pnum_clobbers);

    case 569:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12079; /* aarch64_sve_usublbvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12100; /* aarch64_sve_usublbvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12121; /* aarch64_sve_usublbvnx2di */

        default:
          return -1;
        }

    case 570:
      switch (pattern123 (x1))
        {
        case 0:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12080; /* aarch64_sve_usubltvnx8hi */

        case 1:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12101; /* aarch64_sve_usubltvnx4si */

        case 2:
          if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12122; /* aarch64_sve_usubltvnx2di */

        default:
          return -1;
        }

    case 533:
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12135; /* aarch64_sve_sshllbvnx8hi */

        case 1:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12139; /* aarch64_sve_sshllbvnx4si */

        case 2:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12143; /* aarch64_sve_sshllbvnx2di */

        default:
          return -1;
        }

    case 534:
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12136; /* aarch64_sve_sshlltvnx8hi */

        case 1:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12140; /* aarch64_sve_sshlltvnx4si */

        case 2:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12144; /* aarch64_sve_sshlltvnx2di */

        default:
          return -1;
        }

    case 567:
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12137; /* aarch64_sve_ushllbvnx8hi */

        case 1:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12141; /* aarch64_sve_ushllbvnx4si */

        case 2:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12145; /* aarch64_sve_ushllbvnx2di */

        default:
          return -1;
        }

    case 568:
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12138; /* aarch64_sve_ushlltvnx8hi */

        case 1:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12142; /* aarch64_sve_ushlltvnx4si */

        case 2:
          if (!
#line 2304 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12146; /* aarch64_sve_ushlltvnx2di */

        default:
          return -1;
        }

    case 529:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12310; /* aarch64_sve_sqxtntvnx8hi */

        case 1:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12313; /* aarch64_sve_sqxtntvnx4si */

        case 2:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12316; /* aarch64_sve_sqxtntvnx2di */

        default:
          return -1;
        }

    case 531:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12311; /* aarch64_sve_sqxtuntvnx8hi */

        case 1:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12314; /* aarch64_sve_sqxtuntvnx4si */

        case 2:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12317; /* aarch64_sve_sqxtuntvnx2di */

        default:
          return -1;
        }

    case 566:
      switch (pattern127 (x1))
        {
        case 0:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12312; /* aarch64_sve_uqxtntvnx8hi */

        case 1:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12315; /* aarch64_sve_uqxtntvnx4si */

        case 2:
          if (!
#line 2638 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12318; /* aarch64_sve_uqxtntvnx2di */

        default:
          return -1;
        }

    case 418:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12337; /* aarch64_sve_addhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12341; /* aarch64_sve_addhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12345; /* aarch64_sve_addhnbvnx2di */

        default:
          return -1;
        }

    case 483:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12338; /* aarch64_sve_raddhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12342; /* aarch64_sve_raddhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12346; /* aarch64_sve_raddhnbvnx2di */

        default:
          return -1;
        }

    case 487:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12339; /* aarch64_sve_rsubhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12343; /* aarch64_sve_rsubhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12347; /* aarch64_sve_rsubhnbvnx2di */

        default:
          return -1;
        }

    case 543:
      switch (pattern128 (x1))
        {
        case 0:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12340; /* aarch64_sve_subhnbvnx8hi */

        case 1:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12344; /* aarch64_sve_subhnbvnx4si */

        case 2:
          if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12348; /* aarch64_sve_subhnbvnx2di */

        default:
          return -1;
        }

    case 485:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12364; /* aarch64_sve_rshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12372; /* aarch64_sve_rshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12380; /* aarch64_sve_rshrnbvnx2di */

        default:
          return -1;
        }

    case 498:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12365; /* aarch64_sve_shrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12373; /* aarch64_sve_shrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12381; /* aarch64_sve_shrnbvnx2di */

        default:
          return -1;
        }

    case 518:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12366; /* aarch64_sve_sqrshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12374; /* aarch64_sve_sqrshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12382; /* aarch64_sve_sqrshrnbvnx2di */

        default:
          return -1;
        }

    case 522:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12367; /* aarch64_sve_sqrshrunbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12375; /* aarch64_sve_sqrshrunbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12383; /* aarch64_sve_sqrshrunbvnx2di */

        default:
          return -1;
        }

    case 524:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12368; /* aarch64_sve_sqshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12376; /* aarch64_sve_sqshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12384; /* aarch64_sve_sqshrnbvnx2di */

        default:
          return -1;
        }

    case 526:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12369; /* aarch64_sve_sqshrunbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12377; /* aarch64_sve_sqshrunbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12385; /* aarch64_sve_sqshrunbvnx2di */

        default:
          return -1;
        }

    case 561:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12370; /* aarch64_sve_uqrshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12378; /* aarch64_sve_uqrshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12386; /* aarch64_sve_uqrshrnbvnx2di */

        default:
          return -1;
        }

    case 563:
      switch (pattern129 (x1))
        {
        case 0:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12371; /* aarch64_sve_uqshrnbvnx8hi */

        case 1:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12379; /* aarch64_sve_uqshrnbvnx4si */

        case 2:
          if (!
#line 2760 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12387; /* aarch64_sve_uqshrnbvnx2di */

        default:
          return -1;
        }

    case 516:
      switch (pattern130 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3573 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12412; /* aarch64_sve_sqrshrvnx8si */

        case 1:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3573 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12424; /* aarch64_sve_sqrshrvnx8di */

        case 2:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3573 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12418; /* aarch64_sve_sqrshrvnx16si */

        default:
          return -1;
        }

    case 517:
      switch (pattern130 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3574 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12413; /* aarch64_sve_sqrshrnvnx8si */

        case 1:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3574 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12425; /* aarch64_sve_sqrshrnvnx8di */

        case 2:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3574 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12419; /* aarch64_sve_sqrshrnvnx16si */

        default:
          return -1;
        }

    case 520:
      switch (pattern130 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3575 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12414; /* aarch64_sve_sqrshruvnx8si */

        case 1:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3575 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12426; /* aarch64_sve_sqrshruvnx8di */

        case 2:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3575 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12420; /* aarch64_sve_sqrshruvnx16si */

        default:
          return -1;
        }

    case 521:
      switch (pattern130 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3576 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12415; /* aarch64_sve_sqrshrunvnx8si */

        case 1:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3576 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12427; /* aarch64_sve_sqrshrunvnx8di */

        case 2:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3576 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12421; /* aarch64_sve_sqrshrunvnx16si */

        default:
          return -1;
        }

    case 559:
      switch (pattern130 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3577 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12416; /* aarch64_sve_uqrshrvnx8si */

        case 1:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3577 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12428; /* aarch64_sve_uqrshrvnx8di */

        case 2:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3577 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2)))
            return -1;
          return 12422; /* aarch64_sve_uqrshrvnx16si */

        default:
          return -1;
        }

    case 560:
      switch (pattern130 (x1))
        {
        case 0:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3578 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12417; /* aarch64_sve_uqrshrnvnx8si */

        case 1:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx8DImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3578 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12429; /* aarch64_sve_uqrshrnvnx8di */

        case 2:
          if (!(
#line 2795 "../../../gcc/config/aarch64/aarch64-sve2.md"
((VNx16SImode == VNx8SImode || TARGET_STREAMING_SME2)) && 
#line 3578 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12423; /* aarch64_sve_uqrshrnvnx16si */

        default:
          return -1;
        }

    case 424:
      return recog_185 (x1, insn, pnum_clobbers);

    case 423:
      return recog_183 (x1, insn, pnum_clobbers);

    case 508:
      return recog_184 (x1, insn, pnum_clobbers);

    case 507:
      return recog_182 (x1, insn, pnum_clobbers);

    case 447:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12569; /* aarch64_sve2_fp8_cvt_f1cvtvnx8bf */

        case 1:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12573; /* aarch64_sve2_fp8_cvt_f1cvtvnx8hf */

        default:
          return -1;
        }

    case 449:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12570; /* aarch64_sve2_fp8_cvt_f2cvtvnx8bf */

        case 1:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12574; /* aarch64_sve2_fp8_cvt_f2cvtvnx8hf */

        default:
          return -1;
        }

    case 448:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12571; /* aarch64_sve2_fp8_cvt_f1cvtltvnx8bf */

        case 1:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12575; /* aarch64_sve2_fp8_cvt_f1cvtltvnx8hf */

        default:
          return -1;
        }

    case 450:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12572; /* aarch64_sve2_fp8_cvt_f2cvtltvnx8bf */

        case 1:
          if (!
#line 3207 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
            return -1;
          return 12576; /* aarch64_sve2_fp8_cvt_f2cvtltvnx8hf */

        default:
          return -1;
        }

    case 468:
      return recog_158 (x1, insn, pnum_clobbers);

    case 452:
      if (pattern134 (x2, 
84, 
E_VNx16QImode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!aligned_register_operand (operands[1], E_VNx8SFmode)
          || !
#line 3397 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12591; /* aarch64_sve2_fp8_cvtnbvnx16qi */

    case 477:
      switch (pattern135 (x1))
        {
        case 0:
          if (!
#line 3622 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12615; /* aarch64_sve_pmullbvnx8hi */

        case 1:
          if (!
#line 3622 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12617; /* aarch64_sve_pmullbvnx2di */

        default:
          return -1;
        }

    case 479:
      switch (pattern135 (x1))
        {
        case 0:
          if (!
#line 3622 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12616; /* aarch64_sve_pmulltvnx8hi */

        case 1:
          if (!
#line 3622 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12618; /* aarch64_sve_pmulltvnx2di */

        default:
          return -1;
        }

    case 478:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 3635 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12619; /* aarch64_sve_pmullb_pairvnx16qi */

        case 1:
          if (!
#line 3635 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12621; /* aarch64_sve_pmullb_pairvnx4si */

        case 2:
          if (!(
#line 3635 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 658 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2_AES)))
            return -1;
          return 12623; /* aarch64_sve_pmullb_pairvnx2di */

        default:
          return -1;
        }

    case 480:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 3635 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12620; /* aarch64_sve_pmullt_pairvnx16qi */

        case 1:
          if (!
#line 3635 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12622; /* aarch64_sve_pmullt_pairvnx4si */

        case 2:
          if (!(
#line 3635 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 658 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2_AES)))
            return -1;
          return 12624; /* aarch64_sve_pmullt_pairvnx2di */

        default:
          return -1;
        }

    case 594:
      return recog_180 (x1, insn, pnum_clobbers);

    case 595:
      return recog_181 (x1, insn, pnum_clobbers);

    case 597:
      return recog_179 (x1, insn, pnum_clobbers);

    case 610:
      return recog_178 (x1, insn, pnum_clobbers);

    case 615:
      return recog_177 (x1, insn, pnum_clobbers);

    case 616:
      return recog_176 (x1, insn, pnum_clobbers);

    case 624:
      return recog_175 (x1, insn, pnum_clobbers);

    case 625:
      return recog_174 (x1, insn, pnum_clobbers);

    case 599:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12737; /* aarch64_pred_reduc_faddqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12742; /* aarch64_pred_reduc_faddqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12747; /* aarch64_pred_reduc_faddqv_vnx2df */

        default:
          return -1;
        }

    case 600:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12738; /* aarch64_pred_reduc_fmaxqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12743; /* aarch64_pred_reduc_fmaxqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12748; /* aarch64_pred_reduc_fmaxqv_vnx2df */

        default:
          return -1;
        }

    case 601:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12739; /* aarch64_pred_reduc_fmaxnmqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12744; /* aarch64_pred_reduc_fmaxnmqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12749; /* aarch64_pred_reduc_fmaxnmqv_vnx2df */

        default:
          return -1;
        }

    case 602:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12740; /* aarch64_pred_reduc_fminqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12745; /* aarch64_pred_reduc_fminqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12750; /* aarch64_pred_reduc_fminqv_vnx2df */

        default:
          return -1;
        }

    case 603:
      switch (pattern138 (x1))
        {
        case 0:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12741; /* aarch64_pred_reduc_fminnmqv_vnx8hf */

        case 1:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12746; /* aarch64_pred_reduc_fminnmqv_vnx4sf */

        case 2:
          if (!
#line 3744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 12751; /* aarch64_pred_reduc_fminnmqv_vnx2df */

        default:
          return -1;
        }

    case 596:
      return recog_87 (x1, insn, pnum_clobbers);

    case 545:
      return recog_106 (x1, insn, pnum_clobbers);

    case 576:
      return recog_130 (x1, insn, pnum_clobbers);

    case 574:
      return recog_129 (x1, insn, pnum_clobbers);

    case 577:
      return recog_128 (x1, insn, pnum_clobbers);

    case 575:
      return recog_127 (x1, insn, pnum_clobbers);

    case 420:
      return recog_173 (x1, insn, pnum_clobbers);

    case 421:
      return recog_172 (x1, insn, pnum_clobbers);

    case 422:
      return recog_171 (x1, insn, pnum_clobbers);

    case 470:
      if (pattern74 (x1, 
E_VNx16QImode) != 0
          || !
#line 3996 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 12886; /* aarch64_sve2_histsegvnx16qi */

    case 682:
      if (pattern141 (x1, 
E_DImode, 
67) != 0)
        return -1;
      return 12922; /* aarch64_old_vg_saved */

    case 690:
      if (pnum_clobbers == NULL
          || pattern142 (x1, 
91, 
90) != 0)
        return -1;
      *pnum_clobbers = 7;
      return 12928; /* aarch64_tpidr2_save */

    case 689:
      if (pattern142 (x1, 
93, 
91) != 0)
        return -1;
      return 12931; /* aarch64_initial_zero_za */

    case 693:
      if (pattern134 (x2, 
88, 
E_DImode) != 0
          || pattern727 (x1, 
90) != 0)
        return -1;
      return 12934; /* aarch64_write_tpidr2 */

    case 692:
      if (GET_MODE (x2) != E_DImode
          || pattern257 (x2, 
92, 
E_DImode, 
90) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 12935; /* aarch64_read_tpidr2 */

    case 700:
      return recog_160 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sve_dup_operand (operands[1], E_QImode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6401; /* *vec_duplicatevnx16qi_reg */

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6420; /* aarch64_vec_duplicate_vqvnx16qi_le */

        default:
          return -1;
        }

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6402; /* *vec_duplicatevnx8qi_reg */

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6403; /* *vec_duplicatevnx4qi_reg */

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6404; /* *vec_duplicatevnx2qi_reg */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!aarch64_sve_dup_operand (operands[1], E_HImode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6405; /* *vec_duplicatevnx8hi_reg */

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6421; /* aarch64_vec_duplicate_vqvnx8hi_le */

        default:
          return -1;
        }

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6406; /* *vec_duplicatevnx4hi_reg */

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6407; /* *vec_duplicatevnx2hi_reg */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!aarch64_sve_dup_operand (operands[1], E_SImode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6408; /* *vec_duplicatevnx4si_reg */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6422; /* aarch64_vec_duplicate_vqvnx4si_le */

        default:
          return -1;
        }

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2SImode
          || !aarch64_sve_dup_operand (operands[1], E_SImode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6409; /* *vec_duplicatevnx2si_reg */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!aarch64_sve_dup_operand (operands[1], E_DImode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6410; /* *vec_duplicatevnx2di_reg */

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6423; /* aarch64_vec_duplicate_vqvnx2di_le */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_HFmode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6411; /* *vec_duplicatevnx8hf_reg */

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6425; /* aarch64_vec_duplicate_vqvnx8hf_le */

        default:
          return -1;
        }

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6412; /* *vec_duplicatevnx4hf_reg */

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6413; /* *vec_duplicatevnx2hf_reg */

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_BFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_BFmode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6414; /* *vec_duplicatevnx8bf_reg */

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[1], E_V8BFmode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6424; /* aarch64_vec_duplicate_vqvnx8bf_le */

        default:
          return -1;
        }

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6415; /* *vec_duplicatevnx4bf_reg */

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6416; /* *vec_duplicatevnx2bf_reg */

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_SFmode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6417; /* *vec_duplicatevnx4sf_reg */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6426; /* aarch64_vec_duplicate_vqvnx4sf_le */

        default:
          return -1;
        }

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2SFmode
          || !aarch64_sve_dup_operand (operands[1], E_SFmode)
          || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 6418; /* *vec_duplicatevnx2sf_reg */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_DFmode)
              || !
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 6419; /* *vec_duplicatevnx2df_reg */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
            return -1;
          *pnum_clobbers = 1;
          return 6427; /* aarch64_vec_duplicate_vqvnx2df_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_485 (x1, insn, pnum_clobbers);

    case 1:
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 187:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern904 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1627; /* aarch64_absv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern904 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1631; /* aarch64_absv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern904 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1635; /* aarch64_absv2si_vec_concatz_be */

            case E_V2DImode:
              if (pattern904 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 803 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1640; /* aarch64_absdi_vec_concatz_be */

            default:
              return -1;
            }

        case 36:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2489; /* btruncv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2517; /* btruncv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2492; /* ceilv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2520; /* ceilv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2495; /* floorv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2523; /* floorv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2498; /* roundevenv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2526; /* roundevenv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 31:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2501; /* nearbyintv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2529; /* nearbyintv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2504; /* rintv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2532; /* rintv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 30:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2507; /* roundv4hf2_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2535; /* roundv2sf2_vec_concatz_be */

            default:
              return -1;
            }

        case 254:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern904 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5024; /* aarch64_rev64v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern904 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5036; /* aarch64_rev64v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern904 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5048; /* aarch64_rev64v2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5063; /* aarch64_rev64v4hf_vec_concatz_be */

            case E_V8BFmode:
              if (pattern904 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5075; /* aarch64_rev64v4bf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5087; /* aarch64_rev64v2sf_vec_concatz_be */

            default:
              return -1;
            }

        case 255:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern904 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5027; /* aarch64_rev32v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern904 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5039; /* aarch64_rev32v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern904 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5051; /* aarch64_rev32v2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5066; /* aarch64_rev32v4hf_vec_concatz_be */

            case E_V8BFmode:
              if (pattern904 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5078; /* aarch64_rev32v4bf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5090; /* aarch64_rev32v2sf_vec_concatz_be */

            default:
              return -1;
            }

        case 256:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern904 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5030; /* aarch64_rev16v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern904 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5042; /* aarch64_rev16v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern904 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5054; /* aarch64_rev16v2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern904 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5069; /* aarch64_rev16v4hf_vec_concatz_be */

            case E_V8BFmode:
              if (pattern904 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5081; /* aarch64_rev16v4bf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern904 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5093; /* aarch64_rev16v2sf_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 275:
          switch (pattern829 (x2))
            {
            case 0:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3518; /* aarch64_sqrdmlahv4hi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3526; /* aarch64_sqrdmlahv2si_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3538; /* aarch64_sqrdmlah_lanev4hi_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3558; /* aarch64_sqrdmlah_laneqv4hi_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3546; /* aarch64_sqrdmlah_lanev2si_vec_concatz_be */

            case 5:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3566; /* aarch64_sqrdmlah_laneqv2si_vec_concatz_be */

            default:
              return -1;
            }

        case 276:
          switch (pattern829 (x2))
            {
            case 0:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3521; /* aarch64_sqrdmlshv4hi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3529; /* aarch64_sqrdmlshv2si_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3541; /* aarch64_sqrdmlsh_lanev4hi_vec_concatz_be */

            case 3:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3561; /* aarch64_sqrdmlsh_laneqv4hi_vec_concatz_be */

            case 4:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3549; /* aarch64_sqrdmlsh_lanev2si_vec_concatz_be */

            case 5:
              if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3569; /* aarch64_sqrdmlsh_laneqv2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern318 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1354; /* addv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1358; /* addv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 346 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1362; /* addv2si3_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2635 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2361; /* addv4hf3_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2635 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2365; /* addv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern767 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1419; /* aarch64_fcmla0v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1435; /* aarch64_fcmla0v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 408:
              switch (pattern767 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1422; /* aarch64_fcmla90v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1438; /* aarch64_fcmla90v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 409:
              switch (pattern767 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1425; /* aarch64_fcmla180v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1441; /* aarch64_fcmla180v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 410:
              switch (pattern767 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1428; /* aarch64_fcmla270v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1444; /* aarch64_fcmla270v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 279:
              if (pattern768 (x2) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 577 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1511; /* sdot_prodv2siv8qi_vec_concatz_le */

            case 280:
              if (pattern768 (x2) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 577 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1514; /* udot_prodv2siv8qi_vec_concatz_le */

            case 573:
              if (pattern768 (x2) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 591 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                return -1;
              return 1519; /* usdot_prodv2siv8qi_vec_concatz_le */

            default:
              return -1;
            }

        case 3:
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x4, 0, 1);
          operands[3] = x7;
          x8 = XVECEXP (x4, 0, 2);
          operands[4] = x8;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern1023 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1455; /* aarch64_fcmla_lane0v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1491; /* aarch64_fcmla_laneq0v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1471; /* aarch64_fcmla_lane0v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 408:
              switch (pattern1023 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1458; /* aarch64_fcmla_lane90v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1494; /* aarch64_fcmla_laneq90v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1474; /* aarch64_fcmla_lane90v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 409:
              switch (pattern1023 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1461; /* aarch64_fcmla_lane180v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1497; /* aarch64_fcmla_laneq180v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1477; /* aarch64_fcmla_lane180v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 410:
              switch (pattern1023 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1464; /* aarch64_fcmla_lane270v4hf_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 486 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1500; /* aarch64_fcmla_laneq270v4hf_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 471 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1480; /* aarch64_fcmla_lane270v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case 279:
              switch (pattern1024 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1523; /* aarch64_sdot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 622 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1531; /* aarch64_sdot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 280:
              switch (pattern1024 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1526; /* aarch64_udot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 622 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1534; /* aarch64_udot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 573:
              switch (pattern1024 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1539; /* aarch64_usdot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1547; /* aarch64_usdot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            case 578:
              switch (pattern1024 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1542; /* aarch64_sudot_lanev8qi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 640 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1550; /* aarch64_sudot_laneqv8qi_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != VEC_SELECT)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      x13 = XEXP (x11, 1);
      operands[4] = x13;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      x5 = XEXP (x2, 1);
      operands[5] = x5;
      x14 = XEXP (x10, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTEND:
          switch (pattern1026 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1702; /* *aarch64_sadalpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1710; /* *aarch64_sadalpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1720; /* *aarch64_sadalpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1026 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1705; /* *aarch64_uadalpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1713; /* *aarch64_uadalpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1723; /* *aarch64_uadalpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      x5 = XEXP (x2, 1);
      operands[4] = x5;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SMAX:
          switch (pattern770 (x2, 
SMIN))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1726; /* aarch64_sabav8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1734; /* aarch64_sabav4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1742; /* aarch64_sabav2si_vec_concatz_le */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern770 (x2, 
UMIN))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1729; /* aarch64_uabav8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1737; /* aarch64_uabav4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1104 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1745; /* aarch64_uabav2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern965 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1636 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2001; /* aarch64_mlav8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern965 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1636 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2005; /* aarch64_mlav4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern965 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1636 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2009; /* aarch64_mlav2si_vec_concatz_le */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x14 = XEXP (x10, 0);
          switch (GET_CODE (x14))
            {
            case VEC_SELECT:
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x16 = XEXP (x14, 0);
              operands[1] = x16;
              x17 = XVECEXP (x15, 0, 0);
              operands[2] = x17;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x4, 1);
              operands[3] = x11;
              x9 = XEXP (x3, 1);
              operands[4] = x9;
              x5 = XEXP (x2, 1);
              operands[5] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1205 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[1], E_V4HImode)
                          || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1651 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2013; /* *aarch64_mla_eltv4hi_vec_concatz_le */

                    case E_V8HImode:
                      if (!register_operand (operands[1], E_V8HImode)
                          || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1669 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2021; /* *aarch64_mla_elt_to_128v4hi_vec_concatz_le */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (pattern1205 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[1], E_V2SImode)
                          || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1651 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2017; /* *aarch64_mla_eltv2si_vec_concatz_le */

                    case E_V4SImode:
                      if (!register_operand (operands[1], E_V4SImode)
                          || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1669 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2025; /* *aarch64_mla_elt_to_128v2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x14;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x9 = XEXP (x3, 1);
              operands[1] = x9;
              x5 = XEXP (x2, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1027 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1685 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2029; /* aarch64_mla_nv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1027 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1685 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2033; /* aarch64_mla_nv2si_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != VEC_SELECT)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          switch (pattern663 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2795; /* *aarch64_saddlpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2803; /* *aarch64_saddlpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2813; /* *aarch64_saddlpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern663 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2798; /* *aarch64_uaddlpv8qi_vec_concatz_le_insn */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2806; /* *aarch64_uaddlpv4hi_vec_concatz_le_insn */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3540 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2816; /* *aarch64_uaddlpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x18 = XEXP (x5, 0);
          if (GET_CODE (x18) != VEC_SELECT)
            return -1;
          x19 = XEXP (x5, 1);
          if (GET_CODE (x19) != VEC_SELECT)
            return -1;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x20 = XEXP (x9, 1);
          operands[4] = x20;
          x21 = XEXP (x18, 0);
          operands[2] = x21;
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[1]))
            return -1;
          x23 = XEXP (x18, 1);
          if (!rtx_equal_p (x23, operands[3]))
            return -1;
          x24 = XEXP (x19, 0);
          if (!rtx_equal_p (x24, operands[2]))
            return -1;
          x25 = XEXP (x19, 1);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1280 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 7462 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4367; /* aarch64_addpv16qi_insn */

            case E_V8HImode:
              if (pattern1280 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 7462 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4368; /* aarch64_addpv8hi_insn */

            case E_V4SImode:
              if (pattern1280 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 7462 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4369; /* aarch64_addpv4si_insn */

            case E_V2DImode:
              if (pattern1280 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 7462 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4370; /* aarch64_addpv2di_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x22 = XEXP (x9, 0);
          if (GET_CODE (x22) != VEC_CONCAT)
            return -1;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x20 = XEXP (x9, 1);
          operands[4] = x20;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          x26 = XEXP (x22, 0);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          x27 = XEXP (x22, 1);
          if (!rtx_equal_p (x27, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1206 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7484 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4372; /* aarch64_addpv8qi_vec_concatz_le_insn */

            case E_V8HImode:
              if (pattern1206 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7484 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4375; /* aarch64_addpv4hi_vec_concatz_le_insn */

            case E_V4SImode:
              if (pattern1206 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7484 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4378; /* aarch64_addpv2si_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x9 = XEXP (x3, 1);
          operands[4] = x9;
          x5 = XEXP (x2, 1);
          operands[5] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1028 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7331 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4212; /* aarch64_cmtstv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern1028 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7331 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4216; /* aarch64_cmtstv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern1028 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7331 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4220; /* aarch64_cmtstv2si_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          x5 = XEXP (x2, 1);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern966 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4225; /* *aarch64_cmtst_same_v8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern966 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4229; /* *aarch64_cmtst_same_v4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern966 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4233; /* *aarch64_cmtst_same_v2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_511 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_448 (x1, insn, pnum_clobbers);

    case 2:
      return recog_444 (x1, insn, pnum_clobbers);

    case 3:
      return recog_447 (x1, insn, pnum_clobbers);

    case 4:
      return recog_446 (x1, insn, pnum_clobbers);

    case 5:
      return recog_445 (x1, insn, pnum_clobbers);

    case 7:
      switch (XINT (x2, 1))
        {
        case 120:
          x3 = XVECEXP (x2, 0, 6);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != SCRATCH)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 0);
          operands[5] = x6;
          x7 = XVECEXP (x2, 0, 1);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 3);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 4);
          operands[4] = x9;
          x10 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
              operands[2] = x10;
              x11 = XVECEXP (x2, 0, 5);
              operands[6] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4QImode:
                  if (pattern1226 (x2, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6093; /* mask_gather_loadvnx4qivnx4si */

                case E_VNx4HImode:
                  if (pattern1227 (x2, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6094; /* mask_gather_loadvnx4hivnx4si */

                case E_VNx4HFmode:
                  if (pattern1227 (x2, 
E_VNx4HFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6095; /* mask_gather_loadvnx4hfvnx4si */

                case E_VNx4BFmode:
                  if (pattern1227 (x2, 
E_VNx4BFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6096; /* mask_gather_loadvnx4bfvnx4si */

                case E_VNx4SImode:
                  if (!register_operand (operands[0], E_VNx4SImode)
                      || GET_MODE (x2) != E_VNx4SImode
                      || !register_operand (operands[5], E_VNx4BImode)
                      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      || !register_operand (operands[2], E_VNx4SImode)
                      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      || !aarch64_maskload_else_operand (operands[6], E_VNx4SImode)
                      || !
#line 1507 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6097; /* mask_gather_loadvnx4sivnx4si */

                case E_VNx4SFmode:
                  if (pattern1228 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1507 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6098; /* mask_gather_loadvnx4sfvnx4si */

                case E_VNx2QImode:
                  if (pattern1226 (x2, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6099; /* mask_gather_loadvnx2qivnx2di */

                case E_VNx2HImode:
                  if (pattern1227 (x2, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6100; /* mask_gather_loadvnx2hivnx2di */

                case E_VNx2HFmode:
                  if (pattern1227 (x2, 
E_VNx2HFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6101; /* mask_gather_loadvnx2hfvnx2di */

                case E_VNx2BFmode:
                  if (pattern1227 (x2, 
E_VNx2BFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6102; /* mask_gather_loadvnx2bfvnx2di */

                case E_VNx2SImode:
                  if (pattern1228 (x2, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6103; /* mask_gather_loadvnx2sivnx2di */

                case E_VNx2SFmode:
                  if (pattern1228 (x2, 
E_VNx2SFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6104; /* mask_gather_loadvnx2sfvnx2di */

                case E_VNx2DImode:
                  if (pattern1229 (x2, 
E_VNx2DImode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6105; /* mask_gather_loadvnx2divnx2di */

                case E_VNx2DFmode:
                  if (pattern1229 (x2, 
E_VNx2DFmode) != 0
                      || !
#line 1537 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6106; /* mask_gather_loadvnx2dfvnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern1127 (x10) != 0
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x12 = XVECEXP (x10, 0, 0);
              operands[6] = x12;
              x13 = XVECEXP (x10, 0, 1);
              if (GET_MODE (x13) != E_VNx2DImode)
                return -1;
              switch (pattern1307 (x2))
                {
                case 0:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6107; /* *mask_gather_loadvnx2qivnx2di_sxtw_unpacked */

                case 1:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6109; /* *mask_gather_loadvnx2hivnx2di_sxtw_unpacked */

                case 2:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6111; /* *mask_gather_loadvnx2hfvnx2di_sxtw_unpacked */

                case 3:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6113; /* *mask_gather_loadvnx2bfvnx2di_sxtw_unpacked */

                case 4:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6115; /* *mask_gather_loadvnx2sivnx2di_sxtw_unpacked */

                case 5:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6117; /* *mask_gather_loadvnx2sfvnx2di_sxtw_unpacked */

                case 6:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6119; /* *mask_gather_loadvnx2divnx2di_sxtw_unpacked */

                case 7:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6121; /* *mask_gather_loadvnx2dfvnx2di_sxtw_unpacked */

                case 8:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6123; /* *mask_gather_loadvnx2qivnx2di_sxtw */

                case 9:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6124; /* *mask_gather_loadvnx2hivnx2di_sxtw */

                case 10:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6125; /* *mask_gather_loadvnx2hfvnx2di_sxtw */

                case 11:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6126; /* *mask_gather_loadvnx2bfvnx2di_sxtw */

                case 12:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6127; /* *mask_gather_loadvnx2sivnx2di_sxtw */

                case 13:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6128; /* *mask_gather_loadvnx2sfvnx2di_sxtw */

                case 14:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6129; /* *mask_gather_loadvnx2divnx2di_sxtw */

                case 15:
                  if (!
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6130; /* *mask_gather_loadvnx2dfvnx2di_sxtw */

                case 16:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6108; /* *mask_gather_loadvnx2qivnx2di_uxtw_unpacked */

                case 17:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6110; /* *mask_gather_loadvnx2hivnx2di_uxtw_unpacked */

                case 18:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6112; /* *mask_gather_loadvnx2hfvnx2di_uxtw_unpacked */

                case 19:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6114; /* *mask_gather_loadvnx2bfvnx2di_uxtw_unpacked */

                case 20:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6116; /* *mask_gather_loadvnx2sivnx2di_uxtw_unpacked */

                case 21:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6118; /* *mask_gather_loadvnx2sfvnx2di_uxtw_unpacked */

                case 22:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6120; /* *mask_gather_loadvnx2divnx2di_uxtw_unpacked */

                case 23:
                  if (!
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6122; /* *mask_gather_loadvnx2dfvnx2di_uxtw_unpacked */

                default:
                  return -1;
                }

            case AND:
              if (pattern1128 (x10) != 0)
                return -1;
              x11 = XVECEXP (x2, 0, 5);
              operands[7] = x11;
              switch (pattern1305 (x2))
                {
                case 0:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6131; /* *mask_gather_loadvnx2qivnx2di_uxtw */

                case 1:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6132; /* *mask_gather_loadvnx2hivnx2di_uxtw */

                case 2:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6133; /* *mask_gather_loadvnx2hfvnx2di_uxtw */

                case 3:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6134; /* *mask_gather_loadvnx2bfvnx2di_uxtw */

                case 4:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6135; /* *mask_gather_loadvnx2sivnx2di_uxtw */

                case 5:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6136; /* *mask_gather_loadvnx2sfvnx2di_uxtw */

                case 6:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6137; /* *mask_gather_loadvnx2divnx2di_uxtw */

                case 7:
                  if (!
#line 1625 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6138; /* *mask_gather_loadvnx2dfvnx2di_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          if (pattern258 (x2) != 0)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x2, 0, 0);
          operands[5] = x6;
          x7 = XVECEXP (x2, 0, 1);
          operands[1] = x7;
          x8 = XVECEXP (x2, 0, 3);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 4);
          operands[4] = x9;
          x10 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
              operands[2] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4SImode:
                  if (pattern1278 (x2, 
E_VNx4SImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1851 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6237; /* aarch64_ldff1_gathervnx4si */

                case E_VNx4SFmode:
                  if (pattern1278 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                      || !
#line 1851 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6238; /* aarch64_ldff1_gathervnx4sf */

                case E_VNx2DImode:
                  if (pattern1279 (x2, 
E_VNx2DImode) != 0
                      || !
#line 1881 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6239; /* aarch64_ldff1_gathervnx2di */

                case E_VNx2DFmode:
                  if (pattern1279 (x2, 
E_VNx2DFmode) != 0
                      || !
#line 1881 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6240; /* aarch64_ldff1_gathervnx2df */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x10, 0) != 2
                  || XINT (x10, 1) != 125
                  || GET_MODE (x10) != E_VNx2DImode)
                return -1;
              x13 = XVECEXP (x10, 0, 1);
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_MODE (x13) != E_VNx2DImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != TRUNCATE
                  || GET_MODE (x14) != E_VNx2SImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x12 = XVECEXP (x10, 0, 0);
              operands[6] = x12;
              switch (pattern1354 (x2))
                {
                case 0:
                  if (!
#line 1911 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6241; /* *aarch64_ldff1_gathervnx2di_sxtw */

                case 1:
                  if (!
#line 1911 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6242; /* *aarch64_ldff1_gathervnx2df_sxtw */

                default:
                  return -1;
                }

            case AND:
              if (pattern1128 (x10) != 0)
                return -1;
              switch (pattern1340 (x2))
                {
                case 0:
                  if (!
#line 1938 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6243; /* *aarch64_ldff1_gathervnx2di_uxtw */

                case 1:
                  if (!
#line 1938 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6244; /* *aarch64_ldff1_gathervnx2df_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 659:
          switch (pattern261 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13865; /* aarch64_sme_smopavnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13881; /* aarch64_sme_smopavnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13873; /* aarch64_sme_smopavnx2divnx8hi */

            default:
              return -1;
            }

        case 660:
          switch (pattern261 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13866; /* aarch64_sme_smopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13882; /* aarch64_sme_smopsvnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13874; /* aarch64_sme_smopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 667:
          switch (pattern262 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13867; /* aarch64_sme_sumopavnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13875; /* aarch64_sme_sumopavnx2divnx8hi */

            default:
              return -1;
            }

        case 668:
          switch (pattern262 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13868; /* aarch64_sme_sumopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13876; /* aarch64_sme_sumopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 673:
          switch (pattern261 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13869; /* aarch64_sme_umopavnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13883; /* aarch64_sme_umopavnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13877; /* aarch64_sme_umopavnx2divnx8hi */

            default:
              return -1;
            }

        case 674:
          switch (pattern261 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13870; /* aarch64_sme_umopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1732 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13884; /* aarch64_sme_umopsvnx4sivnx8hi */

            case 2:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13878; /* aarch64_sme_umopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 677:
          switch (pattern262 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13871; /* aarch64_sme_usmopavnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13879; /* aarch64_sme_usmopavnx2divnx8hi */

            default:
              return -1;
            }

        case 678:
          switch (pattern262 (x1))
            {
            case 0:
              if (!
#line 1702 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 13872; /* aarch64_sme_usmopsvnx4sivnx16qi */

            case 1:
              if (!
#line 1717 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING && TARGET_SME_I16I64))
                return -1;
              return 13880; /* aarch64_sme_usmopsvnx2divnx8hi */

            default:
              return -1;
            }

        case 637:
          if (pattern263 (x1) != 0
              || !
#line 1747 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13885; /* aarch64_sme_bmopavnx4sivnx4si */

        case 638:
          if (pattern263 (x1) != 0
              || !
#line 1747 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13886; /* aarch64_sme_bmopsvnx4sivnx4si */

        case 644:
          switch (pattern265 (x1))
            {
            case 0:
              if (!
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14079; /* aarch64_sme_fmopavnx4sfvnx4sf */

            case 1:
              if (!(
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 734 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
                return -1;
              return 14081; /* aarch64_sme_fmopavnx2dfvnx2df */

            case 2:
              if (!(
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 735 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
                return -1;
              return 14083; /* aarch64_sme_fmopavnx8hfvnx8hf */

            case 3:
              if (!(
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 736 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
                return -1;
              return 14085; /* aarch64_sme_fmopavnx8bfvnx8bf */

            case 4:
              if (!
#line 2121 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14087; /* aarch64_sme_fmopavnx4sivnx8bf */

            case 5:
              if (!
#line 2121 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14089; /* aarch64_sme_fmopavnx4sivnx8hf */

            default:
              return -1;
            }

        case 645:
          switch (pattern265 (x1))
            {
            case 0:
              if (!
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14080; /* aarch64_sme_fmopsvnx4sfvnx4sf */

            case 1:
              if (!(
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 734 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
                return -1;
              return 14082; /* aarch64_sme_fmopsvnx2dfvnx2df */

            case 2:
              if (!(
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 735 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
                return -1;
              return 14084; /* aarch64_sme_fmopsvnx8hfvnx8hf */

            case 3:
              if (!(
#line 2106 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 736 "../../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
                return -1;
              return 14086; /* aarch64_sme_fmopsvnx8bfvnx8bf */

            case 4:
              if (!
#line 2121 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14088; /* aarch64_sme_fmopsvnx4sivnx8bf */

            case 5:
              if (!
#line 2121 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
                return -1;
              return 14090; /* aarch64_sme_fmopsvnx4sivnx8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 6:
      return recog_449 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 576; /* one_cmplsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 577; /* one_cmpldi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1802; /* one_cmplv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1805; /* one_cmplv16qi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1806; /* one_cmplv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1809; /* one_cmplv8hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1810; /* one_cmplv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1813; /* one_cmplv4si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1162 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1814; /* one_cmplv2di2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern293 (x3))
        {
        case 0:
          return 579; /* *one_cmpl_ashlsi2 */

        case 1:
          return 584; /* *one_cmpl_ashldi2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern293 (x3))
        {
        case 0:
          return 580; /* *one_cmpl_ashrsi2 */

        case 1:
          return 585; /* *one_cmpl_ashrdi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern293 (x3))
        {
        case 0:
          return 581; /* *one_cmpl_lshrsi2 */

        case 1:
          return 586; /* *one_cmpl_lshrdi2 */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern293 (x3))
        {
        case 0:
          return 582; /* *one_cmpl_rotrsi2 */

        case 1:
          return 587; /* *one_cmpl_rotrdi2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern293 (x3))
        {
        case 0:
          return 583; /* *one_cmpl_rotlsi2 */

        case 1:
          return 588; /* *one_cmpl_rotldi2 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern365 (x3))
            {
            case 0:
              return 596; /* *xor_one_cmplsi3 */

            case 1:
              return 597; /* *xor_one_cmpldi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern410 (x3))
            {
            case 0:
              return 648; /* *eor_one_cmpl_ashlsi3_alt */

            case 1:
              return 653; /* *eor_one_cmpl_ashldi3_alt */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern410 (x3))
            {
            case 0:
              return 649; /* *eor_one_cmpl_ashrsi3_alt */

            case 1:
              return 654; /* *eor_one_cmpl_ashrdi3_alt */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern410 (x3))
            {
            case 0:
              return 650; /* *eor_one_cmpl_lshrsi3_alt */

            case 1:
              return 655; /* *eor_one_cmpl_lshrdi3_alt */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern410 (x3))
            {
            case 0:
              return 651; /* *eor_one_cmpl_rotrsi3_alt */

            case 1:
              return 656; /* *eor_one_cmpl_rotrdi3_alt */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern410 (x3))
            {
            case 0:
              return 652; /* *eor_one_cmpl_rotlsi3_alt */

            case 1:
              return 657; /* *eor_one_cmpl_rotldi3_alt */

            default:
              return -1;
            }

        case AND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern896 (x3, 
E_V8QImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11896; /* *aarch64_sve2_nbsl_unpredv8qi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11897; /* *aarch64_sve2_nbsl_unpredv8qi */

            case E_V16QImode:
              if (pattern896 (x3, 
E_V16QImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11898; /* *aarch64_sve2_nbsl_unpredv16qi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11899; /* *aarch64_sve2_nbsl_unpredv16qi */

            case E_V4HImode:
              if (pattern896 (x3, 
E_V4HImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11900; /* *aarch64_sve2_nbsl_unpredv4hi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11901; /* *aarch64_sve2_nbsl_unpredv4hi */

            case E_V8HImode:
              if (pattern896 (x3, 
E_V8HImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11902; /* *aarch64_sve2_nbsl_unpredv8hi */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11903; /* *aarch64_sve2_nbsl_unpredv8hi */

            case E_V2SImode:
              if (pattern896 (x3, 
E_V2SImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11904; /* *aarch64_sve2_nbsl_unpredv2si */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11905; /* *aarch64_sve2_nbsl_unpredv2si */

            case E_V4SImode:
              if (pattern896 (x3, 
E_V4SImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11906; /* *aarch64_sve2_nbsl_unpredv4si */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11907; /* *aarch64_sve2_nbsl_unpredv4si */

            case E_V2DImode:
              if (pattern896 (x3, 
E_V2DImode) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              if (rtx_equal_p (x10, operands[1])
                  && 
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return 11908; /* *aarch64_sve2_nbsl_unpredv2di */
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 1746 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11909; /* *aarch64_sve2_nbsl_unpredv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern309 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern755 (x3, 
E_SImode) == 0
                  && 
#line 7385 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1082; /* *aarch64_smaxsi3_cssc */
              break;

            case E_DImode:
              if (pattern755 (x3, 
E_DImode) == 0
                  && 
#line 7385 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1086; /* *aarch64_smaxdi3_cssc */
              break;

            case E_SFmode:
              if (pattern31 (x3, 
E_SFmode) == 0
                  && 
#line 7410 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1094; /* smaxsf3 */
              break;

            case E_DFmode:
              if (pattern31 (x3, 
E_DFmode) == 0
                  && 
#line 7410 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1095; /* smaxdf3 */
              break;

            case E_V8QImode:
              if (pattern31 (x3, 
E_V8QImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2072; /* smaxv8qi3 */
              break;

            case E_V16QImode:
              if (pattern31 (x3, 
E_V16QImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2084; /* smaxv16qi3 */
              break;

            case E_V4HImode:
              if (pattern31 (x3, 
E_V4HImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2088; /* smaxv4hi3 */
              break;

            case E_V8HImode:
              if (pattern31 (x3, 
E_V8HImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2100; /* smaxv8hi3 */
              break;

            case E_V2SImode:
              if (pattern31 (x3, 
E_V2SImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2104; /* smaxv2si3 */
              break;

            case E_V4SImode:
              if (pattern31 (x3, 
E_V4SImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2116; /* smaxv4si3 */
              break;

            case E_V4HFmode:
              if (pattern31 (x3, 
E_V4HFmode) == 0
                  && (
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2670; /* smaxv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern31 (x3, 
E_V8HFmode) == 0
                  && (
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2672; /* smaxv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern31 (x3, 
E_V2SFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2674; /* smaxv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern31 (x3, 
E_V4SFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2676; /* smaxv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern31 (x3, 
E_V2DFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2678; /* smaxv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern32 (x3, 
E_VNx32QImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11390; /* *smaxvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern32 (x3, 
E_VNx16HImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11394; /* *smaxvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern32 (x3, 
E_VNx8SImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11398; /* *smaxvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern32 (x3, 
E_VNx4DImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11402; /* *smaxvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern32 (x3, 
E_VNx64QImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11406; /* *smaxvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern32 (x3, 
E_VNx32HImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11410; /* *smaxvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern32 (x3, 
E_VNx16SImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11414; /* *smaxvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern32 (x3, 
E_VNx8DImode) == 0
                  && 
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11418; /* *smaxvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1090; /* *aarch64_smaxsi3_zero */

            case 1:
              return 1092; /* *aarch64_smaxdi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7398; /* *post_ra_smaxvnx16qi3 */

        case 2:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7403; /* *post_ra_smaxvnx8qi3 */

        case 3:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7408; /* *post_ra_smaxvnx4qi3 */

        case 4:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7413; /* *post_ra_smaxvnx2qi3 */

        case 5:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7418; /* *post_ra_smaxvnx8hi3 */

        case 6:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7423; /* *post_ra_smaxvnx4hi3 */

        case 7:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7428; /* *post_ra_smaxvnx2hi3 */

        case 8:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7433; /* *post_ra_smaxvnx4si3 */

        case 9:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7438; /* *post_ra_smaxvnx2si3 */

        case 10:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7443; /* *post_ra_smaxvnx2di3 */

        case 11:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7448; /* *post_ra_smaxv2di3 */

        case 12:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11423; /* aarch64_sve_single_smaxvnx32qi */

        case 13:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11428; /* aarch64_sve_single_smaxvnx16hi */

        case 14:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11433; /* aarch64_sve_single_smaxvnx8si */

        case 15:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11438; /* aarch64_sve_single_smaxvnx4di */

        case 16:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11443; /* aarch64_sve_single_smaxvnx64qi */

        case 17:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11448; /* aarch64_sve_single_smaxvnx32hi */

        case 18:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11453; /* aarch64_sve_single_smaxvnx16si */

        case 19:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11458; /* aarch64_sve_single_smaxvnx8di */

        default:
          return -1;
        }

    case ABS:
      switch (pattern310 (x3))
        {
        case 0:
          if (!(
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5291; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5293; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5295; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5297; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 10043 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5299; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      switch (pattern444 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3251; /* ussubv8qi3 */

        case 1:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3257; /* ussubv16qi3 */

        case 2:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3267; /* ussubv4hi3 */

        case 3:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3273; /* ussubv8hi3 */

        case 4:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3283; /* ussubv2si3 */

        case 5:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3289; /* ussubv4si3 */

        case 6:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3293; /* ussubv2di3 */

        case 7:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3297; /* ussubhi3 */

        case 8:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3301; /* ussubqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3307; /* ussubsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3309; /* ussubdi3 */

        case 11:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8085; /* ussubvnx16qi3 */

        case 12:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8087; /* ussubvnx8hi3 */

        case 13:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8089; /* ussubvnx4si3 */

        case 14:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8091; /* ussubvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern446 (x3))
        {
        case 0:
          if (!
#line 10531 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10981; /* aarch64_sve_uqdecdi_pat */

        case 1:
          if (!
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11033; /* *aarch64_sve_uqdecdivnx16bi_cntp */

        case 2:
          if (!
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11036; /* *aarch64_sve_uqdecdivnx8bi_cntp */

        case 3:
          if (!
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11039; /* *aarch64_sve_uqdecdivnx4bi_cntp */

        case 4:
          if (!
#line 10949 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11042; /* *aarch64_sve_uqdecdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern447 (x3))
        {
        case 0:
          if (!
#line 10596 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10987; /* aarch64_sve_uqdecvnx2di_pat */

        case 1:
          if (!
#line 11056 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11057; /* *aarch64_sve_uqdecvnx2di_cntp */

        case 2:
          if (!
#line 10617 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10990; /* aarch64_sve_uqdecvnx4si_pat */

        case 3:
          if (!
#line 11095 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11060; /* *aarch64_sve_uqdecvnx4si_cntp */

        case 4:
          if (!
#line 10652 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10993; /* *aarch64_sve_uqdecvnx8hi_pat */

        case 5:
          if (!
#line 11136 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11063; /* *aarch64_sve_uqdecvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10097; /* *while_rwsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10107; /* *while_rwdivnx2bi_cc */
}

 int
recog_567 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10096; /* *while_ugesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3450 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10106; /* *while_ugedivnx2bi_cc */
}

 int
recog_577 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10055; /* *while_ugtsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10065; /* *while_ugtdivnx8bi_cc */
}

 int
recog_587 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10173; /* while_gesivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10183; /* while_gedivnx2bi_ptest */
}

 int
recog_597 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  if (XVECLEN (x5, 0) != 2)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[3] = x7;
  switch (XINT (x5, 1))
    {
    case 341:
      switch (pattern1356 (x1, 
341))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9889; /* *aarch64_pred_cmpeqvnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9899; /* *aarch64_pred_cmpeqvnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9909; /* *aarch64_pred_cmpeqvnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9919; /* *aarch64_pred_cmpeqvnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9929; /* *aarch64_pred_cmpeqvnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9939; /* *aarch64_pred_cmpeqvnx4si_wide_ptest */

        default:
          return -1;
        }

    case 342:
      switch (pattern1356 (x1, 
342))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9890; /* *aarch64_pred_cmpgevnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9900; /* *aarch64_pred_cmpgevnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9910; /* *aarch64_pred_cmpgevnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9920; /* *aarch64_pred_cmpgevnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9930; /* *aarch64_pred_cmpgevnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9940; /* *aarch64_pred_cmpgevnx4si_wide_ptest */

        default:
          return -1;
        }

    case 343:
      switch (pattern1356 (x1, 
343))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9891; /* *aarch64_pred_cmpgtvnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9901; /* *aarch64_pred_cmpgtvnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9911; /* *aarch64_pred_cmpgtvnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9921; /* *aarch64_pred_cmpgtvnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9931; /* *aarch64_pred_cmpgtvnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9941; /* *aarch64_pred_cmpgtvnx4si_wide_ptest */

        default:
          return -1;
        }

    case 344:
      switch (pattern1356 (x1, 
344))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9892; /* *aarch64_pred_cmphivnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9902; /* *aarch64_pred_cmphivnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9912; /* *aarch64_pred_cmphivnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9922; /* *aarch64_pred_cmphivnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9932; /* *aarch64_pred_cmphivnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9942; /* *aarch64_pred_cmphivnx4si_wide_ptest */

        default:
          return -1;
        }

    case 345:
      switch (pattern1356 (x1, 
345))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9893; /* *aarch64_pred_cmphsvnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9903; /* *aarch64_pred_cmphsvnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9913; /* *aarch64_pred_cmphsvnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9923; /* *aarch64_pred_cmphsvnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9933; /* *aarch64_pred_cmphsvnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9943; /* *aarch64_pred_cmphsvnx4si_wide_ptest */

        default:
          return -1;
        }

    case 346:
      switch (pattern1356 (x1, 
346))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9894; /* *aarch64_pred_cmplevnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9904; /* *aarch64_pred_cmplevnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9914; /* *aarch64_pred_cmplevnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9924; /* *aarch64_pred_cmplevnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9934; /* *aarch64_pred_cmplevnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9944; /* *aarch64_pred_cmplevnx4si_wide_ptest */

        default:
          return -1;
        }

    case 347:
      switch (pattern1356 (x1, 
347))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9895; /* *aarch64_pred_cmplovnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9905; /* *aarch64_pred_cmplovnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9915; /* *aarch64_pred_cmplovnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9925; /* *aarch64_pred_cmplovnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9935; /* *aarch64_pred_cmplovnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9945; /* *aarch64_pred_cmplovnx4si_wide_ptest */

        default:
          return -1;
        }

    case 348:
      switch (pattern1356 (x1, 
348))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9896; /* *aarch64_pred_cmplsvnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9906; /* *aarch64_pred_cmplsvnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9916; /* *aarch64_pred_cmplsvnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9926; /* *aarch64_pred_cmplsvnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9936; /* *aarch64_pred_cmplsvnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9946; /* *aarch64_pred_cmplsvnx4si_wide_ptest */

        default:
          return -1;
        }

    case 349:
      switch (pattern1356 (x1, 
349))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9897; /* *aarch64_pred_cmpltvnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9907; /* *aarch64_pred_cmpltvnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9917; /* *aarch64_pred_cmpltvnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9927; /* *aarch64_pred_cmpltvnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9937; /* *aarch64_pred_cmpltvnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9947; /* *aarch64_pred_cmpltvnx4si_wide_ptest */

        default:
          return -1;
        }

    case 350:
      switch (pattern1356 (x1, 
350))
        {
        case 0:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9898; /* *aarch64_pred_cmpnevnx16qi_wide_cc */

        case 1:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9908; /* *aarch64_pred_cmpnevnx8hi_wide_cc */

        case 2:
          if (!
#line 8347 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9918; /* *aarch64_pred_cmpnevnx4si_wide_cc */

        case 3:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9928; /* *aarch64_pred_cmpnevnx16qi_wide_ptest */

        case 4:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9938; /* *aarch64_pred_cmpnevnx8hi_wide_ptest */

        case 5:
          if (!
#line 8374 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9948; /* *aarch64_pred_cmpnevnx4si_wide_ptest */

        default:
          return -1;
        }

    case 473:
      switch (pattern1359 (x1, 
473))
        {
        case 0:
          if (!
#line 4054 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12891; /* *aarch64_pred_matchvnx16qi_cc */

        case 1:
          if (!
#line 4054 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12893; /* *aarch64_pred_matchvnx8hi_cc */

        case 2:
          if (!
#line 4082 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12895; /* *aarch64_pred_matchvnx16qi_ptest */

        case 3:
          if (!
#line 4082 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12897; /* *aarch64_pred_matchvnx8hi_ptest */

        default:
          return -1;
        }

    case 474:
      switch (pattern1359 (x1, 
474))
        {
        case 0:
          if (!
#line 4054 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12892; /* *aarch64_pred_nmatchvnx16qi_cc */

        case 1:
          if (!
#line 4054 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12894; /* *aarch64_pred_nmatchvnx8hi_cc */

        case 2:
          if (!
#line 4082 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12896; /* *aarch64_pred_nmatchvnx16qi_ptest */

        case 3:
          if (!
#line 4082 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 12898; /* *aarch64_pred_nmatchvnx8hi_ptest */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_617 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (aarch64_call_insn_operand (operands[1], E_DImode))
    {
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      if (const_int_operand (operands[3], E_DImode))
        {
          x9 = XVECEXP (x1, 0, 2);
          switch (pattern1155 (x9))
            {
            case 0:
              return 64; /* *call_value_insn */

            case 1:
              if (
#line 1432 "../../../gcc/config/aarch64/aarch64.md"
(SIBLING_CALL_P (insn)))
                return 66; /* *sibcall_value_insn */
              break;

            default:
              break;
            }
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern981 (x1) != 0)
    return -1;
  switch (pattern1268 (x1))
    {
    case 0:
      if (!
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
        return -1;
      *pnum_clobbers = 1;
      return 1134; /* *tlsgd_small_si */

    case 1:
      if (!
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
        return -1;
      *pnum_clobbers = 1;
      return 1135; /* *tlsgd_small_di */

    default:
      return -1;
    }
}

 int
recog_619 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (!aarch64_mem_pair_operator (x3, E_TImode))
    return -1;
  operands[7] = x3;
  x4 = XEXP (x3, 0);
  if (!pmode_plus_operator (x4, E_VOIDmode))
    return -1;
  operands[8] = x4;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  operands[5] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!aarch64_ldp_reg_operand (operands[2], E_TImode))
    return -1;
  x10 = XEXP (x2, 1);
  operands[3] = x10;
  if (!aarch64_ldp_reg_operand (operands[3], E_TImode))
    return -1;
  x11 = XEXP (x8, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 0);
  if (!rtx_equal_p (x13, operands[0])
      || !
#line 2314 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && aarch64_mem_pair_offset (operands[4], TImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return -1;
  return 105; /* *storewb_post_pair_16 */
}

 int
recog_620 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case IF_THEN_ELSE:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != LABEL_REF)
            return -1;
          x5 = XEXP (x3, 2);
          if (GET_CODE (x5) != PC)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern449 (x7, 
66, 
E_CCmode, 
CLOBBER) != 0)
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case EQ:
              switch (pattern1033 (x3))
                {
                case 0:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 39; /* aarch64_tbeqqisi */

                case 1:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 43; /* aarch64_tbeqhisi */

                case 2:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 47; /* aarch64_tbeqsisi */

                case 3:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 51; /* aarch64_tbeqdisi */

                case 4:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 41; /* aarch64_tbeqqidi */

                case 5:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 45; /* aarch64_tbeqhidi */

                case 6:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 49; /* aarch64_tbeqsidi */

                case 7:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 53; /* aarch64_tbeqdidi */

                default:
                  return -1;
                }

            case NE:
              switch (pattern1033 (x3))
                {
                case 0:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 40; /* aarch64_tbneqisi */

                case 1:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 44; /* aarch64_tbnehisi */

                case 2:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 48; /* aarch64_tbnesisi */

                case 3:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 52; /* aarch64_tbnedisi */

                case 4:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 42; /* aarch64_tbneqidi */

                case 5:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 46; /* aarch64_tbnehidi */

                case 6:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 50; /* aarch64_tbnesidi */

                case 7:
                  if (!
#line 1171 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 54; /* aarch64_tbnedidi */

                default:
                  return -1;
                }

            case LT:
              switch (pattern1034 (x3))
                {
                case 0:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 55; /* *cbltqi1 */

                case 1:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 57; /* *cblthi1 */

                case 2:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 59; /* *cbltsi1 */

                case 3:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 61; /* *cbltdi1 */

                default:
                  return -1;
                }

            case GE:
              switch (pattern1034 (x3))
                {
                case 0:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 56; /* *cbgeqi1 */

                case 1:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 58; /* *cbgehi1 */

                case 2:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 60; /* *cbgesi1 */

                case 3:
                  if (!
#line 1207 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                    return -1;
                  return 62; /* *cbgedi1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CALL:
          if (pnum_clobbers == NULL
              || pattern352 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x9 = XVECEXP (x7, 0, 0);
          if (!const_int_operand (x9, E_DImode))
            return -1;
          x8 = XEXP (x3, 0);
          x10 = XEXP (x8, 0);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
            case SYMBOL_REF:
              operands[1] = x10;
              if (!aarch64_call_insn_operand (operands[1], E_DImode))
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x4 = XEXP (x3, 1);
              operands[2] = x4;
              operands[3] = x9;
              *pnum_clobbers = 1;
              return 64; /* *call_value_insn */

            case UNSPEC:
              if (pattern980 (x2) != 0)
                return -1;
              x11 = XVECEXP (x10, 0, 0);
              operands[0] = x11;
              if (!aarch64_valid_symref (operands[0], E_VOIDmode))
                return -1;
              operands[1] = x9;
              x6 = XEXP (x2, 0);
              switch (GET_MODE (x6))
                {
                case E_SImode:
                  if (GET_MODE (x10) != E_SImode
                      || !(
#line 7869 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1152; /* tlsdesc_small_sve_si */

                case E_DImode:
                  if (GET_MODE (x10) != E_DImode
                      || !(
#line 7869 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1153; /* tlsdesc_small_sve_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          return recog_613 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 44
              || GET_MODE (x8) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x12 = XEXP (x7, 1);
          if (pattern914 (x12, 
SIGN_EXTEND) != 0)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x13 = XVECEXP (x8, 0, 0);
          operands[1] = x13;
          if (!aarch64_mem_pair_lanes_operand (operands[1], E_V2x4QImode))
            return -1;
          x14 = XEXP (x7, 0);
          operands[2] = x14;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x15 = XEXP (x12, 0);
          x16 = XVECEXP (x15, 0, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          return 107; /* *load_pair_extendsidi2_aarch64 */

        case ZERO_EXTEND:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case UNSPEC:
              if (XVECLEN (x8, 0) != 1
                  || XINT (x8, 1) != 44
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x12 = XEXP (x7, 1);
              if (pattern914 (x12, 
ZERO_EXTEND) != 0
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x13 = XVECEXP (x8, 0, 0);
              operands[1] = x13;
              if (!aarch64_mem_pair_lanes_operand (operands[1], E_V2x4QImode))
                return -1;
              x14 = XEXP (x7, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_DImode))
                return -1;
              x15 = XEXP (x12, 0);
              x16 = XVECEXP (x15, 0, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return -1;
              return 109; /* *load_pair_zero_extendsidi2_aarch64 */

            case SUBREG:
            case MEM:
              operands[1] = x8;
              x12 = XEXP (x7, 1);
              if (GET_CODE (x12) != UNSPEC_VOLATILE
                  || XVECLEN (x12, 0) != 3
                  || XINT (x12, 1) != 27
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x17 = XVECEXP (x12, 0, 1);
              operands[2] = x17;
              x18 = XVECEXP (x12, 0, 2);
              operands[3] = x18;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x19 = XVECEXP (x12, 0, 0);
              if (!rtx_equal_p (x19, operands[0]))
                return -1;
              x14 = XEXP (x7, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_QImode)
                      || GET_MODE (x12) != E_QImode
                      || !aarch64_reg_or_zero (operands[2], E_QImode)
                      || !
#line 128 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                    return -1;
                  return 5370; /* aarch64_compare_and_swapqi_lse */

                case E_HImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_HImode)
                      || GET_MODE (x12) != E_HImode
                      || !aarch64_reg_or_zero (operands[2], E_HImode)
                      || !
#line 128 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                    return -1;
                  return 5371; /* aarch64_compare_and_swaphi_lse */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case COMPARE:
          return recog_614 (x1, insn, pnum_clobbers);

        case EQ:
          switch (pattern342 (x1))
            {
            case 0:
              if (!
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              return 445; /* *compare_cstoresi_insn */

            case 1:
              if (!
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              return 447; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        case NE:
          switch (pattern342 (x1))
            {
            case 0:
              if (!
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              return 446; /* *compare_cstoresi_insn */

            case 1:
              if (!
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              return 448; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case SMAX:
              switch (pattern560 (x1))
                {
                case 0:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
                    return -1;
                  return 494; /* *aarch64_minmax_plus */

                case 1:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
                    return -1;
                  return 498; /* *aarch64_minmax_plus */

                default:
                  return -1;
                }

            case SMIN:
              switch (pattern560 (x1))
                {
                case 0:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
                    return -1;
                  return 495; /* *aarch64_minmax_plus */

                case 1:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
                    return -1;
                  return 499; /* *aarch64_minmax_plus */

                default:
                  return -1;
                }

            case UMAX:
              switch (pattern560 (x1))
                {
                case 0:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
                    return -1;
                  return 496; /* *aarch64_minmax_plus */

                case 1:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
                    return -1;
                  return 500; /* *aarch64_minmax_plus */

                default:
                  return -1;
                }

            case UMIN:
              switch (pattern560 (x1))
                {
                case 0:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
                    return -1;
                  return 497; /* *aarch64_minmax_plus */

                case 1:
                  if (!
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
                    return -1;
                  return 501; /* *aarch64_minmax_plus */

                default:
                  return -1;
                }

            case SUBREG:
            case MEM:
              if (pattern561 (x1, pnum_clobbers) != 0)
                return -1;
              switch (pattern973 (x1))
                {
                case 0:
                  *pnum_clobbers = 2;
                  return 5463; /* aarch64_atomic_add_fetchqi */

                case 1:
                  *pnum_clobbers = 2;
                  return 5468; /* aarch64_atomic_add_fetchhi */

                case 2:
                  *pnum_clobbers = 2;
                  return 5473; /* aarch64_atomic_add_fetchsi */

                case 3:
                  *pnum_clobbers = 2;
                  return 5478; /* aarch64_atomic_add_fetchdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          return recog_616 (x1, insn, pnum_clobbers);

        case US_PLUS:
          switch (pattern344 (x1))
            {
            case 0:
              return 3306; /* usaddsi3 */

            case 1:
              return 3308; /* usadddi3 */

            default:
              return -1;
            }

        case US_MINUS:
          switch (pattern344 (x1))
            {
            case 0:
              return 3307; /* ussubsi3 */

            case 1:
              return 3309; /* ussubdi3 */

            default:
              return -1;
            }

        case NEG:
          switch (pattern345 (x1))
            {
            case 0:
              if (!
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4141; /* aarch64_cmltdi */

            case 1:
              if (!
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4142; /* aarch64_cmledi */

            case 2:
              if (!
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4143; /* aarch64_cmeqdi */

            case 3:
              if (!
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4144; /* aarch64_cmgedi */

            case 4:
              if (!
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4145; /* aarch64_cmgtdi */

            case 5:
              if (!
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4203; /* aarch64_cmltudi */

            case 6:
              if (!
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4204; /* aarch64_cmleudi */

            case 7:
              if (!
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4205; /* aarch64_cmgeudi */

            case 8:
              if (!
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4206; /* aarch64_cmgtudi */

            case 9:
              if (!
#line 7362 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 4237; /* aarch64_cmtstdi */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          res = recog_611 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x3;
          res = recog_612 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 94
              || GET_MODE (x3) != E_V8DImode
              || pattern367 (x1, 
E_DImode, 
89, 
USE) != 0
              || !aarch64_sync_memory_operand (operands[0], E_V8DImode)
              || !
#line 645 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME2))
            return -1;
          return 12990; /* aarch64_sme_str_zt0 */

        case MINUS:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern448 (x7, 
31, 
3, 
UNSPEC_VOLATILE) != 0)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x8 = XEXP (x3, 0);
          operands[1] = x8;
          switch (pattern973 (x1))
            {
            case 0:
              *pnum_clobbers = 2;
              return 5464; /* aarch64_atomic_sub_fetchqi */

            case 1:
              *pnum_clobbers = 2;
              return 5469; /* aarch64_atomic_sub_fetchhi */

            case 2:
              *pnum_clobbers = 2;
              return 5474; /* aarch64_atomic_sub_fetchsi */

            case 3:
              *pnum_clobbers = 2;
              return 5479; /* aarch64_atomic_sub_fetchdi */

            default:
              return -1;
            }

        case IOR:
          switch (pattern349 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 2;
              return 5465; /* aarch64_atomic_or_fetchqi */

            case 1:
              *pnum_clobbers = 2;
              return 5470; /* aarch64_atomic_or_fetchhi */

            case 2:
              *pnum_clobbers = 2;
              return 5475; /* aarch64_atomic_or_fetchsi */

            case 3:
              *pnum_clobbers = 2;
              return 5480; /* aarch64_atomic_or_fetchdi */

            default:
              return -1;
            }

        case XOR:
          switch (pattern349 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 2;
              return 5466; /* aarch64_atomic_xor_fetchqi */

            case 1:
              *pnum_clobbers = 2;
              return 5471; /* aarch64_atomic_xor_fetchhi */

            case 2:
              *pnum_clobbers = 2;
              return 5476; /* aarch64_atomic_xor_fetchsi */

            case 3:
              *pnum_clobbers = 2;
              return 5481; /* aarch64_atomic_xor_fetchdi */

            default:
              return -1;
            }

        case AND:
          return recog_615 (x1, insn, pnum_clobbers);

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != AND)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern448 (x7, 
31, 
3, 
UNSPEC_VOLATILE) != 0)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x20 = XEXP (x8, 1);
          operands[2] = x20;
          x12 = XEXP (x7, 1);
          x18 = XVECEXP (x12, 0, 2);
          operands[3] = x18;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1194 (x1))
            {
            case 0:
              *pnum_clobbers = 2;
              return 5483; /* atomic_nand_fetchqi */

            case 1:
              *pnum_clobbers = 2;
              return 5484; /* atomic_nand_fetchhi */

            case 2:
              *pnum_clobbers = 2;
              return 5485; /* atomic_nand_fetchsi */

            case 3:
              *pnum_clobbers = 2;
              return 5486; /* atomic_nand_fetchdi */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern350 (x1))
            {
            case 0:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6401; /* *vec_duplicatevnx16qi_reg */

            case 1:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6420; /* aarch64_vec_duplicate_vqvnx16qi_le */

            case 2:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6402; /* *vec_duplicatevnx8qi_reg */

            case 3:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6403; /* *vec_duplicatevnx4qi_reg */

            case 4:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6404; /* *vec_duplicatevnx2qi_reg */

            case 5:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6405; /* *vec_duplicatevnx8hi_reg */

            case 6:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6421; /* aarch64_vec_duplicate_vqvnx8hi_le */

            case 7:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6406; /* *vec_duplicatevnx4hi_reg */

            case 8:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6407; /* *vec_duplicatevnx2hi_reg */

            case 9:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6408; /* *vec_duplicatevnx4si_reg */

            case 10:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6422; /* aarch64_vec_duplicate_vqvnx4si_le */

            case 11:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6409; /* *vec_duplicatevnx2si_reg */

            case 12:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6410; /* *vec_duplicatevnx2di_reg */

            case 13:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6423; /* aarch64_vec_duplicate_vqvnx2di_le */

            case 14:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6411; /* *vec_duplicatevnx8hf_reg */

            case 15:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6425; /* aarch64_vec_duplicate_vqvnx8hf_le */

            case 16:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6412; /* *vec_duplicatevnx4hf_reg */

            case 17:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6413; /* *vec_duplicatevnx2hf_reg */

            case 18:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6414; /* *vec_duplicatevnx8bf_reg */

            case 19:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6424; /* aarch64_vec_duplicate_vqvnx8bf_le */

            case 20:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6415; /* *vec_duplicatevnx4bf_reg */

            case 21:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6416; /* *vec_duplicatevnx2bf_reg */

            case 22:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6417; /* *vec_duplicatevnx4sf_reg */

            case 23:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6426; /* aarch64_vec_duplicate_vqvnx4sf_le */

            case 24:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6418; /* *vec_duplicatevnx2sf_reg */

            case 25:
              if (!
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6419; /* *vec_duplicatevnx2df_reg */

            case 26:
              if (!
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN))
                return -1;
              return 6427; /* aarch64_vec_duplicate_vqvnx2df_le */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG)
            return -1;
          switch (REGNO (x6))
            {
            case 89:
              if (GET_MODE (x6) != E_DImode)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              if (pattern779 (x7, 
E_DImode, 
688, 
2, 
UNSPEC) != 0)
                return -1;
              x12 = XEXP (x7, 1);
              x19 = XVECEXP (x12, 0, 0);
              if (GET_CODE (x19) != REG
                  || REGNO (x19) != 90
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x17 = XVECEXP (x12, 0, 1);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 91
                  || GET_MODE (x17) != E_DImode)
                return -1;
              x14 = XEXP (x7, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 92
                  || GET_MODE (x14) != E_DImode)
                return -1;
              return 12930; /* aarch64_smstop_za */

            case 94:
              if (GET_MODE (x6) != E_V8DImode)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              if (pattern449 (x7, 
89, 
E_DImode, 
USE) != 0
                  || !
#line 1109 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME2))
                return -1;
              return 13360; /* aarch64_sme_zero_zt0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL
          || pattern37 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 63; /* *call_insn */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      switch (XINT (x2, 1))
        {
        case 18:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x21 = XVECEXP (x2, 0, 0);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern563 (x7) != 0
              || !
#line 8341 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1222; /* tcommit */

        case 19:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern563 (x7) != 0)
            return -1;
          x21 = XVECEXP (x2, 0, 0);
          operands[0] = x21;
          if (!const_int_operand (operands[0], E_VOIDmode)
              || !
#line 8350 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TME && (UINTVAL (operands[0]) <= 65535)))
            return -1;
          return 1223; /* tcancel */

        case 686:
          if (pattern450 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 24;
          return 12926; /* aarch64_smstart_sm */

        case 687:
          if (pattern450 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 24;
          return 12927; /* aarch64_smstop_sm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2945 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2953 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1294 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2961 (insn, operands);
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2837 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2880 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2920 (insn, operands);
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2836 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2879 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2919 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2823 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2868 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2908 (insn, operands);
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2810 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2857 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2897 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2843 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2885 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2925 (insn, operands);
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2830 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2874 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2914 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2817 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2863 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2903 (insn, operands);
}

 rtx_insn *
split_56 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2839 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2881 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2921 (insn, operands);
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1045 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1677 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1750 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1802 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1690 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1763 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1815 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1703 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1776 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1828 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1716 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1789 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1841 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1725 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1902 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1732 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1909 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1739 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1916 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1854 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1867 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1880 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1893 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1923 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1930 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1937 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_68 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[3] = x6;
  switch (XINT (x3, 1))
    {
    case 391:
      switch (XWINT (x4, 0))
        {
        case 0L:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1158 (x2, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5236 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5241 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1649 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
                  || !(
#line 5281 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5288 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1652 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1158 (x2, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5236 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5241 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1650 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
                  || !(
#line 5281 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5288 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1653 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1158 (x2, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return NULL;
              x7 = XVECEXP (x3, 0, 0);
              operands[4] = x7;
              x8 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x8, operands[2])
                  && (
#line 5236 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5241 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
                return gen_split_1651 (insn, operands);
              operands[5] = x7;
              operands[4] = x8;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
                  || !(
#line 5281 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5288 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_1654 (insn, operands);

            default:
              return NULL;
            }

        case 1L:
          x8 = XVECEXP (x2, 0, 2);
          operands[4] = x8;
          x7 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1222 (x2, 
E_VNx8HFmode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !(
#line 5318 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5325 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1655 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1222 (x2, 
E_VNx4SFmode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !(
#line 5318 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5325 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1656 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1222 (x2, 
E_VNx2DFmode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !(
#line 5318 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5325 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1657 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 352:
      return split_59 (x1, insn);

    case 353:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1671 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1744 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1796 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1684 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1757 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1809 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1697 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1770 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1822 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1710 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1783 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1835 (insn, operands);

        case 4:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1848 (insn, operands);

        case 5:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 6:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1874 (insn, operands);

        case 7:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3347 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1887 (insn, operands);

        default:
          return NULL;
        }

    case 354:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1672 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && (
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2))) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1745 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1797 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1685 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1758 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1810 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1698 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1771 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1823 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1711 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1784 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1836 (insn, operands);

        case 4:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && ((
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1849 (insn, operands);

        case 5:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 6:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1875 (insn, operands);

        case 7:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 3348 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1888 (insn, operands);

        default:
          return NULL;
        }

    case 371:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1673 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1746 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1798 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1686 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1759 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1811 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1699 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1772 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1824 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1712 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1785 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1837 (insn, operands);

        case 4:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1850 (insn, operands);

        case 5:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 6:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1876 (insn, operands);

        case 7:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1889 (insn, operands);

        default:
          return NULL;
        }

    case 372:
      return split_65 (x1, insn);

    case 373:
      return split_64 (x1, insn);

    case 374:
      return split_63 (x1, insn);

    case 375:
      return split_62 (x1, insn);

    case 378:
      return split_58 (x1, insn);

    case 379:
      switch (pattern1041 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1679 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1752 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1804 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1692 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1765 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1817 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1705 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1778 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1718 (insn, operands);
          if (rtx_equal_p (x8, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1791 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 4:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 5:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 6:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1882 (insn, operands);

        case 7:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1895 (insn, operands);

        default:
          return NULL;
        }

    case 393:
      return split_57 (x1, insn);

    case 395:
      return split_61 (x1, insn);

    case 396:
      return split_60 (x1, insn);

    case 355:
      switch (pattern1046 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5956 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5961 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1950 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5999 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6006 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1956 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5956 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5961 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1952 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5999 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6006 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1958 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5956 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5961 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1954 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5999 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6006 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1960 (insn, operands);

        case 3:
          if (!(
#line 6036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6043 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1962 (insn, operands);

        case 4:
          if (!(
#line 6036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6043 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1964 (insn, operands);

        case 5:
          if (!(
#line 6036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6043 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1966 (insn, operands);

        default:
          return NULL;
        }

    case 356:
      switch (pattern1046 (x2))
        {
        case 0:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5956 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5961 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1951 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5999 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6006 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1957 (insn, operands);

        case 1:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5956 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5961 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1953 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5999 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6006 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1959 (insn, operands);

        case 2:
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x8, operands[2])
              && (
#line 5956 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5961 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1955 (insn, operands);
          operands[5] = x7;
          operands[4] = x8;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5999 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6006 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1961 (insn, operands);

        case 3:
          if (!(
#line 6036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6043 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1963 (insn, operands);

        case 4:
          if (!(
#line 6036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6043 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1965 (insn, operands);

        case 5:
          if (!(
#line 6036 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 6043 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1967 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      switch (pattern48 (x3))
        {
        case 0:
          return gen_split_24 (insn, operands);

        case 1:
          return gen_split_25 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          switch (pattern452 (x3))
            {
            case 0:
              if (!
#line 5164 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_40 (insn, operands);

            case 1:
              if (!
#line 5164 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_44 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern453 (x3))
            {
            case 0:
              if (!
#line 5186 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (IOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 1:
              if (!
#line 5186 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (IOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 2:
              if (!
#line 5215 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (IOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 3:
              if (!
#line 5215 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (IOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_60 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || pattern581 (x6) != 0)
            return NULL;
          switch (pattern1038 (x3))
            {
            case 0:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx16QImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2995 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2996 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx16QImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3003 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3004 (insn, operands);

            case 1:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx8HImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2997 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2998 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx8HImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3005 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3006 (insn, operands);

            case 2:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx4SImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2999 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3000 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx4SImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3007 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3008 (insn, operands);

            case 3:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx2DImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3001 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1851 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1856 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_3002 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx2DImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_3009 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1878 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1883 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_3010 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern363 (x3))
        {
        case 0:
          if (!
#line 5238 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_64 (insn, operands);

        case 1:
          if (!
#line 5238 "../../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_67 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_129 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2452 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2462 (insn, operands);
}

 rtx_insn *
split_137 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern342 (x1))
        {
        case 0:
          if (!(
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4466 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 1:
          if (!(
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4466 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_22 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern342 (x1))
        {
        case 0:
          if (!(
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4466 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_21 (insn, operands);

        case 1:
          if (!(
#line 4462 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4466 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_23 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern367 (x1, 
E_CCmode, 
66, 
CLOBBER) != 0)
        return NULL;
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SMAX:
          switch (pattern983 (x3))
            {
            case 0:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_29 (insn, operands);

            case 1:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_33 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern983 (x3))
            {
            case 0:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_30 (insn, operands);

            case 1:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_34 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern983 (x3))
            {
            case 0:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_31 (insn, operands);

            case 1:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern983 (x3))
            {
            case 0:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_32 (insn, operands);

            case 1:
              if (!(
#line 5003 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 5005 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CC_NZVmode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern710 (x1, 
CLOBBER, 
E_CC_NZVmode) != 0)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (!register_operand (x7, E_SImode))
        return NULL;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          operands[2] = x7;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !aarch64_mov_imm_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_73 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !aarch64_mov_imm_operand (operands[1], E_DImode))
                return NULL;
              return gen_split_74 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern1109 (x1))
            {
            case 0:
              return gen_split_75 (insn, operands);

            case 1:
              return gen_split_80 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern1109 (x1))
            {
            case 0:
              return gen_split_76 (insn, operands);

            case 1:
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern1109 (x1))
            {
            case 0:
              return gen_split_77 (insn, operands);

            case 1:
              return gen_split_82 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern1109 (x1))
            {
            case 0:
              return gen_split_78 (insn, operands);

            case 1:
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          switch (pattern1109 (x1))
            {
            case 0:
              return gen_split_79 (insn, operands);

            case 1:
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case US_PLUS:
      switch (pattern344 (x1))
        {
        case 0:
          if (!
#line 5313 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_211 (insn, operands);

        case 1:
          if (!
#line 5313 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_219 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      switch (pattern344 (x1))
        {
        case 0:
          if (!
#line 5313 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_215 (insn, operands);

        case 1:
          if (!
#line 5313 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed && GP_REGNUM_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_223 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern345 (x1))
        {
        case 0:
          if (!(
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7213 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 1:
          if (!(
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7213 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_228 (insn, operands);

        case 2:
          if (!(
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7213 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_229 (insn, operands);

        case 3:
          if (!(
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7213 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_230 (insn, operands);

        case 4:
          if (!(
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7213 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 5:
          if (!(
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7276 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_232 (insn, operands);

        case 6:
          if (!(
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7276 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_233 (insn, operands);

        case 7:
          if (!(
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7276 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 8:
          if (!(
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7276 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 9:
          if (!(
#line 7362 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7364 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_236 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 127
          || pattern557 (x2) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 2);
      if (XWINT (x10, 0) == 1L)
        {
          x11 = XVECEXP (x3, 0, 3);
          switch (GET_CODE (x11))
            {
            case CONST:
              switch (pattern1089 (x1))
                {
                case 0:
                  if ((
#line 983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 987 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_558 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1035 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_562 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
              switch (pattern1091 (x1))
                {
                case 0:
                  if ((
#line 1009 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_559 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1009 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_560 (insn, operands);
                  break;

                case 2:
                  if ((
#line 1009 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_561 (insn, operands);
                  break;

                case 3:
                  if ((
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_563 (insn, operands);
                  break;

                case 4:
                  if ((
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_564 (insn, operands);
                  break;

                case 5:
                  if ((
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_565 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case UNSPEC:
              res = split_132 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
        }
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 3)
        return NULL;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !aarch64_sve_ptrue_flag (x10, E_SImode))
        return NULL;
      x13 = XVECEXP (x11, 0, 1);
      if (!aarch64_sve_ptrue_flag (x13, E_SImode))
        return NULL;
      return split_135 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern350 (x1))
        {
        case 0:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1033 (insn, operands);

        case 1:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1052 (insn, operands);

        case 2:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1034 (insn, operands);

        case 3:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1035 (insn, operands);

        case 4:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1036 (insn, operands);

        case 5:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1037 (insn, operands);

        case 6:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1053 (insn, operands);

        case 7:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1038 (insn, operands);

        case 8:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1039 (insn, operands);

        case 9:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1040 (insn, operands);

        case 10:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1054 (insn, operands);

        case 11:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1041 (insn, operands);

        case 12:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1042 (insn, operands);

        case 13:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1055 (insn, operands);

        case 14:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1043 (insn, operands);

        case 15:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1057 (insn, operands);

        case 16:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1044 (insn, operands);

        case 17:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1045 (insn, operands);

        case 18:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1046 (insn, operands);

        case 19:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1056 (insn, operands);

        case 20:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1047 (insn, operands);

        case 21:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1048 (insn, operands);

        case 22:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1049 (insn, operands);

        case 23:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1058 (insn, operands);

        case 24:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1050 (insn, operands);

        case 25:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1051 (insn, operands);

        case 26:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1059 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      return split_136 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V16QImode))
    {
      switch (pattern933 (
E_V16QImode))
        {
        case 0:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_92 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_93 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_94 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_95 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_96 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_97 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_98 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_99 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode))
    return NULL;
  switch (pattern988 ())
    {
    case 0:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_156 (insn, operands);

    case 1:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_157 (insn, operands);

    case 2:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_158 (insn, operands);

    case 3:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_159 (insn, operands);

    case 4:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_160 (insn, operands);

    case 5:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_161 (insn, operands);

    case 6:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_162 (insn, operands);

    case 7:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_163 (insn, operands);

    default:
      return NULL;
    }
}
