/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      switch (XINT (x4, 1))
        {
        case 36:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              return pattern9 (x3); /* [-1, 11] */

            case MULT:
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (pattern10 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
                    return -1;
                  return 12;

                case E_V4SImode:
                  if (pattern10 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
                    return -1;
                  return 13;

                case E_V2DImode:
                  if (pattern10 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
                    return -1;
                  return 14;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 34:
          res = pattern9 (x3);
          if (res >= 0)
            return res + 15; /* [15, 26] */
          return -1;

        case 32:
          res = pattern9 (x3);
          if (res >= 0)
            return res + 27; /* [27, 38] */
          return -1;

        case 30:
          res = pattern9 (x3);
          if (res >= 0)
            return res + 39; /* [39, 50] */
          return -1;

        case 33:
          res = pattern9 (x3);
          if (res >= 0)
            return res + 51; /* [51, 62] */
          return -1;

        default:
          return -1;
        }

    case MULT:
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          res = pattern11 (x3, 
E_SImode);
          if (res >= 0)
            return res + 63; /* [63, 64] */
          return -1;

        case E_DImode:
          res = pattern11 (x3, 
E_DImode);
          if (res >= 0)
            return res + 65; /* [65, 66] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              return 67;

            case E_HFmode:
              if (!register_operand (operands[1], E_HFmode))
                return -1;
              return 68;

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode))
                return -1;
              return 69;

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode))
                return -1;
              return 70;

            case E_HFmode:
              if (!register_operand (operands[1], E_HFmode))
                return -1;
              return 71;

            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              return 72;

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[1], E_HFmode))
            return -1;
          return 73;

        case E_VNx8SImode:
          if (!aligned_register_operand (operands[0], E_VNx8SImode)
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[1], E_VNx8SFmode))
            return -1;
          return 74;

        case E_VNx16SImode:
          if (!aligned_register_operand (operands[0], E_VNx16SImode)
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[1], E_VNx16SFmode))
            return -1;
          return 75;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 3;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 3;

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      return 4;

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[0] = x5;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern77 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern77 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern77 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern77 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern77 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern77 (x3, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern77 (x3, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern77 (x3, 
E_DFmode) != 0)
        return -1;
      return 7;

    case E_VNx8HFmode:
      if (pattern77 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 8;

    case E_VNx4SFmode:
      if (pattern77 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 9;

    case E_VNx2DFmode:
      if (pattern77 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_hi (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern77 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[1], E_VNx16BImode)
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern122 (x3); /* [-1, 2] */
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  return pattern66 (x3); /* [-1, 2] */
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx8DImode:
          if (!register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_hi (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern163 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern163 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern163 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern173 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[2], E_VNx4SFmode))
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !aarch64_maskload_else_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_maxmin_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  return pattern213 (x3); /* [-1, 2] */
}

int
pattern220 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_VNx16QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 93
      || GET_MODE (x2) != E_VNx16QImode)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[1], E_VNx8SFmode))
            return -1;
          return 0;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[1], E_VNx16SFmode))
            return -1;
          return 1;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[1], E_VNx4DFmode))
            return -1;
          return 2;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[1], E_VNx8DFmode))
            return -1;
          return 3;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[1], E_VNx16HFmode))
            return -1;
          return 4;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[1], E_VNx32HFmode))
            return -1;
          return 5;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[1], E_VNx16BFmode))
            return -1;
          return 6;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[1], E_VNx32BFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[2], E_VNx8SFmode))
            return -1;
          return 8;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[2], E_VNx16SFmode))
            return -1;
          return 9;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[2], E_VNx4DFmode))
            return -1;
          return 10;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[2], E_VNx8DFmode))
            return -1;
          return 11;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[2], E_VNx16HFmode))
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[2], E_VNx32HFmode))
            return -1;
          return 13;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[2], E_VNx16BFmode))
            return -1;
          return 14;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[2], E_VNx32BFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern259 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93
      || GET_MODE (x3) != E_VNx4SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93
      || GET_MODE (x5) != E_VNx4SImode)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  if (!register_operand (operands[1], E_VNx4BImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  if (!register_operand (operands[2], E_VNx4BImode))
    return -1;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  if (!register_operand (operands[3], E_VNx4SImode))
    return -1;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern271 (x2, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern271 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern271 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern271 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx1TImode:
          if (pattern271 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern272 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 5;

        case E_VNx8HImode:
          if (pattern272 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern272 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2DImode:
          if (pattern272 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx1TImode:
          if (pattern272 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern290 (x1, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern290 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern290 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern296 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern296 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              return pattern304 (x1, 
E_SImode); /* [-1, 2] */

            case E_DImode:
              res = pattern304 (x1, 
E_DImode);
              if (res >= 0)
                return res + 3; /* [3, 5] */
              return -1;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern305 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
                return -1;
              return 6;

            case E_V4SImode:
              if (pattern305 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
                return -1;
              return 7;

            case E_V2DImode:
              if (pattern305 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern306 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V4SImode:
          if (pattern306 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern306 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern326 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      res = pattern19 ();
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_VNx16BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x5) != E_VNx16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sve_dup_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x5) != E_VNx8QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x5) != E_VNx4QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 3;

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x5) != E_VNx2QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 4;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x5) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!aarch64_sve_dup_operand (operands[1], E_HImode))
            return -1;
          return 5;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x5) != E_VNx4HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode))
        return -1;
      return 7;

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x5) != E_VNx2HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode))
        return -1;
      return 8;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x5) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!aarch64_sve_dup_operand (operands[1], E_SImode))
            return -1;
          return 9;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x5) != E_VNx2SImode
          || !aarch64_sve_dup_operand (operands[1], E_SImode))
        return -1;
      return 11;

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x5) != E_VNx2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!aarch64_sve_dup_operand (operands[1], E_DImode))
            return -1;
          return 12;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x5) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_HFmode))
            return -1;
          return 14;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x5) != E_VNx4HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode))
        return -1;
      return 16;

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x5) != E_VNx2HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode))
        return -1;
      return 17;

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x5) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_BFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_BFmode))
            return -1;
          return 18;

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[1], E_V8BFmode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x5) != E_VNx4BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode))
        return -1;
      return 20;

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x5) != E_VNx2BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode))
        return -1;
      return 21;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x5) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_SFmode))
            return -1;
          return 22;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 23;

        default:
          return -1;
        }

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x5) != E_VNx2SFmode
          || !aarch64_sve_dup_operand (operands[1], E_SFmode))
        return -1;
      return 24;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x5) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_DFmode))
            return -1;
          return 25;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern411 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_reg_or_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern415 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern419 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern425 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode)
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !aarch64_logical_immediate (operands[3], E_SImode)
          || !register_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !aarch64_logical_immediate (operands[3], E_DImode)
          || !register_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      return pattern464 (x1, 
SIGN_EXTEND); /* [-1, 5] */

    case ZERO_EXTEND:
      res = pattern464 (x1, 
ZERO_EXTEND);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern471 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_vsm_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x1, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern471 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern471 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern471 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern471 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern471 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern471 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern471 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern471 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern471 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern471 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        case E_V2DImode:
          if (pattern471 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case UNSPEC:
      res = pattern474 (x1, 
SMAX);
      if (res >= 0)
        return res + 11; /* [11, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          return pattern495 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern495 (x1, 
E_V4SImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (!register_operand (operands[0], E_VNx4SImode)
              || GET_MODE (x1) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[3], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[1], E_VNx16QImode)
                  || !register_operand (operands[2], E_VNx16QImode))
                return -1;
              return 2;

            case E_VNx8HImode:
              if (!register_operand (operands[1], E_VNx8HImode)
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (pattern495 (x1, 
E_VNx2DImode, 
E_VNx8HImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x1, 1);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          res = pattern496 (x1, 
E_VNx4SImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        case E_VNx2DImode:
          res = pattern496 (x1, 
E_VNx2DImode);
          if (res >= 0)
            return res + 7; /* [7, 8] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern526 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern525 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern525 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern525 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern533 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern533 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern533 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern544 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern535 (x1); /* [-1, 2] */
}

int
pattern549 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x1, 1);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern548 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern548 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 0);
      operands[4] = x9;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || GET_MODE (x5) != E_HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode)
              || GET_MODE (x5) != E_SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern585 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_select_half (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_select_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern593 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern598 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (XINT (x4, 1))
    {
    case 169:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      operands[4] = x7;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern610 (x4);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern624 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern629 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern632 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern632 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V8HImode:
      if (pattern633 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern633 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern633 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern641 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern649 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i4))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern655 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  if (!register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern662 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern672 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern671 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern671 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern671 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern678 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern682 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !aarch64_simd_raddsubhn_imm_vec (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[5], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern689 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_NZCmode
      || !register_operand (operands[0], E_VNx16BImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[1] = x8;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[2] = x9;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x10 = XVECEXP (x3, 0, 4);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern700 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_lo_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern704 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[3] = x4;
          operands[2] = x3;
          return 0;

        case MULT:
          operands[4] = x3;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 125)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125)
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x7))
        {
        case SMAX:
          res = pattern703 (x1, 
SMIN);
          if (res >= 0)
            return res + 2; /* [2, 11] */
          return -1;

        case UMAX:
          res = pattern703 (x1, 
UMIN);
          if (res >= 0)
            return res + 12; /* [12, 21] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern712 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 89
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 90
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 92
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern717 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    case E_VNx2DImode:
      if (!register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern722 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx4BImode)
      || !aarch64_sve_ld1ro_operand_w (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern727 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!pmode_register_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern734 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x3;
      return 0;

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 1;

    case ASHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 2;

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 3;

    case ROTATERT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 4;

    case ROTATE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 5;

    default:
      return -1;
    }
}

int
pattern761 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern758 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern758 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern758 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern758 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern769 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern776 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != SCRATCH
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern782 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern787 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!const_int_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern795 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !memory_operand (operands[1], i1)
      || !aarch64_maskload_else_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern818 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern824 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern823 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern823 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern833 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[4], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[5], i1))
    return -1;
  return 0;
}

int
pattern846 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8BImode:
      if (!register_operand (operands[1], E_VNx8BImode)
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4BImode:
      if (!register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 1;

    case E_VNx2BImode:
      if (!register_operand (operands[1], E_VNx2BImode)
          || !register_operand (operands[2], E_VNx2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern856 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern862 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_VNx4SImode
      || !register_operand (operands[0], E_VNx4SImode)
      || GET_MODE (x1) != E_VNx4SImode
      || !register_operand (operands[1], E_VNx4BImode)
      || !register_operand (operands[2], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern868 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern874 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[3], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[3], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[3], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[3], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[3], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[3], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[3], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[3], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[3], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern911 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern910 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern910 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern910 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern923 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CC_NZCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 1);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 2);
  switch (GET_CODE (x9))
    {
    case LT:
      return pattern921 (x5); /* [-1, 9] */

    case LE:
      res = pattern921 (x5);
      if (res >= 0)
        return res + 10; /* [10, 19] */
      return -1;

    case EQ:
      res = pattern921 (x5);
      if (res >= 0)
        return res + 20; /* [20, 29] */
      return -1;

    case NE:
      res = pattern921 (x5);
      if (res >= 0)
        return res + 30; /* [30, 39] */
      return -1;

    case GE:
      res = pattern921 (x5);
      if (res >= 0)
        return res + 40; /* [40, 49] */
      return -1;

    case GT:
      res = pattern921 (x5);
      if (res >= 0)
        return res + 50; /* [50, 59] */
      return -1;

    case LTU:
      res = pattern922 (x5);
      if (res >= 0)
        return res + 60; /* [60, 69] */
      return -1;

    case LEU:
      res = pattern922 (x5);
      if (res >= 0)
        return res + 70; /* [70, 79] */
      return -1;

    case GEU:
      res = pattern922 (x5);
      if (res >= 0)
        return res + 80; /* [80, 89] */
      return -1;

    case GTU:
      res = pattern922 (x5);
      if (res >= 0)
        return res + 90; /* [90, 99] */
      return -1;

    default:
      return -1;
    }
}

int
pattern937 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern941 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !aarch64_sve_reg_or_dup_imm (operands[1], i1)
      || !aarch64_simd_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern945 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_sve_float_arith_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern952 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern951 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern951 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern951 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern960 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern965 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern972 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[3] = x2;
      return 1;

    default:
      return -1;
    }
}

int
pattern979 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[2] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[5] = x11;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (XINT (x6, 1))
    {
    case 357:
      return pattern976 (x3); /* [-1, 5] */

    case 358:
      res = pattern976 (x3);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case 359:
      res = pattern976 (x3);
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case 364:
      res = pattern976 (x3);
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    case 365:
      res = pattern976 (x3);
      if (res >= 0)
        return res + 24; /* [24, 29] */
      return -1;

    case 366:
      res = pattern976 (x3);
      if (res >= 0)
        return res + 30; /* [30, 35] */
      return -1;

    case 367:
      x13 = XEXP (x4, 1);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BImode:
              if (pattern977 (x3, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
                return -1;
              return 36;

            case E_VNx4BImode:
              if (pattern977 (x3, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
                return -1;
              return 37;

            case E_VNx2BImode:
              if (pattern977 (x3, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
                return -1;
              return 38;

            default:
              return -1;
            }

        case NOT:
          x14 = XEXP (x13, 0);
          operands[4] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BImode:
              if (pattern978 (x3, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
                return -1;
              return 39;

            case E_VNx4BImode:
              if (pattern978 (x3, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
                return -1;
              return 40;

            case E_VNx2BImode:
              if (pattern978 (x3, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
                return -1;
              return 41;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1004 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XVECEXP (x4, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1003 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern1003 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern1003 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern1003 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern1003 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern1003 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern1003 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern1003 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern1003 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern1003 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern1028 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1035 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1039 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1045 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      return pattern1043 (x1); /* [-1, 6] */

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1040 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 7;

            case E_VNx8HFmode:
              if (pattern1040 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 8;

            case E_VNx4SFmode:
              if (pattern1040 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return -1;
              return 9;

            case E_VNx2DFmode:
              if (pattern1040 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return -1;
              return 10;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
                return -1;
              return 11;

            case E_VNx4SFmode:
              if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
                return -1;
              return 12;

            case E_VNx2DFmode:
              if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
                return -1;
              return 13;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1070 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1078 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1085 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1)
      || !aarch64_simd_umax_half_mode (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1095 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  return 0;
}

int
pattern1100 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_mul_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1104 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !aarch64_simd_reg_or_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1123 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1132 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x4, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1131 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1131 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1131 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1131 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1156 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1165 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1175 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1179 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i4))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1187 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_reg_or_zero (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern1193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1208 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[4], i4))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1177 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1222 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1231 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1238 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_int_rnd_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1246 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[3] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XVECEXP (x6, 0, 0);
  operands[4] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[5] = x8;
  if (!aarch64_sve_ptrue_flag (operands[5], E_SImode))
    return -1;
  return pattern1245 (x1, 
i1); /* [-1, 7] */
}

int
pattern1254 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_mul_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1260 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1273 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1273 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1273 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1273 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern1269 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern1269 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern1269 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XVECEXP (x2, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern1300 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern1300 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern1300 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1315 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_VNx2HImode:
      if (!register_operand (operands[4], E_VNx2HImode))
        return -1;
      return 0;

    case E_VNx2HFmode:
      if (!register_operand (operands[4], E_VNx2HFmode))
        return -1;
      return 1;

    case E_VNx2BFmode:
      if (!register_operand (operands[4], E_VNx2BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1318 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1327 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2HImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2SImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
        return -1;
      return 2;

    case E_VNx2DImode:
      if (!register_operand (operands[2], E_VNx2DImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1336 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_carry_operation (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !aarch64_carry_operation (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8HImode)
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8BFmode:
      if (!register_operand (operands[2], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1366 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (XINT (x7, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1365 (x1, 
E_VNx16QImode, 
E_VNx64QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1365 (x1, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1365 (x1, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1365 (x1, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
        return -1;
      return 3;

    case E_VNx8BFmode:
      if (pattern1365 (x1, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0)
        return -1;
      return 4;

    case E_VNx8HFmode:
      if (pattern1365 (x1, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0)
        return -1;
      return 5;

    case E_VNx4SFmode:
      if (pattern1365 (x1, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern1365 (x1, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8QImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4641; /* aarch64_ld1_x3_v8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4642; /* aarch64_ld1_x3_v4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4643; /* aarch64_ld1_x3_v2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4644; /* aarch64_ld1_x3_di */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4645; /* aarch64_ld1_x3_v4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4646; /* aarch64_ld1_x3_v2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4647; /* aarch64_ld1_x3_df */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4BFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4648; /* aarch64_ld1_x3_v4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x16QImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4649; /* aarch64_ld1_x3_v16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4650; /* aarch64_ld1_x3_v8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4651; /* aarch64_ld1_x3_v4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DImode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4652; /* aarch64_ld1_x3_v2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4653; /* aarch64_ld1_x3_v8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4654; /* aarch64_ld1_x3_v4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4655; /* aarch64_ld1_x3_v2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8BFmode)
          || !
#line 8006 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4656; /* aarch64_ld1_x3_v8bf */

    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8QImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4657; /* aarch64_ld1_x4_v8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4658; /* aarch64_ld1_x4_v4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4659; /* aarch64_ld1_x4_v2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4660; /* aarch64_ld1_x4_di */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4661; /* aarch64_ld1_x4_v4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4662; /* aarch64_ld1_x4_v2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4663; /* aarch64_ld1_x4_df */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4BFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4664; /* aarch64_ld1_x4_v4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x16QImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4665; /* aarch64_ld1_x4_v16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4666; /* aarch64_ld1_x4_v8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4667; /* aarch64_ld1_x4_v4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DImode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4668; /* aarch64_ld1_x4_v2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4669; /* aarch64_ld1_x4_v8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4670; /* aarch64_ld1_x4_v4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4671; /* aarch64_ld1_x4_v2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8BFmode)
          || !
#line 8026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4672; /* aarch64_ld1_x4_v8bf */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V8QImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4722; /* aarch64_be_ld1v8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V16QImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4723; /* aarch64_be_ld1v16qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4HImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4724; /* aarch64_be_ld1v4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V8HImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4725; /* aarch64_be_ld1v8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2SImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4726; /* aarch64_be_ld1v2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4SImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4727; /* aarch64_be_ld1v4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2DImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4728; /* aarch64_be_ld1v2di */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4HFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4729; /* aarch64_be_ld1v4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8HFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4730; /* aarch64_be_ld1v8hf */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4BFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4731; /* aarch64_be_ld1v4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8BFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4732; /* aarch64_be_ld1v8bf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2SFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4733; /* aarch64_be_ld1v2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4SFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4734; /* aarch64_be_ld1v4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2DFmode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4735; /* aarch64_be_ld1v2df */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !aarch64_simd_struct_operand (operands[1], E_DImode)
          || !
#line 8106 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4736; /* aarch64_be_ld1di */

    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5138; /* aarch64_simd_ld1v8qi_x2 */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5139; /* aarch64_simd_ld1v4hi_x2 */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5140; /* aarch64_simd_ld1v2si_x2 */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5141; /* aarch64_simd_ld1di_x2 */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5142; /* aarch64_simd_ld1v4hf_x2 */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5143; /* aarch64_simd_ld1v2sf_x2 */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5144; /* aarch64_simd_ld1df_x2 */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5145; /* aarch64_simd_ld1v4bf_x2 */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x16QImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5146; /* aarch64_simd_ld1v16qi_x2 */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5147; /* aarch64_simd_ld1v8hi_x2 */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5148; /* aarch64_simd_ld1v4si_x2 */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DImode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5149; /* aarch64_simd_ld1v2di_x2 */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5150; /* aarch64_simd_ld1v8hf_x2 */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5151; /* aarch64_simd_ld1v4sf_x2 */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5152; /* aarch64_simd_ld1v2df_x2 */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8BFmode)
          || !
#line 8827 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5153; /* aarch64_simd_ld1v8bf_x2 */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern603 (x2))
        {
        case 0:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8210; /* aarch64_pred_lshrvnx16qi */

        case 1:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8213; /* aarch64_pred_lshrvnx8qi */

        case 2:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8216; /* aarch64_pred_lshrvnx4qi */

        case 3:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8219; /* aarch64_pred_lshrvnx2qi */

        case 4:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8222; /* aarch64_pred_lshrvnx8hi */

        case 5:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8225; /* aarch64_pred_lshrvnx4hi */

        case 6:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8228; /* aarch64_pred_lshrvnx2hi */

        case 7:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8231; /* aarch64_pred_lshrvnx4si */

        case 8:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8234; /* aarch64_pred_lshrvnx2si */

        case 9:
          if (!
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8237; /* aarch64_pred_lshrvnx2di */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern993 (x2, 
E_VNx8HImode) != 0
              || !
#line 2727 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12361; /* *bitmask_shift_plusvnx8hi */

        case E_VNx4SImode:
          if (pattern993 (x2, 
E_VNx4SImode) != 0
              || !
#line 2727 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12362; /* *bitmask_shift_plusvnx4si */

        case E_VNx2DImode:
          if (pattern993 (x2, 
E_VNx2DImode) != 0
              || !
#line 2727 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12363; /* *bitmask_shift_plusvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern470 (x2))
    {
    case 0:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6554; /* aarch64_pred_qabsvnx16qi */

    case 1:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6563; /* aarch64_pred_qabsvnx8qi */

    case 2:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6572; /* aarch64_pred_qabsvnx4qi */

    case 3:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6581; /* aarch64_pred_qabsvnx2qi */

    case 4:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6590; /* aarch64_pred_qabsvnx8hi */

    case 5:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6599; /* aarch64_pred_qabsvnx4hi */

    case 6:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6608; /* aarch64_pred_qabsvnx2hi */

    case 7:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6617; /* aarch64_pred_qabsvnx4si */

    case 8:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6626; /* aarch64_pred_qabsvnx2si */

    case 9:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6635; /* aarch64_pred_qabsvnx2di */

    case 10:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6644; /* aarch64_pred_qabsv8qi */

    case 11:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6653; /* aarch64_pred_qabsv16qi */

    case 12:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6662; /* aarch64_pred_qabsv4hi */

    case 13:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6671; /* aarch64_pred_qabsv8hi */

    case 14:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6680; /* aarch64_pred_qabsv2si */

    case 15:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6689; /* aarch64_pred_qabsv4si */

    case 16:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6698; /* aarch64_pred_qabsv2di */

    case 17:
      if (!(
#line 3200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2758 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6707; /* aarch64_pred_qabsv1di */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern77 (x3, 
E_V8QImode) != 0
          || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4844; /* aarch64_zip1v8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4862; /* aarch64_zip1v16qi */

        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5000; /* aarch64_zip1v16qi_low */

        default:
          return -1;
        }

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0
          || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4868; /* aarch64_zip1v4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4886; /* aarch64_zip1v8hi */

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5001; /* aarch64_zip1v8hi_low */

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0
          || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4892; /* aarch64_zip1v2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4910; /* aarch64_zip1v4si */

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5002; /* aarch64_zip1v4si_low */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4916; /* aarch64_zip1v2di */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5003; /* aarch64_zip1v2di_low */

        default:
          return -1;
        }

    case E_V4HFmode:
      if (pattern77 (x3, 
E_V4HFmode) != 0
          || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4922; /* aarch64_zip1v4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !register_operand (operands[2], E_V8HFmode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4940; /* aarch64_zip1v8hf */

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !register_operand (operands[2], E_V4HFmode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5004; /* aarch64_zip1v8hf_low */

        default:
          return -1;
        }

    case E_V4BFmode:
      if (pattern77 (x3, 
E_V4BFmode) != 0
          || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4946; /* aarch64_zip1v4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !register_operand (operands[2], E_V8BFmode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4964; /* aarch64_zip1v8bf */

        case E_V4BFmode:
          if (!register_operand (operands[1], E_V4BFmode)
              || !register_operand (operands[2], E_V4BFmode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5007; /* aarch64_zip1v8bf_low */

        default:
          return -1;
        }

    case E_V2SFmode:
      if (pattern77 (x3, 
E_V2SFmode) != 0
          || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4970; /* aarch64_zip1v2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4988; /* aarch64_zip1v4sf */

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !register_operand (operands[2], E_V2SFmode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5005; /* aarch64_zip1v4sf_low */

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !register_operand (operands[2], E_V2DFmode)
              || !
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4994; /* aarch64_zip1v2df */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !register_operand (operands[2], E_DFmode)
              || !
#line 8646 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5006; /* aarch64_zip1v2df_low */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern77 (x3, 
E_VNx16QImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10465; /* aarch64_sve_zip1vnx16qi */

    case E_VNx8QImode:
      if (pattern77 (x3, 
E_VNx8QImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10475; /* aarch64_sve_zip1vnx8qi */

    case E_VNx4QImode:
      if (pattern77 (x3, 
E_VNx4QImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10485; /* aarch64_sve_zip1vnx4qi */

    case E_VNx2QImode:
      if (pattern77 (x3, 
E_VNx2QImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10495; /* aarch64_sve_zip1vnx2qi */

    case E_VNx8HImode:
      if (pattern77 (x3, 
E_VNx8HImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10505; /* aarch64_sve_zip1vnx8hi */

    case E_VNx4HImode:
      if (pattern77 (x3, 
E_VNx4HImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10515; /* aarch64_sve_zip1vnx4hi */

    case E_VNx2HImode:
      if (pattern77 (x3, 
E_VNx2HImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10525; /* aarch64_sve_zip1vnx2hi */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10535; /* aarch64_sve_zip1vnx4si */

    case E_VNx2SImode:
      if (pattern77 (x3, 
E_VNx2SImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10545; /* aarch64_sve_zip1vnx2si */

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10555; /* aarch64_sve_zip1vnx2di */

    case E_VNx8HFmode:
      if (pattern77 (x3, 
E_VNx8HFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10565; /* aarch64_sve_zip1vnx8hf */

    case E_VNx4HFmode:
      if (pattern77 (x3, 
E_VNx4HFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10575; /* aarch64_sve_zip1vnx4hf */

    case E_VNx2HFmode:
      if (pattern77 (x3, 
E_VNx2HFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10585; /* aarch64_sve_zip1vnx2hf */

    case E_VNx8BFmode:
      if (pattern77 (x3, 
E_VNx8BFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10595; /* aarch64_sve_zip1vnx8bf */

    case E_VNx4BFmode:
      if (pattern77 (x3, 
E_VNx4BFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10605; /* aarch64_sve_zip1vnx4bf */

    case E_VNx2BFmode:
      if (pattern77 (x3, 
E_VNx2BFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10615; /* aarch64_sve_zip1vnx2bf */

    case E_VNx4SFmode:
      if (pattern77 (x3, 
E_VNx4SFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10625; /* aarch64_sve_zip1vnx4sf */

    case E_VNx2SFmode:
      if (pattern77 (x3, 
E_VNx2SFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10635; /* aarch64_sve_zip1vnx2sf */

    case E_VNx2DFmode:
      if (pattern77 (x3, 
E_VNx2DFmode) != 0
          || !
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10645; /* aarch64_sve_zip1vnx2df */

    case E_VNx16BImode:
      if (pattern77 (x3, 
E_VNx16BImode) != 0
          || !
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10726; /* aarch64_sve_zip1vnx16bi */

    case E_VNx8BImode:
      if (pattern77 (x3, 
E_VNx8BImode) != 0
          || !
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10732; /* aarch64_sve_zip1vnx8bi */

    case E_VNx4BImode:
      if (pattern77 (x3, 
E_VNx4BImode) != 0
          || !
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10738; /* aarch64_sve_zip1vnx4bi */

    case E_VNx2BImode:
      if (pattern77 (x3, 
E_VNx2BImode) != 0
          || !
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10744; /* aarch64_sve_zip1vnx2bi */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4853; /* aarch64_trn2v8qi */

    case 1:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4865; /* aarch64_trn2v16qi */

    case 2:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4877; /* aarch64_trn2v4hi */

    case 3:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4889; /* aarch64_trn2v8hi */

    case 4:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4901; /* aarch64_trn2v2si */

    case 5:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4913; /* aarch64_trn2v4si */

    case 6:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4919; /* aarch64_trn2v2di */

    case 7:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4931; /* aarch64_trn2v4hf */

    case 8:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4943; /* aarch64_trn2v8hf */

    case 9:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4955; /* aarch64_trn2v4bf */

    case 10:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4967; /* aarch64_trn2v8bf */

    case 11:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4979; /* aarch64_trn2v2sf */

    case 12:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4991; /* aarch64_trn2v4sf */

    case 13:
      if (!
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4997; /* aarch64_trn2v2df */

    case 14:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10468; /* aarch64_sve_trn2vnx16qi */

    case 15:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10478; /* aarch64_sve_trn2vnx8qi */

    case 16:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10488; /* aarch64_sve_trn2vnx4qi */

    case 17:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10498; /* aarch64_sve_trn2vnx2qi */

    case 18:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10508; /* aarch64_sve_trn2vnx8hi */

    case 19:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10518; /* aarch64_sve_trn2vnx4hi */

    case 20:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10528; /* aarch64_sve_trn2vnx2hi */

    case 21:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10538; /* aarch64_sve_trn2vnx4si */

    case 22:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10548; /* aarch64_sve_trn2vnx2si */

    case 23:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10558; /* aarch64_sve_trn2vnx2di */

    case 24:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10568; /* aarch64_sve_trn2vnx8hf */

    case 25:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10578; /* aarch64_sve_trn2vnx4hf */

    case 26:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10588; /* aarch64_sve_trn2vnx2hf */

    case 27:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10598; /* aarch64_sve_trn2vnx8bf */

    case 28:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10608; /* aarch64_sve_trn2vnx4bf */

    case 29:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10618; /* aarch64_sve_trn2vnx2bf */

    case 30:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10628; /* aarch64_sve_trn2vnx4sf */

    case 31:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10638; /* aarch64_sve_trn2vnx2sf */

    case 32:
      if (!
#line 9215 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10648; /* aarch64_sve_trn2vnx2df */

    case 33:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10729; /* aarch64_sve_trn2vnx16bi */

    case 34:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10735; /* aarch64_sve_trn2vnx8bi */

    case 35:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10741; /* aarch64_sve_trn2vnx4bi */

    case 36:
      if (!
#line 9284 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10747; /* aarch64_sve_trn2vnx2bi */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern77 (x3, 
E_V8QImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3310; /* aarch64_suqaddv8qi */

        case E_V16QImode:
          if (pattern77 (x3, 
E_V16QImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3316; /* aarch64_suqaddv16qi */

        case E_V4HImode:
          if (pattern77 (x3, 
E_V4HImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3318; /* aarch64_suqaddv4hi */

        case E_V8HImode:
          if (pattern77 (x3, 
E_V8HImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3324; /* aarch64_suqaddv8hi */

        case E_V2SImode:
          if (pattern77 (x3, 
E_V2SImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3326; /* aarch64_suqaddv2si */

        case E_V4SImode:
          if (pattern77 (x3, 
E_V4SImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3332; /* aarch64_suqaddv4si */

        case E_V2DImode:
          if (pattern77 (x3, 
E_V2DImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3334; /* aarch64_suqaddv2di */

        case E_QImode:
          if (pattern77 (x3, 
E_QImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3336; /* aarch64_suqaddqi */

        case E_HImode:
          if (pattern77 (x3, 
E_HImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3338; /* aarch64_suqaddhi */

        case E_SImode:
          if (pattern77 (x3, 
E_SImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3340; /* aarch64_suqaddsi */

        case E_DImode:
          if (pattern77 (x3, 
E_DImode) != 0
              || !
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3342; /* aarch64_suqadddi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern789 (x3, 
E_VNx16QImode) != 0
              || !
#line 980 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11557; /* aarch64_sve_suqaddvnx16qi_const */

        case E_VNx8HImode:
          if (pattern789 (x3, 
E_VNx8HImode) != 0
              || !
#line 980 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11558; /* aarch64_sve_suqaddvnx8hi_const */

        case E_VNx4SImode:
          if (pattern789 (x3, 
E_VNx4SImode) != 0
              || !
#line 980 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11559; /* aarch64_sve_suqaddvnx4si_const */

        case E_VNx2DImode:
          if (pattern789 (x3, 
E_VNx2DImode) != 0
              || !
#line 980 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11560; /* aarch64_sve_suqaddvnx2di_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern100 (x3, 
E_V8QImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3860; /* aarch64_sqshlu_nv8qi */

    case E_V16QImode:
      if (pattern100 (x3, 
E_V16QImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3863; /* aarch64_sqshlu_nv16qi */

    case E_V4HImode:
      if (pattern101 (x3, 
E_V4HImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3866; /* aarch64_sqshlu_nv4hi */

    case E_V8HImode:
      if (pattern101 (x3, 
E_V8HImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3869; /* aarch64_sqshlu_nv8hi */

    case E_V2SImode:
      if (pattern102 (x3, 
E_V2SImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3872; /* aarch64_sqshlu_nv2si */

    case E_V4SImode:
      if (pattern102 (x3, 
E_V4SImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3875; /* aarch64_sqshlu_nv4si */

    case E_V2DImode:
      if (pattern103 (x3, 
E_V2DImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3878; /* aarch64_sqshlu_nv2di */

    case E_QImode:
      if (pattern100 (x3, 
E_QImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3881; /* aarch64_sqshlu_nqi */

    case E_HImode:
      if (pattern101 (x3, 
E_HImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3884; /* aarch64_sqshlu_nhi */

    case E_SImode:
      if (pattern102 (x3, 
E_SImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3887; /* aarch64_sqshlu_nsi */

    case E_DImode:
      if (pattern103 (x3, 
E_DImode) != 0
          || !
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3890; /* aarch64_sqshlu_ndi */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3706; /* aarch64_sqshlv8qi */

    case 1:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3718; /* aarch64_sqshlv16qi */

    case 2:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3722; /* aarch64_sqshlv4hi */

    case 3:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3734; /* aarch64_sqshlv8hi */

    case 4:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3738; /* aarch64_sqshlv2si */

    case 5:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3750; /* aarch64_sqshlv4si */

    case 6:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3754; /* aarch64_sqshlv2di */

    case 7:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3758; /* aarch64_sqshlqi */

    case 8:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3762; /* aarch64_sqshlhi */

    case 9:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3766; /* aarch64_sqshlsi */

    case 10:
      if (!
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3770; /* aarch64_sqshldi */

    case 11:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3861; /* aarch64_sqshl_nv8qi */

    case 12:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3864; /* aarch64_sqshl_nv16qi */

    case 13:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3867; /* aarch64_sqshl_nv4hi */

    case 14:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3870; /* aarch64_sqshl_nv8hi */

    case 15:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3873; /* aarch64_sqshl_nv2si */

    case 16:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3876; /* aarch64_sqshl_nv4si */

    case 17:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3879; /* aarch64_sqshl_nv2di */

    case 18:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3882; /* aarch64_sqshl_nqi */

    case 19:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3885; /* aarch64_sqshl_nhi */

    case 20:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3888; /* aarch64_sqshl_nsi */

    case 21:
      if (!
#line 6668 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3891; /* aarch64_sqshl_ndi */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern77 (x3, 
E_VNx4SImode) != 0
              || !
#line 4132 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7982; /* aarch64_adrvnx4si */

        case E_VNx2DImode:
          if (pattern77 (x3, 
E_VNx2DImode) != 0
              || !
#line 4132 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7983; /* aarch64_adrvnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern604 (x5) != 0
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !
#line 4148 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 7984; /* *aarch64_adr_sxtw */

    case AND:
      if (GET_MODE (x5) != E_VNx2DImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x10 = XEXP (x5, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[3] = x11;
      if (!aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode)
          || !
#line 4165 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 7985; /* *aarch64_adr_uxtw_unspec */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern121 (x3, 
E_VNx16QImode, 
E_VNx8HImode) != 0
          || !
#line 9321 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10754; /* vec_pack_trunc_vnx8hi */

    case E_VNx8HImode:
      if (pattern121 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0
          || !
#line 9321 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10755; /* vec_pack_trunc_vnx4si */

    case E_VNx4SImode:
      if (pattern121 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0
          || !
#line 9321 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10756; /* vec_pack_trunc_vnx2di */

    case E_VNx16BImode:
      if (pattern121 (x3, 
E_VNx16BImode, 
E_VNx8BImode) != 0
          || !
#line 10003 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10915; /* vec_pack_trunc_vnx8bi */

    case E_VNx8BImode:
      if (pattern121 (x3, 
E_VNx8BImode, 
E_VNx4BImode) != 0
          || !
#line 10003 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10916; /* vec_pack_trunc_vnx4bi */

    case E_VNx4BImode:
      if (pattern121 (x3, 
E_VNx4BImode, 
E_VNx2BImode) != 0
          || !
#line 10003 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10917; /* vec_pack_trunc_vnx2bi */

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern113 (x3, 
E_V4HImode, 
E_V4HFmode) != 0
          || !(
#line 10141 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5330; /* aarch64_fscalev4hf */

    case E_V8HFmode:
      if (pattern113 (x3, 
E_V8HImode, 
E_V8HFmode) != 0
          || !(
#line 10141 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5331; /* aarch64_fscalev8hf */

    case E_V2SFmode:
      if (pattern113 (x3, 
E_V2SImode, 
E_V2SFmode) != 0
          || !
#line 10141 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5332; /* aarch64_fscalev2sf */

    case E_V4SFmode:
      if (pattern113 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 10141 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5333; /* aarch64_fscalev4sf */

    case E_V2DFmode:
      if (pattern113 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 10141 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5334; /* aarch64_fscalev2df */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern115 (x1))
    {
    case 0:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8994; /* *andvnx8hf3 */

    case 1:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8997; /* *andvnx4hf3 */

    case 2:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9000; /* *andvnx2hf3 */

    case 3:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9003; /* *andvnx8bf3 */

    case 4:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9006; /* *andvnx4bf3 */

    case 5:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9009; /* *andvnx2bf3 */

    case 6:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9012; /* *andvnx4sf3 */

    case 7:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9015; /* *andvnx2sf3 */

    case 8:
      if (!
#line 6579 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9018; /* *andvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern119 (x1))
    {
    case 0:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10657; /* aarch64_sve_trn1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10663; /* aarch64_sve_trn1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10669; /* aarch64_sve_trn1qvnx4si */

    case 3:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10675; /* aarch64_sve_trn1qvnx2di */

    case 4:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10681; /* aarch64_sve_trn1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10687; /* aarch64_sve_trn1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10693; /* aarch64_sve_trn1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10699; /* aarch64_sve_trn1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern92 (x1))
    {
    case 0:
      if (!(
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2174; /* aarch64_smaxpv4hf */

    case 1:
      if (!(
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2182; /* aarch64_smaxpv8hf */

    case 2:
      if (!
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2190; /* aarch64_smaxpv2sf */

    case 3:
      if (!
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2198; /* aarch64_smaxpv4sf */

    case 4:
      if (!
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2202; /* aarch64_smaxpv2df */

    case 5:
      if (!
#line 9027 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10375; /* aarch64_pred_reduc_smax_vnx8hf */

    case 6:
      if (!
#line 9027 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10380; /* aarch64_pred_reduc_smax_vnx4sf */

    case 7:
      if (!
#line 9027 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10385; /* aarch64_pred_reduc_smax_vnx2df */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern89 (x1))
    {
    case 0:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1956; /* aarch64_simd_reg_shlv8qi_unsigned */

    case 1:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1959; /* aarch64_simd_reg_shlv16qi_unsigned */

    case 2:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1960; /* aarch64_simd_reg_shlv4hi_unsigned */

    case 3:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1963; /* aarch64_simd_reg_shlv8hi_unsigned */

    case 4:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1964; /* aarch64_simd_reg_shlv2si_unsigned */

    case 5:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1967; /* aarch64_simd_reg_shlv4si_unsigned */

    case 6:
      if (!
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1968; /* aarch64_simd_reg_shlv2di_unsigned */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1))
    {
    case 0:
      if (!(
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5281; /* aarch64_famaxv4hf */

    case 1:
      if (!(
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5283; /* aarch64_famaxv8hf */

    case 2:
      if (!
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5285; /* aarch64_famaxv2sf */

    case 3:
      if (!
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5287; /* aarch64_famaxv4sf */

    case 4:
      if (!
#line 10034 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5289; /* aarch64_famaxv2df */

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12708; /* aarch64_pred_reduc_orqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12716; /* aarch64_pred_reduc_orqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12724; /* aarch64_pred_reduc_orqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12732; /* aarch64_pred_reduc_orqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10345; /* aarch64_pred_reduc_and_vnx16qi */

    case 1:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10352; /* aarch64_pred_reduc_and_vnx8hi */

    case 2:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10359; /* aarch64_pred_reduc_and_vnx4si */

    case 3:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10366; /* aarch64_pred_reduc_and_vnx2di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      switch (pattern1197 (x2, 
E_VNx8HFmode))
        {
        case 0:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
            return -1;
          return 10900; /* *cond_fcvt_truncvnx4sfvnx8hf */

        case 1:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10901; /* *cond_fcvt_truncvnx2dfvnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      switch (pattern1197 (x2, 
E_VNx4SFmode))
        {
        case 0:
          if (!register_operand (operands[1], E_VNx4BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4SFmode:
              if (!register_operand (operands[2], E_VNx4SFmode)
                  || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                return -1;
              return 10902; /* *cond_fcvt_truncvnx4sfvnx4sf */

            case E_VNx8HFmode:
              if (!register_operand (operands[2], E_VNx8HFmode)
                  || !
#line 9980 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                return -1;
              return 10911; /* *cond_fcvt_nontruncvnx8hfvnx4sf */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10903; /* *cond_fcvt_truncvnx2dfvnx4sf */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (pattern1157 (x2, 
E_VNx8BFmode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9880 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
        return -1;
      return 10905; /* *cond_fcvt_truncvnx4sfvnx8bf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[2], E_VNx8HFmode)
              || !
#line 9980 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10912; /* *cond_fcvt_nontruncvnx8hfvnx2df */

        case E_VNx4SFmode:
          if (!register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9980 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10914; /* *cond_fcvt_nontruncvnx4sfvnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern867 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7213; /* *cond_ceilvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7279; /* *cond_ceilvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7224; /* *cond_ceilvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7290; /* *cond_ceilvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7235; /* *cond_ceilvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7301; /* *cond_ceilvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7246; /* *cond_ceilvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7312; /* *cond_ceilvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7257; /* *cond_ceilvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7323; /* *cond_ceilvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7268; /* *cond_ceilvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7334; /* *cond_ceilvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11632; /* *cond_uhsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11675; /* *cond_uhsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11715; /* *cond_uhsubvnx4si_any */
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11605; /* *cond_srshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11653; /* *cond_srshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11693; /* *cond_srshlvnx16qi_any */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11626; /* *cond_shsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11670; /* *cond_shsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11710; /* *cond_shsubvnx4si_any */
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1056 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8514; /* *cond_fminvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8660; /* *cond_fminvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8764; /* *cond_fminvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8527; /* *cond_fminvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8673; /* *cond_fminvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8777; /* *cond_fminvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8540; /* *cond_fminvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8686; /* *cond_fminvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8790; /* *cond_fminvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8553; /* *cond_fminvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8699; /* *cond_fminvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8803; /* *cond_fminvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8614; /* *cond_fminvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8864; /* *cond_fminvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8621; /* *cond_fminvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8871; /* *cond_fminvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8628; /* *cond_fminvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8878; /* *cond_fminvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8566; /* *cond_fminvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8712; /* *cond_fminvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8816; /* *cond_fminvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8579; /* *cond_fminvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8725; /* *cond_fminvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8829; /* *cond_fminvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8592; /* *cond_fminvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8738; /* *cond_fminvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8842; /* *cond_fminvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8605; /* *cond_fminvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8751; /* *cond_fminvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8855; /* *cond_fminvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8635; /* *cond_fminvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8885; /* *cond_fminvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8642; /* *cond_fminvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8892; /* *cond_fminvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8649; /* *cond_fminvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8899; /* *cond_fminvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1121 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9244; /* *cond_fmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9272; /* *cond_fmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9304; /* *cond_fmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9248; /* *cond_fmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9276; /* *cond_fmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9308; /* *cond_fmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9252; /* *cond_fmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9280; /* *cond_fmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9312; /* *cond_fmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9268; /* *cond_fmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9300; /* *cond_fmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9256; /* *cond_fmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9288; /* *cond_fmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9320; /* *cond_fmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9260; /* *cond_fmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9292; /* *cond_fmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9324; /* *cond_fmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9264; /* *cond_fmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9296; /* *cond_fmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9328; /* *cond_fmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9284; /* *cond_fmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9316; /* *cond_fmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      switch (GET_CODE (operands[3]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1058 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7078; /* *cond_uxtvnx16qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7088; /* *cond_uxtvnx16qi_any */

            case E_VNx8QImode:
              if (pattern1058 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7079; /* *cond_uxtvnx8qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7089; /* *cond_uxtvnx8qi_any */

            case E_VNx4QImode:
              if (pattern1058 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7080; /* *cond_uxtvnx4qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7090; /* *cond_uxtvnx4qi_any */

            case E_VNx2QImode:
              if (pattern1058 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7081; /* *cond_uxtvnx2qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7091; /* *cond_uxtvnx2qi_any */

            case E_VNx8HImode:
              if (pattern1058 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7082; /* *cond_uxtvnx8hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7092; /* *cond_uxtvnx8hi_any */

            case E_VNx4HImode:
              if (pattern1058 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7083; /* *cond_uxtvnx4hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7093; /* *cond_uxtvnx4hi_any */

            case E_VNx2HImode:
              if (pattern1058 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7084; /* *cond_uxtvnx2hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7094; /* *cond_uxtvnx2hi_any */

            case E_VNx4SImode:
              if (pattern1058 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7085; /* *cond_uxtvnx4si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7095; /* *cond_uxtvnx4si_any */

            case E_VNx2SImode:
              if (pattern1058 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7086; /* *cond_uxtvnx2si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7096; /* *cond_uxtvnx2si_any */

            case E_VNx2DImode:
              if (pattern1058 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7087; /* *cond_uxtvnx2di_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7097; /* *cond_uxtvnx2di_any */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern479 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7462; /* *cond_andvnx16qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7632; /* *cond_andvnx16qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7802; /* *cond_andvnx16qi_any */

            case E_VNx8QImode:
              if (pattern479 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7479; /* *cond_andvnx8qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7649; /* *cond_andvnx8qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7819; /* *cond_andvnx8qi_any */

            case E_VNx4QImode:
              if (pattern479 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7496; /* *cond_andvnx4qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7666; /* *cond_andvnx4qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7836; /* *cond_andvnx4qi_any */

            case E_VNx2QImode:
              if (pattern479 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7513; /* *cond_andvnx2qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7683; /* *cond_andvnx2qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7853; /* *cond_andvnx2qi_any */

            case E_VNx8HImode:
              if (pattern479 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7530; /* *cond_andvnx8hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7700; /* *cond_andvnx8hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7870; /* *cond_andvnx8hi_any */

            case E_VNx4HImode:
              if (pattern479 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7547; /* *cond_andvnx4hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7717; /* *cond_andvnx4hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7887; /* *cond_andvnx4hi_any */

            case E_VNx2HImode:
              if (pattern479 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7564; /* *cond_andvnx2hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7734; /* *cond_andvnx2hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7904; /* *cond_andvnx2hi_any */

            case E_VNx4SImode:
              if (pattern479 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7581; /* *cond_andvnx4si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7751; /* *cond_andvnx4si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7921; /* *cond_andvnx4si_any */

            case E_VNx2SImode:
              if (pattern479 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7598; /* *cond_andvnx2si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7768; /* *cond_andvnx2si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7938; /* *cond_andvnx2si_any */

            case E_VNx2DImode:
              if (pattern479 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7615; /* *cond_andvnx2di_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7785; /* *cond_andvnx2di_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7955; /* *cond_andvnx2di_any */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern995 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8188; /* *cond_bicvnx16qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8198; /* *cond_bicvnx16qi_any */

        case E_VNx8QImode:
          if (pattern995 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8189; /* *cond_bicvnx8qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8199; /* *cond_bicvnx8qi_any */

        case E_VNx4QImode:
          if (pattern995 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8190; /* *cond_bicvnx4qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8200; /* *cond_bicvnx4qi_any */

        case E_VNx2QImode:
          if (pattern995 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8191; /* *cond_bicvnx2qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8201; /* *cond_bicvnx2qi_any */

        case E_VNx8HImode:
          if (pattern995 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8192; /* *cond_bicvnx8hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8202; /* *cond_bicvnx8hi_any */

        case E_VNx4HImode:
          if (pattern995 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8193; /* *cond_bicvnx4hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8203; /* *cond_bicvnx4hi_any */

        case E_VNx2HImode:
          if (pattern995 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8194; /* *cond_bicvnx2hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8204; /* *cond_bicvnx2hi_any */

        case E_VNx4SImode:
          if (pattern995 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8195; /* *cond_bicvnx4si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8205; /* *cond_bicvnx4si_any */

        case E_VNx2SImode:
          if (pattern995 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8196; /* *cond_bicvnx2si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8206; /* *cond_bicvnx2si_any */

        case E_VNx2DImode:
          if (pattern995 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8197; /* *cond_bicvnx2di_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8207; /* *cond_bicvnx2di_any */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern729 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7464; /* *cond_xorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7634; /* *cond_xorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7804; /* *cond_xorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7481; /* *cond_xorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7651; /* *cond_xorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7821; /* *cond_xorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7498; /* *cond_xorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7668; /* *cond_xorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7838; /* *cond_xorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7515; /* *cond_xorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7685; /* *cond_xorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7855; /* *cond_xorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7532; /* *cond_xorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7702; /* *cond_xorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7872; /* *cond_xorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7549; /* *cond_xorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7719; /* *cond_xorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7889; /* *cond_xorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7566; /* *cond_xorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7736; /* *cond_xorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7906; /* *cond_xorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7583; /* *cond_xorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7753; /* *cond_xorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7923; /* *cond_xorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7600; /* *cond_xorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7770; /* *cond_xorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7940; /* *cond_xorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7617; /* *cond_xorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7787; /* *cond_xorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7957; /* *cond_xorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern605 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6715; /* *cond_rbitvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6805; /* *cond_rbitvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6724; /* *cond_rbitvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6814; /* *cond_rbitvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6733; /* *cond_rbitvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6823; /* *cond_rbitvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6742; /* *cond_rbitvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6832; /* *cond_rbitvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6751; /* *cond_rbitvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6841; /* *cond_rbitvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6760; /* *cond_rbitvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6850; /* *cond_rbitvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6769; /* *cond_rbitvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6859; /* *cond_rbitvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6778; /* *cond_rbitvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6868; /* *cond_rbitvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6787; /* *cond_rbitvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6877; /* *cond_rbitvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6796; /* *cond_rbitvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6886; /* *cond_rbitvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern793 (x3, 
E_V8QImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5008; /* aarch64_extv8qi */

    case E_V16QImode:
      if (pattern793 (x3, 
E_V16QImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5009; /* aarch64_extv16qi */

    case E_V4HImode:
      if (pattern793 (x3, 
E_V4HImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5010; /* aarch64_extv4hi */

    case E_V8HImode:
      if (pattern793 (x3, 
E_V8HImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5011; /* aarch64_extv8hi */

    case E_V2SImode:
      if (pattern793 (x3, 
E_V2SImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5012; /* aarch64_extv2si */

    case E_V4SImode:
      if (pattern793 (x3, 
E_V4SImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5013; /* aarch64_extv4si */

    case E_V2DImode:
      if (pattern793 (x3, 
E_V2DImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5014; /* aarch64_extv2di */

    case E_V4HFmode:
      if (pattern793 (x3, 
E_V4HFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5015; /* aarch64_extv4hf */

    case E_V8HFmode:
      if (pattern793 (x3, 
E_V8HFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5016; /* aarch64_extv8hf */

    case E_V4BFmode:
      if (pattern793 (x3, 
E_V4BFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5017; /* aarch64_extv4bf */

    case E_V8BFmode:
      if (pattern793 (x3, 
E_V8BFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5018; /* aarch64_extv8bf */

    case E_V2SFmode:
      if (pattern793 (x3, 
E_V2SFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5019; /* aarch64_extv2sf */

    case E_V4SFmode:
      if (pattern793 (x3, 
E_V4SFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5020; /* aarch64_extv4sf */

    case E_V2DFmode:
      if (pattern793 (x3, 
E_V2DFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5021; /* aarch64_extv2df */

    case E_VNx16QImode:
      if (pattern794 (x3, 
E_VNx16QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 8 / 8, 0, 255)))
        return -1;
      return 10703; /* aarch64_sve_extvnx16qi */

    case E_VNx8QImode:
      if (pattern794 (x3, 
E_VNx8QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10704; /* aarch64_sve_extvnx8qi */

    case E_VNx4QImode:
      if (pattern794 (x3, 
E_VNx4QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10705; /* aarch64_sve_extvnx4qi */

    case E_VNx2QImode:
      if (pattern794 (x3, 
E_VNx2QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10706; /* aarch64_sve_extvnx2qi */

    case E_VNx8HImode:
      if (pattern794 (x3, 
E_VNx8HImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10707; /* aarch64_sve_extvnx8hi */

    case E_VNx4HImode:
      if (pattern794 (x3, 
E_VNx4HImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10708; /* aarch64_sve_extvnx4hi */

    case E_VNx2HImode:
      if (pattern794 (x3, 
E_VNx2HImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10709; /* aarch64_sve_extvnx2hi */

    case E_VNx4SImode:
      if (pattern794 (x3, 
E_VNx4SImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10710; /* aarch64_sve_extvnx4si */

    case E_VNx2SImode:
      if (pattern794 (x3, 
E_VNx2SImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10711; /* aarch64_sve_extvnx2si */

    case E_VNx2DImode:
      if (pattern794 (x3, 
E_VNx2DImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10712; /* aarch64_sve_extvnx2di */

    case E_VNx8HFmode:
      if (pattern794 (x3, 
E_VNx8HFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10713; /* aarch64_sve_extvnx8hf */

    case E_VNx4HFmode:
      if (pattern794 (x3, 
E_VNx4HFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10714; /* aarch64_sve_extvnx4hf */

    case E_VNx2HFmode:
      if (pattern794 (x3, 
E_VNx2HFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10715; /* aarch64_sve_extvnx2hf */

    case E_VNx8BFmode:
      if (pattern794 (x3, 
E_VNx8BFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10716; /* aarch64_sve_extvnx8bf */

    case E_VNx4BFmode:
      if (pattern794 (x3, 
E_VNx4BFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10717; /* aarch64_sve_extvnx4bf */

    case E_VNx2BFmode:
      if (pattern794 (x3, 
E_VNx2BFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10718; /* aarch64_sve_extvnx2bf */

    case E_VNx4SFmode:
      if (pattern794 (x3, 
E_VNx4SFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10719; /* aarch64_sve_extvnx4sf */

    case E_VNx2SFmode:
      if (pattern794 (x3, 
E_VNx2SFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10720; /* aarch64_sve_extvnx2sf */

    case E_VNx2DFmode:
      if (pattern794 (x3, 
E_VNx2DFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10721; /* aarch64_sve_extvnx2df */

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern148 (x1))
    {
    case 0:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3516; /* aarch64_sqrdmlahv4hi */

    case 1:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3522; /* aarch64_sqrdmlahv8hi */

    case 2:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3524; /* aarch64_sqrdmlahv2si */

    case 3:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3530; /* aarch64_sqrdmlahv4si */

    case 4:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3532; /* aarch64_sqrdmlahhi */

    case 5:
      if (!
#line 5643 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3534; /* aarch64_sqrdmlahsi */

    case 6:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11815; /* aarch64_sve_sqrdmlahvnx16qi */

    case 7:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11823; /* aarch64_sve_sqrdmlahvnx8hi */

    case 8:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11831; /* aarch64_sve_sqrdmlahvnx4si */

    case 9:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11839; /* aarch64_sve_sqrdmlahvnx2di */

    case 10:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3536; /* aarch64_sqrdmlah_lanev4hi */

    case 11:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3556; /* aarch64_sqrdmlah_laneqv4hi */

    case 12:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3542; /* aarch64_sqrdmlah_lanev8hi */

    case 13:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3562; /* aarch64_sqrdmlah_laneqv8hi */

    case 14:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3544; /* aarch64_sqrdmlah_lanev2si */

    case 15:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3564; /* aarch64_sqrdmlah_laneqv2si */

    case 16:
      if (!
#line 5659 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3550; /* aarch64_sqrdmlah_lanev4si */

    case 17:
      if (!
#line 5697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3570; /* aarch64_sqrdmlah_laneqv4si */

    case 18:
      if (!
#line 5677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3552; /* aarch64_sqrdmlah_lanehi */

    case 19:
      if (!
#line 5715 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3572; /* aarch64_sqrdmlah_laneqhi */

    case 20:
      if (!
#line 5677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3554; /* aarch64_sqrdmlah_lanesi */

    case 21:
      if (!
#line 5715 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3574; /* aarch64_sqrdmlah_laneqsi */

    case 22:
      if (!
#line 1468 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11841; /* aarch64_sve_sqrdmlah_lane_vnx8hi */

    case 23:
      if (!
#line 1468 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11843; /* aarch64_sve_sqrdmlah_lane_vnx4si */

    case 24:
      if (!
#line 1468 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11845; /* aarch64_sve_sqrdmlah_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9950; /* while_ultsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9960; /* while_ultdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9970; /* while_ultsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9980; /* while_ultdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9990; /* while_ultsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10000; /* while_ultdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10010; /* while_ultsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10020; /* while_ultdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern182 (x1))
    {
    case 0:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11125; /* aarch64_ldnt1vnx32qi */

    case 1:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11127; /* aarch64_ldnt1vnx16hi */

    case 2:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11129; /* aarch64_ldnt1vnx8si */

    case 3:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11131; /* aarch64_ldnt1vnx4di */

    case 4:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11133; /* aarch64_ldnt1vnx16bf */

    case 5:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11135; /* aarch64_ldnt1vnx16hf */

    case 6:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11137; /* aarch64_ldnt1vnx8sf */

    case 7:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11139; /* aarch64_ldnt1vnx4df */

    case 8:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11141; /* aarch64_ldnt1vnx64qi */

    case 9:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11143; /* aarch64_ldnt1vnx32hi */

    case 10:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11145; /* aarch64_ldnt1vnx16si */

    case 11:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11147; /* aarch64_ldnt1vnx8di */

    case 12:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11149; /* aarch64_ldnt1vnx32bf */

    case 13:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11151; /* aarch64_ldnt1vnx32hf */

    case 14:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11153; /* aarch64_ldnt1vnx16sf */

    case 15:
      if (!
#line 275 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11155; /* aarch64_ldnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern162 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5925; /* aarch64_ldff1vnx16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5927; /* aarch64_ldff1vnx8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5929; /* aarch64_ldff1vnx4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5931; /* aarch64_ldff1vnx2di */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5933; /* aarch64_ldff1vnx8bf */

    case 5:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5935; /* aarch64_ldff1vnx8hf */

    case 6:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5937; /* aarch64_ldff1vnx4sf */

    case 7:
      x2 = XEXP (x1, 1);
      if (pattern939 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5939; /* aarch64_ldff1vnx2df */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern799 (x3, 
E_VNx16QImode) != 0
          || !
#line 2003 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11992; /* aarch64_sve_slivnx16qi */

    case E_VNx8HImode:
      if (pattern799 (x3, 
E_VNx8HImode) != 0
          || !
#line 2003 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11994; /* aarch64_sve_slivnx8hi */

    case E_VNx4SImode:
      if (pattern799 (x3, 
E_VNx4SImode) != 0
          || !
#line 2003 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11996; /* aarch64_sve_slivnx4si */

    case E_VNx2DImode:
      if (pattern799 (x3, 
E_VNx2DImode) != 0
          || !
#line 2003 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11998; /* aarch64_sve_slivnx2di */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern154 (x1))
    {
    case 0:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3828; /* aarch64_ssli_nv8qi */

    case 1:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3832; /* aarch64_ssli_nv16qi */

    case 2:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3836; /* aarch64_ssli_nv4hi */

    case 3:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3840; /* aarch64_ssli_nv8hi */

    case 4:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3844; /* aarch64_ssli_nv2si */

    case 5:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3848; /* aarch64_ssli_nv4si */

    case 6:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3852; /* aarch64_ssli_nv2di */

    case 7:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3856; /* aarch64_ssli_ndi */

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12500; /* aarch64_sve_cmla90vnx16qi */

    case 1:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12508; /* aarch64_sve_cmla90vnx8hi */

    case 2:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12516; /* aarch64_sve_cmla90vnx4si */

    case 3:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12524; /* aarch64_sve_cmla90vnx2di */

    case 4:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12532; /* aarch64_cmla90_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12540; /* aarch64_cmla90_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 3096 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12548; /* aarch64_sve_cdot90vnx4si */

    case 1:
      if (!
#line 3096 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12552; /* aarch64_sve_cdot90vnx2di */

    case 2:
      if (!
#line 3113 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12556; /* aarch64_cdot90_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12560; /* aarch64_cdot90_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern192 (x1))
    {
    case 0:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12430; /* aarch64_pred_addpvnx16qi */

    case 1:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12435; /* aarch64_pred_addpvnx8hi */

    case 2:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12440; /* aarch64_pred_addpvnx4si */

    case 3:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12445; /* aarch64_pred_addpvnx2di */

    default:
      return -1;
    }
}

 int
recog_385 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern184 (x1, 
E_VNx32BImode))
    {
    case 0:
      if (!
#line 625 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11366; /* aarch64_sve_pext8x2 */

    case 1:
      if (!
#line 625 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11367; /* aarch64_sve_pext16x2 */

    case 2:
      if (!
#line 625 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11368; /* aarch64_sve_pext32x2 */

    case 3:
      if (!
#line 625 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11369; /* aarch64_sve_pext64x2 */

    default:
      return -1;
    }
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (XVECLEN (x3, 0) != 3)
    return -1;
  switch (XINT (x3, 1))
    {
    case 140:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10109; /* while_lesivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10119; /* while_ledivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10129; /* while_lesivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10139; /* while_ledivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10149; /* while_lesivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10159; /* while_ledivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10169; /* while_lesivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10179; /* while_ledivnx2bi_ptest */

        default:
          return -1;
        }

    case 141:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10110; /* while_ultsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10120; /* while_ultdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10130; /* while_ultsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10140; /* while_ultdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10150; /* while_ultsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10160; /* while_ultdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10170; /* while_ultsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10180; /* while_ultdivnx2bi_ptest */

        default:
          return -1;
        }

    case 142:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10111; /* while_ulesivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10121; /* while_uledivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10131; /* while_ulesivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10141; /* while_uledivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10151; /* while_ulesivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10161; /* while_uledivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10171; /* while_ulesivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10181; /* while_uledivnx2bi_ptest */

        default:
          return -1;
        }

    case 143:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10112; /* while_ltsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10122; /* while_ltdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10132; /* while_ltsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10142; /* while_ltdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10152; /* while_ltsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10162; /* while_ltdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            {
              *pnum_clobbers = 1;
              return 10172; /* while_ltsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 10182; /* while_ltdivnx2bi_ptest */

        default:
          return -1;
        }

    case 136:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10113; /* while_gesivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10123; /* while_gedivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10133; /* while_gesivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10143; /* while_gedivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10153; /* while_gesivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10163; /* while_gedivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10173; /* while_gesivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10183; /* while_gedivnx2bi_ptest */

        default:
          return -1;
        }

    case 137:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10114; /* while_gtsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10124; /* while_gtdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10134; /* while_gtsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10144; /* while_gtdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10154; /* while_gtsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10164; /* while_gtdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10174; /* while_gtsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10184; /* while_gtdivnx2bi_ptest */

        default:
          return -1;
        }

    case 138:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_VNx16BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10115; /* while_ugtsivnx16bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10125; /* while_ugtdivnx16bi_ptest */

        case E_VNx8BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10135; /* while_ugtsivnx8bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10145; /* while_ugtdivnx8bi_ptest */

        case E_VNx4BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10155; /* while_ugtsivnx4bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10165; /* while_ugtdivnx4bi_ptest */

        case E_VNx2BImode:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            {
              *pnum_clobbers = 1;
              return 10175; /* while_ugtsivnx2bi_ptest */
            }
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          *pnum_clobbers = 1;
          return 10185; /* while_ugtdivnx2bi_ptest */

        default:
          return -1;
        }

    case 139:
      return recog_393 (x1, insn, pnum_clobbers);

    case 144:
      return recog_392 (x1, insn, pnum_clobbers);

    case 145:
      return recog_391 (x1, insn, pnum_clobbers);

    case 302:
      if (GET_MODE (x3) != E_VNx16BImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[5] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!register_operand (operands[3], E_VNx16BImode)
          || !
#line 10196 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10934; /* *aarch64_brkn_ptest */

    default:
      return -1;
    }
}

 int
recog_435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern246 (x1))
    {
    case 0:
      if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13446; /* aarch64_sme_udotvnx4sivnx32qi */

    case 1:
      if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13449; /* aarch64_sme_udotvnx4sivnx64qi */

    case 2:
      if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13452; /* aarch64_sme_udotvnx4sivnx16hi */

    case 3:
      if (!
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13455; /* aarch64_sme_udotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13458; /* aarch64_sme_udotvnx2divnx32qi */

    case 5:
      if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13461; /* aarch64_sme_udotvnx2divnx64qi */

    case 6:
      if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13464; /* aarch64_sme_udotvnx2divnx16hi */

    case 7:
      if (!(
#line 1288 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13467; /* aarch64_sme_udotvnx2divnx32hi */

    case 8:
      if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13494; /* aarch64_sme_single_udotvnx4sivnx32qi */

    case 9:
      if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13497; /* aarch64_sme_single_udotvnx4sivnx64qi */

    case 10:
      if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13500; /* aarch64_sme_single_udotvnx4sivnx16hi */

    case 11:
      if (!
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13503; /* aarch64_sme_single_udotvnx4sivnx32hi */

    case 12:
      if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13506; /* aarch64_sme_single_udotvnx2divnx32qi */

    case 13:
      if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13509; /* aarch64_sme_single_udotvnx2divnx64qi */

    case 14:
      if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13512; /* aarch64_sme_single_udotvnx2divnx16hi */

    case 15:
      if (!(
#line 1320 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13515; /* aarch64_sme_single_udotvnx2divnx32hi */

    case 16:
      if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13547; /* aarch64_sme_lane_udotvnx4sivnx32qi */

    case 17:
      if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13555; /* aarch64_sme_lane_udotvnx4sivnx64qi */

    case 18:
      if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13563; /* aarch64_sme_lane_udotvnx4sivnx16hi */

    case 19:
      if (!
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13571; /* aarch64_sme_lane_udotvnx4sivnx32hi */

    case 20:
      if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13579; /* aarch64_sme_lane_udotvnx2divnx32qi */

    case 21:
      if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13587; /* aarch64_sme_lane_udotvnx2divnx64qi */

    case 22:
      if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13595; /* aarch64_sme_lane_udotvnx2divnx16hi */

    case 23:
      if (!(
#line 1385 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13603; /* aarch64_sme_lane_udotvnx2divnx32hi */

    case 24:
      if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13470; /* *aarch64_sme_udotvnx4sivnx32qi_plus */

    case 25:
      if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13473; /* *aarch64_sme_udotvnx4sivnx64qi_plus */

    case 26:
      if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13476; /* *aarch64_sme_udotvnx4sivnx16hi_plus */

    case 27:
      if (!
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13479; /* *aarch64_sme_udotvnx4sivnx32hi_plus */

    case 28:
      if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13482; /* *aarch64_sme_udotvnx2divnx32qi_plus */

    case 29:
      if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13485; /* *aarch64_sme_udotvnx2divnx64qi_plus */

    case 30:
      if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13488; /* *aarch64_sme_udotvnx2divnx16hi_plus */

    case 31:
      if (!(
#line 1304 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13491; /* *aarch64_sme_udotvnx2divnx32hi_plus */

    case 32:
      if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13518; /* *aarch64_sme_single_udotvnx4sivnx32qi_plus */

    case 33:
      if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13521; /* *aarch64_sme_single_udotvnx4sivnx64qi_plus */

    case 34:
      if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13524; /* *aarch64_sme_single_udotvnx4sivnx16hi_plus */

    case 35:
      if (!
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13527; /* *aarch64_sme_single_udotvnx4sivnx32hi_plus */

    case 36:
      if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13530; /* *aarch64_sme_single_udotvnx2divnx32qi_plus */

    case 37:
      if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13533; /* *aarch64_sme_single_udotvnx2divnx64qi_plus */

    case 38:
      if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13536; /* *aarch64_sme_single_udotvnx2divnx16hi_plus */

    case 39:
      if (!(
#line 1337 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13539; /* *aarch64_sme_single_udotvnx2divnx32hi_plus */

    case 40:
      if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13611; /* *aarch64_sme_lane_udotvnx4sivnx32qi_plus */

    case 41:
      if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13619; /* *aarch64_sme_lane_udotvnx4sivnx64qi_plus */

    case 42:
      if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13627; /* *aarch64_sme_lane_udotvnx4sivnx16hi_plus */

    case 43:
      if (!
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13635; /* *aarch64_sme_lane_udotvnx4sivnx32hi_plus */

    case 44:
      if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13643; /* *aarch64_sme_lane_udotvnx2divnx32qi_plus */

    case 45:
      if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13651; /* *aarch64_sme_lane_udotvnx2divnx64qi_plus */

    case 46:
      if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13659; /* *aarch64_sme_lane_udotvnx2divnx16hi_plus */

    case 47:
      if (!(
#line 1404 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13667; /* *aarch64_sme_lane_udotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 123:
      return recog_443 (x1, insn, pnum_clobbers);

    case 541:
      switch (pattern267 (x1))
        {
        case 0:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11309; /* aarch64_st1vnx32qi_strided4 */

        case 1:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11311; /* aarch64_st1vnx16hi_strided4 */

        case 2:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11313; /* aarch64_st1vnx8si_strided4 */

        case 3:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11315; /* aarch64_st1vnx4di_strided4 */

        case 4:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11317; /* aarch64_st1vnx16bf_strided4 */

        case 5:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11319; /* aarch64_st1vnx16hf_strided4 */

        case 6:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11321; /* aarch64_st1vnx8sf_strided4 */

        case 7:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11323; /* aarch64_st1vnx4df_strided4 */

        case 8:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11325; /* aarch64_st1vnx64qi_strided4 */

        case 9:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11327; /* aarch64_st1vnx32hi_strided4 */

        case 10:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11329; /* aarch64_st1vnx16si_strided4 */

        case 11:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11331; /* aarch64_st1vnx8di_strided4 */

        case 12:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11333; /* aarch64_st1vnx32bf_strided4 */

        case 13:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11335; /* aarch64_st1vnx32hf_strided4 */

        case 14:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11337; /* aarch64_st1vnx16sf_strided4 */

        case 15:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11339; /* aarch64_st1vnx8df_strided4 */

        default:
          return -1;
        }

    case 542:
      switch (pattern267 (x1))
        {
        case 0:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11310; /* aarch64_stnt1vnx32qi_strided4 */

        case 1:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11312; /* aarch64_stnt1vnx16hi_strided4 */

        case 2:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11314; /* aarch64_stnt1vnx8si_strided4 */

        case 3:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11316; /* aarch64_stnt1vnx4di_strided4 */

        case 4:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11318; /* aarch64_stnt1vnx16bf_strided4 */

        case 5:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11320; /* aarch64_stnt1vnx16hf_strided4 */

        case 6:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11322; /* aarch64_stnt1vnx8sf_strided4 */

        case 7:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11324; /* aarch64_stnt1vnx4df_strided4 */

        case 8:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11326; /* aarch64_stnt1vnx64qi_strided4 */

        case 9:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11328; /* aarch64_stnt1vnx32hi_strided4 */

        case 10:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11330; /* aarch64_stnt1vnx16si_strided4 */

        case 11:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11332; /* aarch64_stnt1vnx8di_strided4 */

        case 12:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11334; /* aarch64_stnt1vnx32bf_strided4 */

        case 13:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11336; /* aarch64_stnt1vnx32hf_strided4 */

        case 14:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11338; /* aarch64_stnt1vnx16sf_strided4 */

        case 15:
          if (!
#line 509 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 4, 4)))
            return -1;
          return 11340; /* aarch64_stnt1vnx8df_strided4 */

        default:
          return -1;
        }

    case 647:
      switch (pattern270 (x1))
        {
        case 0:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12942; /* aarch64_sme_ld1_horvnx16qi */

        case 1:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12944; /* aarch64_sme_ld1_horvnx8hi */

        case 2:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12946; /* aarch64_sme_ld1_horvnx4si */

        case 3:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12948; /* aarch64_sme_ld1_horvnx2di */

        case 4:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12950; /* aarch64_sme_ld1_horvnx1ti */

        case 5:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 12952; /* aarch64_sme_ld1_horvnx16qi_plus */

        case 6:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 12954; /* aarch64_sme_ld1_horvnx8hi_plus */

        case 7:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 12956; /* aarch64_sme_ld1_horvnx4si_plus */

        case 8:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 12958; /* aarch64_sme_ld1_horvnx2di_plus */

        case 9:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 128))
            return -1;
          return 12960; /* aarch64_sme_ld1_horvnx1ti_plus */

        default:
          return -1;
        }

    case 648:
      switch (pattern270 (x1))
        {
        case 0:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12943; /* aarch64_sme_ld1_vervnx16qi */

        case 1:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12945; /* aarch64_sme_ld1_vervnx8hi */

        case 2:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12947; /* aarch64_sme_ld1_vervnx4si */

        case 3:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12949; /* aarch64_sme_ld1_vervnx2di */

        case 4:
          if (!
#line 484 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12951; /* aarch64_sme_ld1_vervnx1ti */

        case 5:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 12953; /* aarch64_sme_ld1_vervnx16qi_plus */

        case 6:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 12955; /* aarch64_sme_ld1_vervnx8hi_plus */

        case 7:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 12957; /* aarch64_sme_ld1_vervnx4si_plus */

        case 8:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 12959; /* aarch64_sme_ld1_vervnx2di_plus */

        case 9:
          if (!
#line 499 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 128))
            return -1;
          return 12961; /* aarch64_sme_ld1_vervnx1ti_plus */

        default:
          return -1;
        }

    case 661:
      switch (pattern273 (x1))
        {
        case 0:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12967; /* aarch64_sme_st1_horvnx16qi */

        case 1:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12969; /* aarch64_sme_st1_horvnx8hi */

        case 2:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12971; /* aarch64_sme_st1_horvnx4si */

        case 3:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12973; /* aarch64_sme_st1_horvnx2di */

        case 4:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12975; /* aarch64_sme_st1_horvnx1ti */

        case 5:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 12977; /* aarch64_sme_st1_horvnx16qi_plus */

        case 6:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 12979; /* aarch64_sme_st1_horvnx8hi_plus */

        case 7:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 12981; /* aarch64_sme_st1_horvnx4si_plus */

        case 8:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 12983; /* aarch64_sme_st1_horvnx2di_plus */

        case 9:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 128))
            return -1;
          return 12985; /* aarch64_sme_st1_horvnx1ti_plus */

        default:
          return -1;
        }

    case 662:
      switch (pattern273 (x1))
        {
        case 0:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12968; /* aarch64_sme_st1_vervnx16qi */

        case 1:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12970; /* aarch64_sme_st1_vervnx8hi */

        case 2:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12972; /* aarch64_sme_st1_vervnx4si */

        case 3:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12974; /* aarch64_sme_st1_vervnx2di */

        case 4:
          if (!
#line 586 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12976; /* aarch64_sme_st1_vervnx1ti */

        case 5:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 8))
            return -1;
          return 12978; /* aarch64_sme_st1_vervnx16qi_plus */

        case 6:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 16))
            return -1;
          return 12980; /* aarch64_sme_st1_vervnx8hi_plus */

        case 7:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 32))
            return -1;
          return 12982; /* aarch64_sme_st1_vervnx4si_plus */

        case 8:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 64))
            return -1;
          return 12984; /* aarch64_sme_st1_vervnx2di_plus */

        case 9:
          if (!
#line 601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[3]) < 128 / 128))
            return -1;
          return 12986; /* aarch64_sme_st1_vervnx1ti_plus */

        default:
          return -1;
        }

    case 650:
      switch (pattern279 (x1))
        {
        case 0:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12991; /* aarch64_sme_read_horvnx16qivnx16qi */

        case 1:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13023; /* aarch64_sme_read_horvnx1tivnx16qi */

        case 2:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12993; /* aarch64_sme_read_horvnx8hivnx8hi */

        case 3:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13025; /* aarch64_sme_read_horvnx1tivnx8hi */

        case 4:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12995; /* aarch64_sme_read_horvnx4sivnx4si */

        case 5:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13027; /* aarch64_sme_read_horvnx1tivnx4si */

        case 6:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12997; /* aarch64_sme_read_horvnx2divnx2di */

        case 7:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13029; /* aarch64_sme_read_horvnx1tivnx2di */

        case 8:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12999; /* aarch64_sme_read_horvnx8hivnx8bf */

        case 9:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13031; /* aarch64_sme_read_horvnx1tivnx8bf */

        case 10:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13001; /* aarch64_sme_read_horvnx8hivnx8hf */

        case 11:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13033; /* aarch64_sme_read_horvnx1tivnx8hf */

        case 12:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13003; /* aarch64_sme_read_horvnx4sivnx4sf */

        case 13:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13035; /* aarch64_sme_read_horvnx1tivnx4sf */

        case 14:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13005; /* aarch64_sme_read_horvnx2divnx2df */

        case 15:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13037; /* aarch64_sme_read_horvnx1tivnx2df */

        case 16:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 8))
            return -1;
          return 13007; /* *aarch64_sme_read_horvnx16qivnx16qi_plus */

        case 17:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13009; /* *aarch64_sme_read_horvnx8hivnx8hi_plus */

        case 18:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13011; /* *aarch64_sme_read_horvnx4sivnx4si_plus */

        case 19:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13013; /* *aarch64_sme_read_horvnx2divnx2di_plus */

        case 20:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13015; /* *aarch64_sme_read_horvnx8hivnx8bf_plus */

        case 21:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13017; /* *aarch64_sme_read_horvnx8hivnx8hf_plus */

        case 22:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13019; /* *aarch64_sme_read_horvnx4sivnx4sf_plus */

        case 23:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13021; /* *aarch64_sme_read_horvnx2divnx2df_plus */

        default:
          return -1;
        }

    case 651:
      switch (pattern279 (x1))
        {
        case 0:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12992; /* aarch64_sme_read_vervnx16qivnx16qi */

        case 1:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13024; /* aarch64_sme_read_vervnx1tivnx16qi */

        case 2:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12994; /* aarch64_sme_read_vervnx8hivnx8hi */

        case 3:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13026; /* aarch64_sme_read_vervnx1tivnx8hi */

        case 4:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12996; /* aarch64_sme_read_vervnx4sivnx4si */

        case 5:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13028; /* aarch64_sme_read_vervnx1tivnx4si */

        case 6:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 12998; /* aarch64_sme_read_vervnx2divnx2di */

        case 7:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13030; /* aarch64_sme_read_vervnx1tivnx2di */

        case 8:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13000; /* aarch64_sme_read_vervnx8hivnx8bf */

        case 9:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13032; /* aarch64_sme_read_vervnx1tivnx8bf */

        case 10:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13002; /* aarch64_sme_read_vervnx8hivnx8hf */

        case 11:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13034; /* aarch64_sme_read_vervnx1tivnx8hf */

        case 12:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13004; /* aarch64_sme_read_vervnx4sivnx4sf */

        case 13:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13036; /* aarch64_sme_read_vervnx1tivnx4sf */

        case 14:
          if (!
#line 667 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13006; /* aarch64_sme_read_vervnx2divnx2df */

        case 15:
          if (!
#line 697 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13038; /* aarch64_sme_read_vervnx1tivnx2df */

        case 16:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 8))
            return -1;
          return 13008; /* *aarch64_sme_read_vervnx16qivnx16qi_plus */

        case 17:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13010; /* *aarch64_sme_read_vervnx8hivnx8hi_plus */

        case 18:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13012; /* *aarch64_sme_read_vervnx4sivnx4si_plus */

        case 19:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13014; /* *aarch64_sme_read_vervnx2divnx2di_plus */

        case 20:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13016; /* *aarch64_sme_read_vervnx8hivnx8bf_plus */

        case 21:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 16))
            return -1;
          return 13018; /* *aarch64_sme_read_vervnx8hivnx8hf_plus */

        case 22:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 32))
            return -1;
          return 13020; /* *aarch64_sme_read_vervnx4sivnx4sf_plus */

        case 23:
          if (!
#line 682 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[5]) < 128 / 64))
            return -1;
          return 13022; /* *aarch64_sme_read_vervnx2divnx2df_plus */

        default:
          return -1;
        }

    case 680:
      switch (pattern280 (x1))
        {
        case 0:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13087; /* aarch64_sme_write_horvnx16qivnx16qi */

        case 1:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13089; /* aarch64_sme_write_horvnx8hivnx8hi */

        case 2:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13095; /* aarch64_sme_write_horvnx8hivnx8bf */

        case 3:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13097; /* aarch64_sme_write_horvnx8hivnx8hf */

        case 4:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13091; /* aarch64_sme_write_horvnx4sivnx4si */

        case 5:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13099; /* aarch64_sme_write_horvnx4sivnx4sf */

        case 6:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13093; /* aarch64_sme_write_horvnx2divnx2di */

        case 7:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13101; /* aarch64_sme_write_horvnx2divnx2df */

        case 8:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13119; /* aarch64_sme_write_horvnx1tivnx16qi */

        case 9:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13121; /* aarch64_sme_write_horvnx1tivnx8hi */

        case 10:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13123; /* aarch64_sme_write_horvnx1tivnx4si */

        case 11:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13125; /* aarch64_sme_write_horvnx1tivnx2di */

        case 12:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13127; /* aarch64_sme_write_horvnx1tivnx8bf */

        case 13:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13129; /* aarch64_sme_write_horvnx1tivnx8hf */

        case 14:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13131; /* aarch64_sme_write_horvnx1tivnx4sf */

        case 15:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13133; /* aarch64_sme_write_horvnx1tivnx2df */

        case 16:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 13103; /* *aarch64_sme_write_horvnx16qivnx16qi_plus */

        case 17:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13105; /* *aarch64_sme_write_horvnx8hivnx8hi_plus */

        case 18:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13111; /* *aarch64_sme_write_horvnx8hivnx8bf_plus */

        case 19:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13113; /* *aarch64_sme_write_horvnx8hivnx8hf_plus */

        case 20:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13107; /* *aarch64_sme_write_horvnx4sivnx4si_plus */

        case 21:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13115; /* *aarch64_sme_write_horvnx4sivnx4sf_plus */

        case 22:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13109; /* *aarch64_sme_write_horvnx2divnx2di_plus */

        case 23:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13117; /* *aarch64_sme_write_horvnx2divnx2df_plus */

        default:
          return -1;
        }

    case 681:
      switch (pattern280 (x1))
        {
        case 0:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13088; /* aarch64_sme_write_vervnx16qivnx16qi */

        case 1:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13090; /* aarch64_sme_write_vervnx8hivnx8hi */

        case 2:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13096; /* aarch64_sme_write_vervnx8hivnx8bf */

        case 3:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13098; /* aarch64_sme_write_vervnx8hivnx8hf */

        case 4:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13092; /* aarch64_sme_write_vervnx4sivnx4si */

        case 5:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13100; /* aarch64_sme_write_vervnx4sivnx4sf */

        case 6:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13094; /* aarch64_sme_write_vervnx2divnx2di */

        case 7:
          if (!
#line 777 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13102; /* aarch64_sme_write_vervnx2divnx2df */

        case 8:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13120; /* aarch64_sme_write_vervnx1tivnx16qi */

        case 9:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13122; /* aarch64_sme_write_vervnx1tivnx8hi */

        case 10:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13124; /* aarch64_sme_write_vervnx1tivnx4si */

        case 11:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13126; /* aarch64_sme_write_vervnx1tivnx2di */

        case 12:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13128; /* aarch64_sme_write_vervnx1tivnx8bf */

        case 13:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13130; /* aarch64_sme_write_vervnx1tivnx8hf */

        case 14:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13132; /* aarch64_sme_write_vervnx1tivnx4sf */

        case 15:
          if (!
#line 807 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13134; /* aarch64_sme_write_vervnx1tivnx2df */

        case 16:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 8))
            return -1;
          return 13104; /* *aarch64_sme_write_vervnx16qivnx16qi_plus */

        case 17:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13106; /* *aarch64_sme_write_vervnx8hivnx8hi_plus */

        case 18:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13112; /* *aarch64_sme_write_vervnx8hivnx8bf_plus */

        case 19:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 16))
            return -1;
          return 13114; /* *aarch64_sme_write_vervnx8hivnx8hf_plus */

        case 20:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13108; /* *aarch64_sme_write_vervnx4sivnx4si_plus */

        case 21:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 32))
            return -1;
          return 13116; /* *aarch64_sme_write_vervnx4sivnx4sf_plus */

        case 22:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13110; /* *aarch64_sme_write_vervnx2divnx2di_plus */

        case 23:
          if (!
#line 792 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING
   && UINTVAL (operands[2]) < 128 / 64))
            return -1;
          return 13118; /* *aarch64_sme_write_vervnx2divnx2df_plus */

        default:
          return -1;
        }

    case 635:
      switch (pattern282 (x1))
        {
        case 0:
          if (!
#line 1135 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13361; /* aarch64_sme_addhavnx4si */

        case 1:
          if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
            return -1;
          return 13363; /* aarch64_sme_addhavnx2di */

        default:
          return -1;
        }

    case 636:
      switch (pattern282 (x1))
        {
        case 0:
          if (!
#line 1135 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING))
            return -1;
          return 13362; /* aarch64_sme_addvavnx4si */

        case 1:
          if (!(
#line 1135 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING) && 
#line 702 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
            return -1;
          return 13364; /* aarch64_sme_addvavnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern637 (x2, 
E_SImode) != 0)
            return -1;
          return 383; /* *msubsi */

        case E_DImode:
          if (pattern637 (x2, 
E_DImode) != 0)
            return -1;
          return 384; /* *msubdi */

        case E_V8QImode:
          if (pattern638 (x2, 
E_V8QImode) != 0
              || !
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2036; /* aarch64_mlsv8qi */

        case E_V16QImode:
          if (pattern638 (x2, 
E_V16QImode) != 0
              || !
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2039; /* aarch64_mlsv16qi */

        case E_V4HImode:
          if (pattern638 (x2, 
E_V4HImode) != 0
              || !
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2040; /* aarch64_mlsv4hi */

        case E_V8HImode:
          if (pattern638 (x2, 
E_V8HImode) != 0
              || !
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2043; /* aarch64_mlsv8hi */

        case E_V2SImode:
          if (pattern638 (x2, 
E_V2SImode) != 0
              || !
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2044; /* aarch64_mlsv2si */

        case E_V4SImode:
          if (pattern638 (x2, 
E_V4SImode) != 0
              || !
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2047; /* aarch64_mlsv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern743 (x2))
                {
                case 0:
                  return 393; /* msubsidi4 */

                case 1:
                  if (!
#line 2201 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2276; /* aarch64_smlslv8qi */

                case 2:
                  if (!
#line 2201 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2278; /* aarch64_smlslv4hi */

                case 3:
                  if (!
#line 2201 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2280; /* aarch64_smlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern745 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2282; /* aarch64_smlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2284; /* aarch64_smlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2344; /* aarch64_vec_smlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2346; /* aarch64_vec_smlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2348; /* aarch64_vec_smlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2350; /* aarch64_vec_smlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern952 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2250; /* *aarch64_smlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2256; /* aarch64_smlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2252; /* *aarch64_smlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2258; /* aarch64_smlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2254; /* *aarch64_smlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2260; /* aarch64_smlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern954 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2262; /* aarch64_smlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2264; /* aarch64_smlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2352; /* aarch64_smlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2356; /* aarch64_smlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2354; /* aarch64_smlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2358; /* aarch64_smlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern743 (x2))
                {
                case 0:
                  return 394; /* umsubsidi4 */

                case 1:
                  if (!
#line 2201 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2277; /* aarch64_umlslv8qi */

                case 2:
                  if (!
#line 2201 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2279; /* aarch64_umlslv4hi */

                case 3:
                  if (!
#line 2201 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2281; /* aarch64_umlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern745 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2283; /* aarch64_umlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2285; /* aarch64_umlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2345; /* aarch64_vec_umlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2347; /* aarch64_vec_umlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2349; /* aarch64_vec_umlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2351; /* aarch64_vec_umlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern952 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2251; /* *aarch64_umlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2257; /* aarch64_umlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2253; /* *aarch64_umlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2259; /* aarch64_umlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2255; /* *aarch64_umlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2261; /* aarch64_umlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern954 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2263; /* aarch64_umlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2265; /* aarch64_umlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2353; /* aarch64_umlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2357; /* aarch64_umlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2355; /* aarch64_umlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2359; /* aarch64_umlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern1171 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1710 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2048; /* *aarch64_mls_eltv4hi */

                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1728 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2056; /* *aarch64_mls_elt_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1171 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1710 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2051; /* *aarch64_mls_eltv8hi */

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1728 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2059; /* *aarch64_mls_elt_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1171 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1710 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2052; /* *aarch64_mls_eltv2si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1728 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2060; /* *aarch64_mls_elt_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1171 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1710 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2055; /* *aarch64_mls_eltv4si */

                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1728 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2063; /* *aarch64_mls_elt_to_64v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x5;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern955 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2064; /* aarch64_mls_nv4hi */

            case E_V8HImode:
              if (pattern955 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2067; /* aarch64_mls_nv8hi */

            case E_V2SImode:
              if (pattern955 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2068; /* aarch64_mls_nv2si */

            case E_V4SImode:
              if (pattern955 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2071; /* aarch64_mls_nv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x11 = XVECEXP (x4, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern1134 (x2, 
E_VNx8HImode) != 0
              || !
#line 1510 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11850; /* aarch64_sve_sub_mul_lane_vnx8hi */

        case E_VNx4SImode:
          if (pattern1134 (x2, 
E_VNx4SImode) != 0
              || !
#line 1510 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11851; /* aarch64_sve_sub_mul_lane_vnx4si */

        case E_VNx2DImode:
          if (pattern1134 (x2, 
E_VNx2DImode) != 0
              || !
#line 1510 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11852; /* aarch64_sve_sub_mul_lane_vnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_483 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (XVECLEN (x4, 0) == 1)
    {
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern818 (x2, 
E_V8QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1259; /* aarch64_dup_lanev8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1273; /* aarch64_dup_lane_to_128v8qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V16QImode:
          if (pattern818 (x2, 
E_V16QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1260; /* aarch64_dup_lanev16qi */
                  break;

                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1274; /* aarch64_dup_lane_to_64v16qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4HImode:
          if (pattern818 (x2, 
E_V4HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1261; /* aarch64_dup_lanev4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1275; /* aarch64_dup_lane_to_128v4hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HImode:
          if (pattern818 (x2, 
E_V8HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1262; /* aarch64_dup_lanev8hi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1276; /* aarch64_dup_lane_to_64v8hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2SImode:
          if (pattern818 (x2, 
E_V2SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1263; /* aarch64_dup_lanev2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1277; /* aarch64_dup_lane_to_128v2si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SImode:
          if (pattern818 (x2, 
E_V4SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1264; /* aarch64_dup_lanev4si */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1278; /* aarch64_dup_lane_to_64v4si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DImode:
          if (pattern819 (x2, 
E_V2DImode, 
E_DImode) == 0
              && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1265; /* aarch64_dup_lanev2di */
          break;

        case E_V4HFmode:
          if (pattern818 (x2, 
E_V4HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1266; /* aarch64_dup_lanev4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1279; /* aarch64_dup_lane_to_128v4hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HFmode:
          if (pattern818 (x2, 
E_V8HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1267; /* aarch64_dup_lanev8hf */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1280; /* aarch64_dup_lane_to_64v8hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4BFmode:
          if (pattern819 (x2, 
E_V4BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1268; /* aarch64_dup_lanev4bf */
          break;

        case E_V8BFmode:
          if (pattern819 (x2, 
E_V8BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1269; /* aarch64_dup_lanev8bf */
          break;

        case E_V2SFmode:
          if (pattern818 (x2, 
E_V2SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1270; /* aarch64_dup_lanev2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1281; /* aarch64_dup_lane_to_128v2sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern818 (x2, 
E_V4SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1271; /* aarch64_dup_lanev4sf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 137 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1282; /* aarch64_dup_lane_to_64v4sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DFmode:
          if (pattern819 (x2, 
E_V2DFmode, 
E_DFmode) == 0
              && 
#line 122 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1272; /* aarch64_dup_lanev2df */
          break;

        case E_VNx16QImode:
          if (pattern820 (x2, 
E_VNx16QImode, 
E_QImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 8 / 8, 0, 63)))
            return 10411; /* aarch64_sve_dup_lanevnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern820 (x2, 
E_VNx8QImode, 
E_QImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10412; /* aarch64_sve_dup_lanevnx8qi */
          break;

        case E_VNx4QImode:
          if (pattern820 (x2, 
E_VNx4QImode, 
E_QImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10413; /* aarch64_sve_dup_lanevnx4qi */
          break;

        case E_VNx2QImode:
          if (pattern820 (x2, 
E_VNx2QImode, 
E_QImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10414; /* aarch64_sve_dup_lanevnx2qi */
          break;

        case E_VNx8HImode:
          if (pattern820 (x2, 
E_VNx8HImode, 
E_HImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10415; /* aarch64_sve_dup_lanevnx8hi */
          break;

        case E_VNx4HImode:
          if (pattern820 (x2, 
E_VNx4HImode, 
E_HImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10416; /* aarch64_sve_dup_lanevnx4hi */
          break;

        case E_VNx2HImode:
          if (pattern820 (x2, 
E_VNx2HImode, 
E_HImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10417; /* aarch64_sve_dup_lanevnx2hi */
          break;

        case E_VNx4SImode:
          if (pattern820 (x2, 
E_VNx4SImode, 
E_SImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10418; /* aarch64_sve_dup_lanevnx4si */
          break;

        case E_VNx2SImode:
          if (pattern820 (x2, 
E_VNx2SImode, 
E_SImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10419; /* aarch64_sve_dup_lanevnx2si */
          break;

        case E_VNx2DImode:
          if (pattern820 (x2, 
E_VNx2DImode, 
E_DImode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10420; /* aarch64_sve_dup_lanevnx2di */
          break;

        case E_VNx8HFmode:
          if (pattern820 (x2, 
E_VNx8HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10421; /* aarch64_sve_dup_lanevnx8hf */
          break;

        case E_VNx4HFmode:
          if (pattern820 (x2, 
E_VNx4HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10422; /* aarch64_sve_dup_lanevnx4hf */
          break;

        case E_VNx2HFmode:
          if (pattern820 (x2, 
E_VNx2HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10423; /* aarch64_sve_dup_lanevnx2hf */
          break;

        case E_VNx8BFmode:
          if (pattern820 (x2, 
E_VNx8BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10424; /* aarch64_sve_dup_lanevnx8bf */
          break;

        case E_VNx4BFmode:
          if (pattern820 (x2, 
E_VNx4BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10425; /* aarch64_sve_dup_lanevnx4bf */
          break;

        case E_VNx2BFmode:
          if (pattern820 (x2, 
E_VNx2BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10426; /* aarch64_sve_dup_lanevnx2bf */
          break;

        case E_VNx4SFmode:
          if (pattern820 (x2, 
E_VNx4SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10427; /* aarch64_sve_dup_lanevnx4sf */
          break;

        case E_VNx2SFmode:
          if (pattern820 (x2, 
E_VNx2SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10428; /* aarch64_sve_dup_lanevnx2sf */
          break;

        case E_VNx2DFmode:
          if (pattern820 (x2, 
E_VNx2DFmode, 
E_DFmode) == 0
              && 
#line 9124 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10429; /* aarch64_sve_dup_lanevnx2df */
          break;

        default:
          break;
        }
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x2) != E_VNx16QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
            return -1;
          return 6428; /* aarch64_vec_duplicate_vqvnx16qi_be */

        case E_VNx16QImode:
          if (!register_operand (operands[1], E_VNx16QImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (QImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (QImode), 0, 63)))
            return -1;
          return 10430; /* aarch64_sve_dupq_lanevnx16qi */

        default:
          return -1;
        }

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
            return -1;
          return 6429; /* aarch64_vec_duplicate_vqvnx8hi_be */

        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HImode), 0, 63)))
            return -1;
          return 10431; /* aarch64_sve_dupq_lanevnx8hi */

        default:
          return -1;
        }

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
            return -1;
          return 6430; /* aarch64_vec_duplicate_vqvnx4si_be */

        case E_VNx4SImode:
          if (!register_operand (operands[1], E_VNx4SImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SImode), 0, 63)))
            return -1;
          return 10432; /* aarch64_sve_dupq_lanevnx4si */

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
            return -1;
          return 6431; /* aarch64_vec_duplicate_vqvnx2di_be */

        case E_VNx2DImode:
          if (!register_operand (operands[1], E_VNx2DImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DImode), 0, 63)))
            return -1;
          return 10433; /* aarch64_sve_dupq_lanevnx2di */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x2) != E_VNx8BFmode
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
            return -1;
          return 6432; /* aarch64_vec_duplicate_vqvnx8bf_be */

        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (BFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (BFmode), 0, 63)))
            return -1;
          return 10434; /* aarch64_sve_dupq_lanevnx8bf */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x2) != E_VNx8HFmode
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
            return -1;
          return 6433; /* aarch64_vec_duplicate_vqvnx8hf_be */

        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HFmode), 0, 63)))
            return -1;
          return 10435; /* aarch64_sve_dupq_lanevnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
            return -1;
          return 6434; /* aarch64_vec_duplicate_vqvnx4sf_be */

        case E_VNx4SFmode:
          if (!register_operand (operands[1], E_VNx4SFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SFmode), 0, 63)))
            return -1;
          return 10436; /* aarch64_sve_dupq_lanevnx4sf */

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
            return -1;
          return 6435; /* aarch64_vec_duplicate_vqvnx2df_be */

        case E_VNx2DFmode:
          if (!register_operand (operands[1], E_VNx2DFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DFmode), 0, 63)))
            return -1;
          return 10437; /* aarch64_sve_dupq_lanevnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[0]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern835 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V16QImode, operands[1], operands[2])))
            return 2950; /* load_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern835 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HImode, operands[1], operands[2])))
            return 2951; /* load_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern835 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8BFmode, operands[1], operands[2])))
            return 2952; /* load_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern835 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HFmode, operands[1], operands[2])))
            return 2953; /* load_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern835 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SImode, operands[1], operands[2])))
            return 2954; /* load_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern835 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SFmode, operands[1], operands[2])))
            return 2955; /* load_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern835 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SImode, operands[1], operands[2])))
            return 2956; /* load_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern835 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SFmode, operands[1], operands[2])))
            return 2957; /* load_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern835 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DImode, operands[1], operands[2])))
            return 2958; /* load_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern835 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4302 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DFmode, operands[1], operands[2])))
            return 2959; /* load_pair_lanesdf */
          break;

        case E_VNx16QImode:
          if (pattern836 (x2, 
E_VNx8QImode, 
E_VNx16QImode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10757; /* aarch64_pack_partialvnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern836 (x2, 
E_VNx4QImode, 
E_VNx8QImode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10758; /* aarch64_pack_partialvnx8qi */
          break;

        case E_VNx8HImode:
          if (pattern836 (x2, 
E_VNx4HImode, 
E_VNx8HImode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10759; /* aarch64_pack_partialvnx8hi */
          break;

        case E_VNx8HFmode:
          if (pattern836 (x2, 
E_VNx4HFmode, 
E_VNx8HFmode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10760; /* aarch64_pack_partialvnx8hf */
          break;

        case E_VNx8BFmode:
          if (pattern836 (x2, 
E_VNx4BFmode, 
E_VNx8BFmode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10761; /* aarch64_pack_partialvnx8bf */
          break;

        case E_VNx4QImode:
          if (pattern836 (x2, 
E_VNx2QImode, 
E_VNx4QImode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10762; /* aarch64_pack_partialvnx4qi */
          break;

        case E_VNx4HImode:
          if (pattern836 (x2, 
E_VNx2HImode, 
E_VNx4HImode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10763; /* aarch64_pack_partialvnx4hi */
          break;

        case E_VNx4HFmode:
          if (pattern836 (x2, 
E_VNx2HFmode, 
E_VNx4HFmode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10764; /* aarch64_pack_partialvnx4hf */
          break;

        case E_VNx4BFmode:
          if (pattern836 (x2, 
E_VNx2BFmode, 
E_VNx4BFmode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10765; /* aarch64_pack_partialvnx4bf */
          break;

        case E_VNx4SImode:
          if (pattern836 (x2, 
E_VNx2SImode, 
E_VNx4SImode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10766; /* aarch64_pack_partialvnx4si */
          break;

        case E_VNx4SFmode:
          if (pattern836 (x2, 
E_VNx2SFmode, 
E_VNx4SFmode) == 0
              && 
#line 9334 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10767; /* aarch64_pack_partialvnx4sf */
          break;

        default:
          break;
        }
      break;

    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern837 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2960; /* store_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern837 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2961; /* store_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern837 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2962; /* store_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern837 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2963; /* store_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern837 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2964; /* store_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern837 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2965; /* store_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern837 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2966; /* store_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern837 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2967; /* store_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern837 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2968; /* store_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern837 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4332 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2969; /* store_pair_lanesdf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V8QImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
            return 2970; /* *aarch64_combine_internalv8qi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V8QImode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
        return -1;
      return 2980; /* *aarch64_combine_internal_bev8qi */

    case E_V8HImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
            return 2971; /* *aarch64_combine_internalv4hi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
        return -1;
      return 2981; /* *aarch64_combine_internal_bev4hi */

    case E_V8BFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4BFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
            return 2972; /* *aarch64_combine_internalv4bf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4BFmode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
        return -1;
      return 2982; /* *aarch64_combine_internal_bev4bf */

    case E_V8HFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
            return 2973; /* *aarch64_combine_internalv4hf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HFmode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
        return -1;
      return 2983; /* *aarch64_combine_internal_bev4hf */

    case E_V4SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
            return 2974; /* *aarch64_combine_internalv2si */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
        return -1;
      return 2984; /* *aarch64_combine_internal_bev2si */

    case E_V4SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
            return 2975; /* *aarch64_combine_internalv2sf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
        return -1;
      return 2985; /* *aarch64_combine_internal_bev2sf */

    case E_V2SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SImode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
            return 2976; /* *aarch64_combine_internalsi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
        return -1;
      return 2986; /* *aarch64_combine_internal_besi */

    case E_V2SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SFmode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
            return 2977; /* *aarch64_combine_internalsf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
        return -1;
      return 2987; /* *aarch64_combine_internal_besf */

    case E_V2DImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DImode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
            return 2978; /* *aarch64_combine_internaldi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
        return -1;
      return 2988; /* *aarch64_combine_internal_bedi */

    case E_V2DFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DFmode)
              && 
#line 4351 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
            return 2979; /* *aarch64_combine_internaldf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4370 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
        return -1;
      return 2989; /* *aarch64_combine_internal_bedf */

    default:
      return -1;
    }
}

 int
recog_503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (pattern317 (x2))
            {
            case 0:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1367; /* subv8qi3_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1371; /* subv4hi3_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1375; /* subv2si3_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2644 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2370; /* subv4hf3_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2644 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2374; /* subv2sf3_vec_concatz_le */

            default:
              return -1;
            }

        case MULT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[2] = x6;
              operands[1] = x4;
              x7 = XEXP (x5, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1029 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2037; /* aarch64_mlsv8qi_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1029 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2041; /* aarch64_mlsv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1029 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2045; /* aarch64_mlsv2si_vec_concatz_le */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x9 = XEXP (x6, 0);
              switch (GET_CODE (x9))
                {
                case VEC_SELECT:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != PARALLEL
                      || XVECLEN (x10, 0) != 1)
                    return -1;
                  operands[4] = x4;
                  x11 = XEXP (x9, 0);
                  operands[1] = x11;
                  x12 = XVECEXP (x10, 0, 0);
                  operands[2] = x12;
                  if (!immediate_operand (operands[2], E_SImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x8 = XEXP (x2, 1);
                  operands[5] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1236 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[1], E_V4HImode)
                              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1710 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2049; /* *aarch64_mls_eltv4hi_vec_concatz_le */

                        case E_V8HImode:
                          if (!register_operand (operands[1], E_V8HImode)
                              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1728 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2057; /* *aarch64_mls_elt_to_128v4hi_vec_concatz_le */

                        default:
                          return -1;
                        }

                    case E_V4SImode:
                      if (pattern1236 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[1], E_V2SImode)
                              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1710 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2053; /* *aarch64_mls_eltv2si_vec_concatz_le */

                        case E_V4SImode:
                          if (!register_operand (operands[1], E_V4SImode)
                              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1728 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2061; /* *aarch64_mls_elt_to_128v2si_vec_concatz_le */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[3] = x9;
                  operands[1] = x4;
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  x8 = XEXP (x2, 1);
                  operands[4] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1084 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                          || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1744 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2065; /* aarch64_mls_nv4hi_vec_concatz_le */

                    case E_V4SImode:
                      if (pattern1084 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                          || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1744 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2069; /* aarch64_mls_nv2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern423 (x2, 
SMIN))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1642; /* aarch64_sabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1650; /* aarch64_sabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1658; /* aarch64_sabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern423 (x2, 
UMIN))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1645; /* aarch64_uabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1653; /* aarch64_uabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1661; /* aarch64_uabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 6; /* jump */
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x2))
            {
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
              res = recog_476 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
              res = recog_477 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x2;
          if (aarch64_movti_operand (operands[1], E_TImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (nonimmediate_operand (operands[0], E_TImode)
                  && 
#line 1710 "../../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], TImode)
    || aarch64_reg_or_zero (operands[1], TImode))))
                return 75; /* *movti_aarch64 */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (register_operand (operands[0], E_VNx16QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16QImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx16QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx16QImode)))))
            return 5542; /* *aarch64_sve_movvnx16qi_no_ldr_str */
          break;

        case E_VNx8QImode:
          if (register_operand (operands[0], E_VNx8QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8QImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8QImode)))))
            return 5543; /* *aarch64_sve_movvnx8qi_no_ldr_str */
          break;

        case E_VNx4QImode:
          if (register_operand (operands[0], E_VNx4QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4QImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4QImode)))))
            return 5544; /* *aarch64_sve_movvnx4qi_no_ldr_str */
          break;

        case E_VNx2QImode:
          if (register_operand (operands[0], E_VNx2QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2QImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2QImode)))))
            return 5545; /* *aarch64_sve_movvnx2qi_no_ldr_str */
          break;

        case E_VNx8HImode:
          if (register_operand (operands[0], E_VNx8HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HImode)))))
            return 5546; /* *aarch64_sve_movvnx8hi_no_ldr_str */
          break;

        case E_VNx4HImode:
          if (register_operand (operands[0], E_VNx4HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HImode)))))
            return 5547; /* *aarch64_sve_movvnx4hi_no_ldr_str */
          break;

        case E_VNx2HImode:
          if (register_operand (operands[0], E_VNx2HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HImode)))))
            return 5548; /* *aarch64_sve_movvnx2hi_no_ldr_str */
          break;

        case E_VNx4SImode:
          if (register_operand (operands[0], E_VNx4SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SImode)))))
            return 5549; /* *aarch64_sve_movvnx4si_no_ldr_str */
          break;

        case E_VNx2SImode:
          if (register_operand (operands[0], E_VNx2SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SImode)))))
            return 5550; /* *aarch64_sve_movvnx2si_no_ldr_str */
          break;

        case E_VNx2DImode:
          if (register_operand (operands[0], E_VNx2DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DImode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DImode)))))
            return 5551; /* *aarch64_sve_movvnx2di_no_ldr_str */
          break;

        case E_VNx8HFmode:
          if (register_operand (operands[0], E_VNx8HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HFmode)))))
            return 5552; /* *aarch64_sve_movvnx8hf_no_ldr_str */
          break;

        case E_VNx4HFmode:
          if (register_operand (operands[0], E_VNx4HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HFmode)))))
            return 5553; /* *aarch64_sve_movvnx4hf_no_ldr_str */
          break;

        case E_VNx2HFmode:
          if (register_operand (operands[0], E_VNx2HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HFmode)))))
            return 5554; /* *aarch64_sve_movvnx2hf_no_ldr_str */
          break;

        case E_VNx8BFmode:
          if (register_operand (operands[0], E_VNx8BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8BFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8BFmode)))))
            return 5555; /* *aarch64_sve_movvnx8bf_no_ldr_str */
          break;

        case E_VNx4BFmode:
          if (register_operand (operands[0], E_VNx4BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4BFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4BFmode)))))
            return 5556; /* *aarch64_sve_movvnx4bf_no_ldr_str */
          break;

        case E_VNx2BFmode:
          if (register_operand (operands[0], E_VNx2BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2BFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2BFmode)))))
            return 5557; /* *aarch64_sve_movvnx2bf_no_ldr_str */
          break;

        case E_VNx4SFmode:
          if (register_operand (operands[0], E_VNx4SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SFmode)))))
            return 5558; /* *aarch64_sve_movvnx4sf_no_ldr_str */
          break;

        case E_VNx2SFmode:
          if (register_operand (operands[0], E_VNx2SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SFmode)))))
            return 5559; /* *aarch64_sve_movvnx2sf_no_ldr_str */
          break;

        case E_VNx2DFmode:
          if (register_operand (operands[0], E_VNx2DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DFmode)
              && 
#line 711 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DFmode)))))
            return 5560; /* *aarch64_sve_movvnx2df_no_ldr_str */
          break;

        case E_VNx32QImode:
          if (register_operand (operands[0], E_VNx32QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32QImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5666; /* *aarch64_sve_movvnx32qi_be */
          break;

        case E_VNx16HImode:
          if (register_operand (operands[0], E_VNx16HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5667; /* *aarch64_sve_movvnx16hi_be */
          break;

        case E_VNx8SImode:
          if (register_operand (operands[0], E_VNx8SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5668; /* *aarch64_sve_movvnx8si_be */
          break;

        case E_VNx4DImode:
          if (register_operand (operands[0], E_VNx4DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5669; /* *aarch64_sve_movvnx4di_be */
          break;

        case E_VNx16BFmode:
          if (register_operand (operands[0], E_VNx16BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16BFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5670; /* *aarch64_sve_movvnx16bf_be */
          break;

        case E_VNx16HFmode:
          if (register_operand (operands[0], E_VNx16HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5671; /* *aarch64_sve_movvnx16hf_be */
          break;

        case E_VNx8SFmode:
          if (register_operand (operands[0], E_VNx8SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5672; /* *aarch64_sve_movvnx8sf_be */
          break;

        case E_VNx4DFmode:
          if (register_operand (operands[0], E_VNx4DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5673; /* *aarch64_sve_movvnx4df_be */
          break;

        case E_VNx48QImode:
          if (register_operand (operands[0], E_VNx48QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx48QImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5674; /* *aarch64_sve_movvnx48qi_be */
          break;

        case E_VNx24HImode:
          if (register_operand (operands[0], E_VNx24HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5675; /* *aarch64_sve_movvnx24hi_be */
          break;

        case E_VNx12SImode:
          if (register_operand (operands[0], E_VNx12SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5676; /* *aarch64_sve_movvnx12si_be */
          break;

        case E_VNx6DImode:
          if (register_operand (operands[0], E_VNx6DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5677; /* *aarch64_sve_movvnx6di_be */
          break;

        case E_VNx24BFmode:
          if (register_operand (operands[0], E_VNx24BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24BFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5678; /* *aarch64_sve_movvnx24bf_be */
          break;

        case E_VNx24HFmode:
          if (register_operand (operands[0], E_VNx24HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5679; /* *aarch64_sve_movvnx24hf_be */
          break;

        case E_VNx12SFmode:
          if (register_operand (operands[0], E_VNx12SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5680; /* *aarch64_sve_movvnx12sf_be */
          break;

        case E_VNx6DFmode:
          if (register_operand (operands[0], E_VNx6DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5681; /* *aarch64_sve_movvnx6df_be */
          break;

        case E_VNx64QImode:
          if (register_operand (operands[0], E_VNx64QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx64QImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5682; /* *aarch64_sve_movvnx64qi_be */
          break;

        case E_VNx32HImode:
          if (register_operand (operands[0], E_VNx32HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5683; /* *aarch64_sve_movvnx32hi_be */
          break;

        case E_VNx16SImode:
          if (register_operand (operands[0], E_VNx16SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5684; /* *aarch64_sve_movvnx16si_be */
          break;

        case E_VNx8DImode:
          if (register_operand (operands[0], E_VNx8DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DImode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5685; /* *aarch64_sve_movvnx8di_be */
          break;

        case E_VNx32BFmode:
          if (register_operand (operands[0], E_VNx32BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32BFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5686; /* *aarch64_sve_movvnx32bf_be */
          break;

        case E_VNx32HFmode:
          if (register_operand (operands[0], E_VNx32HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5687; /* *aarch64_sve_movvnx32hf_be */
          break;

        case E_VNx16SFmode:
          if (register_operand (operands[0], E_VNx16SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5688; /* *aarch64_sve_movvnx16sf_be */
          break;

        case E_VNx8DFmode:
          if (register_operand (operands[0], E_VNx8DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DFmode)
              && 
#line 865 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5689; /* *aarch64_sve_movvnx8df_be */
          break;

        case E_VNx16BImode:
          if (nonimmediate_operand (operands[0], E_VNx16BImode)
              && aarch64_mov_operand (operands[1], E_VNx16BImode)
              && 
#line 957 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BImode)
       || register_operand (operands[1], VNx16BImode))))
            return 5714; /* *aarch64_sve_movvnx16bi */
          break;

        case E_VNx8BImode:
          if (nonimmediate_operand (operands[0], E_VNx8BImode)
              && aarch64_mov_operand (operands[1], E_VNx8BImode)
              && 
#line 957 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BImode)
       || register_operand (operands[1], VNx8BImode))))
            return 5715; /* *aarch64_sve_movvnx8bi */
          break;

        case E_VNx4BImode:
          if (nonimmediate_operand (operands[0], E_VNx4BImode)
              && aarch64_mov_operand (operands[1], E_VNx4BImode)
              && 
#line 957 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BImode)
       || register_operand (operands[1], VNx4BImode))))
            return 5716; /* *aarch64_sve_movvnx4bi */
          break;

        case E_VNx2BImode:
          if (nonimmediate_operand (operands[0], E_VNx2BImode)
              && aarch64_mov_operand (operands[1], E_VNx2BImode)
              && 
#line 957 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BImode)
       || register_operand (operands[1], VNx2BImode))))
            return 5717; /* *aarch64_sve_movvnx2bi */
          break;

        case E_VNx32BImode:
          if (nonimmediate_operand (operands[0], E_VNx32BImode)
              && aarch64_mov_operand (operands[1], E_VNx32BImode)
              && 
#line 1079 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5726; /* movvnx32bi */
          break;

        case E_VNx64BImode:
          if (nonimmediate_operand (operands[0], E_VNx64BImode)
              && aarch64_mov_operand (operands[1], E_VNx64BImode)
              && 
#line 1079 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5727; /* movvnx64bi */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == REG
          && GET_MODE (x2) == E_VNx16BImode)
        {
          switch (REGNO (x2))
            {
            case 85:
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 86
                  && GET_MODE (x3) == E_VNx16BImode
                  && 
#line 1141 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 5730; /* aarch64_copy_ffr_to_ffrt */
              break;

            case 86:
              operands[0] = x3;
              if (register_operand (operands[0], E_VNx16BImode)
                  && 
#line 1152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 5731; /* aarch64_rdffr */
              break;

            default:
              break;
            }
        }
      operands[1] = x2;
      operands[0] = x3;
      res = recog_478 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && GET_CODE (x3) == REG
          && REGNO (x3) == 90
          && GET_MODE (x3) == E_DImode)
        return 12933; /* aarch64_clear_tpidr2 */
      break;

    case TRUNCATE:
      res = recog_480 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!subreg_lowpart_operator (x2, E_DImode))
    return -1;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 844; /* *aarch64_bfidiqi_subreg_8 */

    case 1:
      if (!
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 845; /* *aarch64_bfidihi_subreg_8 */

    case 2:
      if (!
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 847; /* *aarch64_bfidisi_subreg_8 */

    case 3:
      if (!
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 846; /* *aarch64_bfidihi_subreg_16 */

    case 4:
      if (!
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 848; /* *aarch64_bfidisi_subreg_16 */

    case 5:
      if (!
#line 6462 "../../../gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64))
        return -1;
      return 849; /* *aarch64_bfidisi_subreg_32 */

    default:
      return -1;
    }
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_483 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && GET_MODE (x3) == E_V8QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1245; /* aarch64_simd_dupv8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[0], E_V16QImode)
                      && GET_MODE (x3) == E_V16QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1246; /* aarch64_simd_dupv16qi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && GET_MODE (x3) == E_V4HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1247; /* aarch64_simd_dupv4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[0], E_V8HImode)
                      && GET_MODE (x3) == E_V8HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1248; /* aarch64_simd_dupv8hi */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1249; /* aarch64_simd_dupv2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x3) == E_V4SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1250; /* aarch64_simd_dupv4si */
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 97 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1251; /* aarch64_simd_dupv2di */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[0], E_V4HFmode)
                      && GET_MODE (x3) == E_V4HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1252; /* aarch64_simd_dupv4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[0], E_V8HFmode)
                      && GET_MODE (x3) == E_V8HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1253; /* aarch64_simd_dupv8hf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1254; /* aarch64_simd_dupv2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[0], E_V4SFmode)
                      && GET_MODE (x3) == E_V4SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1255; /* aarch64_simd_dupv4sf */
                  break;

                case E_V2DFmode:
                  if (register_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1256; /* aarch64_simd_dupv2df */
                  break;

                case E_V4BFmode:
                  if (register_operand (operands[0], E_V4BFmode)
                      && GET_MODE (x3) == E_V4BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1257; /* aarch64_simd_dupv4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[0], E_V8BFmode)
                      && GET_MODE (x3) == E_V8BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1258; /* aarch64_simd_dupv8bf */
                  break;

                default:
                  break;
                }
              break;

            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 237 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1311; /* aarch64_simd_stpv2si */
                  break;

                case E_V2SFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 237 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1312; /* aarch64_simd_stpv2sf */
                  break;

                case E_V2DImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 237 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1313; /* aarch64_simd_stpv2di */
                  break;

                case E_V2DFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 237 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1314; /* aarch64_simd_stpv2df */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (register_operand (operands[0], E_V8QImode)
                  && GET_MODE (x3) == E_V8QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5124; /* *aarch64_simd_ld1rv8qi */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5125; /* *aarch64_simd_ld1rv16qi */
              break;

            case E_V4HImode:
              if (register_operand (operands[0], E_V4HImode)
                  && GET_MODE (x3) == E_V4HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5126; /* *aarch64_simd_ld1rv4hi */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5127; /* *aarch64_simd_ld1rv8hi */
              break;

            case E_V2SImode:
              if (register_operand (operands[0], E_V2SImode)
                  && GET_MODE (x3) == E_V2SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5128; /* *aarch64_simd_ld1rv2si */
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x3) == E_V4SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5129; /* *aarch64_simd_ld1rv4si */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x3) == E_V2DImode
                  && aarch64_simd_struct_operand (operands[1], E_DImode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5130; /* *aarch64_simd_ld1rv2di */
              break;

            case E_V4HFmode:
              if (register_operand (operands[0], E_V4HFmode)
                  && GET_MODE (x3) == E_V4HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5131; /* *aarch64_simd_ld1rv4hf */
              break;

            case E_V8HFmode:
              if (register_operand (operands[0], E_V8HFmode)
                  && GET_MODE (x3) == E_V8HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5132; /* *aarch64_simd_ld1rv8hf */
              break;

            case E_V4BFmode:
              if (register_operand (operands[0], E_V4BFmode)
                  && GET_MODE (x3) == E_V4BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5133; /* *aarch64_simd_ld1rv4bf */
              break;

            case E_V8BFmode:
              if (register_operand (operands[0], E_V8BFmode)
                  && GET_MODE (x3) == E_V8BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5134; /* *aarch64_simd_ld1rv8bf */
              break;

            case E_V2SFmode:
              if (register_operand (operands[0], E_V2SFmode)
                  && GET_MODE (x3) == E_V2SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5135; /* *aarch64_simd_ld1rv2sf */
              break;

            case E_V4SFmode:
              if (register_operand (operands[0], E_V4SFmode)
                  && GET_MODE (x3) == E_V4SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5136; /* *aarch64_simd_ld1rv4sf */
              break;

            case E_V2DFmode:
              if (register_operand (operands[0], E_V2DFmode)
                  && GET_MODE (x3) == E_V2DFmode
                  && aarch64_simd_struct_operand (operands[1], E_DFmode)
                  && 
#line 8817 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5137; /* *aarch64_simd_ld1rv2df */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      return recog_482 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          switch (pattern486 (x3))
            {
            case 0:
              return 106; /* *extendsidi2_aarch64 */

            case 1:
              return 111; /* *extendqidi2_aarch64 */

            case 2:
              return 113; /* *extendhidi2_aarch64 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern487 (x3))
            {
            case 0:
              return 110; /* *extendqisi2_aarch64 */

            case 1:
              return 112; /* *extendhisi2_aarch64 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 118; /* *extendqihi2_aarch64 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5242; /* extendv8qiv8hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5244; /* extendv4hiv4si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 5246; /* extendv2siv2di2 */

        case E_VNx16HImode:
          if (!aligned_register_operand (operands[0], E_VNx16HImode)
              || GET_MODE (x3) != E_VNx16HImode
              || !register_operand (operands[1], E_VNx16QImode)
              || !
#line 2201 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12024; /* extendvnx16qivnx16hi2 */

        case E_VNx8SImode:
          if (!aligned_register_operand (operands[0], E_VNx8SImode)
              || GET_MODE (x3) != E_VNx8SImode
              || !register_operand (operands[1], E_VNx8HImode)
              || !
#line 2201 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12026; /* extendvnx8hivnx8si2 */

        case E_VNx4DImode:
          if (!aligned_register_operand (operands[0], E_VNx4DImode)
              || GET_MODE (x3) != E_VNx4DImode
              || !register_operand (operands[1], E_VNx4SImode)
              || !
#line 2201 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12028; /* extendvnx4sivnx4di2 */

        case E_VNx32HImode:
          if (!aligned_register_operand (operands[0], E_VNx32HImode)
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[1], E_VNx32QImode)
              || !
#line 2209 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12030; /* extendvnx32qivnx32hi2 */

        case E_VNx16SImode:
          if (!aligned_register_operand (operands[0], E_VNx16SImode)
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[1], E_VNx16HImode)
              || !
#line 2209 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12032; /* extendvnx16hivnx16si2 */

        case E_VNx8DImode:
          if (!aligned_register_operand (operands[0], E_VNx8DImode)
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[1], E_VNx8SImode)
              || !
#line 2209 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12034; /* extendvnx8sivnx8di2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 6274 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 798; /* *extendsi_ashlqi */

        case 1:
          if (!
#line 6274 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 802; /* *extendsi_ashlhi */

        case 2:
          if (!
#line 6274 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 800; /* *extenddi_ashlqi */

        case 3:
          if (!
#line 6274 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 804; /* *extenddi_ashlhi */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 6300 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 810; /* *extendsi_ashrqi */

        case 1:
          if (!
#line 6300 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 812; /* *extendsi_ashrhi */

        case 2:
          if (!
#line 6300 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
            return -1;
          return 811; /* *extenddi_ashrqi */

        case 3:
          if (!
#line 6300 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
            return -1;
          return 813; /* *extenddi_ashrhi */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern360 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) == 0
              && 
#line 1968 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2228; /* aarch64_simd_vec_unpacks_hi_v16qi */
          break;

        case E_V4SImode:
          if (pattern360 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) == 0
              && 
#line 1968 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2230; /* aarch64_simd_vec_unpacks_hi_v8hi */
          break;

        case E_V2DImode:
          if (pattern360 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) == 0
              && 
#line 1968 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2232; /* aarch64_simd_vec_unpacks_hi_v4si */
          break;

        default:
          break;
        }
      if (XVECLEN (x5, 0) != 1)
        return -1;
      switch (pattern489 (x3))
        {
        case 0:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2918; /* *aarch64_get_lane_extendsiv8qi */

        case 1:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2920; /* *aarch64_get_lane_extendsiv16qi */

        case 2:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2922; /* *aarch64_get_lane_extendsiv4hi */

        case 3:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2924; /* *aarch64_get_lane_extendsiv8hi */

        case 4:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2919; /* *aarch64_get_lane_extenddiv8qi */

        case 5:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2921; /* *aarch64_get_lane_extenddiv16qi */

        case 6:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2923; /* *aarch64_get_lane_extenddiv4hi */

        case 7:
          if (!
#line 4229 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2925; /* *aarch64_get_lane_extenddiv8hi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 25)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern878 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 725 "../../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 8)))
                return -1;
              return 5513; /* *aarch64_atomic_loadqi_rcpc_sext */

            case 1:
              if (!
#line 725 "../../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 16)))
                return -1;
              return 5515; /* *aarch64_atomic_loadhi_rcpc_sext */

            case 2:
              if (!
#line 725 "../../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (32 > 32)))
                return -1;
              return 5517; /* *aarch64_atomic_loadsi_rcpc_sext */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern878 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 725 "../../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 8)))
                return -1;
              return 5514; /* *aarch64_atomic_loadqi_rcpc_sext */

            case 1:
              if (!
#line 725 "../../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 16)))
                return -1;
              return 5516; /* *aarch64_atomic_loadhi_rcpc_sext */

            case 2:
              if (!
#line 725 "../../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC2 && (64 > 32)))
                return -1;
              return 5518; /* *aarch64_atomic_loadsi_rcpc_sext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 3)
        return -1;
      switch (pattern609 (x3))
        {
        case 0:
          if (!
#line 10417 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10968; /* aarch64_sve_sqincsi_pat */

        case 1:
          if (!
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11014; /* *aarch64_sve_sqincsivnx16bi_cntp */

        case 2:
          if (!
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11016; /* *aarch64_sve_sqincsivnx8bi_cntp */

        case 3:
          if (!
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11018; /* *aarch64_sve_sqincsivnx4bi_cntp */

        case 4:
          if (!
#line 10771 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11020; /* *aarch64_sve_sqincsivnx2bi_cntp */

        default:
          return -1;
        }

    case SS_MINUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3)
        return -1;
      switch (pattern611 (x3))
        {
        case 0:
          if (!
#line 10567 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10983; /* aarch64_sve_sqdecsi_pat */

        case 1:
          if (!
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11047; /* *aarch64_sve_sqdecsivnx16bi_cntp */

        case 2:
          if (!
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11049; /* *aarch64_sve_sqdecsivnx8bi_cntp */

        case 3:
          if (!
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11051; /* *aarch64_sve_sqdecsivnx4bi_cntp */

        case 4:
          if (!
#line 11004 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11053; /* *aarch64_sve_sqdecsivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (XVECLEN (x3, 0) == 1)
    {
      res = recog_484 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V16QImode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1315; /* aarch64_simd_mov_from_v16qilow */
      if (!vect_par_cnst_hi_half (operands[2], E_V16QImode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1321; /* aarch64_simd_mov_from_v16qihigh */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8HImode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1316; /* aarch64_simd_mov_from_v8hilow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8HImode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1322; /* aarch64_simd_mov_from_v8hihigh */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V4SImode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1317; /* aarch64_simd_mov_from_v4silow */
      if (!vect_par_cnst_hi_half (operands[2], E_V4SImode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1323; /* aarch64_simd_mov_from_v4sihigh */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8HFmode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1318; /* aarch64_simd_mov_from_v8hflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8HFmode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1324; /* aarch64_simd_mov_from_v8hfhigh */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x2) != E_V4BFmode
          || !register_operand (operands[1], E_V8BFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8BFmode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1319; /* aarch64_simd_mov_from_v8bflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8BFmode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1325; /* aarch64_simd_mov_from_v8bfhigh */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V4SFmode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1320; /* aarch64_simd_mov_from_v4sflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V4SFmode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1326; /* aarch64_simd_mov_from_v4sfhigh */

    case E_V16QImode:
      if (pattern661 (x2, 
E_VNx16QImode, 
E_V16QImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
        return -1;
      return 11064; /* aarch64_sve_get_neonq_vnx16qi */

    case E_V8HImode:
      if (pattern661 (x2, 
E_VNx8HImode, 
E_V8HImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
        return -1;
      return 11065; /* aarch64_sve_get_neonq_vnx8hi */

    case E_V4SImode:
      if (pattern661 (x2, 
E_VNx4SImode, 
E_V4SImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
        return -1;
      return 11066; /* aarch64_sve_get_neonq_vnx4si */

    case E_V2DImode:
      if (pattern661 (x2, 
E_VNx2DImode, 
E_V2DImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
        return -1;
      return 11067; /* aarch64_sve_get_neonq_vnx2di */

    case E_V8BFmode:
      if (pattern661 (x2, 
E_VNx8BFmode, 
E_V8BFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
        return -1;
      return 11068; /* aarch64_sve_get_neonq_vnx8bf */

    case E_V8HFmode:
      if (pattern661 (x2, 
E_VNx8HFmode, 
E_V8HFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
        return -1;
      return 11069; /* aarch64_sve_get_neonq_vnx8hf */

    case E_V4SFmode:
      if (pattern661 (x2, 
E_VNx4SFmode, 
E_V4SFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
        return -1;
      return 11070; /* aarch64_sve_get_neonq_vnx4sf */

    case E_V2DFmode:
      if (pattern661 (x2, 
E_VNx2DFmode, 
E_V2DFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
        return -1;
      return 11071; /* aarch64_sve_get_neonq_vnx2df */

    default:
      return -1;
    }
}

 int
recog_536 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 6978 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 997; /* extendsfdf2 */

            case E_HFmode:
              if (!register_operand (operands[1], E_HFmode)
                  || !
#line 6994 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 999; /* extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 6986 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 998; /* extendhfsf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !
#line 3188 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2654; /* extendv2sfv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4HFmode)
              || !
#line 3188 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2655; /* extendv4hfv4sf2 */

        case E_VNx8SFmode:
          if (!aligned_register_operand (operands[0], E_VNx8SFmode)
              || GET_MODE (x3) != E_VNx8SFmode
              || !register_operand (operands[1], E_VNx8HFmode)
              || !
#line 3339 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME_F16F16))
            return -1;
          return 12583; /* extendvnx8hfvnx8sf2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern660 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_V4SFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[2], E_V8HFmode)
              && 
#line 3112 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2630; /* aarch64_simd_vec_unpacks_lo_v8hf */
          if (!vect_par_cnst_hi_half (operands[2], E_V8HFmode)
              || !
#line 3168 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2652; /* aarch64_simd_vec_unpacks_hi_v8hf */

        case E_V2DFmode:
          if (pattern660 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[2], E_V4SFmode)
              && 
#line 3112 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2631; /* aarch64_simd_vec_unpacks_lo_v4sf */
          if (!vect_par_cnst_hi_half (operands[2], E_V4SFmode)
              || !
#line 3168 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2653; /* aarch64_simd_vec_unpacks_hi_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern333 (x3))
        {
        case 0:
          if (!
#line 5391 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3349; /* aarch64_uqmovnhi */

        case 1:
          if (!
#line 5391 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3351; /* aarch64_uqmovnsi */

        case 2:
          if (!
#line 5391 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3353; /* aarch64_uqmovndi */

        case 3:
          if (!
#line 5400 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3357; /* aarch64_uqmovnv8hi */

        case 4:
          if (!
#line 5400 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3363; /* aarch64_uqmovnv4si */

        case 5:
          if (!
#line 5400 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3369; /* aarch64_uqmovnv2di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern339 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 6682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3894; /* aarch64_uqshrn_nhi */

        case 1:
          if (!
#line 6682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3896; /* aarch64_uqshrn_nsi */

        case 2:
          if (!
#line 6682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3898; /* aarch64_uqshrn_ndi */

        case 3:
          if (!
#line 6693 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
            return -1;
          return 3908; /* *aarch64_uqshrn_nv8hi_insn */

        case 4:
          if (!
#line 6693 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
            return -1;
          return 3926; /* *aarch64_uqshrn_nv4si_insn */

        case 5:
          if (!
#line 6693 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
            return -1;
          return 3944; /* *aarch64_uqshrn_nv2di_insn */

        case 6:
          if (!
#line 6720 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
            return -1;
          return 3956; /* *aarch64_uqrshrn_nv8hi_insn */

        case 7:
          if (!
#line 6720 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
            return -1;
          return 3965; /* *aarch64_uqrshrn_nv4si_insn */

        case 8:
          if (!
#line 6720 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
            return -1;
          return 3974; /* *aarch64_uqrshrn_nv2di_insn */

        case 9:
          if (!
#line 6735 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
            return -1;
          return 3981; /* *aarch64_uqrshrn_nhi_insn */

        case 10:
          if (!
#line 6735 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
            return -1;
          return 3983; /* *aarch64_uqrshrn_nsi_insn */

        case 11:
          if (!
#line 6735 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
            return -1;
          return 3985; /* *aarch64_uqrshrn_ndi_insn */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern340 (x3))
        {
        case 0:
          if (!
#line 6693 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
            return -1;
          return 3905; /* *aarch64_uqsshrn_nv8hi_insn */

        case 1:
          if (!
#line 6693 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
            return -1;
          return 3923; /* *aarch64_uqsshrn_nv4si_insn */

        case 2:
          if (!
#line 6693 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
            return -1;
          return 3941; /* *aarch64_uqsshrn_nv2di_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_574 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10115; /* while_ugtsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10125; /* while_ugtdivnx16bi_ptest */
}

 int
recog_584 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10074; /* *while_gtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3448 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10084; /* *while_gtdivnx4bi_cc */
}

 int
recog_594 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10033; /* *while_gesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3447 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10043; /* *while_gedivnx16bi_cc */
}

 int
recog_604 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern684 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9955; /* while_ugtsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9965; /* while_ugtdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9975; /* while_ugtsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9985; /* while_ugtdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9995; /* while_ugtsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10005; /* while_ugtdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10015; /* while_ugtsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3449 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10025; /* while_ugtdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          switch (GET_CODE (x10))
            {
            case PLUS:
              switch (pattern1248 (x1))
                {
                case 0:
                  return 125; /* addsi3_compare0 */

                case 1:
                  return 126; /* adddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1186 (x1, 
PLUS) != 0
                  || !aarch64_plus_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              return 127; /* *addsi3_compare0_uxtw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Cmode
              || GET_MODE (x3) != E_CC_Cmode)
            return -1;
          switch (pattern1248 (x1))
            {
            case 0:
              return 130; /* addsi3_compareC */

            case 1:
              return 131; /* adddi3_compareC */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          operands[2] = x6;
          if (pattern1095 (x2) != 0)
            return -1;
          switch (pattern1265 (x1))
            {
            case 0:
              if (pattern1334 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 136; /* addsi3_compareV_imm */

            case 1:
              if (pattern1334 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 137; /* adddi3_compareV_imm */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern1095 (x2) != 0)
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          switch (pattern1265 (x1))
            {
            case 0:
              if (pattern1335 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 138; /* addsi3_compareV */

            case 1:
              if (pattern1335 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 139; /* adddi3_compareV */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          switch (pattern1250 (x1))
            {
            case 0:
              return 152; /* *adds_extendqi_si */

            case 1:
              return 156; /* *adds_extendhi_si */

            case 2:
              return 160; /* *adds_extendsi_si */

            case 3:
              return 154; /* *adds_extendqi_di */

            case 4:
              return 158; /* *adds_extendhi_di */

            case 5:
              return 162; /* *adds_extendsi_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern915 (x1, 
ASHIFT) != 0)
        return -1;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x17 = XEXP (x10, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x14 = XEXP (x5, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[1] = x14;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (pattern917 (x1))
            {
            case 0:
              return 140; /* *adds_shift_imm_si */

            case 1:
              return 143; /* *adds_shift_imm_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1297 (x1, 
SIGN_EXTEND))
            {
            case 0:
              return 176; /* *adds_extendqi_shift_si */

            case 1:
              return 180; /* *adds_extendhi_shift_si */

            case 2:
              return 184; /* *adds_extendsi_shift_si */

            case 3:
              return 178; /* *adds_extendqi_shift_di */

            case 4:
              return 182; /* *adds_extendhi_shift_di */

            case 5:
              return 186; /* *adds_extendsi_shift_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1297 (x1, 
ZERO_EXTEND))
            {
            case 0:
              return 177; /* *adds_zero_extendqi_shift_si */

            case 1:
              return 181; /* *adds_zero_extendhi_shift_si */

            case 2:
              return 185; /* *adds_zero_extendsi_shift_si */

            case 3:
              return 179; /* *adds_zero_extendqi_shift_di */

            case 4:
              return 183; /* *adds_zero_extendhi_shift_di */

            case 5:
              return 187; /* *adds_zero_extendsi_shift_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern919 (x1, 
ASHIFTRT))
        {
        case 0:
          return 141; /* *adds_shift_imm_si */

        case 1:
          return 144; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern919 (x1, 
LSHIFTRT))
        {
        case 0:
          return 142; /* *adds_shift_imm_si */

        case 1:
          return 145; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern915 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern1250 (x1))
        {
        case 0:
          return 153; /* *adds_zero_extendqi_si */

        case 1:
          return 157; /* *adds_zero_extendhi_si */

        case 2:
          return 161; /* *adds_zero_extendsi_si */

        case 3:
          return 155; /* *adds_zero_extendqi_di */

        case 4:
          return 159; /* *adds_zero_extendhi_di */

        case 5:
          return 163; /* *adds_zero_extendsi_di */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x5;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          if (!const_scalar_int_operand (operands[4], E_VOIDmode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1309 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3154 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 254; /* *addsi3_carryinC_zero */

            case E_TImode:
              if (pattern1309 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3154 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 255; /* *adddi3_carryinC_zero */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x19 = XEXP (x18, 0);
          operands[3] = x19;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1336 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 258; /* *addsi3_carryinV_zero */

            case E_TImode:
              if (pattern1336 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 259; /* *adddi3_carryinV_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[3] = x14;
      x16 = XEXP (x5, 1);
      switch (GET_CODE (x16))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!const_scalar_int_operand (operands[5], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1344 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3174 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 256; /* *addsi3_carryinC */

            case E_TImode:
              if (pattern1344 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3174 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 257; /* *adddi3_carryinC */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x22 = XEXP (x19, 0);
          operands[4] = x22;
          x23 = XEXP (x19, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1362 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 260; /* *addsi3_carryinV */

            case E_TImode:
              if (pattern1362 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 261; /* *adddi3_carryinV */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_616 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x4, 1))
        {
        case 17:
          if (pattern776 (x1) != 0
              || !
#line 8324 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1220; /* tstart */

        case 157:
          if (pattern776 (x1) != 0
              || !
#line 8333 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1221; /* ttest */

        case 20:
          if (pattern777 (x1, 
20) != 0
              || !
#line 8360 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1224; /* aarch64_rndr */

        case 21:
          if (pattern777 (x1, 
21) != 0
              || !
#line 8370 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1225; /* aarch64_rndrrs */

        case 66:
          if (pattern778 (x1, 
65) != 0
              || !
#line 8491 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1234; /* st64bv */

        case 68:
          if (pattern778 (x1, 
67) != 0
              || !
#line 8503 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1235; /* st64bv0 */

        case 23:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XINT (x7, 1) != 23
              || !register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (XVECLEN (x7, 0))
            {
            case 2:
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_QImode)
                      || GET_MODE (x7) != E_QImode
                      || !aarch64_reg_or_zero (operands[2], E_QImode))
                    return -1;
                  return 5528; /* aarch64_store_exclusiveqi */

                case E_HImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_HImode)
                      || GET_MODE (x7) != E_HImode
                      || !aarch64_reg_or_zero (operands[2], E_HImode))
                    return -1;
                  return 5529; /* aarch64_store_exclusivehi */

                case E_SImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_SImode)
                      || GET_MODE (x7) != E_SImode
                      || !aarch64_reg_or_zero (operands[2], E_SImode))
                    return -1;
                  return 5530; /* aarch64_store_exclusivesi */

                case E_DImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_DImode)
                      || GET_MODE (x7) != E_DImode
                      || !aarch64_reg_or_zero (operands[2], E_DImode))
                    return -1;
                  return 5531; /* aarch64_store_exclusivedi */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x7) != E_TImode
                  || !aarch64_sync_memory_operand (operands[1], E_TImode))
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!aarch64_reg_or_zero (operands[2], E_DImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!aarch64_reg_or_zero (operands[3], E_DImode))
                return -1;
              x11 = XVECEXP (x7, 0, 2);
              operands[4] = x11;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              return 5532; /* aarch64_store_exclusive_pair */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[1] = x12;
      x13 = XVECEXP (x4, 0, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x5 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1152 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5403; /* aarch64_atomic_iorqi_lse */

            case E_HImode:
              if (pattern1152 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5407; /* aarch64_atomic_iorhi_lse */

            case E_SImode:
              if (pattern1152 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5411; /* aarch64_atomic_iorsi_lse */

            case E_DImode:
              if (pattern1152 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5415; /* aarch64_atomic_iordi_lse */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1152 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5404; /* aarch64_atomic_bicqi_lse */

            case E_HImode:
              if (pattern1152 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5408; /* aarch64_atomic_bichi_lse */

            case E_SImode:
              if (pattern1152 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5412; /* aarch64_atomic_bicsi_lse */

            case E_DImode:
              if (pattern1152 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5416; /* aarch64_atomic_bicdi_lse */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1152 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5405; /* aarch64_atomic_xorqi_lse */

            case E_HImode:
              if (pattern1152 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5409; /* aarch64_atomic_xorhi_lse */

            case E_SImode:
              if (pattern1152 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5413; /* aarch64_atomic_xorsi_lse */

            case E_DImode:
              if (pattern1152 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5417; /* aarch64_atomic_xordi_lse */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1152 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5406; /* aarch64_atomic_addqi_lse */

            case E_HImode:
              if (pattern1152 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5410; /* aarch64_atomic_addhi_lse */

            case E_SImode:
              if (pattern1152 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5414; /* aarch64_atomic_addsi_lse */

            case E_DImode:
              if (pattern1152 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5418; /* aarch64_atomic_adddi_lse */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern779 (x6, 
E_DImode, 
22, 
2, 
UNSPEC_VOLATILE) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!aarch64_sync_memory_operand (operands[2], E_TImode))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 1);
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      return 5527; /* aarch64_load_exclusive_pair */

    default:
      return -1;
    }
}

 int
recog_624 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 5:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (scratch_operand (operands[4], E_DImode))
            {
              res = recog_546 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC_VOLATILE
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 31)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          operands[1] = x5;
          x12 = XVECEXP (x8, 0, 1);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1276 (x1))
            {
            case 0:
              return 5423; /* aarch64_atomic_fetch_addqi */

            case 1:
              return 5428; /* aarch64_atomic_fetch_addhi */

            case 2:
              return 5433; /* aarch64_atomic_fetch_addsi */

            case 3:
              return 5438; /* aarch64_atomic_fetch_adddi */

            case 4:
              return 5424; /* aarch64_atomic_fetch_subqi */

            case 5:
              return 5429; /* aarch64_atomic_fetch_subhi */

            case 6:
              return 5434; /* aarch64_atomic_fetch_subsi */

            case 7:
              return 5439; /* aarch64_atomic_fetch_subdi */

            case 8:
              return 5425; /* aarch64_atomic_fetch_orqi */

            case 9:
              return 5430; /* aarch64_atomic_fetch_orhi */

            case 10:
              return 5435; /* aarch64_atomic_fetch_orsi */

            case 11:
              return 5440; /* aarch64_atomic_fetch_ordi */

            case 12:
              return 5426; /* aarch64_atomic_fetch_xorqi */

            case 13:
              return 5431; /* aarch64_atomic_fetch_xorhi */

            case 14:
              return 5436; /* aarch64_atomic_fetch_xorsi */

            case 15:
              return 5441; /* aarch64_atomic_fetch_xordi */

            case 16:
              return 5427; /* aarch64_atomic_fetch_andqi */

            case 17:
              return 5432; /* aarch64_atomic_fetch_andhi */

            case 18:
              return 5437; /* aarch64_atomic_fetch_andsi */

            case 19:
              return 5442; /* aarch64_atomic_fetch_anddi */

            case 20:
              return 5459; /* atomic_fetch_nandqi */

            case 21:
              return 5460; /* atomic_fetch_nandhi */

            case 22:
              return 5461; /* atomic_fetch_nandsi */

            case 23:
              return 5462; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 66
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 2)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_BLKmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x11 = XEXP (x2, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x7, 0);
          operands[0] = x16;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_DImode)
              || GET_MODE (x13) != E_BLKmode)
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x19 = XEXP (x15, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          switch (XINT (x13, 1))
            {
            case 8:
              if (!
#line 1947 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 85; /* *aarch64_cpymemdi */

            case 70:
              if (!
#line 1993 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 86; /* *aarch64_movmemdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 98)
            return -1;
          x11 = XEXP (x2, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern449 (x7, 
30, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (pattern1241 (x10, 
29, 
USE) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!scratch_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x11))
            {
            case E_SImode:
              if (GET_MODE (x5) != E_SImode
                  || !(
#line 7853 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1150; /* tlsdesc_small_advsimd_si */

            case E_DImode:
              if (GET_MODE (x5) != E_DImode
                  || !(
#line 7853 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1151; /* tlsdesc_small_advsimd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_620 (x1, insn, pnum_clobbers);

    case 3:
      return recog_622 (x1, insn, pnum_clobbers);

    case 4:
      return recog_621 (x1, insn, pnum_clobbers);

    case 6:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || pattern359 (x5, 
E_TImode, 
684) != 0
          || pattern451 (x1, 
17, 
CLOBBER, 
16, 
E_TImode, 
0) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (pattern1221 (x4, 
18) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 4);
      if (pattern1241 (x10, 
30, 
CLOBBER) != 0)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x21) != CLOBBER)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 66
          || GET_MODE (x22) != E_CCmode)
        return -1;
      return 12924; /* aarch64_get_sme_state */

    case 26:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1)
        return -1;
      x23 = XVECEXP (x2, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE
          || pattern572 (x1, 
32, 
67, 
CLOBBER) != 0
          || pattern1036 (x1, 
E_V4x16QImode, 
48, 
44, 
40, 
36) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern1364 (x24, 
E_V4x16QImode, 
52) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 8);
      if (pattern695 (x25, 
E_V4x16QImode, 
56) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x26) != CLOBBER)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 60
          || GET_MODE (x27) != E_V4x16QImode)
        return -1;
      x28 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x28) != CLOBBER)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 68
          || GET_MODE (x29) != E_VNx16BImode)
        return -1;
      x30 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x30) != CLOBBER)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 69
          || GET_MODE (x31) != E_VNx16BImode)
        return -1;
      x32 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x32) != CLOBBER)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 70
          || GET_MODE (x33) != E_VNx16BImode)
        return -1;
      x34 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x34) != CLOBBER)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 71
          || GET_MODE (x35) != E_VNx16BImode)
        return -1;
      x36 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x36) != CLOBBER)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 72
          || GET_MODE (x37) != E_VNx16BImode)
        return -1;
      x38 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x38) != CLOBBER)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 73
          || GET_MODE (x39) != E_VNx16BImode)
        return -1;
      x40 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x40) != CLOBBER)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 74
          || GET_MODE (x41) != E_VNx16BImode)
        return -1;
      x42 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x42) != CLOBBER)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 75
          || GET_MODE (x43) != E_VNx16BImode)
        return -1;
      x44 = XVECEXP (x1, 0, 18);
      if (GET_CODE (x44) != CLOBBER)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 76
          || GET_MODE (x45) != E_VNx16BImode)
        return -1;
      x46 = XVECEXP (x1, 0, 19);
      if (GET_CODE (x46) != CLOBBER)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 77
          || GET_MODE (x47) != E_VNx16BImode)
        return -1;
      x48 = XVECEXP (x1, 0, 20);
      if (GET_CODE (x48) != CLOBBER)
        return -1;
      x49 = XEXP (x48, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 78
          || GET_MODE (x49) != E_VNx16BImode)
        return -1;
      x50 = XVECEXP (x1, 0, 21);
      if (GET_CODE (x50) != CLOBBER)
        return -1;
      x51 = XEXP (x50, 0);
      if (GET_CODE (x51) != REG
          || REGNO (x51) != 79
          || GET_MODE (x51) != E_VNx16BImode)
        return -1;
      x52 = XVECEXP (x1, 0, 22);
      if (GET_CODE (x52) != CLOBBER)
        return -1;
      x53 = XEXP (x52, 0);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 80
          || GET_MODE (x53) != E_VNx16BImode)
        return -1;
      x54 = XVECEXP (x1, 0, 23);
      if (GET_CODE (x54) != CLOBBER)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != REG
          || REGNO (x55) != 81
          || GET_MODE (x55) != E_VNx16BImode)
        return -1;
      x56 = XVECEXP (x1, 0, 24);
      if (GET_CODE (x56) != CLOBBER)
        return -1;
      x57 = XEXP (x56, 0);
      if (GET_CODE (x57) != REG
          || REGNO (x57) != 82
          || GET_MODE (x57) != E_VNx16BImode)
        return -1;
      x58 = XVECEXP (x1, 0, 25);
      if (GET_CODE (x58) != CLOBBER)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != REG
          || REGNO (x59) != 83
          || GET_MODE (x59) != E_VNx16BImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 686:
          return 12926; /* aarch64_smstart_sm */

        case 687:
          return 12927; /* aarch64_smstop_sm */

        default:
          return -1;
        }

    case 8:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 690
          || pattern573 (x5, 
89) != 0)
        return -1;
      x60 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x60) != REG
          || REGNO (x60) != 90
          || GET_MODE (x60) != E_DImode)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 91
          || GET_MODE (x11) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern572 (x1, 
15, 
14, 
CLOBBER) != 0
          || pattern1036 (x1, 
E_DImode, 
30, 
18, 
17, 
16) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern1364 (x24, 
E_CCmode, 
66) != 0)
        return -1;
      return 12928; /* aarch64_tpidr2_save */

    case 9:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 92
          || GET_MODE (x11) != E_DImode
          || pattern696 (x1) != 0
          || GET_MODE (x5) != E_DImode)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XINT (x5, 1) != 691)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 0
              || GET_MODE (x20) != E_DImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern1149 (x7) != 0)
            return -1;
          return 12936; /* aarch64_tpidr2_restore */

        case 4:
          if (XINT (x5, 1) != 695
              || pattern712 (x5) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern449 (x7, 
0, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          return 12937; /* aarch64_restore_za */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern468 (x2))
        {
        case 0:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16QImode)
       || register_operand (operands[2], VNx16QImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx16QImode)
   && register_operand (operands[2], VNx16QImode))))
            return NULL;
          return gen_split_429 (insn, operands);

        case 1:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8QImode)
       || register_operand (operands[2], VNx8QImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8QImode)
   && register_operand (operands[2], VNx8QImode))))
            return NULL;
          return gen_split_430 (insn, operands);

        case 2:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4QImode)
       || register_operand (operands[2], VNx4QImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4QImode)
   && register_operand (operands[2], VNx4QImode))))
            return NULL;
          return gen_split_431 (insn, operands);

        case 3:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2QImode)
       || register_operand (operands[2], VNx2QImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2QImode)
   && register_operand (operands[2], VNx2QImode))))
            return NULL;
          return gen_split_432 (insn, operands);

        case 4:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HImode)
       || register_operand (operands[2], VNx8HImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HImode)
   && register_operand (operands[2], VNx8HImode))))
            return NULL;
          return gen_split_433 (insn, operands);

        case 5:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HImode)
       || register_operand (operands[2], VNx4HImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HImode)
   && register_operand (operands[2], VNx4HImode))))
            return NULL;
          return gen_split_434 (insn, operands);

        case 6:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HImode)
       || register_operand (operands[2], VNx2HImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HImode)
   && register_operand (operands[2], VNx2HImode))))
            return NULL;
          return gen_split_435 (insn, operands);

        case 7:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SImode)
       || register_operand (operands[2], VNx4SImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SImode)
   && register_operand (operands[2], VNx4SImode))))
            return NULL;
          return gen_split_436 (insn, operands);

        case 8:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SImode)
       || register_operand (operands[2], VNx2SImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SImode)
   && register_operand (operands[2], VNx2SImode))))
            return NULL;
          return gen_split_437 (insn, operands);

        case 9:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DImode)
       || register_operand (operands[2], VNx2DImode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DImode)
   && register_operand (operands[2], VNx2DImode))))
            return NULL;
          return gen_split_438 (insn, operands);

        case 10:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HFmode)
       || register_operand (operands[2], VNx8HFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HFmode)
   && register_operand (operands[2], VNx8HFmode))))
            return NULL;
          return gen_split_439 (insn, operands);

        case 11:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HFmode)
       || register_operand (operands[2], VNx4HFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HFmode)
   && register_operand (operands[2], VNx4HFmode))))
            return NULL;
          return gen_split_440 (insn, operands);

        case 12:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HFmode)
       || register_operand (operands[2], VNx2HFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HFmode)
   && register_operand (operands[2], VNx2HFmode))))
            return NULL;
          return gen_split_441 (insn, operands);

        case 13:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BFmode)
       || register_operand (operands[2], VNx8BFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8BFmode)
   && register_operand (operands[2], VNx8BFmode))))
            return NULL;
          return gen_split_442 (insn, operands);

        case 14:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BFmode)
       || register_operand (operands[2], VNx4BFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4BFmode)
   && register_operand (operands[2], VNx4BFmode))))
            return NULL;
          return gen_split_443 (insn, operands);

        case 15:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BFmode)
       || register_operand (operands[2], VNx2BFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2BFmode)
   && register_operand (operands[2], VNx2BFmode))))
            return NULL;
          return gen_split_444 (insn, operands);

        case 16:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SFmode)
       || register_operand (operands[2], VNx4SFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SFmode)
   && register_operand (operands[2], VNx4SFmode))))
            return NULL;
          return gen_split_445 (insn, operands);

        case 17:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SFmode)
       || register_operand (operands[2], VNx2SFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SFmode)
   && register_operand (operands[2], VNx2SFmode))))
            return NULL;
          return gen_split_446 (insn, operands);

        case 18:
          if (!(
#line 753 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DFmode)
       || register_operand (operands[2], VNx2DFmode))) && 
#line 761 "../../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DFmode)
   && register_operand (operands[2], VNx2DFmode))))
            return NULL;
          return gen_split_447 (insn, operands);

        case 19:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32QImode)
       || register_operand (operands[2], VNx32QImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_534 (insn, operands);

        case 20:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HImode)
       || register_operand (operands[2], VNx16HImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_535 (insn, operands);

        case 21:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SImode)
       || register_operand (operands[2], VNx8SImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_536 (insn, operands);

        case 22:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DImode)
       || register_operand (operands[2], VNx4DImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_537 (insn, operands);

        case 23:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BFmode)
       || register_operand (operands[2], VNx16BFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_538 (insn, operands);

        case 24:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HFmode)
       || register_operand (operands[2], VNx16HFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_539 (insn, operands);

        case 25:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SFmode)
       || register_operand (operands[2], VNx8SFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_540 (insn, operands);

        case 26:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DFmode)
       || register_operand (operands[2], VNx4DFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_541 (insn, operands);

        case 27:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx48QImode)
       || register_operand (operands[2], VNx48QImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_542 (insn, operands);

        case 28:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HImode)
       || register_operand (operands[2], VNx24HImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_543 (insn, operands);

        case 29:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SImode)
       || register_operand (operands[2], VNx12SImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_544 (insn, operands);

        case 30:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DImode)
       || register_operand (operands[2], VNx6DImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_545 (insn, operands);

        case 31:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24BFmode)
       || register_operand (operands[2], VNx24BFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_546 (insn, operands);

        case 32:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HFmode)
       || register_operand (operands[2], VNx24HFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_547 (insn, operands);

        case 33:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SFmode)
       || register_operand (operands[2], VNx12SFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_548 (insn, operands);

        case 34:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DFmode)
       || register_operand (operands[2], VNx6DFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_549 (insn, operands);

        case 35:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx64QImode)
       || register_operand (operands[2], VNx64QImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_550 (insn, operands);

        case 36:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HImode)
       || register_operand (operands[2], VNx32HImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_551 (insn, operands);

        case 37:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SImode)
       || register_operand (operands[2], VNx16SImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_552 (insn, operands);

        case 38:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DImode)
       || register_operand (operands[2], VNx8DImode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_553 (insn, operands);

        case 39:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32BFmode)
       || register_operand (operands[2], VNx32BFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_554 (insn, operands);

        case 40:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HFmode)
       || register_operand (operands[2], VNx32HFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_555 (insn, operands);

        case 41:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SFmode)
       || register_operand (operands[2], VNx16SFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_556 (insn, operands);

        case 42:
          if (!(
#line 904 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DFmode)
       || register_operand (operands[2], VNx8DFmode))) && 
#line 908 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_557 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC)
        return NULL;
      return split_3 (x1, insn);

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC)
        return NULL;
      return split_4 (x1, insn);

    case MULT:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1190 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1195 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1200 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1205 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1210 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1215 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1220 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1225 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1230 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1235 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1240 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1191 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1196 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1201 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1206 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1211 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1216 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1221 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1226 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1231 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1236 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1241 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern475 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1192 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1197 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1202 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1207 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1212 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1217 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1222 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1227 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1232 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1237 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1242 (insn, operands);

        case 11:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2795 (insn, operands);

        case 12:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2797 (insn, operands);

        case 13:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case 14:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2801 (insn, operands);

        default:
          return NULL;
        }

    case UMAX:
      switch (pattern477 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1193 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1198 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1203 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1208 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1213 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1218 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1223 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1228 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1233 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1238 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1243 (insn, operands);

        default:
          return NULL;
        }

    case UMIN:
      switch (pattern478 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1194 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1199 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1204 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1209 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1214 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1219 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1224 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1229 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1234 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1239 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1244 (insn, operands);

        case 11:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2796 (insn, operands);

        case 12:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2798 (insn, operands);

        case 13:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2800 (insn, operands);

        case 14:
          if (!(
#line 806 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 811 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2802 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern482 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1509 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1512 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1515 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1518 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1521 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1524 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1527 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1530 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1533 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1536 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern603 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1510 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1513 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1516 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1519 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1522 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1525 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1528 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1531 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1534 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1537 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern603 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1511 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1514 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1517 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1520 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1523 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1526 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1529 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1532 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1535 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1538 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2971 (insn, operands);

        case 1:
          if (!(
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2972 (insn, operands);

        case 2:
          if (!(
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2973 (insn, operands);

        case 3:
          if (!(
#line 1628 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1633 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2974 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2975 (insn, operands);

        case 1:
          if (!(
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2976 (insn, operands);

        case 2:
          if (!(
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2977 (insn, operands);

        case 3:
          if (!(
#line 1650 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1655 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2978 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return NULL;
      switch (pattern601 (x2))
        {
        case 0:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2979 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2980 (insn, operands);

        case 1:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2981 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2982 (insn, operands);

        case 2:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2983 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2984 (insn, operands);

        case 3:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2985 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1725 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1730 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2986 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern706 (x2))
        {
        case 0:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1245 (insn, operands);

        case 1:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1262 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1279 (insn, operands);

        case 3:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1296 (insn, operands);

        case 4:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1313 (insn, operands);

        case 5:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1330 (insn, operands);

        case 6:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1347 (insn, operands);

        case 7:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1364 (insn, operands);

        case 8:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1381 (insn, operands);

        case 9:
          if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1398 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      x8 = XVECEXP (x2, 0, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1108 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1992 (insn, operands);

        case E_VNx8QImode:
          if (pattern1108 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1993 (insn, operands);

        case E_VNx4QImode:
          if (pattern1108 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1994 (insn, operands);

        case E_VNx2QImode:
          if (pattern1108 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1995 (insn, operands);

        case E_VNx8HImode:
          if (pattern1108 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1996 (insn, operands);

        case E_VNx4HImode:
          if (pattern1108 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1997 (insn, operands);

        case E_VNx2HImode:
          if (pattern1108 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1998 (insn, operands);

        case E_VNx4SImode:
          if (pattern1108 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1999 (insn, operands);

        case E_VNx2SImode:
          if (pattern1108 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2000 (insn, operands);

        case E_VNx2DImode:
          if (pattern1108 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2001 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_77 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 205:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern465 (x2))
                {
                case 0:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_160 (insn, operands);

                case 1:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case 2:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case 3:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_166 (insn, operands);

                case 4:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_168 (insn, operands);

                case 5:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                case 6:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case 7:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case 8:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case 9:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_167 (insn, operands);

                case 10:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_169 (insn, operands);

                case 11:
                  if (!(
#line 3458 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != PLUS)
                return NULL;
              switch (pattern586 (x2))
                {
                case 0:
                  if (!(
#line 3485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                case 1:
                  if (!(
#line 3485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_173 (insn, operands);

                case 2:
                  if (!(
#line 3485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_174 (insn, operands);

                case 3:
                  if (!(
#line 3485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_175 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 153:
          switch (pattern372 (x2))
            {
            case 0:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_467 (insn, operands);

            case 1:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_468 (insn, operands);

            case 2:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_469 (insn, operands);

            case 3:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_470 (insn, operands);

            case 4:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_471 (insn, operands);

            case 5:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_472 (insn, operands);

            case 6:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_473 (insn, operands);

            case 7:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_474 (insn, operands);

            case 8:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_475 (insn, operands);

            case 9:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_476 (insn, operands);

            case 10:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_477 (insn, operands);

            case 11:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_478 (insn, operands);

            case 12:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_479 (insn, operands);

            case 13:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_480 (insn, operands);

            case 14:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_481 (insn, operands);

            case 15:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_482 (insn, operands);

            case 16:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_483 (insn, operands);

            case 17:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_484 (insn, operands);

            case 18:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_485 (insn, operands);

            case 19:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_486 (insn, operands);

            case 20:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_487 (insn, operands);

            case 21:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_488 (insn, operands);

            case 22:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_489 (insn, operands);

            case 23:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_490 (insn, operands);

            case 24:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_491 (insn, operands);

            case 25:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_492 (insn, operands);

            case 26:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_493 (insn, operands);

            case 27:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_494 (insn, operands);

            case 28:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_495 (insn, operands);

            case 29:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_496 (insn, operands);

            case 30:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_497 (insn, operands);

            case 31:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_498 (insn, operands);

            case 32:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_499 (insn, operands);

            case 33:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_500 (insn, operands);

            case 34:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_501 (insn, operands);

            case 35:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_502 (insn, operands);

            case 36:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_503 (insn, operands);

            case 37:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_504 (insn, operands);

            case 38:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_505 (insn, operands);

            case 39:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_506 (insn, operands);

            case 40:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_507 (insn, operands);

            case 41:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_508 (insn, operands);

            case 42:
              if (!(
#line 812 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_509 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      return split_76 (x1, insn);

    case 7:
      x6 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 125
          || GET_MODE (x6) != E_VNx2DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[5] = x4;
      if (!register_operand (operands[5], E_VNx2BImode))
        return NULL;
      x7 = XVECEXP (x2, 0, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x8 = XVECEXP (x6, 0, 0);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 1);
      if (GET_MODE (x9) != E_VNx2DImode)
        return NULL;
      x10 = XVECEXP (x2, 0, 3);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return NULL;
      x11 = XVECEXP (x2, 0, 4);
      operands[4] = x11;
      switch (XINT (x2, 1))
        {
        case 120:
          x12 = XVECEXP (x2, 0, 6);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return NULL;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SCRATCH)
            return NULL;
          switch (pattern1307 (x2))
            {
            case 0:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_856 (insn, operands);

            case 1:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_858 (insn, operands);

            case 2:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_860 (insn, operands);

            case 3:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_862 (insn, operands);

            case 4:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_864 (insn, operands);

            case 5:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_866 (insn, operands);

            case 6:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_868 (insn, operands);

            case 7:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_870 (insn, operands);

            case 8:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_872 (insn, operands);

            case 9:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_873 (insn, operands);

            case 10:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_874 (insn, operands);

            case 11:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_875 (insn, operands);

            case 12:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_876 (insn, operands);

            case 13:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_877 (insn, operands);

            case 14:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_878 (insn, operands);

            case 15:
              if (!(
#line 1597 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_879 (insn, operands);

            case 16:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_857 (insn, operands);

            case 17:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_859 (insn, operands);

            case 18:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_861 (insn, operands);

            case 19:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_863 (insn, operands);

            case 20:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_865 (insn, operands);

            case 21:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_867 (insn, operands);

            case 22:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_869 (insn, operands);

            case 23:
              if (!(
#line 1566 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_871 (insn, operands);

            default:
              return NULL;
            }

        case 121:
          if (GET_CODE (x9) != SIGN_EXTEND)
            return NULL;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != TRUNCATE
              || GET_MODE (x14) != E_VNx2SImode
              || pattern258 (x2) != 0)
            return NULL;
          switch (pattern1354 (x2))
            {
            case 0:
              if (!(
#line 1911 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1918 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_978 (insn, operands);

            case 1:
              if (!(
#line 1911 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1918 "../../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_979 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 6:
      return split_75 (x1, insn);

    case 3:
      return split_74 (x1, insn);

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 352:
          switch (pattern458 (x2))
            {
            case 0:
              if (!(
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return NULL;
              return gen_split_1658 (insn, operands);

            case 1:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1661 (insn, operands);

            case 2:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1664 (insn, operands);

            case 3:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1667 (insn, operands);

            default:
              return NULL;
            }

        case 393:
          switch (pattern458 (x2))
            {
            case 0:
              if (!(
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return NULL;
              return gen_split_1659 (insn, operands);

            case 1:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1662 (insn, operands);

            case 2:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1665 (insn, operands);

            case 3:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1668 (insn, operands);

            default:
              return NULL;
            }

        case 378:
          switch (pattern458 (x2))
            {
            case 0:
              if (!(
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return NULL;
              return gen_split_1660 (insn, operands);

            case 1:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1663 (insn, operands);

            case 2:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1666 (insn, operands);

            case 3:
              if (!
#line 5358 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1669 (insn, operands);

            default:
              return NULL;
            }

        case 358:
          switch (pattern460 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2631 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2635 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2639 (insn, operands);

            default:
              return NULL;
            }

        case 359:
          switch (pattern460 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2632 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2636 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2640 (insn, operands);

            default:
              return NULL;
            }

        case 364:
          switch (pattern460 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2633 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2637 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2641 (insn, operands);

            default:
              return NULL;
            }

        case 365:
          switch (pattern460 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2634 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2638 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2642 (insn, operands);

            default:
              return NULL;
            }

        case 375:
          x7 = XVECEXP (x2, 0, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x6 = XVECEXP (x2, 0, 2);
          if (pattern485 (x6, 
373) != 0)
            return NULL;
          switch (pattern927 (x2))
            {
            case 0:
              if (!(
#line 491 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 1400 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2963 (insn, operands);

            case 1:
              if (!(
#line 492 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2) && 
#line 1400 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2964 (insn, operands);

            case 2:
              if (!(
#line 493 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2) && 
#line 1400 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2965 (insn, operands);

            case 3:
              if (!(
#line 494 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2) && 
#line 1400 "../../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2966 (insn, operands);

            default:
              return NULL;
            }

        case 395:
          switch (pattern461 (x2))
            {
            case 0:
              if (!(
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2) && 
#line 2958 "../../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3031 (insn, operands);

            case 1:
              if (!(
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2) && 
#line 2958 "../../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3033 (insn, operands);

            case 2:
              if (!(
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2) && 
#line 2958 "../../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3035 (insn, operands);

            default:
              return NULL;
            }

        case 396:
          switch (pattern461 (x2))
            {
            case 0:
              if (!(
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2) && 
#line 2958 "../../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3032 (insn, operands);

            case 1:
              if (!(
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2) && 
#line 2958 "../../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3034 (insn, operands);

            case 2:
              if (!(
#line 2953 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_FAMINMAX && TARGET_SVE2_OR_SME2) && 
#line 2958 "../../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3036 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2DImode))
    {
      switch (pattern933 (
E_V2DImode))
        {
        case 0:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_116 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_117 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_118 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_119 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_120 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_121 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_122 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_123 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2DImode))
    {
      if (register_operand (operands[1], E_V2DImode))
        {
          switch (pattern988 ())
            {
            case 0:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_180 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_181 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_182 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_183 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_184 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_185 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_186 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              if (
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_187 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern987 (x2, 
E_V2DImode) == 0
              && 
#line 304 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2DImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_238 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern932 (x2, 
E_V2DImode) != 0
      || !
#line 325 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2DImode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_242 (insn, operands);
}

 rtx_insn *
peephole2_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V4SImode))
    {
      switch (pattern933 (
E_V4SImode))
        {
        case 0:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_108 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_109 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_110 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_111 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_112 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_113 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_114 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_115 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode))
    return NULL;
  switch (pattern988 ())
    {
    case 0:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_172 (insn, operands);

    case 1:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_173 (insn, operands);

    case 2:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_174 (insn, operands);

    case 3:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_175 (insn, operands);

    case 4:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_176 (insn, operands);

    case 5:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_177 (insn, operands);

    case 6:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_178 (insn, operands);

    case 7:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_179 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2SImode))
    {
      switch (pattern930 (
E_V2SImode))
        {
        case 0:
          if (
#line 74 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_23 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 74 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_29 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 74 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_35 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 74 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_41 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 74 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_47 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 74 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_53 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2SImode))
    {
      if (register_operand (operands[1], E_V2SImode))
        {
          switch (pattern985 ())
            {
            case 0:
              if (
#line 86 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_59 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 86 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_65 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 86 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_71 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 86 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_77 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 86 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_83 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 86 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_89 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern987 (x2, 
E_V2SImode) == 0
              && 
#line 304 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2SImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_236 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern932 (x2, 
E_V2SImode) != 0
      || !
#line 325 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2SImode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_240 (insn, operands);
}
